{$A-,B-,D+,E-,F+,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{III   誮쭨   ணࠬ஢}
{-, 9  1995 }

{  C (SOS)}

PROGRAM ANTON_C;
const eps = 0.0001;
      MaxN = 50;
      infinity = -1;
var inf, ouf: TEXT;

(* =================== ⢥ ᫠   ============== *)

function eq (a, b: real): boolean;
begin  eq := abs (a-b) <= eps  end;

function le (a, b: real): boolean;
begin  le := a <= b + eps  end;

function lt (a, b: real): boolean;
begin  lt := a < b - eps  end;

function DET (a11, a12, a21, a22: real): real;
begin
   DET := a11 * a22 - a21 * a12;
end;

function EQUATION (a11, a12, b1, a21, a22, b2: real; var x, y: real): integer;
var d: real;
begin
   d := DET (a11, a12, a21, a22);
   x := DET (b1, a12, b2, a22);
   y := DET (a11, b1, a21, b2);
   if eq (d,0) then
      if eq (x,0) and eq (y,0) then EQUATION := 2
      else EQUATION := 0
   else begin
     x := x / d; y := y / d;
     EQUATION := 1;
   end;
end;

function Leng (x, y: real): real;
begin
   Leng := sqrt (x*x+y*y);
end;

procedure Norm (x, y: real; var a, b: real);
var d: real;
begin
   d := Leng (x,y); a := x / d; b := y / d
end;

{ﬠ a+b*t, 窠 (x0,y0) --> ࠬ t  . ௥}
procedure Perp (ax, ay, bx, by, x0, y0: real; var t, x, y: real);
begin
   t := (- ax*bx - ay*by + bx*x0 + by*y0) / (bx*bx+by*by);
   x := ax + bx * t;
   y := ay + by * t;
end;


{   ⮪ 祭; res = 1 -  襭, 0 -  ., 2- }
function Cross (a1x, a1y, b1x, b1y, a2x, a2y, b2x, b2y: real;
                var t1, t2, x, y: real): integer;
var r: integer;
begin
   r := EQUATION (b1x, -b2x, a2x-a1x, b1y, -b2y, a2y-a1y, t1, t2);
   if r = 1 then
   begin
      x := a1x + b1x * t1; y := a1y + b1y * t2
   end;
   Cross := r
end;

(* ===================== 襭 ᭮  =============== *)

var X0, Y0: real;
    V: real;
    VTX, VTY: real;
    XN, YN: array [1..MaxN] of real;
    N: integer;
    P: integer;
    Tmin: real; {쭮 ६}
    i: integer;
    test: integer;
    nx, ny, fx, fy, cx, cy: real;
    ax, ay: array [1..MaxN] of real;

    procedure NewT (t: real);
    begin
       if eq (Tmin, infinity) or (Tmin > t) then TMin := t;
    end;

    procedure CheckLine (ax, ay, bx, by: real);
    var t, x, y, t1, t2: real;
        vx, vy: real;
        fvx, fvy: real;
    begin
       Perp (ax, ay, bx, by, X0, Y0,t, x, y);
       vx := x-X0; vy := y-Y0;

       if eq (Leng(vx,vy),0) then
          if le (t,1) and le (0,t) then
          begin NewT (0); exit end
       else exit;

       Norm (vx, vy, vx, vy);
       vx := vx*V; vy := vy*V;
       fvx := vx + VTX; fvy := vy + VTY;
       if Cross (ax, ay, bx, by, X0, Y0, fvx, fvy, t1, t2, x, y) <> 1 then
          Exit;
       if lt (t2, 0) or lt (t1,0) or lt (1,t1) then exit; { 室}
       NewT (t2);
    end;

    procedure CheckPoint (px, py: real);
    var dx, dy: real;
        t1, t2: real;
        d: real;
        A, B, C: real;
    begin
       dx := px - X0; dy := py - Y0;

       if eq (Leng (dx, dy), 0) then
       begin
          NewT (0); exit
       end;

       Norm (dx, dy, dx, dy);

       A := dx*dx + dy * dy;
       B := - 2 * (dx*VTX + dy * VTY);
       C := VTX*VTX + VTY*VTY - V*V;

       {蠥 ࠢ: A*t*t + B * t + C = 0}

       D := sqr (B) - 4 * A * C;
       if lt (d, 0) then
          exit; { 襭}

       t1 := (-B + sqrt (d)) / (2*A);
       t2 := (-B - sqrt (d)) / (2*A);

       if lt (0, t1) then NewT (Leng(px-X0,py-Y0) / t1);
       if lt (0, t2) then NewT (Leng(px-X0,py-Y0) / t2);
    end;

    procedure CheckSide (x1,y1,x2,y2: real);
    begin
       CheckLine (x1,y1,x2-x1,y2-y1);
       CheckPoint (x1,y1);
    end;


BEGIN
   assign (inf, 'INPUT.TXT'); assign (ouf, 'OUTPUT.TXT');
   reset (inf); rewrite (ouf);

   read (inf, P);

   for test := 1 to P do
   begin
      TMin := infinity;
      read (inf, X0, Y0, N);
      for i := 1 to N do read (inf, ax[i], ay [i]);
      read (inf, V, VTX, VTY);
      for i := 1 to N-1 do
         CheckSide (ax[i],ay[i],ax[i+1],ay[i+1]);
      CheckSide (ax[N], ay[N], ax[1], ay[1]); {㫨}
      if eq (TMin, infinity) then writeln (ouf, ' ')
                             else writeln (ouf, Tmin);
   end;
   close (ouf);



end.
