{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,0}
Program P_Swaps1;

Const NMax = 5000; MMax = 100; RMax = 5000;
      d = 10000; cd = 4;

Var A : Array [1..NMax] Of Boolean;
    P : Array [1..MMax] Of Integer;
    R : Array [0..RMax] Of Integer;
    N,M,Cnt : Integer;

Procedure ReadData;
Var i : Integer;
Begin
  Assign(Input,'Input.Txt');
  Reset(Input);
  Read(N,M);
  For i:=1 To M Do Read(P[i]);
  Close(Input);
End;

Procedure WG(i : Integer);
Var j,k : Integer;
Begin
  A[i]:=False; Inc(Cnt);
  For k:=1 To M Do
  Begin
    j:=i+P[k]+1;
    If (j<=N) And A[j] Then WG(j);
    j:=i-P[k]-1;
    If (j>0) And A[j] Then WG(j);
  End;
End;

Procedure Mult(x : Integer);
Var i,c : Integer;
    t : LongInt;
Begin
  c:=0;
  For i:=1 To R[0] Do
  Begin
    t:=LongInt(R[i])*x+c;
    R[i]:=t Mod d;
    c:=t Div d;
  End;
  If c<>0 Then
  Begin
    Inc(R[0]);
    R[R[0]]:=c;
  End;
End;

Procedure Solve;
Var i,j : Integer;
Begin
  R[0]:=1; R[1]:=1;
  FillChar(A,SizeOf(A),True);
  For i:=1 To N Do
    If A[i] Then
    Begin
      Cnt:=0;
      WG(i);
      For j:=2 To Cnt Do Mult(j);
    End;
End;

Procedure PrintAns;
Var i : Integer;
    S : String;
Begin
  Assign(Output,'Output.Txt');
  Rewrite(Output);
  Write(R[R[0]]);
  For i:=R[0]-1 DownTo 1 Do
  Begin
    Str(R[i],S);
    While Length(S)<cd Do S:='0'+S;
    Write(S);
  End;
  Close(Output);
End;

Begin
  ReadData;
  Solve;
  PrintAns;
End.