{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,0}
Type
  TLong=Array[0..10000] Of Integer;
Var
  a,b:TLong;
  n,m,ns:Integer;
  p:Array[1..500] Of Integer;
  Used:Array[-3000..6000] Of Boolean;

Procedure Mul(Var a:TLong; b:TLong);
Var
  c:TLong;
  i,j:Integer;
Begin
  FillChar(c,SizeOf(c),0);
  For i:=1 To Abs(b[0]) Do
    For j:=1 To Abs(a[0]) Do
      Inc(c[i+j-1],b[i]*a[j]);
  c[0]:=i+j-1;
  i:=1;
  While i<=c[0] Do
  Begin
    If c[i]>9 Then
    Begin
      Inc(c[i+1],c[i] Div 10);
      c[i]:=c[i] Mod 10;
      If i=c[0] Then Inc(c[0]);
    End;
    Inc(i);
  End;
  If ((a[0]<0) And (b[0]>0)) Or ((a[0]>0) And (b[0]<0)) Then c[0]:=-c[0];
  a:=c;
End;

Procedure Convert(n:LongInt; Var a:TLong);
Var
  i:Integer;
Begin
  If n<>0 Then
  Begin
    i:=0;
    a[0]:=0;
    While n<>0 Do
    Begin
      Inc(i);
      Inc(a[0]);
      a[i]:=n Mod 10;
      n:=n Div 10;
    End;
    If n<0 Then a[0]:=-a[0];
  End
  Else
  Begin
    a[0]:=1;
    a[1]:=0;
  End;
End;

Procedure Fact(n:LongInt; Var a:TLong);
Var
  b:TLong;
Begin
  Convert(n,a);
  If n=0 Then
  Begin
    a[1]:=1;
    Exit;
  End;
  While n>1 Do
  Begin
    Dec(n);
    Convert(n,b);
    Mul(a,b);
  End;
End;

Procedure WriteLong(a:TLong);
Var
  i:Integer;
Begin
  If a[0]<0 Then Write('-');
  For i:=Abs(a[0]) DownTo 1 Do
    Write(a[i]);
  WriteLn;
End;

Procedure ReadData;
Var
  i:Integer;
Begin
  Assign(Input,'Input.Txt');
  Reset(Input);
  Read(n); Read(m);
  For i:=1 To m Do
  Begin
    Read(p[i]);
    Inc(p[i]);
  End;
  Close(Input);
  a[0]:=1;
  a[1]:=1;
End;

Procedure WriteResult;
Begin
  Assign(Output,'Output.Txt');
  Rewrite(Output);
  WriteLong(a);
  Close(Output);
End;

Procedure Rec(i:Integer);
Var
  j:Integer;
Begin
  Used[i]:=True;
  Inc(ns);
  For j:=1 To m Do
  Begin
    If Used[i-p[j]]=False Then Rec(i-p[j]);
    If Used[i+p[j]]=False Then Rec(i+p[j]);
  End;
End;

Procedure Calculate;
Var
  i,j,k:Integer;
Begin
  FillChar(Used,SizeOf(Used),True);
  For i:=1 To n Do
    Used[i]:=False;
  For i:=1 To n Do
  Begin
    ns:=0;
    Rec(i);
    If ns<>1 Then
    Begin
      Fact(ns,b);
      Mul(a,b);
    End;
  End;
End;

Begin
  ReadData;
  Calculate;
  WriteResult;
End.
