{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
uses Crt;
const errors:array[1..4] of string=(' ⠪ ',
                                    '  ',
                                    '  ',
                                    '  뫪');
      raz:set of char={[#0..#255]-['a'..'z','A'..'Z','0'..'9',''..'',
                    ''..'',''..'']}[' ','.',',',';',':','''','"',')','-',
                    '+','*','/'];
type
     PText=^TText;
     TText=record
             Length:word;
             text:array[1..12000] of char;
           end;
     Pstat=^Tstat;
     TStat=record
             name:string[33];
             stattext:PText;
             Next:Pstat;
           end;
Var
    tom:array[1..100] of record
                           name:string[9];
                           stat:Pstat;
                         end;
    LastTom:integer;
procedure ReadData;
Var F:text;
begin
  assign(f,'input.txt');
  reset(f);
  while Not eof(f) do
   begin
     inc(Lasttom);
     readln(f,tom[LastTom].name);
   end;
  close(f);
end;
procedure readtoms;
Var I:Integer;
    F:Text;
    c:char;
    stat, oldstat:Pstat;
    buf,buf1:ptext;
    bi:longint;

begin
  new(buf);
  for i:=1 to LastTom do
   begin
     assign(f,tom[i].name+'.txt');
     reset(f);
     oldstat:=nil;
     while Not Eof(f) do
      begin
        new(stat);
        if oldstat<>nil then
          oldstat^.next:=stat
        else
          tom[i].stat:=stat;
        read(f,c);
        stat^.name:='';
        while c<>' ' do
         begin
           stat^.name:=stat^.name+c;
           read(f,c);
         end;
        bi:=0;
        while Not eoln(f) do
         begin
           read(f,c);
           inc(bi);
           buf^.text[bi]:=c;
         end;
        GetMem(buf1,bi+2);
        move(buf^, buf1^,bi+2);
        buf1^.length:=bi;
        stat^.stattext:=buf1;
        stat^.next:=nil;
        Oldstat:=stat;
        readln(f);
      end;
     close(f);
   end;
  dispose(buf);
end;
function upstring(var s:string):string;
Var I:Integer;
begin
  for i:=1 to Length(s) do
    s[i]:=upcase(s[i]);
  UpString:=s;
end;
procedure Dialog;
Var
    ActiveTom:integer;
    _ActiveTom:integer;
    SS:array[1..100] of record
                            show:boolean;
                            tomname:string[8];
                            statname:string[33];
                          end;
    LastSS:integer;
  procedure writeError(I:Integer);
  begin
    writeln(errors[i]);
  end;
  function comstr:string;
  Var s:string;
  begin
    writeln;
    write(tom[activetom].name,'>');
    readln(s);
    comstr:=s;
  end;
  function Getfirst(var s:string):String;
  Var I:Integer;
      o:string;
  begin
    i:=1;
    o:='';
    while s[i]<>' ' do
     begin
       o:=o+s[i];
       inc(i);
     end;
    delete(s,1,i);
    GetFirst:=UpString(o);
  end;
  function FindTom( S:String):Integer;
  var I:Integer;
  begin
    for i:=1 to LastTom do
      if tom[i].name=s then
       begin
         FindTom:=i;
         exit;
       end;
    writeError(2);
    FindTom:=-1;
  end;
  function _FindTom( S:String):Integer;
  var I:Integer;
  begin
    for i:=1 to LastTom do
      if tom[i].name=s then
       begin
         _FindTom:=i;
         exit;
       end;
    _FindTom:=-1;
  end;
  function GetNames(var t:integer; var sname:string; var s:string):boolean;
  Var r:Integer;
  begin
    if pos(':',s)=0 then
     begin
       t:=ActiveTom;
       sname:=s;
       GetNames:=true;
       exit;
     end;
    r:=FindTom(copy(s,1,pos(':',s)-1));
    if r=-1 then
     begin
       GetNames:=False;
       exit;
     end;
    sname:=copy(s,pos(':',s)+1,255);
    GetNames:=True;
    t:=r;
  end;
  function FindStat(t:integer;var name:string):Pstat;
  var s:pstat;
  begin
    s:=tom[t].stat;
    while s<>nil do
     begin
       if s^.name=name then
        begin
          Findstat:=s;
          exit;
        end;
       s:=s^.next;
     end;
    findStat:=nil;
    writeError(3);
  end;
  function _FindStat(t:integer; name:string):Pstat;
  var s:pstat;
  begin
    s:=tom[t].stat;
    while s<>nil do
     begin
       if s^.name=name then
        begin
          _Findstat:=s;
          exit;
        end;
       s:=s^.next;
     end;
    _findStat:=nil;
  end;
  var anbuf1,anbuf2,ann:string;
      anf:boolean;
  procedure Analize(c:char);
  Var r:integer;
      s:pstat;
  begin
    if anf then
      ann:=ann+c;
    if not (c in raz) then
      anbuf1:=anbuf1+c
    else
     begin
       if anf then
        begin
          dec(ann[0]);
          if ann='' then
            ss[Lastss].tomname:=tom[Activetom].name
          else
            ss[Lastss].tomname:=ann;
          ss[LastSs].show:=ss[LastSs].tomname<>tom[_ActiveTom].name;
          anf:=False;
        end;
       if ((copy(anbuf1,1,4)+c)=' (.') then
        begin
          ann:='';
          anf:=true;
          inc(Lastss);
          ss[Lastss].statname:=copy(anbuf2,2,255);
        end;
       anbuf2:=anbuf1;
       anbuf1:=' ';
     end;
  end;
  procedure WriteStatText(s:pstat);
    function SpacePos(I:word):word;
    var r:word;
    begin
      R:=i;
      while (i<=s^.stattext^.Length) and (s^.stattext^.text[i]<>' ')  do
        inc(i);
      SpacePos:=i-r;
    end;
  Var I:word;
      P:word;
      t:boolean;
  begin
    anf:=False;
    anbuf2:='';
    anbuf1:='';
    Lastss:=0;
    write(s^.name,' ');
    p:=Length(s^.name)+2;
    i:=1;
    t:=True;
    while i<=S^.stattext^.Length do
     begin
       if s^.stattext^.text[i]=' ' then
        begin
          if (SpacePos(i+1)+p)>79 then
           begin
             writeln;
             p:=1;
             t:=False;
           end
          else
            write(' ');
          analize(' ');
        end
       else
        begin
          write(s^.stattext^.text[i]);
          analize(s^.stattext^.text[i]);
        end;
       inc(p);
       inc(i);
     end;
  end;

  procedure _dir;
  Var I:Integer;
  begin
    for i:=1 to LastTom do
      writeln(tom[i].name);
  end;
  procedure _volume(Var S:String);
  Var R:integer;
  begin
    r:=findTom(s);
    if r<>-1 then
     begin
       ActiveTom:=r;
       _ActiveTom:=r;
     end;
  end;
  procedure _List(var s:string);
  Var
      t:integer;
      stat:pstat;
      n:integer;
  begin
    if s='' then
      t:=ActiveTom
    else
     begin
       t:=Findtom(s);
       if t=-1 then
         exit;
     end;
    stat:=tom[t].stat;
    n:=1;
    while stat<>nil do
     begin
       writeln(n,'. ',stat^.Name);
       stat:=stat^.Next;
       inc(n);
     end;
  end;
  procedure _type(s:string);
  Var sname:string;
      t:integer;
      stat:Pstat;
      I:Word;
      oldac:integer;
  begin
    LastSS:=0;
    if Not GetNames(t,sname,s) then
      exit;
    OldAc:=ActiveTom ;
    stat:=findstat(t,sname);
    if stat=nil then
      exit;
    writestattext(stat);
    writeln;
    writeln;
    for i:=1 to Lastss do
     begin
       write(i,'. ',ss[i].statname);
       if ss[i].show then
         write(', ⮬ ',SS[I].tomname);
       writeln;
     end;
    ActiveTom:=oldac;
  end;
  procedure _ref(Var s:string);
  var a,b:integer;
      o:integer;
  begin
    val(s,a,b);
    if (b<>0) or (a>LastSS) then
     begin
       writeError(4);
       exit;
     end;
    o:=LastSS;
    if ss[a].tomname='' then
      _type(ss[a].statname)
    else
      _type(ss[a].tomname+':'+ss[a].statname);
    LastSS:=o;
  end;
  procedure _Verify;
  var f:boolean;
      fc:longint;
    procedure verstat(s:Pstat);
    Var I:Integer;
        s1:pstat;
        r1:integer;
    begin
      anf:=False;
      anbuf2:='';
      anbuf1:='';
      Lastss:=0;
      i:=1;
      while i<=S^.stattext^.Length do
       begin
         analize(s^.stattext^.text[i]);
         inc(i);
       end;
      for I:=1 to LastSS do
       begin
         if ss[i].tomname='' then
           ss[i].tomname:=tom[ActiveTom].name;
         r1:=_findTom(ss[i].tomname);
         if r1=-1 then
          begin
            f:=true;
            inc(fc);
            writeln(fc,'.  ',tom[activetom].name,':',s^.name,
                 ' 뫪  ',ss[i].tomname,':',ss[i].statname);
          end
         else
          begin
            if r1<1 then
              r1:=r1;
            s1:=_findstat(r1,ss[i].statname);
            if s1=nil then
             begin
               f:=true;
               inc(fc);
               writeln(fc,'.  ',tom[activetom].name,':',s^.name,
                    ' 뫪  ',ss[i].tomname,':',ss[i].statname);
             end;
          end;
       end;

    end;
  Var I:Integer;
      s:PStat;
      oldac:integer;
  begin
    f:=False;
    fc:=0;
    oldac:=ActiveTom;
    for i:=1 to LastTom do
     begin
       ActiveTom:=i;
       s:=tom[i].stat;
       while s<>nil do
        begin
          verstat(s);
          s:=s^.Next;
        end;
     end;
    ActiveTom:=oldac;
    LastSS:=0;
  end;
Var
    s,com:string;
    use:boolean;
begin
  activetom:=1;
  _activetom:=1;
  writeln('ਢ!');
  LastSS:=0;
  repeat
    s:=comstr+' ';
    com:=Getfirst(s);
    use:=False;
    if s<>'' then
      dec(s[0]);
    if com='DIR' then
     begin
       _dir;
       use:=true;
     end;
    if com='VOLUME' then
     begin
       _Volume(s);
       use:=True;
     end;
    if com='LIST' then
     begin
       _List(s);
       use:=true;
     end;
    if com='TYPE' then
     begin
       _Type(s);
       use:=True;
     end;
    if com='REF' then
     begin
       _ref(s);
       use:=True;
     end;
    if com='CLS' then
     begin
       clrscr;
       use:=True;
     end;
    if com='VERIFY' then
     begin
       _VERIFY;
       use:=True;
     end;
    if (com<>'EXIT') and Not use then
      WriteError(1);
  until com='EXIT';
  writeln(' ᢨ');
end;
begin
  ReadData;
  readtoms;
  dialog;
end.