{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
Const Eps=0.0000001;
type
     TPoint=record
              x,y:real;
            end;
     TVol=array[1..100] of record
                             n:integer;
                             r:real;
                           end;
     PVol=^TVol;
Var
    Graph:array[1..100,1..100] of boolean;
    vol:PVol;
    Points:array[1..110] of TPoint;
    LastPoint:word;
    StartPoint,StopPoint:integer;
function Sign(a:real):Integer;
begin
  Sign:=ord(a>0)-ord(a<0);
end;
function Min(a,b:real):real;
begin
  if a>b then
    min:=b
  else
    min:=a;
end;
procedure readdata;
Var F:text;
    I:Integer;
begin
  assign(f,'input.txt');
  reset(f);
  readln(f,LastPoint);
  for i:=1 to LastPoint do
    readln(f,Points[i].x, Points[i].y);
  Points[LastPoint+1]:=Points[1];
  readln(f,startpoint,stopPoint);
  close(f);
end;
Procedure MakeLine(Var a,b,c:real; x1,y1,x2,y2:real);
begin
  a:=y1-y2;
  b:=x2-x1;
  c:=-a*x1-b*y1;
end;
function TestXLines(x1,y1,x2,y2,x3,y3,x4,y4:real):boolean;
Var a,b,c:real;
    s1,s2:integer;
begin
  MakeLine(a,b,c,x1,y1,x2,y2);
  s1:=sign(a*x3+b*y3+c) * sign(a*x4+b*y4+c);
  MakeLine(a,b,c,x3,y3,x4,y4);
  s2:=sign(a*x1+b*y1+c) * sign(a*x2+b*y2+c);
  TestXLines:=(s1=-1) and (s2=-1);
end;
function Path(a,b:integer):Real;
begin
  Path:= SQRT( SQR(points[a].x-points[b].x) + SQR(points[a].y-points[b].y ))
end;
function TestOut(x,y:real):boolean;
Var I:Integer;
    c:integer;
begin
  c:=0;
  for i:=1 to LastPoint do
   begin
     if abs(points[i+1].y-points[i].y)>Eps then
      begin
        if (sign(points[i].y-y)*sign(points[i+1].y-y)=-1) or
         ( min(sign(points[i].y-y),sign(points[i+1].y-y))=0) then
         begin
          if (points[i].x+
           (points[i+1].x-points[i].x)/(points[i+1].y-points[i].y)*
           (y-points[i].y))>x then
            inc(c);
          if abs(points[i].x+
           (points[i+1].x-points[i].x)/(points[i+1].y-points[i].y)*
           (y-points[i].y)-x)<Eps then
            begin
              TestOut:=False;
              Exit;
            end;
         end;
      end;
   end;
  TestOut:=c mod 2=0;
end;
Function Testxy(a,b:integer):boolean;
Var c,d:integer;
begin
  if (a=7) and (b=6) then
    a:=a;
  for c:=1 to LastPoint do
    if TestXLines(points[a].x, points[a].y, points[b].x, points[b].y,
       points[c].x, points[c].y,  points[c+1].x, points[c+1].y) then
     begin
       Testxy:=False;
       exit;
     end;
  Testxy:=Not TestOut( (points[a].x+points[b].x)/2, (points[a].y+points[b].y)/2);
end;
Procedure MakeGraph;
Var x,y:integer;
begin
  for y:=1 to LastPoint do
    for x:=y+1 to LastPoint do
     begin
       Graph[x,y]:=(x<>y) and testxy(x,y);
       Graph[y,x]:=Graph[x,y];
     end;
end;
Var otvet:real;
procedure FindPath;
Var n:integer;
    i,j:integer;
    ex:boolean;
begin
  new(vol);
  for i:=1 to LastPoint do
   begin
     Vol^[i].n:=0;
     Vol^[i].r:=-1;
   end;
  n:=1;
  Vol^[startPoint].n:=n;
  vol^[startPoint].r:=0;
  repeat
    ex:=true;
    for i:=1 to LastPoint do
      if vol^[i].n=n then
       begin
         for j:=1 to LastPoint do
           if Graph[i,j] then
             if Not( (vol^[j].r<>-1) and
                (vol^[j].r<(Vol^[i].r+Path(j,i)))) then
              begin
                vol^[j].n:=n+1;
                vol^[j].r:=Vol^[i].r+Path(j,i);
                ex:=false;
              end;
       end;
    inc(n);
  until ex;
  otvet:=vol^[StopPoint].r
end;
procedure OutResult;
Var F:text;
begin
  assign(f,'output.txt');
  rewrite(f);
  write(f,otvet:0:6);
  close(f);
end;
Var x,y:integer;
begin
  readData;
  MakeGraph;
  FindPath;
  OutResult;
end.