{$N+}
const
 maxr=1e15;
 infile='input.txt';
 outfile='output.txt';
 eps=1e-8;
type
 mov=record
           bt:real;
           mt:real;
           p:boolean;
 end;
 server=record
              all:boolean;
              at:real;
              s:array[1..100] of mov;
 end;

var
 a:array[1..100] of ^server;
 g:array[1..100,1..100] of real;
 n,m,last:integer;
 time,t:real;
 l:longint;
procedure tone(p:integer);
var
 i,j:integer;
 s,dt,t,mint,xx:real;
begin
 dt:=0;
 s:=0;
 for i:=1 to n do
  if a[p]^.s[i].p then
   begin
    s:=s+1/a[p]^.s[i].mt;
    dt:=dt+a[p]^.s[i].bt/a[p]^.s[i].mt;
   end;
 t:=(l+dt)/s;
 mint:=maxr;
 for i:=1 to n do
  if a[p]^.s[i].p then
  begin
   xx:=frac((t-a[p]^.s[i].bt)/a[p]^.s[i].mt);
   if xx<eps then
    xx:=t
         else
    xx:=a[p]^.s[i].bt+(trunc((t-a[p]^.s[i].bt)/a[p]^.s[i].mt)+1)*a[p]^.s[i].mt;
   if xx<mint then
    mint:=xx;
  end;
 a[p]^.at:=mint;
end;
procedure makeone(p:integer;tt:real);
var
 i:integer;
begin
 a[p]^.all:=true;
 a[p]^.at:=tt;
 for i:=1 to n do
  if (a[i]^.all=false) and (g[p,i]<maxr) then
   begin
    a[i]^.s[p].bt:=tt+t;
    a[i]^.s[p].mt:=g[p,i];
    a[i]^.s[p].p:=true;
    tone(i);
   end;
end;
procedure readall;
var
 i,p1,p2:integer;
 r:real;
 f:text;
begin
 assign(f,infile);
 reset(f);
 read(f,n,m,l,t);
 for i:=1 to m do
  begin
   read(f,p1,p2,r);
   g[p1,p2]:=r;
   g[p2,p1]:=r;
  end;
 makeone(1,-t);
end;
procedure init;
var
 i,j:integer;
begin
 for i:=1 to 100 do
  for j:=1 to 100 do
   g[i,j]:=maxr;
 for i:=1 to 100 do
  begin
   a[i]^.all:=false;
   a[i]^.at:=maxr;
  end;
end;
procedure newall;
var
 i,j:integer;
begin
 for i:=1 to 100 do
  begin
   new(a[i]);
   for j:=1 to 100 do
    a[i]^.s[j].p:=false;
  end;
end;
function ff(var r:real):integer;
var
 mm,i:integer;
begin
 i:=1;
 while a[i]^.all do
  inc(i);
 mm:=i;
 for i:=1 to n do
  if (a[i]^.all=false) and (a[mm]^.at>a[i]^.at) then
   mm:=i;
 r:=a[mm]^.at;
 ff:=mm;
end;
procedure makeall;
var
 inset,i,j:integer;
 r:real;
begin
 inset:=1;
 while inset<n do
  begin
   i:=ff(r);
   makeone(i,r);
   last:=i;
   inc(inset);
  end;
 time:=a[last]^.at;
end;
procedure outall;
var
 f:text;
begin
 assign(f,outfile);
 rewrite(f);
 writeln(f,time:20:20);
 writeln(f,last);
 close(f);
end;
begin
  newall;
  init;
  readall;
  makeall;
  outall;
end.