{$N+}
const
 eps=1e-5;
 maxr=1e17;
 infile='input.txt';
 outfile='output.txt';
type
 pointype=record
                x,y:real;
 end;
 linetype=record
                x1,y1,x2,y2:real;
                a,b,c:real;
 end;
 ntype=record
             h:array[1..100] of pointype;
             n:integer;
 end;
var
 a:ntype;
 g:array[1..100,1..100] of real;
{ d1,d2:linetype;}
 n:integer;
 kk,ll:integer;
procedure makeabc(var p:linetype);
begin
 with p do
  begin
   a:=y1-y2;
   b:=x2-x1;
   c:=x1*y2-x2*y1;
  end;
end;
function r(r1,r2:real):boolean;
begin
 if (r1>=r2-eps) and (r1<=r2+eps) then
  r:=true
  else
  r:=false;
end;
function twoline(p1,p2:linetype;var s:pointype):boolean;
var
 d:real;
begin
 d:=p1.a*p2.b-p1.b*p2.a;
 if r(d,0) then
  twoline:=false
                else
  begin
   with s do
    begin
     x:=-(p1.c*p2.b-p2.c*p1.b)/d;
     y:=-(p1.a*p2.c-p2.a*p1.c)/d;
     twoline:=true;
    end;
  end;
end;
procedure swap(var i,j:real);
var
 c:real;
begin
 c:=i;
 i:=j;
 j:=c;
end;
procedure sortx(var p:linetype);
begin
 with p do
  if x1>x2 then
   begin
    swap(x1,x2);
    swap(y1,y2);
   end;
end;
procedure sorty(var p:linetype);
begin
 with p do
  if y1>y2 then
   begin
    swap(x1,x2);
    swap(y1,y2);
   end;
end;
function pointotr(p:linetype;s:pointype):boolean;
var
 f:boolean;
begin
 makeabc(p);
 f:=true;
{ if r(p.a*s.x+p.b*s.y+p.c,0) then
  f:=true
         else
  f:=false;}
 with p do
  begin
   sortx(p);
   if not ((x1-abs(x1*eps)<=s.x) and (x2+abs(x2*eps)>=s.x)) then
    f:=false;
   sorty(p);
   if not ((y1-abs(y1*eps)<=s.y) and (y2+abs(y2*eps)>=s.y)) then
    f:=false;
  end;
 pointotr:=f;
end;
function twootr(p1,p2:linetype;var s:pointype):boolean;
var
 i,j:integer;
begin
 makeabc(p1);
 makeabc(p2);
 if twoline(p1,p2,s)=false then
  twootr:=false
               else
  if (pointotr(p1,s)) and (pointotr(p2,s)) then
   twootr:=true
               else
   twootr:=false;
end;
procedure init;
var
 i,j:integer;
begin
 for i:=1 to 100 do
  for j:=1 to 100 do
   g[i,j]:=maxr;
end;
procedure readall;
var
 f:text;
 i:integer;
begin
 assign(f,infile);
 reset(f);
 read(f,n);
 for i:=1 to n do
  read(f,a.h[i].x,a.h[i].y);
 read(f,kk,ll);
end;
function len(l:linetype):real;
begin
 len:=sqrt((l.x1-l.x2)*(l.x1-l.x2)+(l.y1-l.y2)*(l.y1-l.y2));

end;
function intype(p:pointype):boolean;
var
 l,l2:linetype;
 nt,i,j:longint;
 s:pointype;
 t:array[1..100] of pointype;
 f:boolean;
begin
 nt:=0;
 l.x1:=p.x-1e10;
 l.y1:=p.y;
 l.x2:=p.x+1e10;
 l.y2:=p.y+0.43563645;
 for i:=1 to n do
  begin
   l2.x1:=a.h[i].x;
   l2.y1:=a.h[i].y;
   if i=n then
    begin
     l2.x2:=a.h[1].x;
     l2.y2:=a.h[1].y;
    end
       else
    begin
     l2.x2:=a.h[i+1].x;
     l2.y2:=a.h[i+1].y;
    end;
   if twootr(l,l2,s) then
    begin
     inc(nt);
     t[nt]:=s;
    end;
  end;
 for i:=1 to nt-1 do
  for j:=i+1 to nt do
   if t[i].x>t[j].x then
    swap(t[i].x,t[j].x);
 if (p.x<t[1].x) or (p.x>t[nt].x) then
  intype:=false
               else
  begin
   f:=false;
   for i:=2 to nt-1 do
    begin
     if (t[i].x<s.x) and (t[i+1].x>s.x) then
      begin
       intype:=f;
       exit;
      end;
     f:=not f;
    end;
  end;
end;
procedure makegr;
var
 i,j,k:integer;
 l1,l2:linetype;
 s:pointype;
 r:real;
 f:boolean;
begin
 for i:=1 to n do
  for j:=i to n do
   if i=j then
    begin
     g[i,j]:=maxr;
    end
       else
    begin
     if (j=i+1) or ((i=1) and (j=n)) then
      begin
       l1.x1:=a.h[i].x;
       l1.y1:=a.h[i].y;
       l1.x2:=a.h[j].x;
       l1.y2:=a.h[j].y;
       g[i,j]:=len(l1);
       g[j,i]:=g[i,j];
      end
       else
      begin
       f:=true;
       l1.x1:=a.h[i].x;
       l1.y1:=a.h[i].y;
       l1.x2:=a.h[j].x;
       l1.y2:=a.h[j].y;
       for k:=1 to n do
        if not ((k=i) or (k=j) or (k+1=i) or (k+1=j) or ((k=n) and (i=1))) then
        begin
         l2.x1:=a.h[k].x;
         l2.y1:=a.h[k].y;
         if k=n then
          begin
           l2.x2:=a.h[1].x;
           l2.y2:=a.h[1].y;
          end
             else
          begin
           l2.x2:=a.h[k+1].x;
           l2.y2:=a.h[k+1].y;
          end;
         if twootr(l1,l2,s) then
          begin
           f:=false;
           break;
          end;
         s.x:=(l1.x1+l1.x2)/2;
         s.y:=(l1.y1+l1.y2)/2;
         if not intype(s) then
          begin
           f:=false;
          end;
        end;
       if f then
        begin
         g[i,j]:=len(l1);
         g[j,i]:=g[i,j];
        end;
      end
    end;
end;
function min(i,j:real):real;
begin
 if i>j then
  min:=j
        else
  min:=i;
end;
procedure floid;
var
 i,j,m:integer;
begin
 for m:=1 to n do
  for i:=1 to n do
   for j:=1 to n do
    g[i,j]:=min(g[i,j],g[i,m]+g[m,j]);
end;
procedure outall;
var
 f:text;
begin
 assign(f,outfile);
 rewrite(f);
 writeln(f,g[kk,ll]:20:20);
 close(f);
end;
begin
 init;
 readall;
 makegr;
 floid;
 outall;
end.