Program P0608_5;
Uses Crt;
Label Ex;
Const
  CnvLen = 58;
  _SUp   : String[CnvLen] = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  _SDown : String[CnvLen] = 'abcdefghijklmnopqrstuvwxyz';
  OK = 8;
  Commands : Array [1..OK] of String[6] = ('DIR','VOLUME','LIST','TYPE','REF','CLS','VERIFY','EXIT');
  Strq  = 'QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm'+
         +'';

Var
  INP    : Text;
  Fgh    : File;
  Curr, Comm, C2, S1, S2, S3, S4 : String;
  S5, S6 : String;
  Good : Boolean;
  K1   : Byte;

Procedure StrUpCase(Var S : String);
Var
  L, L2 : Byte;
Begin
  For L:=1 to Length(S) do
  Begin
    L2:=Pos(S[L],_SDown);
    if L2>0 then S[L]:=_SUp[L2];
  End;
End;

Procedure Dir;
Var
  F : Text;
  I : Integer;
Begin
  Assign(F,'INPUT.TXT');
  ReSet(F);
  I:=0;
  Repeat
    ReadLn(F,S1);
    WriteLn(S1);
    Inc(I);
    if I>23 then
    Begin
      Write(' ENTER  ᫥饣 ࠭...');
      Repeat Until ReadKey=#13;
      WriteLn;
      I:=0;
    End;
  Until EOF(F);
  Close(F);
End;

Procedure VOLUME;
Var
  VOL : String;
  F   : Text;
  Finded : Boolean;
Begin
  VOL:=Copy(Comm,Pos(' ',Comm)+1,Length(Comm)-Pos(' ',Comm)-1);
  Assign(F,'INPUT.TXT');
  ReSet(F);
  Finded:=False;
  StrUpCase(VOL);
  Repeat
    ReadLn(F,S1);
    StrUpCase(S1);
    if S1=VOL then Finded:=True;
  Until EOF(F)or(Finded);
  Close(F);
  if not Finded then
  Begin
    WriteLn('  .');
    VOL:=Curr;
  End;
  Curr:=VOL;
End;

Procedure List;
Var
  F, F1 : Text;
  I : Integer;
Begin
  if Length(Comm)>5 then S1:=Copy(Comm,6,Length(Comm)-6) else S1:=Curr;
  Assign(F,S1+'.TXT');
  Assign(F1,'TEMP.TXT');
  ReWrite(F1);
  WriteLn(F1,'LIST:'+S1);
  ReSet(F);
  I:=0;
  Repeat
    ReadLn(F,S1);
    Inc(I);
    WriteLn(I,'. '+Copy(S1,1,Pos(' ',S1)-1));
    WriteLn(F1,I,'. '+Copy(S1,1,Pos(' ',S1)-1));
  Until EOF(F);
  Close(F);
  Close(F1);
End;

Procedure _Type2;
Label Ex2;
Var
  F, F1 : Text;
  Ms : String;
  Ch : Char;
  P1, P2 : Integer;

Procedure Make;
Var
  K1 : Integer;
Begin
  if Pos('(.',S3)=1 then S4:=S5+' '+S3 else S4:=S3;
  While Pos('(.',S4)>0 do
  Begin
    S5:='';
    For K1:=Pos(' (.',S4)-1 downto 1 do
    Begin
      if Pos(S4[K1],Strq)=0 then Break;
      S5:=S4[K1]+S5;
    End;
    Inc(P2);
    Write(F1,S2+':'+Ms+' ');
    Delete(S4,1,Pos(' (.',S4)+4);
    if S4[1]=')' then WriteLn(F1,S2+':'+S5) else WriteLn(F1,Copy(S4,1,Pos(')',S4)-1)+':'+S5);
  End;
End;

Begin
  Assign(F,S2+'.TXT');
  Reset(F);
  Assign(F1,'TEMP2.TXT');
  {$I-}
  Append(F1);
  {$I+}
  if IOResult<>0 then ReWrite(F1);
  Repeat
    S1:='';
    Repeat
      Read(F,Ch);
      S1:=S1+Ch;
    Until Ch=#32;
    Ms:=Copy(S1,1,Length(S1)-1);
    S4:='';
    Repeat
      S1:='';
      Repeat
        Read(F,Ch);
        S1:=S1+Ch;
      Until (Ch=#32)or(EOLN(F));
      if (Length(S3+S1)<=80) then S3:=S3+S1 else
      Begin
        Make;
        S5:='';
        For P1:=Length(S3)-1 downto 1 do
        Begin
          if Pos(S3[P1],Strq)=0 then Break;
          S5:=S3[P1]+S5;
        End;
        While S3[1]=' ' do Delete(S3,1,1);
        S4:=S3;
        S3:=S1;
      End;
    Until EOLN(F);
    Make;
    ReadLn(F);
  Until EOF(F);
Ex2:
  Close(F);
  Close(F1);
End;

Procedure _Type;
Label Ex2;
Var
  F, F1 : Text;
  Ch : Char;
  P1, P2 : Integer;

Procedure Make;
Var
  K1 : Integer;
Begin
  if Pos('(.',S3)=1 then S4:=S5+' '+S3 else S4:=S3;
  While Pos('(.',S4)>0 do
  Begin
    S5:='';
    For K1:=Pos(' (.',S4)-1 downto 1 do
    Begin
      if Pos(S4[K1],Strq)=0 then Break;
      S5:=S4[K1]+S5;
    End;
    Inc(P2);
    Write(F1,P2,'. ',S5);
    Delete(S4,1,Pos(' (.',S4)+4);
    if S4[1]=')' then WriteLn(F1) else WriteLn(F1,', ⮬ ',Copy(S4,1,Pos(')',S4)-1));
  End;
End;

Begin
  S2:=Copy(Comm,6,Length(Comm)-6);
  if Pos(':',Comm)>0 then
  Begin
    S1:=Copy(Comm,6,Pos(':',Comm)-6);
    S2:=Copy(S2,Pos(':',S2)+1,Length(S2)-Pos(':',S2));
  End else S1:=Curr;
  StrUpCase(S2);
  Assign(F,S1+'.TXT');
  {$I-}
  Reset(F);
  {$I+}
  if IOResult<>0 then
  Begin
    WriteLn('  .');
    Exit;
  End;
  Assign(F1,'TEMP.TXT');
  ReWrite(F1);
  WriteLn(F1,'TYPE:'+S1);
  P2:=0;
  Repeat
    S1:='';
    Repeat
      Read(F,Ch);
      S1:=S1+Ch;
    Until Ch=#32;
    S3:=S1;
    StrUpCase(S1);
    if Copy(S1,1,Length(S1)-1)=S2 then
    Begin
      S4:='';
      Repeat
        S1:='';
        Repeat
          Read(F,Ch);
          S1:=S1+Ch;
        Until (Ch=#32)or(EOLN(F));
        if (Length(S3+S1)<=80){or(not EOLN(F))} then S3:=S3+S1 else
        Begin
          Make;
          S5:='';
          For P1:=Length(S3)-1 downto 1 do
          Begin
            if Pos(S3[P1],Strq)=0 then Break;
            S5:=S3[P1]+S5;
          End;
          While S3[1]=' ' do Delete(S3,1,1);
          if Length(S3)=80 then Write(S3) else WriteLn(S3);
          S4:=S3;
          S3:=S1;
        End;
      Until EOLN(F);
      WriteLn(S3);
      Make;
      goto Ex2;
    End else ReadLn(F);
  Until EOF(F);
  WriteLn('  .');
Ex2:
  Close(F);
  Close(F1);
  if P2>0 then
  Begin
    Assign(F1,'TEMP.TXT');
    ReSet(F1);
    WriteLn;
    ReadLn(F1,S1);
    Repeat
      ReadLn(F1,S1);
      WriteLn(S1);
    Until EOF(F1);
    Close(F1);
  End;
End;

Procedure REF;
Var
  F1 : Text;
  P1, P2, Code : Integer;
Begin
  Assign(F1,'TEMP.TXT');
  {$I-}
  ReSet(F1);
  {$I+}
  if IOResult<>0 then
  Begin
    WriteLn('  뫪.');
    Exit;
  End;
  ReadLn(F1,S1);
  S2:=Copy(S1,6,Length(S1)-5);
  S1:=Copy(Comm,5,Length(Comm)-5);
  Val(S1,P1,Code);
  if Code<>0 then
  Begin
    WriteLn('訡  .');
    Close(F1);
    Exit;
  End;
  Repeat
    ReadLn(F1,S1);
    Val(Copy(S1,1,Pos('.',S1)-1),P2,Code);
    if P2=P1 then Break else P2:=P1+1;
  Until EOF(F1);
  Close(F1);
  if P1=P2 then
  Begin
    if Pos(', ⮬ ',S1)>0 then
    Begin
      S2:=Copy(S1,Pos(', ⮬ ',S1)+6,Length(S1)-Pos(', ⮬ ',S1)-5);
      Delete(S1,Pos(', ⮬ ',S1),Length(S1)-Pos(', ⮬ ',S1)+1);
    End;
    Delete(S1,1,Pos(' ',S1));
    Comm:='TYPE '+S2+':'+S1+' ';
    _Type;
  End else WriteLn('  뫪.');
End;

Procedure Verify;
Var
  F3, F4 : Text;
  K      : Boolean;
  P2     : Integer;
  d1 : String;
Begin
  P2:=0;
  Assign(F3,'INPUT.TXT');
  ReSet(F3);
  Repeat
    ReadLn(F3,S2);
    _Type2;
  Until EOF(F3);
  Close(F3);
  Assign(F3,'TEMP2.TXT');
  ReSet(F3);
  Repeat
    ReadLn(F3,S1);
    S2:=S1;
    Delete(S2,1,Pos(' ',S2));
    S3:=Copy(S2,Pos(':',S2)+1,Length(S2)-Pos(':',S2));
    S2:=Copy(S2,1,Pos(':',S2)-1);
    Assign(F4,S2+'.TXT');
    {$I-}
    ReSet(F4);
    {$I+}
    if IOResult<>0 then
    Begin
      Inc(P2);
      if P2=1 then WriteLn(' 뫪  騥 :');
      S3:=S1;
      Write(P2,'.  ',Copy(S3,1,Pos(' ',S3)),'뫪  ');
      Delete(S3,1,Pos(' ',S1));
      Write(S3);
      WriteLn;
    End else
    Begin
      StrUpCase(S3);
      K:=False;
      Repeat
        ReadLn(F4,d1);
        StrUpCase(d1);
        if Pos(s3,d1)=1 then K:=True;
      Until EOF(F4);
      if not K then
      Begin
        Inc(P2);
        if P2=1 then WriteLn(' 뫪  騥 :');
        S3:=S1;
        Write(P2,'.  ',Copy(S3,1,Pos(' ',S3)),'뫪  ');
        Delete(S3,1,Pos(' ',S1));
        Write(S3);
        WriteLn;
      End;
      Close(F4);
    End;
  Until EOF(F3);
  Close(F3);
  Assign(Fgh,'TEMP2.TXT');
  {$I-}
  Reset(Fgh);
  {$I+}
  if IOResult=0 then
  Begin
    Close(Fgh);
    Erase(Fgh);
  End;
End;

Begin
  Assign(Fgh,'TEMP.TXT');
  {$I-}
  Reset(Fgh);
  {$I+}
  if IOResult=0 then
  Begin
    Close(Fgh);
    Erase(Fgh);
  End;
  ClrScr;
  WriteLn('ਢ!');
  Assign(INP,'INPUT.TXT');
  ReSet(INP);
  ReadLn(INP,Curr);
  Close(INP);
  StrUpCase(Curr);
  Repeat
    WriteLn;
    Write(Curr+'>');
    ReadLn(Comm);
    Comm:=Comm+' ';
    C2:=Copy(Comm,1,Pos(' ',Comm)-1);
    StrUpCase(C2);
    Good:=False;
    For K1:=1 to OK do if Commands[K1]=C2 then
    Begin
      Good:=True;
      Case K1 of
        1: DIR;
        2: VOLUME;
        3: LIST;
        4: _TYPE;
        5: REF;
        6: ClrScr;
        7: Verify;
        8: Goto Ex;
      End;
    End;
    if not Good then WriteLn(' ⠪ .');
  Until 0<>0;
Ex:
  WriteLn(' ᢨ.');
End.
