Program TurboDialog;
  Uses
    Crt;
  Var
    Volums : array[1..255] of record
               Name,UpN : String[8];
               Start : Word;
               Sum : Word;
             end;
    Art : array[0..800] of record
            Name : String[32];
            UpN  : String[32];
            Vol  : Byte;
          end;
    Cross : array[1..255] of Word;
    I,CurV,SumV,SumC : Byte;
    SumA : Word;
    EnableC : Boolean;
    F,F2 : Text;
    S : String;
    NA,NT,NT2,NA2 : String[40];
  Const
    Com : array[1..8] of String[6] = (
          'DIR',
          'VOLUME',
          'LIST',
          'TYPE',
          'REF',
          'CLS',
          'VERIFY',
          'EXIT');

  Function UpCase(C : Char) : Char;
    Begin
      UpCase := C;
      Case C of
       'a'..'z' : UpCase := Char(Byte(C)-Byte('a')+Byte('A'));
       ''..'' : UpCase := Char(Byte(C)-Byte('')+Byte(''));
       ''..'' : UpCase := Char(Byte(C)-Byte('')+Byte(''));
      End;
    End;

  Function FindCom(C : String) : ShortInt;
    Var
      I : Byte;
    Begin
      FindCom := -1;
      For I := 1 to 8 do
        If Com[I]=C then begin
          FindCom := I;
          Break;
        End;
    End;

  Function Get(Var S : String) : String;
    Var
      S1 : String;
    Begin
      while not (S[1] in ['a'..'z','A'..'Z',''..'',''..'',''..'']) and
            (Length(S) > 0) do Delete(S,1,1);
      S1 := '';
      while (S[1] in ['a'..'z','A'..'Z',''..'',''..'',''..'']) and
            (Length(S) > 0) do begin
        S1 := S1+S[1];
        Delete(S,1,1);
      end;
      Get := S1;
    End;

  Function Get2(Var S : String) : String;
    Var
      S1 : String;
    Begin
      while not (S[1] in ['0'..'9']) and (Length(S) > 0) do Delete(S,1,1);
      S1 := '';
      while (S[1] in ['0'..'9']) and (Length(S) > 0) do begin
        S1 := S1+S[1];
        Delete(S,1,1);
      end;
      Get2 := S1;
    End;

  Function CorInp(S : String) : Boolean;
    Var
      I,N : Boolean;
    Begin
      CorInp := False;
      while (S[1]=' ') and (Length(S) > 0) do Delete(S,1,1);
      If S='' then exit;
      while (S[1] in ['a'..'z','A'..'Z',''..'',''..'',''..'']) and
            (Length(S) > 0) do Delete(S,1,1);
      N := False;
      I := False;
      while S<>'' do begin
        Case S[1] of
        '0'..'9' : If I then exit else N := True;
        'a'..'z','A'..'Z',''..'',''..'',''..'' : if N then Exit
                                                            else I := True;
        ':' : begin
                I := True;
                N := False;
              end;
        ' ' :;
        else exit;
        end;
        Delete(S,1,1);
      end;
      CorInp := True;
    End;
  Procedure Dir;
    Var
      I : Byte;
    Begin
      For I := 1 to SumV do
      Writeln(Volums[I].Name);
    End;

  Procedure ChgVol(S : String);
    Var
      I : Byte;
    Begin
      S := Get(S);
      If S='' then begin
        Writeln('४ ࠬ  VOLUME');
        Exit;
      end;
      For I := 1 to SumV do
        If S=Volums[I].UpN then begin
          CurV := I;
          Exit;
        end;
      Writeln('  ');
    End;

  Function FindArt(Tom : Byte;S : String) : Word;
    Var
      I : Word;
    Begin
      FindArt := 0;
      If Tom=0 then exit;
      For I := 1 to Volums[Tom].Sum do
        If S=Art[Volums[Tom].Start+I].UpN then begin
          FindArt := I+Volums[Tom].Start;
          Break;
        End;
    End;

  Function FindTom(S : String) : Byte;
    Var
      I : Word;
    Begin
       FindTom := 0;
       For I := 1 to SumV do
         If S=Volums[I].UpN then begin
           FindTom := I;
           Break;
         end;
    End;

  Procedure List(S : String);
    Var
      Tom : Byte;
      I : Word;
    Begin
      S := Get(S);
      If S='' then Tom := CurV
        else begin
         Tom := FindTom(S);
         If Tom=0 then begin
           Writeln('  ');
           Exit;
         end;
        end;
      If Volums[Tom].Sum=0 then begin
        Writeln(' ⮩');
        Exit;
      end;
      EnableC := True;
      For I := 1 to Volums[Tom].Sum do begin
        Writeln(I:2,'. ',Art[Volums[Tom].Start+I].Name);
        Cross[I] := Volums[Tom].Start+I;
      end;
      SumC := Volums[Tom].Sum;
    End;

  Function FindSM(Var S : String) : Boolean;
    Var
      P,St : Byte;
      S1 : String;
    Begin
      FindSM := False;
      P := Pos('(.',S);
      If P=0 then Exit;
      FindSM := True;
      St := P-1;
      NA := '';
      while not (S[St] in ['a'..'z','A'..'Z',''..'',''..'',''..'']) and
            (Length(S) > 0) do begin
        Delete(S,St,1);
        Dec(St);
      end;
      while (S[St] in ['a'..'z','A'..'Z',''..'',''..'',''..'']) and
            (Length(S) > 0) do begin
        NA := S[St]+NA;
        Dec(St);
      end;
      NA := Get(NA);
      Delete(S,1,Pos('(.',S)+3);
      If S[1]<>')' then NT := Get(S) else NT := '';
    End;

  Procedure OutArt(A : Word);
    Var
      F : Text;
      S : String;
      I : Byte;
      AI : Word;
    Begin
      SumC := 0;
      If Art[A].Vol=0 then begin
        Writeln('  ');
        Exit;
      end;
      Assign(F,Volums[Art[A].Vol].Name+'.TXT');
      Reset(F);
      For I := 1 to A-Volums[Art[A].Vol].Start-1 do Readln(F);
      Readln(F,S);
      Writeln(S);
      Close(F);
      Writeln;
      while FindSM(S) do begin
        Inc(SumC);
        NA2 := NA;
        For I := 1 to Length(NA) do NA[I] := UpCase(NA[I]);
        NT2 := NT;
        For I := 1 to Length(NT) do NT[I] := UpCase(NT[I]);
        If NT='' then AI := FindArt(Art[A].Vol,NA)
                 else AI := FindArt(FindTom(NT),NA);
        If AI=0 then begin
          Inc(SumA);
          Art[SumA].Name := NA;
          If NT='' then Art[SumA].Vol := Art[A].Vol
                   else Art[SumA].Vol := FindTom(NT);;
          NT := '';
          AI := SumA;
        end;
        Cross[SumC] := AI;
{        If Art[AI].Vol <> CurV
          then if NT=''
                 then Writeln(SumC:2,'. ',NA2,', ⮬ ',Volums[Art[AI].Vol].Name)
                 else Writeln(SumC:2,'. ',NA2,', ⮬ ',NT2)
          else Writeln(SumC:2,'. ',NA2);}
         if NT='' then Writeln(SumC:2,'. ',NA2)
                  else Writeln(SumC:2,'. ',NA2,', ⮬ ',NT2)
      end;
      EnableC := True;
    End;

  Procedure TypeText(S : String);
    Var
      Tom : Byte;
      A : Word;
    Begin
      If S='' then begin
        Writeln('४ ࠬ  TYPE');
        Exit;
      end;
      If Pos(':',S) <> 0 then begin
        Tom := FindTom(Get(S));
        If Tom=0 then begin
          Writeln('  ');
          Exit;
        end;
      end else Tom := CurV;
      A := FindArt(Tom,Get(S));
      If A=0 then begin
        Writeln(' ⠪   ⮬ ',Volums[Tom].Name);
        Exit;
      end;
      OutArt(A);
    End;
  Procedure Ref(Cr : String);
    Var
      CI : Word;
      C : Integer;
    Begin
      Val(Get2(Cr),CI,C);
      If C <> 0 then begin
        Writeln('४ ࠬ  REF');
        Exit;
      end;
      If CI > SumC then begin
        Writeln('७  뫪');
        SumC := 0;
        Exit;
      end;
      OutArt(Cross[CI]);
    End;
  Procedure Verify;
    Var
      F : Text;
      I,J,AI,K,Sum : Word;
      Ok : Boolean;
    Begin
      Ok := True;
      Sum := 0;
      For I := 1 to SumV do begin
        Write(' ⮬ ',Volums[I].Name,#13);
        Assign(F,Volums[I].Name+'.TXT');
        Reset(F);
        For J := 1 to Volums[I].Sum do begin
          Readln(F,S);
          while FindSM(S) do begin
            NA2 := NA;
            For K := 1 to Length(NA) do NA[K] := UpCase(NA[K]);
            NT2 := NT;
            For K := 1 to Length(NT) do NT[K] := UpCase(NT[K]);
            If NT='' then AI := FindArt(I,NA)
                     else AI := FindArt(FindTom(NT),NA);
            if (AI=0) or (Art[AI].Vol=0) then begin
              Inc(Sum);
              If Ok then begin
                Ok := False;
                Writeln(' 뫪  騥 :');
              end;
              if NT='' then
                Writeln(Sum:2,'.  ',Volums[I].Name,':',Art[Volums[I].Start+J].Name,
                        ' 뫪  ',Volums[I].Name,':',NA2)
                        else
                Writeln(Sum:2,'.  ',Volums[I].Name,':',Art[Volums[I].Start+J].Name,
                        ' 뫪  ',NT2,':',NA2)
           end;
          end;
        end;
        Close(F);
      end;
      If Ok then Writeln(' 뫪 ४!');
    End;
  Begin
    Assign(F,'INPUT.TXT');
    Reset(F);
    SumV := 0;
    while not EOF(F) do begin
      Inc(SumV);
      Readln(F,Volums[SumV].Name);
      Volums[SumV].Sum := 0;
      Volums[SumV].Start := SumA;
      Assign(F2,Volums[SumV].Name+'.TXT');
      Reset(F2);
      Volums[SumV].UpN := Volums[SumV].Name;
      For I := 1 to Length(Volums[SumV].UpN) do
        Volums[SumV].UpN[I] := UpCase(Volums[SumV].UpN[I]);
      while not EOF(F2) do begin
        Readln(F2,S);
        Inc(Volums[SumV].Sum);
        Inc(SumA);
        Art[SumA].Name := Get(S);
        Art[SumA].UpN := Art[SumA].Name;
        For I := 1 to Length(Art[SumA].UpN) do
          Art[SumA].UpN[I] := UpCase(Art[SumA].UpN[I]);
        Art[SumA].Vol := SumV;
      end;
      Close(F2);
    end;
    Close(F);
    If SumV=0 then begin
      Writeln('  !');
      Writeln('    म');
      Halt;
    end;
    Writeln('  横 ਢ ');
    Writeln;
    CurV := 1;
    Repeat
      Write(Volums[CurV].Name,'>');
      Readln(S);
      For I := 1 to Length(S) do S[I] := UpCase(S[I]);
      if CorInp(S) then
      Case FindCom(Get(S)) of
       -1 : Writeln(' ⠪ ');
        1 : Dir;
        2 : ChgVol(S);
        3 : List(S);
        4 : TypeText(S);
        5 : If not EnableC then Writeln('  ᬮ५       ⮬')
            else Ref(S);
        6 : ClrScr;
        7 : Verify;
        8 : begin
              Writeln('讥 ᯠᨡ,   ᯮ짮');
              Delay(500);
              Halt;
            end;
      End else Writeln('४ ');
      Writeln;
    Until 1>1;
  End.