Program LightIntoNight;
  Type
    TP = array[1..100,0..1] of extended;
  Var
    Ok : Boolean;
    F : Text;
    Pnt :  TP;
    N : Byte;
    Tmp,R,L,I : Byte;
    RP,LP : array[1..100] of Byte;

  Function InRegion(A1,A2,A : extended) : Boolean;
    Var
      Tmp : extended;
    Begin
      If A1 > A2 then begin
        Tmp := A1;
        A1 := A2;
        A2 := Tmp;
      end;
      InRegion := (A1 <= A) and (A <= A2);
    End;
  Function Right(R,L,P : Byte) : Boolean;
    Var
      K,B,Y : extended;
    Begin
      If Pnt[L,0]=Pnt[R,0] then begin
        if Pnt[L,1] < Pnt[R,1]
          then Right := (Pnt[L,0] > Pnt[P,0])
          else Right := (Pnt[L,0] < Pnt[P,0]);
          Ok := InRegion(Pnt[L,1],Pnt[R,1],Pnt[P,1])
        end
        else begin
          K := (Pnt[L,1]-Pnt[R,1])/(Pnt[L,0]-Pnt[R,0]);
          B := Pnt[L,1]-Pnt[L,0]*K;
          Y := Pnt[P,0]*K+B;
          Right := (Pnt[P,1] > Y);
          Ok := InRegion(Pnt[L,0],Pnt[R,0],Pnt[P,0])
        end;
    End;

  Function Connect(R,L : Byte) : extended;
    Var
      Tmp,SumL,SumR,I,J : Byte;
      F : Boolean;
    Label Skip;
    Begin
      If R > L then begin
        Tmp := R;
        R := L;
        L := Tmp;
      end;
      SumL := 0;
      SumR := 0;
      If L-R=1 then Goto Skip;
      For I := R+1 to L-1 do if (not Right(R,L,I)) and Ok then begin
        Inc(SumL);
        LP[SumL] := I;
      end;
      For I := L+1 to N do if Right(R,L,I) and Ok then begin
        Inc(SumR);
        RP[SumR] := I;
      end;
      For I := 1 to R-1 do if Right(R,L,I) and Ok then begin
        Inc(SumR);
        RP[SumR] := I;
      end;
Skip:
      If (SumR=0) and (SumL=0)
       then Connect := Sqrt(Sqr(Pnt[L,0]-Pnt[R,0])+Sqr(Pnt[L,1]-Pnt[R,1]))
       else begin
         if SumL <> 0 then
           For I := SumL downto 1 do begin
             F := True;
             For J := 1 to I-1 do if not Right(R,LP[I],LP[J]) then begin
               F := False;
               Break;
             end;
             If F then Break;
           end
         else
           For I := SumR downto 1 do begin
             F := True;
             For J := 1 to I-1 do if Right(R,RP[I],RP[J]) then begin
               F := False;
               Break;
             end;
             If F then Break;
           end;
        if SumL <> 0 then Connect := Connect(R,LP[I])+Connect(LP[I],L)
                     else Connect := Connect(R,RP[I])+Connect(RP[I],L)
      end;
    End;
  Begin
    Assign(F,'INPUT.TXT');
    Reset(F);
    Readln(F,N);
    For I := 1 to N do
      Readln(F,Pnt[I,0],Pnt[I,1]);
    Readln(F,L,R);
    If R > L then begin
      Tmp := R;
      R := L;
      L := Tmp;
    end;
    Close(F);
    Assign(F,'OUTPUT.TXT');
    Rewrite(F);
    Writeln(F,Connect(R,L));
    Close(F);
  End.