Program Encyclopedia;

Uses Crt,Objects;

Const NonLetters : String=',.:;!@#$%^&*()_+=~`?/><|\*--';

Var Volume:String;
    VolList,Ref:PStringCollection;
    CanRef:Boolean;

Function UpString (S:String):String;
Var i:Byte;
  Res:String;
Begin
  Res:='';
  For i:=1 to Length(S) do Res:=Res+UpCase(S[i]);
  UpString:=Res;
End;

Function ValidVolume (VName:String):String;
Var i:Integer;
Begin
  For i:=0 to VolList^.Count-1 do
  If UpString(PString(VolList^.At(i))^)=UpString(VName) then
  Begin
    ValidVolume:=PString(VolList^.At(i))^;
    Exit;
  End;
  ValidVolume:='';
End;

Function GetNextWord (Var F:File):String;
Var Buf:Char;
    Res:String;
    Result:Word;
Begin
  Res:='';
  Repeat
    BlockRead (F,Buf,1,Result);
    Res:=Res+Buf;
  Until (Result=0) or (Buf=' ') ;
  Delete (Res,Length(Res),1);
  If (Result=0) and (Length(Res)=1) then Res:='';
  GetNextWord:=Res;
End;

Procedure GetAllRefs (Var Col:PStringCollection;VolName:String);
Var F:File;
    PredW,T,Tmp,RefStr:String;
    i:Integer;
    CurRazd:String;
Begin
  Assign (F,VolName+'.txt');
  Reset (F,1);
  T:='a'; PredW:=''; CurRazd:=GetNextWord(F);
  While T<>'' do
  Begin
    T:=GetNextWord(F);
    If Pos('(.',T)<>0 then
    Begin
      Tmp:=Copy(T,Pos('(.',T),Pos(')',T));
      RefStr:=PredW;
      If Length(Tmp)>5 then
      Begin
        RefStr:=Copy(Tmp,Pos('.',Tmp)+1,Length(Tmp))+':'+RefStr;
        Delete (RefStr,Pos('.',RefStr),2);
        Delete (RefStr,Pos(':',RefStr)-1,1);
      End Else RefStr:=VolName+':'+RefStr;
      RefStr:=RefStr+' '+CurRazd;
      Col^.AtInsert (Col^.Count,NewStr(RefStr));
    End;
    If Pos(#10,T)<>0 then CurRazd:=Copy(T,Pos(#10,T)+1,Length(T));
    PredW:=''; i:=Length(T);
    While (Pos(T[i],NonLetters)=0) and (i>0) do
    Begin
      PredW:=T[i]+PredW;
      Dec (i);
    End;
  End;
  Close (F);
End;

Procedure GetVolList (VolName:String;Var Col:PStringCollection);
Var F:File;
  N:Char;
    R:String;
Begin
  Assign (F,VolName+'.txt');
{$I-}
  Reset (F,1);
{$I+}
  If IOResult<>0 then Exit;
  While Not Eof(F) do
  Begin
    R:='';
    Repeat
      BlockRead (F,N,1);
      R:=R+N;
    Until N=' ';
    While N<>#10 do BlockRead (F,N,1);
    Delete (R,Length(R),1);
    Col^.AtInsert (Col^.Count,NewStr(R));
  End;
  Close (F);
End;

Procedure ViewDir;
Var i:Byte;
Begin
  For i:=0 to VolList^.Count-1 do WriteLn (PString(VolList^.At(i))^);
End;

Procedure ChangeVol (NewName:String);
Var T:String;
Begin
  T:=ValidVolume(NewName);
  If T<>'' then Volume:=T Else WriteLn ('  ');
End;

Procedure ListVol (VolName:String);
Var F:File;
    N:Char;
    T:String;
    Num:Integer;
Begin
  If VolName='' then VolName:=Volume;
  T:=ValidVolume(VolName);
  If T='' then
  Begin
    WriteLn ('  ');
    Exit;
  End;
  Assign (F,VolName+'.txt');
  Reset (F,1);
  Num:=1;
  While Not Eof(F) do
  Begin
    Write (Num,'. ');
    Repeat
      BlockRead (F,N,1);
      Write (N);
    Until N=' ';
    While N<>#10 do BlockRead (F,N,1);
    WriteLn;
    Inc (Num);
  End;
  Close (F);
End;

Procedure TypeStory (VolumeName,Story:String);
Var TypeLen:Byte;
    F:File;
    i:Integer;
    T,W,PredW,RefStr,T1:String;
Begin
  T:=ValidVolume(VolumeName);
  If T='' then
  Begin
    WriteLn ('  ');
    Exit;
  End; VolumeName:=T;
  Assign (F,VolumeName+'.txt');
  Reset (F,1);
  T:=GetNextWord(F);
  While UpString(T)<>UpString(Story) do
  Begin
    While Pos(#10,T)=0 do
    Begin
      T:=GetNextWord(F);
      If T='' then
      Begin
        WriteLn ('  ');
        Close (F);
        Exit;
      End;
    End;
    Delete (T,1,Pos(#10,T));
  End;
  If Ref^.Count>0 then Ref^.FreeAll;
  TypeLen:=0; Write (T+' '); Inc (TypeLen,Length(T)+1); RefStr:='';
  While Pos(#10,T)=0 do
  Begin
    T:=GetNextWord (F);
    If RefStr<>'' then
    Begin
      If T[1]=')' then RefStr:=RefStr+', ⮬ '+T
      Else If VolumeName<>Volume then RefStr:=RefStr+', ⮬ '+VolumeName;
      Ref^.AtInsert (Ref^.Count,NewStr(RefStr));
      RefStr:='';
    End;
    If Pos('(.',T)<>0 then RefStr:=PredW;
    If Pos(#10,T)=0 then W:=T Else W:=Copy(T,1,Pos(#10,T)-2);
    Inc (TypeLen,Length(W)+1);
    If TypeLen=81 then
    Begin
      TypeLen:=0;
      Write (W);
    End Else
    If TypeLen<=80 then Write (W+' ') Else
    If TypeLen>81 then
    Begin
      Dec (TypeLen,Length(W)+1);
      For i:=1 to Length(W) do
      If Pos(W[i],NonLetters)<>0 then
      Begin
        T1:=Copy(W,1,i);
        If TypeLen+i=81 then Begin TypeLen:=0; Write (T1); End Else
        If TypeLen<=80 then Begin Write(T1); Inc (TypeLen,Length(T1)); End Else
        If TypeLen>81 then Begin WriteLn; Write (T1+' '); TypeLen:=Length(T1)+1; End;
        Delete (W,1,i);
      End;
      If Length(W)>0 then
      Begin
        If TypeLen+Length(W)<80 then WriteLn;
        Write (W+' ');
        TypeLen:=0;
      End;
    End;
    PredW:=''; i:=Length(T);
    While (Pos(T[i],NonLetters)=0) and (i>0) do
    Begin
      PredW:=T[i]+PredW;
      Dec (i);
    End;
  End;
  Close (F);
    If RefStr<>'' then
    Begin
      Delete (T,Pos(#10,T)-1,Length(T));
      While Pos(T[Length(T)],NonLetters)<>0 do Delete (T,Length(T),1);
      If Pos('(',T)<>0 then Delete (T,1,4);
      If Pos(')',T)<>0 then RefStr:=RefStr+', ⮬ '+Copy(T,1,Length(T)-1)
      Else If VolumeName<>Volume then RefStr:=RefStr+', ⮬ '+VolumeName;
      Ref^.AtInsert (Ref^.Count,NewStr(RefStr));
      RefStr:='';
    End;
  WriteLn;
  For i:=1 to Ref^.Count do
  Begin
    WriteLn (i,'. ',PString(Ref^.At(i-1))^);
    T:=PString(Ref^.At(i-1))^;
    If Pos(', ⮬ ',T)=0 then T:=T+', ⮬ '+Volume;
    Ref^.AtFree (i-1); Ref^.AtInsert (i-1,NewStr(T));
  End;
End;

Procedure ViewRef (Number:Integer);
Var T,VN,St:String;
Begin
  If (Number>Ref^.Count) or (Number<=0) then
  Begin
    WriteLn ('  뫪');
    Exit;
  End;
  T:=PString(Ref^.At(Number-1))^;
  VN:=Copy(T,Pos(', ',T)+6,Length(T)); St:=Copy(T,1,Pos(',',T)-1);
  TypeStory (VN,St);
End;

Procedure Verify;
Label 1;
Var CurRefs,List:PStringCollection;
    i,j,Num,k:Integer;
    T,T1,CurVol,CurRef,Tmp:String;
    CurRazd:String;
Begin
  Num:=0;
  For i:=1 to VolList^.Count do
  Begin
    CurRefs:=New(PStringCollection,Init(10,10));
    CurVol:=PString(VolList^.At(i-1))^;
    GetAllRefs (CurRefs,CurVol);
    For j:=1 to CurRefs^.Count do
    Begin
      T:=PString(CurRefs^.At(j-1))^;
      CurRazd:=Copy(T,Pos(' ',T)+1,Length(T)); Delete (T,Pos(' ',T),Length(T));
      List:=New(PStringCollection,Init(10,10));
      GetVolList (Copy(T,1,Pos(':',T)-1),List);
      For k:=1 to List^.Count do
      Begin
        T1:=PString(List^.At(k-1))^;
        If T1=Copy(T,Pos(':',T)+1,Length(T)) then Goto 1;
      End;
      Inc (Num);
      If Num=1 then WriteLn (' 뫪  騥 :');
      WriteLn (Num,'.  ',PString(VolList^.At(i-1))^,':',CurRazd,' 뫪  ',T);
1:
      Dispose (List,Done);
    End;
    Dispose (CurRefs,Done);
  End;
End;

Procedure Init;
Var T:String;
    F:Text;
Begin
  WriteLn;
  WriteLn ('ਢ !');
  VolList:=New(PStringCollection,Init(10,10));
  Ref:=New(PStringCollection,Init(10,10));
  Assign (F,'input.txt');
  Reset (F);
  While Not Eof(F) do
  Begin
    ReadLn (F,T);
    VolList^.AtInsert(VolList^.Count,NewStr(T));
  End;
  Close (F);
  Volume:=PString(VolList^.At(0))^;
  CanRef:=False;
End;

Procedure Done;
Begin
  WriteLn (' ᢨ.');
  Dispose (VolList,Done);
  Dispose (Ref,Done);
  Halt;
End;

Procedure Run;
Label 1;
Var T:String;
    N,Code:Integer;
Begin
1:
  Write (Volume,'>'); ReadLn (T);
  If UpString(T)='DIR' then ViewDir Else
  If Pos('VOLUME',UpString(T))=1 then ChangeVol(Copy(T,Pos(' ',T)+1,Length(T))) Else
  If UpString(T)='EXIT' then Done Else
  If UpString(T)='CLS' then ClrScr Else
  If Pos('LIST',UpString(T))=1 then
  Begin
    If Length(T)=4 then ListVol ('') Else
    ListVol(Copy(T,Pos(' ',T)+1,Length(T)));
    CanRef:=True;
  End Else
  If Pos('TYPE',UpString(T))=1 then
  Begin
    If Pos(':',T)=0 then TypeStory (Volume,Copy(T,Pos(' ',T)+1,Length(T)))
    Else TypeStory (Copy(T,Pos(' ',T)+1,Pos(':',T)-Pos(' ',T)-1),Copy(T,Pos(':',T)+1,Length(T)));
    CanRef:=True;
  End Else
  If (Pos('REF',UpString(T))=1) then
  Begin
    If Not CanRef then Goto 1;
    Val (Copy(T,5,Length(T)),N,Code);
    If Code<>0 then
    Begin
      WriteLn ('ୠ ');
    End Else ViewRef (N);
  End Else
  If 'VERIFY'=UpString(T) then Verify Else WriteLn ('ୠ ');
  Goto 1;
End;

Begin
  Init;
  Run;
End.
