uses crt;
const
  in_file = 'INPUT.TXT';
  ou_file = 'OUTPUT.TXT';

type
  t_inf  = record s : string[6]; x : integer end;
  t_word = array[1..50] of t_inf;

var
  n,m,i : integer;
  word  : t_word;
  best  : record x : integer; s : string end;
  iwn,zbr   : string;

procedure read_inf;
var
  f : text;
  i,code : integer;
  s : string;
begin
  assign(f,in_file);
  {$I-}
  reset(f);
  if IOResult <> 0
     then begin
       writeln('訡  䠩');
       readln;
       halt;
     end;
  {$I+}

  readln(f,n); readln(f,m);
  for i := 1 to m do begin
    readln(f,s);
    word[i].s := copy(s,1,pos(' ',s)-1);
    delete(s,1,pos(' ',s));
    val(s,word[i].x,code);
  end;

  close(f);
end;

procedure write_inf;
var f : text;
begin
  assign(f,ou_file);
  rewrite(f);
  writeln(f,best.x);
  writeln(f,best.s);
  close(f);
end;

function get_straf(zbr : string) : integer;
var i : integer;
    sh : integer;
    s : string;
begin
  sh := 0;
  for i := 1 to m do begin
    s := zbr;
    while (pos(word[i].s,zbr) <> 0) and
          (pos(word[i].s,zbr) <= length(s)) do begin
      inc(sh,word[i].x);
      zbr[pos(word[i].s,zbr)] := ' ';
    end;
    zbr := s;
  end;
  get_straf := sh;
end;


procedure form_zbr(zbr : string; cena : integer);
var
  let_cena : array[1..3] of integer;
  i,min : integer;
  s,iwn : string;
begin
  if length(zbr) = n
     then begin
       if cena < best.x
          then begin
            best.x := get_straf(zbr);
            best.s := zbr;
          end;
       exit;
     end;

  iwn := 'IWN';
  for i := 1 to 3 do begin
    s := zbr;
    insert(iwn[i],s,length(s)+1);
    let_cena[i] := get_straf(s);
  end;

  min := maxint;
  for i := 1 to 3 do
    if let_cena[i] < min
       then min := let_cena[i];

  for i := 1 to 3 do begin
    if let_cena[i] = min
       then begin
         s := zbr;
         insert(iwn[i],s,length(s)+1);
         form_zbr(s,let_cena[i]);
       end;
  end;
end;

begin
  read_inf;
  best.x := maxint;
{  form_zbr('',0);}


  iwn := 'IWN';
  for i := 1 to 3 do begin
   insert(iwn[i],zbr,length(zbr)+1);
   form_zbr(zbr,0);
   zbr := '';
  end;

  write_inf;
end.
