{$A+,B-,D-,E+,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 56384,0,655360}
(*{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 56384,0,655360}*)
uses crt;
type
  tvol=string[8];
  tref=record
   name:string[32];
   vol:string[8];
  end;
  tlet=string[32];

  _plet=^_tlet;
  _tlet=array[1..1000]of tlet;
  _pref=^_tref;
  _tref=array[1..1000]of tref;
  _pvol=^_tvol;
  _tvol=array[1..1000]of tvol;
var
  _let,_ref,curvol,_vol:integer;
  volumes:_pvol;
  refs:_pref;
  lets:_plet;
function volume(par:string):boolean;forward;

function lowcase(ch:char):char;
begin
  if ch in ['A'..'Z'] then
    ch:=chr(ord(ch)-ord('A')+ord('a'));
  if ch in [''..''] then
    ch:=chr(ord(ch)-ord('')+ord(''));
  if ch in [''..''] then
    ch:=chr(ord(ch)-ord('')+ord(''));
  lowcase:=ch;
end;

procedure readdata;
var
  f:text;
  i:integer;
begin
  volumes:=new(_pvol);
  lets:=new(_plet);
  refs:=new(_pref);


  assign(f,'input.txt');
  reset(f);
  _vol:=0;
  while not seekeof(f) do
   begin
    inc(_vol);
    readln(f,volumes^[_vol]);
  for i:=1 to length(volumes^[_vol]) do
    volumes^[_vol][i]:=lowcase(volumes^[_vol][i]);
   end;
  close(f);
  volume(volumes^[1]);
end;


function readcommand:string;
var
  st:string;
  i:integer;
begin
  writeln;
  write(volumes^[curvol],'>');
  readln(st);
  for i:=1 to length(st) do
   begin
    if st[i]=' ' then break;
    st[i]:=lowcase(st[i]);
   end;

  readcommand:=st;
end;

procedure readref(numb:integer);
var
 f:text;
 st:string[40];
 ch:char;
 vol:string;
 let:string;
 i:integer;
 fl:boolean;
begin
  assign(f,volumes^[curvol]+'.txt');
  reset(f);
  st:='';
  _ref:=0;
  for i:=1 to numb-1 do
    readln(f,ch);
  while not eoln(f) do
    begin
      read(f,ch);
{      ch:=lowcase(ch);}
      if length(st)>39 then
       st:=copy(st,2,39)+ch
      else
        st:=st+ch;
      if (copy(st,length(st)-3,4)='(.') then
        begin
          read(f,ch);
          ch:=lowcase(ch);
          vol:='';
          while ch<>')' do
            begin
              vol:=vol+ch;
              read(f,ch);
              ch:=lowcase(ch);
            end;
          let:='';
          for I:=length(st)-5 downto 1 do
            if st[i]in ['a'..'z',''..''] then
              let:=st[i]+let
            else
              break;
          if vol=volumes^[curvol] then
            vol:='';
          fl:=false;
          for i:=1 to _ref do
            if (refs^[_ref].name=let)and(refs^[_ref].vol=vol) then
              begin
                fl:=true;
                break;
              end;
          if not fl then
           begin
          inc(_ref);
          refs^[_ref].name:=let;
          refs^[_ref].vol:=vol;
           end;
        end;
    end;
  close(f);


end;

procedure _type(par:integer);
var
  wrd:string;
  f:text;
  i:integer;
  ch:char;
begin
  assign(f,volumes^[curvol]+'.txt');
  reset(f);
  for i:=1 to par-1 do
     readln(f);
  wrd:='';
  while not eoln(f) do
   begin
    read(f,ch);
    if ch=' ' then
     begin
      if wherex=1 then
        begin
         for I:=1 to length(wrd) do
           begin
             if wrd[i]<>' ' then
              begin
                dec(i);
                break;
              end;
           end;
         wrd:=copy(wrd,i+1,length(wrd)-i);
         write(wrd);
         wrd:=ch;
        end
      else

      if wherex+length(wrd)<=81 then
        write(wrd)
      else
        begin
         writeln;
         for I:=1 to length(wrd) do
           begin
             if wrd[i]<>' ' then
              begin
                dec(i);
                break;
              end;
           end;
         wrd:=copy(wrd,i+1,length(wrd)-i);
         write(wrd);
        end;
        wrd:=ch;
      end
     else wrd:=wrd+ch;
   end;
      if wherex=1 then
        begin
         for I:=1 to length(wrd) do
           begin
             if wrd[i]<>' ' then
              begin
                dec(i);
                break;
              end;
           end;
         wrd:=copy(wrd,i+1,length(wrd)-i);
         write(wrd);
         wrd:=ch;
        end
      else
      if wherex+length(wrd)<=81 then
        write(wrd)
      else
        begin
         writeln;
         for I:=1 to length(wrd) do
           begin
             if wrd[i]<>' ' then
              begin
                dec(i);
                break;
              end;
           end;
         wrd:=copy(wrd,i+1,length(wrd)-i);
         write(wrd);
        end;
  if wherex<>1 then writeln;

end;


procedure readlet;
var
  f:text;
  st:string[40];
  i:integer;
begin
  assign(f,volumes^[curvol]+'.txt');
  reset(f);
  _let:=0;
  while not seekeof(f) do
    begin
      readln(f,st);
{      for i:=1 to length(st) do
        st[i]:=lowcase(st[i]);}
      inc(_let);
      lets^[_let]:=copy(st,1,pos(' ',st)-1);
    end;
  close(f);
end;

function volume(par:string):boolean;
var
  i:integer;
  flag:boolean;
begin
  flag:=false;
  for i:=1 to length(par) do
    par[i]:=lowcase(par[i]);

  for i:=1 to _vol do
     if volumes^[i]=par then
      begin
       curvol:=i;
       flag:=true;
       break;
      end;
  volume:=true;
  if not flag then
   begin
    writeln('  ');
    volume:=false;
   end
  else
   begin
     readlet;
    { readref(1);}
   end;
end;

function volume2(par:string):boolean;
var
  i:integer;
  flag:boolean;
begin
  flag:=false;
  for i:=1 to length(par) do
    par[i]:=lowcase(par[i]);

  for i:=1 to _vol do
     if volumes^[i]=par then
      begin
       curvol:=i;
       flag:=true;
       break;
      end;
  volume2:=true;
  if not flag then
   begin
{    writeln('  ');}
    volume2:=false;
   end
  else
   begin
     readlet;
    { readref(1);}
   end;
end;

procedure list(par:string);
var
  oldvol:integer;
  i:integer;
begin

 if par<>'' then
  begin
    oldvol:=curvol;
    if not volume(par) then exit;
  end;
  for i:=1 to _let do
    writeln(i,'. ',lets^[i]);

  _ref:=_let;
  for i:=1 to _ref do
   begin
    refs^[i].name:=lets^[i];
    refs^[i].vol:=volumes^[curvol];
   end;

 if par<>'' then
  begin
    volume(volumes^[oldvol]);
  end;

end;

procedure ref(i:integer);
begin
  readref(i);
  writeln;
  for i:=1 to _ref do
   begin
    write(i,'. ',refs^[i].name);
    if refs^[i].vol<>'' then
      writeln(', ⮬ ',refs^[i].vol)
    else
     begin
      writeln;
      refs^[i].vol:=volumes^[curvol];
     end;
   end;
end;

procedure typeext(par:string);
var
  oldvol,i:integer;
  vol:string;
  let:string;
  fl:boolean;
begin
  if pos(':',par)<>0 then
   begin
    vol:=copy(par,1,pos(':',par)-1);
    let:=copy(par,pos(':',par)+1,length(par));
   end
  else
   begin
    let:=par;
    vol:='';
   end;
 if vol<>'' then
  begin
    oldvol:=curvol;
    if not volume(vol) then exit;
  end;
{  for i:=1 to _let do
    writeln(i,'. ',lets^[i]);}
 fl:=false;
 for i:=1 to _let do
   if lets^[i]=let then
    begin
     fl:=true;
     _type(i);
     ref(i);
     break;
    end;
 if not fl then
   writeln('  ');
 if vol<>'' then
  begin
    volume(volumes^[oldvol]);
  end;

end;

procedure refext(par:string);
var
  i:integer;
  code:integer;
begin
  val(par,i,code);
  if (code<>0)or(i<1)or(i>_ref) then
    begin
      writeln('  뫪');
      _ref:=0;
      exit;
    end;
  typeext(refs^[i].vol+':'+refs^[i].name);
end;

procedure dir;
var
 i:integer;
begin
  for i:=1 to _vol do
    writeln(volumes^[i]);
end;

var
  errvol,errlet:string;
  err:integer;

procedure printerr(i:integer);
begin
  if err=0 then
    writeln(' 뫪  騥 :');
  inc(err);
  if refs^[i].vol<>'' then
    writeln(err,'.  ',errvol,':',errlet,' 뫪  ',refs^[i].vol,':',refs^[i].name)
  else
    writeln(err,'.  ',errvol,':',errlet,' 뫪  ',volumes^[curvol],':',refs^[i].name)



end;

procedure checkref(i:integer);
var
  oldvol:integer;
  fl:boolean;
  j:integer;
begin
  if refs^[i].vol<>'' then
    begin
     oldvol:=curvol;

     if not volume2(refs^[i].vol) then
      begin
       printerr(i);
       exit;
      end;
    end;
  fl:=false;
  for j:=1 to _let do
    begin
      if lets^[j]=refs^[i].name then
       begin
         fl:=true;
         break;
       end;
    end;
  if not fl then
    printerr(i);
  if refs^[i].vol<>'' then
    begin
      volume(volumes^[oldvol]);
    end;
end;

procedure verify;
var
  oldvol,i,j,k:integer;
begin
  err:=0;
  oldvol:=curvol;
  for i:=1 to _vol do
   begin
     volume(volumes^[i]);
     errvol:=volumes^[i];
     for j:=1 to _let do
      begin
       errlet:=lets^[j];
       readref(j);
       for k:=1 to _ref do
         checkref(k);
      end;
   end;

  volume(volumes^[oldvol]);
end;

procedure solve;
var
  gameover:boolean;
  st:string;
begin
{  writeln;}
  writeln('ਢ!');
  gameover:=false;
  _ref:=0;

  repeat
    st:=readcommand;
    if copy(st+' ',1,4)='ref ' then
      refext(copy(st,5,length(st)-4))
    else
   begin
    _ref:=0;
    if copy(st+' ',1,5)='exit ' then
     gameover:=true
    else
    if copy(st+' ',1,7)='volume ' then
      volume(copy(st,8,length(st)-7))
    else
    if copy(st+' ',1,4)='cls ' then
      clrscr
    else
    if copy(st+' ',1,4)='dir ' then
      dir
    else
    if copy(st+' ',1,7)='verify ' then
      verify
    else
    if copy(st+' ',1,5)='list ' then
      list(copy(st,6,length(st)-5))
    else
    if copy(st+' ',1,5)='type ' then
      typeext(copy(st,6,length(st)-5))
    else
     writeln(' ⠪ ');
   end;
  until gameover;
  writeln(' ᢨ.');
end;

procedure printdata;
var
  f:text;
begin
  assign(f,'output.txt');
  rewrite(f);
  close(f);
end;

begin
  readdata;
  solve;
{  printdata;}

end.
