(*{$A+,B-,D-,E+,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 36384,0,655360}*)
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 36384,0,655360}
type
  tpoint=record
    x,y:real;
  end;
var
  xx:array[1..105] of tpoint;
  _n,_k,_l:integer;
  answer:real;
  length:array[1..105]of real;
procedure readdata;
var
  f:text;
  i:integer;
begin
  assign(f,'input.txt');
  reset(f);
  read(f,_n);
  for i:=1 to _n do
    readln(f,xx[i].x,xx[i].y);
  xx[_n+1]:=xx[1];
  readln(f,_k,_l);
  close(f);
end;

function _2line(a1,a2,a3,a4:tpoint):boolean;
var
  gr,dx2,dx1,dy1,dy2,tmp:real;
begin
  dx2:=a4.x-a3.x;
  dx1:=a2.x-a1.x;
  dy2:=a4.y-a3.y;
  dy1:=a2.y-a1.y;
  gr:=dx1*dy2-dy1*dx2;
  if gr<>0 then
   begin
      _2line:=true;
    tmp:=(dx2*(a1.y-a3.y)+(a3.x-a1.x)*dy2)/gr;
    if  (tmp<=0) or(tmp>=1) then
      _2line:=false;
    tmp:=(dx1*(a1.y-a3.y)+(a3.x-a1.x)*dy1)/gr;
    if  (tmp<=0) or(tmp>=1) then
      _2line:=false;
   end
  else
    _2line:=false;
end;

function in_fig(a:tpoint):boolean;
var
  s:boolean;
  I:integer;
  c,d:real;
begin
  s:=false;
  for i:=1 to _n do
    begin
      c:=a.x-xx[i].x;
      if c<0 then
       begin
         c:=-c;
         d:=a.x-xx[i+1].x;
       end
      else
        d:=xx[i+1].x-a.x;
      if d>0 then
        begin
          if (xx[i].y-a.y)*d+(xx[i+1].y-a.y)*c>0 then
            s:=not s;
        end;

    end;
  in_fig:=s;
end;

function p(a,b:tpoint):real;
begin
  p:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;


var
  flag:boolean;
  b:tpoint;

procedure rec;
var
  tmpans,ans:real;
  i,j:integer;
begin
 for j:=_k+1 to _l do
 begin
  flag:=true;
  for i:=1 to _n do
   begin
     if (_k=i)or(j=i)or(_k=i+1)or(j=i+1) then continue;
     if _2line(xx[_k],xx[j],xx[i],xx[i+1]) then
       begin
         flag:=false;
         break;
       end;
   end;

  if flag then
   begin
    b.x:=(xx[_k].x+xx[j].x)/2;
    b.y:=(xx[_k].y+xx[j].y)/2;
    if in_fig(b) then
        length[j]:=p(xx[_k],xx[j])
      else
        flag:=false;
   end;
end;


  if not flag then
   begin
    answer:=1e33;
for i:=_k+1 to j-1 do
  begin
       tmpans:=length[i];
  flag:=true;
  for i:=1 to _n do
   begin
     if (_k=i)or(j=i)or(_k=i+1)or(j=i+1) then continue;
     if _2line(xx[_k],xx[j],xx[i],xx[i+1]) then
       begin
         flag:=false;
         break;
       end;
   end;

  if flag then
   begin
    b.x:=(xx[_k].x+xx[j].x)/2;
    b.y:=(xx[_k].y+xx[j].y)/2;
    if in_fig(b) then
        tmpans:=tmpans+p(xx[_k],xx[j])
      else
        flag:=false;
   end;
  if not flag then
       if tmpans<ans then ans:=tmpans;
  end;
end;
end;



procedure solve;
var
 flag:boolean;
 i:integer;
 b:tpoint;
 tmpans:real;
begin
  flag:=true;
  for i:=1 to _n do
   begin
     if (_k=i)or(_l=i)or(_k=i+1)or(_l=i+1) then continue;
     if _2line(xx[_k],xx[_l],xx[i],xx[i+1]) then
       begin
         flag:=false;
         break;
       end;
   end;

  if flag then
   begin
    b.x:=(xx[_k].x+xx[_l].x)/2;
    b.y:=(xx[_k].y+xx[_l].y)/2;
    if in_fig(b) then
        answer:=p(xx[_k],xx[_l])
      else
        flag:=false;
   end;
  if not flag then
   begin
{    answer:=rec(_k,_l,true);
    tmpans:=rec(_k,_l,false);
    if tmpans<answer then answer:=tmpans;}

    for i:=_k to _l-1 do
      tmpans:=tmpans+p(xx[i],xx[i+1]);
    answer:=tmpans;
    tmpans:=0;
    for i:=1 to _k-1 do
      tmpans:=tmpans+p(xx[i],xx[i+1]);
    for i:=_l to _n do
      tmpans:=tmpans+p(xx[i],xx[i+1]);
   end;
end;

procedure printdata;
var
  f:text;
begin
  assign(f,'output.txt');
  rewrite(f);
  write(f,answer:0);
  close(f);
end;

begin
  readdata;
  solve;
  printdata;

end.
