{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
program fontan;

var
 n:integer;
 x,y:array[0..101] of real;
 i,j,k,l:integer;

function len(x1,y1,x2,y2:real):real;
begin
 len:=sqrt(sqr(x2-x1)+sqr(y2-y1))
end;

function det(x11,x12,x21,x22:real):real;
begin
 det:=x11*x22-x21*x12
end;

function sign(x:real):integer;
begin
 if x>0 then sign:=1
 else
 if x<0 then sign:=-1
 else
 sign:=0
end;

function IfInter(x11,y11,x12,y12,x21,y21,x22,y22:real):boolean;
begin
 IfInter:=( sign(det(x21-x11,y21-y11,x12-x11,y12-y11))<>
	    sign(det(x22-x11,y22-y11,x12-x11,y12-y11))) and
	  ( sign(det(x11-x21,y11-y21,x22-x21,y22-y21))<>
	    sign(det(x12-x21,y12-y21,x22-x21,y22-y21)))
end;

function cable(k,l:integer):real;
var
 i:integer;
begin
 if k>n then k:=k-n;
 if k<1 then k:=k+n;
 if l>n then l:=l-n;
 if l<1 then l:=l+n;
 if k=l then
  begin
   cable:=0;
   exit
  end;
 if k>l then
  begin
   i:=k;
   k:=l;
   l:=i
  end;
 if (k+1=l) or ( (k=1) and (l=n) ) then
  begin
   cable:=len(x[k],y[k],x[l],y[l]);
   exit
  end;
 if det( (x[k-1]-x[k])/len(x[k],y[k],x[k-1],y[k-1]) - (x[l]-x[k])/len(x[k],y[k],x[l],y[l]),
	 (y[k-1]-y[k])/len(x[k],y[k],x[k-1],y[k-1]) - (y[l]-y[k])/len(x[k],y[k],x[l],y[l]),
	 (x[k+1]-x[k])/len(x[k],y[k],x[k+1],y[k+1]) - (x[l]-x[k])/len(x[k],y[k],x[l],y[l]),
	 (y[k+1]-y[k])/len(x[k],y[k],x[k+1],y[k+1]) - (y[l]-y[k])/len(x[k],y[k],x[l],y[l]) )<=0
  then exit;
 for i:=k+1 to l-2 do
  if IfInter(x[k],y[k],x[l],y[l],x[i],y[i],x[i+1],y[i+1]) then
   begin
    cable:=cable(k,i+1)+cable(i+1,l);
    exit
   end;
 for i:=k-1 downto 2 do
  if IfInter(x[k],y[k],x[l],y[l],x[i],y[i],x[i-1],y[i-1]) then
   begin
    cable:=cable(k,i-1)+cable(i-1,l);
    exit
   end;
 if l<>n then
  if IfInter(x[k],y[k],x[l],y[l],x[1],y[1],x[n],y[n]) then
   begin
    cable:=cable(k,n)+cable(n,l);
    exit
   end;
 for i:=n downto l+2 do
  if IfInter(x[k],y[k],x[l],y[l],x[i],y[i],x[i-1],y[i-1]) then
   begin
    cable:=cable(k,i-1)+cable(i-1,l);
    exit
   end;
 cable:=len(x[k],y[k],x[l],y[l])
end;

begin
 assign(input,'input.txt');
 assign(output,'output.txt');
 reset(input);
 rewrite(output);
 readln(n);
 for i:=1 to n do
  readln(x[i],y[i]);
 read(k,l);
 x[n+1]:=x[1];
 y[n+1]:=y[1];
 x[0]:=x[n];
 y[0]:=y[n];
 write(cable(k,l))
end.