Program Task1;

 Uses
      Crt, DOS;

 Type
      TPntr = Record
         Volume,
         Topic : String;
       End;
      TPntArr = Array [0..126] Of TPntr;

 Const
      Mark : String = '(.';

 Var
      Command  : String;
      Parametr : String;
      CurVol   : String;
      MaxPnt   : Byte;
      PMas     : ^TPntArr;
      Error    : Byte;

 Function ToInt (S : String) : Byte;
  Var
       I, J : Integer;
  Begin
    If (S = '') Then
     Begin
       WriteLn ('ଠ : REF<஡><_뫪>');
       Exit;
     End;
    Val (S, I, J);
    If ((J <> 0) Or (I > MaxPnt) Or (I < 1)) Then
     Begin
       WriteLn ('  뫪');
       I := 255;
     End;
    ToInt := I;
  End;

 Function ToUpCase (S : String) : String;
  Var
       S1 : String;
       I  : Byte;
  Begin
    S1 := S;
    For I := 1 To Length (S1) Do S1 [I] := UpCase (S1 [I]);
    ToUpCase := S1;
  End;

 Procedure ReadCommand;
  Var
       S : String;
       I : Byte;
  Begin
    WriteLn;
    Write (ToUpCase (CurVol) + '>');
    ReadLn (S);
    I := 1;
    Command := '';
    Parametr := '';
    While ((I <= Length (S)) And (S [I] <> ' ')) Do
     Begin
       Command := Command + S [I];
       Inc (I);
     End;
    While ((I <= Length (S)) And (S [I] = ' ')) Do Inc (I);
    While (I <= Length (S)) Do
     Begin
       Parametr := Parametr + S [I];
       Inc (I);
     End;
    Command := ToUpCase (Command);
  End;

 Procedure WriteDir;
  Var
       F : Text;
       S : String;
  Begin
    Assign (F, 'INPUT.TXT');
    ReSet (F);
    While (Not (SeekEOF (F))) Do
     Begin
       ReadLn (F, S);
       WriteLn (ToUpCase (S));
     End;
    Close (F);
  End;

 Procedure ChangeVolume (Vol : String);
  Var
       F : Text;
       S : String;
       B : Boolean;
  Begin
    If (Vol = '') Then
     Begin
       WriteLn ('ଠ : VOLUME<஡><_⮬>');
       Exit;
     End;
    Assign (F, 'INPUT.TXT');
    ReSet (F);
    B := FALSE;
    While (Not (SeekEOF (F))) Do
     Begin
       ReadLn (F, S);
       If (ToUpCase (S) = ToUpCase (Vol)) Then
        Begin
          B := TRUE;
          Break;
        End;
     End;
    Close (F);
    If (B) Then CurVol := ToUpCase (Vol) Else
     Begin
       WriteLn ('  ');
       Error := 1;
     End;
  End;

 Procedure Done;
  Begin
    Dispose (PMas);
  End;

 Procedure Init;
  Var
       F : Text;
       I : Byte;
  Begin
    Assign (F, 'INPUT.TXT');
    ReSet (F);
    ReadLn (F, CurVol);
    Close (F);
    New (PMas);
    For I := 0 To 126 Do
     Begin
       PMas^ [I].Volume := '';
       PMas^ [I].Topic := '';
     End;
    MaxPnt := 0;
  End;


 Procedure WriteTopic (Name : String);
  Var
       Temp : String;
       Vol  : String;
       Top  : String;
       S    : String;
       F    : Text;
       I, J : Byte;
       Ch   : Char;
       B    : Boolean;

  Procedure FindTopic (TopName : String);
   Var
        I    : Byte;
        Name : String;
        Ch   : Char;
   Begin
     While (Not (SeekEOF (F))) Do
      Begin
        I := 1; Name := ''; Read (F, Ch);
        While ((I <= 32) And (Ch <> ' ')) Do
         Begin
           Name := Name + Ch;
           Read (F, Ch);
           Inc (I);
         End;
        If (I > 32) Then
         Begin
           WriteLn ('ୠ  ⮬. ணࠬ ⠭.');
           Halt;
         End;
        If (TopName = Name) Then Exit;
        ReadLn (F);
      End;
     WriteLn ('  ');
     Error := 2;
   End;
  Begin
    If (Name = '') Then
     Begin
       WriteLn ('ଠ : TYPE<஡>[<_⮬>":"]<_>');
       Exit;
     End;
    Temp := CurVol;
    Vol [1] := #255;
    Top := '';
    For I := 1 To Length (Name) Do If (Name [I] = ':') Then
     Begin
       Vol := Top; Top := '';
     End Else Top := Top + Name [I];
    If (Vol [1] <> #255) Then ChangeVolume (Vol);
    If (Error <> 0) Then Exit;
    Assign (F, CurVol + '.TXT');
    ReSet (F);
    FindTopic (Top);
    If (Error <> 0) Then
     Begin
       Close (F);
       CurVol := Temp;
       Exit;
     End;
    Write (Top + ' ');
    Vol := ''; Top := ''; I := 0; S := '';
    MaxPnt := 0; B := FALSE;
    While (Not (EOLN (F))) Do
     Begin
       Read (F, Ch);
       Write (Ch);
       Vol := Vol + Ch;
       S := S + Ch;

       If (Length (S) > 6) Then
        Begin
          I := Length (S);
          If (Not ((S [I - 6] In ['A'..'z']) Or (S [I - 6] In [''..'']) Or
                   (S [I - 6] In [''..'']))) Then Top := '' Else
           Top := Top + S [I - 6];
          For I := 2 To Length (S) Do S [I - 1] := S [I];
          Dec (S [0]);
        End;

       For J := 1 To Length (Vol) Do If (Vol [J] <> Mark [J]) Then
        Begin
          Vol := ''; Break;
        End;

       If ((B) And (Ch = ')')) Then
        Begin
          Inc (MaxPnt);
          PMas^ [MaxPnt].Volume := CurVol;
          PMas^ [MaxPnt].Topic := Top;
          B := FALSE;
        End Else
       If (B) Then
        Begin
          Vol := Ch;
          While (Ch <> ')') Do
           Begin
             Read (F, Ch);
             Vol :=  Vol + Ch;
             Write (Ch);
           End;
          Dec (Vol [0]);
          Inc (MaxPnt);
          PMas^ [MaxPnt].Volume := Vol;
          PMas^ [MaxPnt].Topic := '';
          PMas^ [MaxPnt].Topic := Top;
          Vol := ''; Top := '';
          B := FALSE;
        End;

       If (Vol = Mark) Then B := TRUE;

     End;
    WriteLn;
    For I := 1 To MaxPnt Do
     If (ToUpCase (PMas^ [I].Volume) <> ToUpCase (CurVol)) Then
      WriteLn (I, '. ', PMas^ [I].Topic, ', ⮬ ', ToUpCase (PMas^ [I].Volume)) Else
      WriteLn (I, '. ', PMas^ [I].Topic);
    Close (F);
    CurVol := Temp;
  End;

 Procedure WritePoints (Vol : String);
  Var
       Temp : String;
       F    : Text;
       Name : String;
       I    : Byte;
       Ch   : Char;
  Begin
    Temp := CurVol;
    MaxPnt :=  0;
    If (Vol <> '') Then ChangeVolume (Vol);
    If (Error <> 0) Then Exit;
    Assign (F, CurVol + '.TXT');
    ReSet (F);
    While (Not (SeekEOF (F))) Do
     Begin
       I := 1; Name := ''; Read (F, Ch);
       While ((I <= 32) And (Ch <> ' ')) Do
        Begin
          Name := Name + Ch;
          Read (F, Ch);
          Inc (I);
        End;
       If (I > 32) Then
        Begin
          WriteLn ('ୠ  ⮬. ணࠬ ⠭.');
          Halt;
        End;
       ReadLn (F);
       Inc (MaxPnt);
       PMas^ [MaxPnt].Volume := CurVol;
       PMas^ [MaxPnt].Topic := Name;
     End;
    Close (F);
    For I := 1 To MaxPnt Do WriteLn (I, '. ', PMas^ [I].Topic);
    CurVol := Temp;
  End;
 Procedure WritePoint (I : Byte);
  Begin
    If (I = 255) Then
     Begin
       MaxPnt := 0;
       Exit;
     End;
    WriteTopic (PMas^ [I].Volume + ':' + PMas^ [I].Topic);
    If (Error <> 0) Then MaxPnt := 0;
  End;

 Procedure Verify;
  Var
      F, Fext,
      SourceF : Text;
      Name    : String;
      CurTop  : String;
      Temp    : String;
      Vol, Top,
      S       : String;
      I, J    : Byte;
      Num     : Word;
      B       : Boolean;
      Ch      : Char;

  Function FindTopic (VolName, TopName : String) : Boolean;
   Var
        F    : Text;
        I    : Byte;
        Nam  : String;
        Ch   : Char;
   Begin
     Assign (F, VolName + '.TXT');
     If (IOResult <> 0) Then
      Begin
        FindTopic := FALSE;
        Exit;
      End;
     ReSet (F);
     If (IOResult <> 0) Then
      Begin
        FindTopic := FALSE;
        Exit;
      End;
     While (Not (SeekEOF (F))) Do
      Begin
        I := 1; Nam := ''; Read (F, Ch);
        While ((I <= 32) And (Ch <> ' ')) Do
         Begin
           Nam := Nam + Ch;
           Read (F, Ch);
           Inc (I);
         End;
        If (I > 32) Then
         Begin
           WriteLn ('ୠ  ⮬. ணࠬ ⠭.');
           Halt;
         End;
        If (TopName = Nam) Then
         Begin
           FindTopic := TRUE;
           Close (F);
           Exit;
         End;
        ReadLn (F);
      End;
     Close (F);
     FindTopic := FALSE;
   End;

  Begin
    Temp := CurVol;
    Assign (SourceF, 'INPUT.TXT');
    ReSet (SourceF); Num := 0;
    While (Not (SeekEOF (SourceF))) Do
     Begin
       ReadLn (SourceF, Name);

       Assign (F, Name + '.TXT');
       ReSet (F);

       While (Not (EOF (F))) Do
        Begin
          Vol := ''; Top := ''; I := 0; S := '';
          MaxPnt := 0; B := FALSE; CurTop := '';
          Ch := #255;
          While ((Ch <> ' ') And (Not (EOF (F)))) Do
           Begin
             Read (F, Ch);
             CurTop := CurTop + Ch;
           End;
          Dec (CurTop [0]);
          While (Not (EOLN (F))) Do
           Begin
             Read (F, Ch);
             Vol := Vol + Ch;
             S := S + Ch;
             If (Length (S) > 6) Then
              Begin
                I := Length (S);
                If (Not ((S [I - 6] In ['A'..'z']) Or (S [I - 6] In [''..'']) Or
                         (S [I - 6] In [''..'']))) Then Top := '' Else
                 Top := Top + S [I - 6];
                For I := 2 To Length (S) Do S [I - 1] := S [I];
                Dec (S [0]);
              End;
             For J := 1 To Length (Vol) Do If (Vol [J] <> Mark [J]) Then
              Begin
                Vol := ''; Break;
              End;
             If ((B) And (Ch = ')')) Then
              Begin
                Inc (MaxPnt);
                PMas^ [MaxPnt].Volume := Name;
                PMas^ [MaxPnt].Topic := Top;
                B := FALSE;
              End Else
             If (B) Then
              Begin
                Vol := Ch;
                While (Ch <> ')') Do
                 Begin
                   Read (F, Ch);
                   Vol :=  Vol + Ch;
                 End;
                Dec (Vol [0]);
                Inc (MaxPnt);
                PMas^ [MaxPnt].Volume := Vol;
                PMas^ [MaxPnt].Topic := '';
                PMas^ [MaxPnt].Topic := Top;
                Vol := ''; Top := '';
                B := FALSE;
              End;
             If (Vol = Mark) Then B := TRUE;
           End;

          For I := 1 To MaxPnt Do
           Begin
             If (Not (FindTopic (PMas^ [I].Volume, PMas^ [I].Topic))) Then
              Begin
                Inc (Num);
                If (Num = 1) Then WriteLn (' 뫪  騥 :');
                WriteLn (Num, '.  ', ToUpCase (Name), ':', CurTop, '  ',
                         ToUpCase (PMas^ [I].Volume), ':', PMas^ [I].Topic);
              End;
           End;
          ReadLn (F);
        End;
       Close (F);
     End;
    Close (SourceF);
    If (Num = 0) Then WriteLn ('뫪   ⮬ 横 ४.');
    CurVol := Temp;
  End;

Begin
  Init;
  WriteLn;
  WriteLn ('ਢ!');
  Repeat
    ReadCommand;
    Error := 0;
    If (Command = '') Then Continue Else
    If (Command = 'DIR') Then WriteDir Else
    If (Command = 'VOLUME') Then ChangeVolume (Parametr) Else
    If (Command = 'LIST') Then WritePoints (Parametr) Else
    If (Command = 'TYPE') Then WriteTopic (Parametr) Else
    If (Command = 'REF') Then WritePoint (ToInt (Parametr)) Else
    If (Command = 'CLS') Then ClrScr Else
    If (Command = 'VERIFY') Then Verify Else
    If (Command = 'EXIT') Then Done Else WriteLn (' ⠪ ');
  Until (Command = 'EXIT');
  WriteLn (' ᢨ.');
End.