{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program Problem6;
 const MaxN=100;
       Delta=0.00000001;
 type real=extended;
      TPoint=record
             X,Y:real;
             end;
      TLine=record
            A,B,C:real;
            end;
 var N,Count,Count1:integer;
     P,O1,O2,O3,O11:array[0..2*MaxN] of TPoint;
     s,t,Con:integer;
     Min:Real;
     A:array[1..MaxN] of 0..1;

 procedure Init;
  var i:integer;
  begin
  assign(input,'input.txt');
  reset(input);
  read(N);
  for i:=1 to N do
   read(P[i].X,P[i].Y);
  read(s,t);
  close(input);
  if s>t then begin i:=s;s:=t;t:=i; end;
  for i:=N+1 to 2*N do P[i]:=P[i-N];
  for i:=2*N+1 to 3*N do P[i]:=P[i-N];
  for i:=s to t do O1[i-s+1]:=P[i];
  for i:=t to N+s do O2[i-t+1]:=P[i];
  if t-s>N+s-t then begin Count:=N+s-t+1;O11:=O1;O1:=O2;Count1:=t-s+1; end
                    else begin O11:=O2;Count:=t-s+1;Count1:=N+s-t+1; end;
  Min:=32000;
  FillChar(A,SizeOf(A),1);
  end;

 function Eq(x1,x2:real):boolean;
  begin
  Eq:=ABS(x1-x2)<Delta;
  end;

 function EqPoint(P1,P2:TPoint):boolean;
  begin
  EqPoint:=(Eq(P1.X,P2.X))and(Eq(P1.Y,P2.Y));
  end;

 function Le(x1,x2:real):boolean;
  begin
  Le:=x2-x1>Delta;
  end;

 function Rast(P1,P2:TPoint):real;
  begin
  Rast:=Sqrt(Sqr(P1.X-P2.X)+Sqr(P1.Y-P2.Y));
  end;

 procedure Point2Line(P1,P2:TPoint;Var L:TLine);
  begin
  L.A:=P1.Y-P2.Y;
  L.B:=P2.X-P1.X;
  L.C:=P1.X*P2.Y-P1.Y*P2.X;
  end;

 function Line2Point(L1,L2:TLine;Var P:TPoint):boolean;
  var R:Real;
  begin
  R:=L1.B*L2.A-L1.A*L2.B;
  if R<>0 then begin
   Line2Point:=True;
   P.Y:=(L1.A*L2.C-L1.C*L2.A)/R;
   P.X:=-(L1.B*L2.C-L1.C*L2.B)/R;
   end
  else Line2Point:=False;
  end;

 function PointOnL(P1,P2,P:TPoint):boolean;
  begin
  if (EqPoint(P1,P))or(EqPoint(P,P2)) then PointOnL:=True
   else PointOnL:=(Rast(P1,P2)) = (Rast(P1,P)+Rast(P2,P));
  end;

 function CheckLine(L:TLine):boolean;
  var i:integer;
      L1:TLine;
      P:TPoint;
      T:boolean;
  begin
  CheckLine:=False;
  for i:=1 to N-1 do
   begin
   Point2Line(O2[i],O2[i+1],L1);
   Line2Point(L1,L,P);
   T:=PointOnL(O2[i],O2[i+1],P);
   if T=False then Exit;
   end;
  Point2Line(O2[N],O2[1],L1);
  Line2Point(L1,L,P);
  T:=PointOnL(O2[N],O2[1],P);
  if T=False then Exit;
  CheckLine:=True;
  end;

 function Check:boolean;
  var L:TLine;
      i,j,t,y:integer;
      Ok:boolean;
      S1,S2:real;
  begin
  i:=0;
  Check:=False;
  while i<(Con-1) do
   begin
   inc(i);
   Point2Line(O2[i],O2[i+1],L);
   Ok:=CheckLine(L);
   if Ok=False then Exit;
   t:=1;
   while EqPoint(O1[t],O2[i])=False do inc(t);
   y:=1;
   while EqPoint(O1[y],O2[i+1])=False do inc(y);
   O3:=O1;
   S1:=0;
   S2:=0;
   for j:=t+1 to N do O3[j]:=O3[y-t-2];
   O3[0]:=O3[Count+y-t-2];
   O3[Count+y-t-1]:=O3[1];
   for i:=1 to Count+y-t-2 do S1:=S1+O3[i].x*(O3[i+1].y-O3[i-1].y);
   for i:=1 to Count do S2:=S2+O1[i+1].x*(O1[i+1].y-O1[i-1].y);
   if S1>S2 then Exit;
   end;
  Check:=True;
  end;

 function Distanse:real;
  var i,j:integer;
      r:real;
  begin
  for i:=1 to Con-1 do
   r:=r+Rast(O2[i],O2[i+1]);
  Distanse:=r;
  end;

 procedure Rec(k:integer);
  var r:real;
      i,j:integer;
  begin

  if k=Count-1 then
   begin
   Con:=Count;
   O2:=O1;
   i:=1;
   while i<Con-1 do
    begin
    Inc(i);
    if A[i]=0 then
     begin
     for j:=i to Con+1 do O2[j]:=O2[j+1];
     Dec(i);
     Dec(Con);
     end;
    end;
   end;
  if (k=Count-1)and(Check) then
                           r:=Distanse
                           else r:=33000;
  if r<Min then Min:=r;
  if k<=(Count-1) then
   for i:=0 to 1 do
    if i=0 then
       begin
       A[k]:=0;
       Rec(k+1);
       A[k]:=1;
       end
    else if (A[k-1]<>1) then Rec(k+1);
  end;

 procedure Solve;
  begin
  Rec(1);
  O1:=O11;
  Count:=Count1;
  FillChar(A,SizeOf(A),1);
  Rec(1);
  end;

 procedure Done;
  begin
  assign(output,'output.txt');
  rewrite(output);
  write(Min);
  close(output);
  end;

 BEGIN
 Init;
 Min:=Rast(P[s],P[t]);
 {Solve;}
 Done;
 END.