program macro;
{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}

const eps=1e-10;

var tm:array [1..30,1..30] of extended;
    l:longint;
    tv,x,allt:extended;
    m,n,i,a,b:integer;
    s,r:array [1..30] of boolean;
    wt:array [1..30] of extended;
    nt:array [1..30] of longint;
    st:array [1..30,1..30] of extended;
    queue:array [1..40] of record
      num:integer;
      tm:extended;
    end;
    qb,qe:integer;
    q,sl:integer;


function queueempty:boolean;
begin
queueempty:=(qb=qe);
end;


procedure popqueue (var num:integer;var tm:extended);
begin
num:=queue[qb].num;
tm:=queue[qb].tm;
inc (qb);
end;

procedure pushqueue (num:integer;tm:extended);
begin
queue[qe].num:=num;
queue[qe].tm:=tm;
inc (qe);
end;


procedure qsort (a,b:integer);
var i,j:integer;
    l:extended;
    rm:extended;
    rs:integer;
begin
if a=b then exit;
l:=queue [(a+b) shr 1].tm;
i:=a;j:=b;
repeat
while queue[i].tm<l do inc (i);
while l<queue[j].tm do dec (j);
if i<=j then
  begin
    rm:=queue[i].tm;
    rs:=queue[i].num;
    queue[i]:=queue[j];
    queue[j].tm:=rm;
    queue[j].num:=rs;
    inc (i);
    dec (j);
  end;
until i>j;
if i>a then qsort (a,i-1);
if i<b then qsort (i,b);
end;

procedure sortqueue;
var i:integer;
begin
qsort (qb,qe-1);
for i:=qe-1 downto qb+1 do
    queue[i].tm:=queue[i].tm-queue[i-1].tm;
end;


function addserver:integer;
var i,j,k,rtp,mwp:integer;
    ct,sm,pr,ss,rtm,mwt,rs:extended;
    ms:array [1..30] of longint;
    rt:array [1..30] of extended;
    nv:longint;
    f:boolean;
begin

{for i:=1 to n do
if (not s[i]) and (nt[i]>=l) then
begin
rs:=(tm[i,j]*(nt[i]-l+1))-st[i]
end;}


for i:=1 to n do
  if not s[i] then
    begin
      pr:=1;
      sm:=0;
      for j:=1 to n do
	if (tm [i,j]<>0) and s[j] then
	  begin
	  pr:=pr*tm [i,j];
	  ss:=1;
	  for k:=1 to n do
	    if (tm [i,k]<>0) and s[k] and (k<>j) then
	      ss:=ss*tm [i,k];
	  sm:=sm+ss;
	  end;
      ct:=pr/sm;
      ct:=ct*(l-nt[i]);
      nv:=0;
      rtm:=0;
      for j:=1 to n do
	if (tm [i,j]<>0) and s[j] then
	  begin
	  ms[j]:=trunc (ct/tm [i,j]-eps)+1;
	  nv:=nv+ms[j];
	  rt[j]:=(ms[j]-1)*tm[i,j]+st[i,j]
	  end
	else
	  rt[j]:=-1e1000;
      while nv>(l-nt[i]) do
	begin
	rtm:=-1e1000;
	  for j:=1 to n do
	    if rt[j]>rtm then
	      begin
		rtm:=rt[j];
		rtp:=j;
	      end;
	dec (nv);
	rt[rtp]:=rt[rtp]-tm[i,rtp];
	dec (ms[rtp]);
	end;
	rtm:=-1e1000;
	for j:=1 to n do
	  if rt[j]>rtm then
	    rtm:=rt [j];
	wt[i]:=rtm;
    end
  else
    wt[i]:=1e1000;
f:=queueempty;
if f then
begin
 mwt:=1e1000;
 for i:=1 to n do
  if wt[i]<mwt then
    begin
    mwt:=wt[i];
    mwp:=i;
    end;
 mwt:=mwt+tv;
 for i:=1 to n do
  if wt[i]<=mwt+eps then
    pushqueue (i,wt[i]);
sortqueue;
end;
r:=s;
popqueue (mwp,mwt);
addserver:=mwp;
if f then mwt:=mwt+tv;
allt:=allt+mwt;
s[mwp]:=true;
inc (q);
for i:=1 to n do
  if not s[i] then
    begin
      for j:=1 to n do
	if (tm [i,j]>0) and r[j] then
	  begin
	    st[i,j]:=mwt-st[i,j];
	    nt[i]:=nt[i]+trunc (st[i,j]/tm[i,j]+eps)+1;
	    st[i,j]:=st[i,j]-trunc (st[i,j]/tm[i,j]+eps)*tm[i,j];
	    st[i,j]:=tm[i,j]-st[i,j];
	    st[j,i]:=st[i,j];
	  end;
    end;
end;


begin
assign (input,'input.txt');
reset (input);
read (n,m,l,tv);
for i:=1 to m do
  begin
    read (a,b,x);
    tm [a,b]:=x;
    tm [b,a]:=x;
    st [a,b]:=x;
    st [b,a]:=x;
  end;
q:=1;
s[1]:=true;
sl:=1;
qb:=1;
qe:=1;
while q<n do
  sl:=addserver;
allt:=allt-tv;
assign (output,'output.txt');
rewrite (output);
writeln (allt:3:10);
writeln (sl);
close (output);
end.
