{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
{ $D-,I-,R-,Q-,S-}

const
  mserv=50;
var
  n: integer;
  vols: longint;
  stop: real;
  servs: array[1..mserv, 1..mserv] of real;
  ts: array [1..mserv] of comp;
  cs: array [1..mserv] of longint;

  mt: real;
  last: integer;

procedure send(a: longint);
var
  i: integer;
  nt: comp;
begin
  for i:=1 to n do
    if (servs[a][i]<>0) then begin
      nt:=ts[a]+servs[a][i];
      if a<>1 then
        nt:=nt+stop;
      if (ts[i]=-1) then begin
        ts[i]:=nt;
        send(i);
      end else
        if nt<ts[i] then begin
          ts[i]:=nt;
          send(i);
        end;
    end;
end;

procedure run;
var
  i: integer;
begin
  for i:=1 to n do begin
    ts[i]:=-1;
    cs[i]:=0;
  end;
  ts[1]:=0;
  cs[1]:=vols;

  send(1);

  mt:=0;
  last:=0;
  for i:=2 to n do
    if ts[i]>mt then begin
      last:=i;
      mt:=ts[i];
    end;
end;

procedure init;
var
  f: text;
  i, j: integer;
  a, b: integer;
  c: real;
begin
  fillchar(servs, sizeof(servs), 0);

  assign(f, 'input.txt');
  reset(f);
  read(f, n, i, vols, stop);
  for j:=1 to i do begin
    read(f, a, b, c);
    servs[a][b]:=c;
    servs[b][a]:=c;
  end;
  close(f);
end;

procedure done;
var
  f: text;
begin
  assign(f, 'output.txt');
  rewrite(f);
  writeln(f, mt*vols);
  writeln(f, last);
  close(f);
end;

begin
  init;
  run;
  done;
end.