{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{ Russia 97 }

uses crt;

type str32=string[32];
     str8=string[8];

const cmDir    =$01;
      cmVolume =$02;
      cmList   =$03;
      cmType   =$04;
      cmRef    =$05;
      cmCls    =$06;
      cmVerify =$07;
      cmExit   =$08;
      cmUnknown=$FF;
      mes1='ਢ!';
      mes2=' ᢨ.';
      mes3=' ⠪ ';
      mes4='  ';
      mes5='  ';
      mes6='  뫪';
      alf=['a'..'z','A'..'Z',''..'',''..''];

const max=1500;

var main,f,f2:text;
    name:string[8];
    s:string;
    statia:array[1..max]of string[32];
    tom:array[1..max]of string[8];
    pos:integer;

procedure Init;
 var c:char;
 begin
  assign(main,'input.txt');
  reset(main);
  readln(main,s);
  name:='';
  while (s[1] in ['a'..'z','A'..'Z'])and(s<>'') do
   begin
    if s[1] in ['A'..'Z'] then name:=name+chr(ord('a')-ord('A')+ord(s[1]))
                          else name:=name+s[1];
    delete(s,1,1);
   end;
  s[1]:=chr(ord(s[1])+ord('a')-ord('A'));
  assign(f,name+'.TXT');
  reset(f);
  writeln(mes1);
 end;

function GetCommand:byte;
 var q:string;
 begin
  writeln;
  write(name,'>');
  readln(s);
  q:='';
  while (s[1]<>' ')and(s<>'') do
   begin
    if s[1] in ['A'..'Z'] then q:=q+chr(ord('a')-ord('A')+ord(s[1]))
                          else q:=q+s[1];
    delete(s,1,1);
   end;
  if length(s)>0 then delete(s,1,1);
  if q='dir' then GetCommand:=cmDir
   else if q='volume' then GetCommand:=cmVolume
    else if q='list' then GetCommand:=cmList
     else if q='type' then GetCommand:=cmType
      else if q='ref' then GetCommand:=cmRef
       else if q='cls' then GetCommand:=cmCls
        else if q='verify' then GetCommand:=cmVerify
         else if q='exit' then GetCommand:=cmExit
          else GetCommand:=cmUnknown;
 end;

procedure MakeDir;
 var v:string;
 begin
  reset(main);
  readln(main,v);
  while v<>'' do
   begin
    writeln(v);
    readln(main,v);
   end;
 end;

function Equal(a,b:string):boolean;
 var i:byte;
 begin
  if length(a)<>length(b) then Equal:=false
   else begin
         i:=1;
         while (i<=length(a))and(UpCase(a[i])=UpCase(b[i])) do inc(i);
         Equal:=(i>length(s));
        end;
 end;

procedure MakeVolume;
 var v:string;
 begin
  reset(main);
  readln(main,v);
  while (v<>'')and not Equal(s,v) do readln(main,v);
  if v='' then writeln(mes4)
          else begin
                close(f);
                assign(f,s+'.TXT');
                reset(f);
                name:=v;
               end;
 end;

function ReadName:str32;
 var c:char;
     v:str32;
 begin
  v:='';
  read(f2,c);
  while (c<>' ')and(length(v)<32) do
   begin
    if c in ['A'..'Z'] then v:=v+chr(ord('a')-ord('A')+ord(c))
     else if c in [''..''] then v:=v+chr(ord('')-ord('')+ord(c))
      else v:=v+c;
    read(f2,c);
   end;
  ReadName:=v;
 end;

procedure MakeList;
 begin
  if s='' then s:=name;
  assign(f2,s+'.TXT');
  reset(f2);
  pos:=0;
  while not seekeof(f2) do
   begin
    inc(pos);
    tom[pos]:=s;
    statia[pos]:=ReadName;
    readln(f2);
    writeln(pos,'. ',statia[pos])
   end;
  close(f2);
 end;

function ReadName2(var v:str32):boolean;
 begin
  v:='';
  while (s[1]<>' ')and(s[1]<>':')and(s<>'')and(length(v)<32) do
   begin
    if s[1] in ['A'..'Z'] then v:=v+chr(ord('a')-ord('A')+ord(s[1]))
     else if s[1] in [''..''] then v:=v+chr(ord('')-ord('')+ord(s[1]))
      else v:=v+s[1];
    delete(s,1,1);
   end;
  ReadName2:=(s[1]=':');
 end;

function ReadName3:str32;
 var v:str32;
     c:char;
 begin
  if Eoln(f2) then begin ReadName3:=''; exit; end;
  v:='';
  read(f2,c);
  while (not Eoln(f2))and(c in Alf)and(length(v)<32) do
   begin
    write(c);
    if c in ['A'..'Z'] then v:=v+chr(ord('a')-ord('A')+ord(c))
     else if c in [''..''] then v:=v+chr(ord('')-ord('')+ord(c))
      else v:=v+c;
    read(f2,c);
   end;
  if c=' ' then ReadName3:=v
           else ReadName3:='';
  write(c);
 end;

function ReadTomName:str8;
 var v:str8;
     c:char;
 begin
  if Eoln(f2) then begin ReadTomName:=''; exit; end;
  v:='';
  read(f2,c);
  write(c);
  if Eoln(f2)or(c<>'(') then exit;
  read(f2,c);
  write(c);
  if Eoln(f2)or(c<>'') then exit;
  read(f2,c);
  write(c);
  if Eoln(f2)or(c<>'') then exit;
  read(f2,c);
  write(c);
  if Eoln(f2)or(c<>'.') then exit;
  read(f2,c);
  while (not Eoln(f2))and(c in ['a'..'z','A'..'Z'])and(length(v)<8) do
   begin
    write(c);
    if c in ['A'..'Z'] then v:=v+chr(ord('a')-ord('A')+ord(c))
     else if c in [''..''] then v:=v+chr(ord('')-ord('')+ord(c))
      else v:=v+c;
    read(f2,c);
   end;
  write(c);
  if c=')' then ReadTomName:=v
           else ReadTomName:='';
 end;


procedure MakeType;
 var v,v2:str32;
     c:char;
 begin
  if ReadName2(v2) then begin delete(s,1,1); ReadName2(v); end
                   else begin v:=v2; v2:=name; end;
  assign(f2,v2+'.TXT');
  reset(f2);
  pos:=0;
  while (not SeekEof(f2))and (ReadName<>v) do readln(f2);
  if not SeekEof(f2) then
   begin
    write(v,' ');
    read(f2,c);
    write(c);
    while not Eoln(f2) do
     begin
      if not(c in Alf) then
       begin
        inc(pos);
        Statia[pos]:=ReadName3;
        if Statia[pos]='' then dec(pos)
         else begin
               Tom[pos]:=ReadTomName;
               if Tom[pos]='' then dec(pos);
              end;
       end;
      read(f2,c);
      write(c);
     end;
   end
  else writeln(mes5);
 end;

procedure MakeRef;
 var k:byte;
     code:integer;
 begin
  val(s,k,code);
  if k<=pos then begin
                  s:=tom[k]+':'+statia[k];
                  MakeType;
                 end
            else writeln(mes6);
  pos:=0;
 end;

procedure MakeCls;
 begin
  clrscr;
 end;

procedure MakeVerify;
 begin
 end;

procedure Run;
 var com:byte;
 begin
  repeat
   com:=GetCommand;
   case com of
    cmDir    : MakeDir;
    cmVolume : MakeVolume;
    cmList   : MakeList;
    cmType   : MakeType;
    cmRef    : MakeRef;
    cmCls    : MakeCls;
    cmVerify : MakeVerify;
    cmExit   : ;
    cmUnknown: writeln(mes3);
   end; (* Case *)
  until com=cmExit;
 end;

procedure Done;
 begin
  close(main);
  close(f);
  writeln(mes2);
 end;

Begin
 Init;
 Run;
 Done;
End.