Uses Objects, CRT;
Type

 PCharArray = ^TCharArray;
 TCharArray = array [0..64000] of Char;

 PStat = ^TStat;
 TStat = object
   Body: PCharArray;
   Len: Integer;
   Name: String;
  constructor Init (AName: String; ABody: PCharArray; ALen: Integer);
  destructor Done;
  procedure WriteBody;
 end;

const
 Letters = ['A'..'Z', 'a'..'z', ''..'', ''..'', '', ''..''];

Var
 List: PStringCollection;
 Stats: PCollection;

 Cur: Integer;
 CurS: String;

Procedure ReadMain;
 var
  F: Text;
  s: String;
 begin
  Assign (F, 'input.txt'); Reset (F);
  List := New(PStringCollection, Init (1, 1));
  While not SeekEOF(F) do begin
   ReadLn (F, s);
   S := S+'.txt';
   List^.Insert(NewStr(S));
  end;
  Close (F);
 end;

Procedure MakeCur (ACur: Integer);
 var
  F: file of Char;
  c: Char;
  s: String;
  P: PCharArray;
  Count: Word;
  i: Integer;
  Stat: PStat;
 begin
  GetMem (P, 64000);
  Cur := ACur;
  If Stats <> nil then For i := 0 to Stats^.Count-1 do begin
   Stat := Stats^.At(i);
   Stat^.Done;
  end;
  Stats := New (PCollection, Init (5, 5));
  Assign (F, PString(List^.At(Cur))^); Reset (F);
  While not EOF(F) do begin
   C := #0; S := '';
   While C <> #32 do begin
    If EOF(F) then Break;
    Read (F, C); If C in Letters then S := S + C;
   end;
   If EOF(F) then Break;
   Count := 0;
   While C <> #13 do begin
    Read (F, C);
    If C <> #13 then begin P^[Count] := C; Inc (Count); end;
   end;
   Stats^.Insert (New (PStat, Init (S, P, Count)));
  end;
  FreeMem (P, 64000);
  Close (F);
  S := PString(List^.At(cur))^;
  CurS := '';
  For i := 1 to Length(S) do If S[i] <> '.' then CurS := CurS + S[i] else Break;
 end;

Constructor TStat.Init;
 begin
  Len := ALen; Name := AName;
  GetMem (Body, Len);
  Move (ABody^, Body^, Len);
 end;

Destructor TStat.Done;
 begin
  FreeMem (Body, Len);
 end;

Procedure TStat.WriteBody;
 var
  i, j: Word;
  S, oS: String;
  C: Char;
 begin
  oS := ''; i := 0; S := '';
  While i < Len do begin
   C := Body^[i];
   If Length(S) <= 79-Length(oS) then S := S + C else begin
    oS := '';
    j := Length(S);
    While S[j] <> #32 do Dec (j);
    oS := Copy (S, j+1, Length(S));
    S := Copy (S, 1, j-1);
{    While (i <= Len) and (Body^[i] <> #32) do begin oS := oS + Body^[i]; Inc (i) end;}
    While S[1] = #32 do S := Copy (S, 2, Length(S));
    WriteLn (S);
    While oS[1] = #32 do oS := Copy (oS, 2, Length(S));
    If oS <> '' then Write (oS);
    S := '';
   end;
   Inc (i);
  end;
  While S[1] = #32 do S := Copy (S, 2, Length(S));
  WriteLn (S);
 end;

Procedure Readstring (var S: sTRing);
 begin
  WriteLn;
  Write (CurS);
  Write ('>');
  ReadLn (S);
 end;

Procedure Dir;
 var I: Integer;
  S: String;
 begin
  For i := 0 to List^.Count-1 do begin
   S := PString(List^.At(i))^;
   S := Copy (S, 1, Length(S)-4);
   WriteLn (S);
  end;
 end;

Function Volume (P: String): Boolean;
 var Yes: Boolean;
  i: Integer;
 begin
  Volume := True;
  Yes := fALSE;
  For i := 0 to List^.Count-1 do
   if PString(List^.At(i))^ = P+'.txt' then begin Yes := True; break end;
  If not Yes then begin
   WriteLn ('  ');
   Volume := False;
  end else MakeCur(i);
 end;

Procedure Sprate (S: String; var S1, S2: String; C: Char);
 var
  i: Integer;
  Yes: Boolean;
 begin
  Yes := False;
  For i := 1 to Length(S) do if s[i] = C then begin Yes := True; Break end;
  If not Yes then begin
   S1 := S; S2 := '';
  end else begin
   S1 := Copy(S, 1, i-1);
   S2 := Copy(S, i+1, Length(S));
  end;
 end;

Procedure TypeList;
 var
  i: Integer;
 begin
  for i := 0 to Stats^.Count-1 do begin
   Write (i+1); Write ('. ');
   WriteLn (PStat(Stats^.At(i))^.Name);
  end;
 end;

Procedure DoType (P: String);
 var
  s, s1, s2: String;
  i: Integer;
  Yes: Boolean;
 begin
  Sprate (P, S1, S2, ':');
  If S2 = '' then s := S1 else begin
   s := s2;
   If not Volume (S1) then Exit;
  end;
  Yes := False;
  For i := 0 to Stats^.count-1 do begin
   S2 := PStat(Stats^.At(i))^.Name;
   if S2 = S then
    begin Yes := True; Break end;
  end;
  If not Yes then begin
   WriteLn (' ⠪ '); Exit;
  end;
  PStat(Stats^.At(i))^.WriteBody;
 end;

Procedure ApplyDialog;
 var
  S, S1, S2: String;
 begin
  WriteLn ('ਢ!');
  While True do begin
   ReadString (S);
   Sprate (S, S1, S2, #32);
   If S = 'EXIT' then begin WriteLn (' ᢨ'); Break end else
    If S = 'DIR' then Dir else
     If S1 = 'VOLUME' then Volume (S2) else
      If S1 = 'LIST' then begin
       If S2 <> '' then Volume(s2);
       TypeList;
      end else
       If S1 = 'TYPE' then DoType(S2) else
        If S1 = 'CLS' then ClrScr else
        WriteLn (' ⠪ ');
  end;
 end;

var
 i: Integer;
Begin
 ReadMain;
 Stats := nil;
 MakeCur (0);
 ApplyDialog;
End.