#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <values.h>
#include <stdlib.h>

#define next(i) (((i)+1)%n)
#define prev(i) (((i)+n-1)%n)
#define sqr(v) ((v)*(v))

FILE *fl;
char n;
float vx[101];
float vy[101];
char k,l;

char ab[100][100];
float gr[100][100];

#undef min

float min(float a,float b)
{
	if(a<b) return(a);
	else return(b);
}

	float a1,b1,c1;
	float a2,b2,c2;

char per(float x1,float y1,float x2,float y2,float x3,float y3,float x4,float y4)
{
	a1=y2-y1;
	b1=-(x2-x1);
	c1=-a1*x1-b1*y1;

	a2=y4-y3;
	b2=-(x4-x3);
	c2=-a2*x3-b2*y3;

	if(((a1*x3+b1*y3+c1)*(a1*x4+b1*y4+c1)<0)&&((a2*x1+b2*y1+c2)*(a2*x2+b2*y2+c2)<0)) return(1);
	else return(0);
}

#define Eps 1e-06

float ang(float x1,float y1,float x2,float y2,float x3,float y3)
{
	float vx1,vy1,vx2,vy2;
	float v;

	vx1=x1-x2;
	vy1=y1-y2;
	vx2=x3-x2;
	vy2=y3-y2;

/*	v=asin(-0.5);*/

/*	if((vx1*vx1+vy1*vy1)*(vx2*vx2+vy2*vy2)==0) return(0);*/

	v=(vx1*vy2-vx2*vy1)/sqrt((vx1*vx1+vy1*vy1)*(vx2*vx2+vy2*vy2));

	if(vx1*vx2+vy1*vy2>0)
	return(asin( v  ));
	else
	if(v>0)
	return(3.141593-asin(v));
	else
		return(-3.141593-asin(v));
}

void set_able(void)
{
	int i,j,k;
	float x1,y1,x2,y2;
	float a1,a2,a3;
	float v;
	char b;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
				ab[i][j]=1;

	for(i=0;i<n;i++)
		for(j=i+1;j<n;j++)
			if((j!=next(i))&&(j!=prev(i)))
			{
				b=1;

				x1=vx[i];
				y1=vy[i];
				x2=vx[j];
				y2=vy[j];

				for(k=0;k<n;k++)
					if(per(x1,y1,x2,y2,vx[k],vy[k],vx[next(k)],vy[next(k)])) b=0;

				if(b==1)
					{
						b=0;

						x1=(x1+x2)/2;
						y1=(y1+y2)/2;

/*						v=ang(2,0,4,1.75,5,0);
						v+=ang(5,0,4,1.75,6,3.5);*/

						v=0;
						for(k=0;k<n;k++)
							v+=ang(vx[k],vy[k],x1,y1,vx[next(k)],vy[next(k)]);

						if(fabs(v)<Eps) b=0;
						else b=1;
					}

				ab[i][j]=b;
				ab[j][i]=b;
			}
}

void set_graf(void)
{
	int i,j;

	for(i=0;i<n;i++)
		for(j=i+1;j<n;j++)
			if(ab[i][j])
				gr[i][j]=gr[j][i]=sqrt(sqr(vx[i]-vx[j])+sqr(vy[i]-vy[j]));
			else
				gr[i][j]=gr[j][i]=MAXFLOAT;
}

float way[100];
char set[100];

float minw;
int u;

void set_ways(void)
{
	int i,j;

	for(i=0;i<n;i++)
		set[i]=1;

	set[k]=0;

	for(i=0;i<n;i++)
		way[i]=gr[k][i];

	for(i=0;i<n-1;i++)
		{
			minw=MAXFLOAT;
			for(j=0;j<n;j++)
				if(set[j])
					if(minw>way[j])
						{
							u=j;
							minw=way[j];
						}
			set[u]=0;
			for(j=0;j<n;j++)
				if(set[j])
					way[j]=min(way[j],way[u]+gr[u][j]);
		}
}

	char ch;

	float v;

void main(void)
{
	int i,j;
	char st[20];

	fl=fopen("input.txt","r");
	fgets(st,10,fl);
	n=atoi(st);
	for(i=0;i<n+1;i++)
		{
//			fscanf(fl,"%s",st);
			j=0;
			ch=fgetc(fl);
			while((ch<'0')||(ch>'9')) ch=fgetc(fl);

			while(ch!=' ')
				{
					st[j++]=ch;
					ch=fgetc(fl);
				}
			st[j]=0;
			vx[i]=atof(st);

			j=0;
			ch=fgetc(fl);
			while((ch<'0')||(ch>'9')) ch=fgetc(fl);

			while((ch!='\n')&&(!feof(fl)))
				{
					st[j++]=ch;
					ch=fgetc(fl);
				}
			st[j]=0;
			vy[i]=atof(st);

		}
	k=vx[n]-1;
	l=vy[n]-1;
	fclose(fl);

/*	v=ang(0,0,0,1,2,0);
	v+=ang(2,0,0,1,0,2);*/

	set_able();
	set_graf();
	set_ways();

	fl=fopen("output.txt","w");
	fprintf(fl,"%f",way[l]);
//	printf("%f\n",way[l]);
	fclose(fl);
}
