{ 3207 }

{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Type String6 = String[6];
     TPenalty = record
              S : String6;
              P : Byte;
     End;
     TString = String[100];
     PString = Array[1..729] of ^TString;
     TTable = record
       V,L,C : Array[1..729] of LongInt;
       N : Array[1..729] of Word;
       S,SN : PString;
     End;

Var P : Array[1..50] of TPenalty;
T : TTable;
N,M,A,B : LongInt;
ErCd : Integer;

Procedure ReadFile;
Var S : String;
S2 : String;
Begin
  Assign(Input,'input.txt');
  ReSet(Input);
  ReadLn(N);
  ReadLn(M);
  For A:=1 to M do
  Begin
    ReadLn(S2);
    B:=Length(S2);
    While S2[B]<>' ' do
      Dec(B);
    S:=Copy(S2,B+1,Length(S2)-B);
    P[A].S:=Copy(S2,1,B-1);
    Val(S,P[A].P,ErCd);
  End;
  Close(Input);
End;

Function Calc(S : String6) : LongInt;
Var E,A,B : LongInt;
Begin
  E:=0;
  For A:=1 to Length(S) do
    For B:=1 to M do
      If (Length(P[B].S)<=Length(S)-A+1) and (P[B].S=Copy(S,A,Length(P[B].S))) then
        Inc(E,P[B].P);
  Calc:=E;
End;

Function GenNext(Var S : String6) : Boolean;
Var A,B : LongInt;
Begin
  A:=Length(S);
  While (A>0) and (S[A]='N') do
  Begin
    S[A]:='I';
    Dec(A);
  End;
  If A=0 then GenNext:=True else
  Begin
    If S[A]='I' then S[A]:='W' else
      If S[A]='W' then S[A]:='N';
    GenNext:=False;
  End;
End;

Procedure Work2;
Var S : String6;
Best : String6;
Min : LongInt;
Begin
  S:='';
  For A:=1 to N do S:=S+'I';
  Best:=S;
  Min:=MaxLongInt;
  Repeat
    B:=Calc(S);
    If B<Min then
    Begin
      Min:=B;
      Best:=S;
    End;
  Until GenNext(S);
  WriteLn(Min);
  WriteLn(Best);
  Close(Output);
  Halt(0);
End;

Function Calc2(S : String6) : Word;
Var B,R : LongInt;
Begin
  R:=0;
  For B:=2 to 6 do
  Begin
    If S[B]='W' then Inc(R) else
      If S[B]='N' then Inc(R,2);
    R:=R*3;
  End;
  Calc2:=R+1;
End;

Function Calc3(S : String6) : Word;
Var B,R : LongInt;
Begin
  R:=0;
  For B:=1 to 6 do
  Begin
    R:=R*3;
    If S[B]='W' then Inc(R) else
      If S[B]='N' then Inc(R,2);
  End;
  Calc3:=R+1;
End;

Function CalN2(S : String) : LongInt;
Var E,A,B : LongInt;
Begin
  E:=0;
  For A:=1 to M do
    If (P[A].S=Copy(S,Length(S)-Length(P[A].S)+1,Length(P[A].S))) then
      Inc(E,P[A].P);
  CalN2:=E;
End;

Function CalN(S : String) : LongInt;
Begin
  CalN:=T.V[Calc3(Copy(S,Length(S)-5,6))];
End;

Procedure Work3;
Var C,E : LongInt;
D : Word;
Min : LongInt;
Best : String;
Begin
  For A:=1 to N-6 do
  Begin
    FillChar(T.L,SizeOf(T.L),$FF);
    For B:=1 to 729 do
    Begin
      For D:=0 to 2 do
      Begin
        C:=T.N[B]+D;
        E:=T.C[B]+CalN(T.S[B]^+T.S[C]^[Length(T.S[C]^)]);
        If (T.L[C]=-1) or (T.L[C]>E) then
        Begin
          T.L[C]:=E;
          T.SN[C]^:=T.S[B]^+T.S[C]^[Length(T.S[C]^)];
        End;
      End;
    End;
    For B:=1 to 729 do
    Begin
      T.C[B]:=T.L[B];
      T.S[B]^:=T.SN[B]^;
    End;
  End;
  Min:=MaxLongint;
  For A:=1 to 729 do
    If Min>T.C[A] then
    Begin
      Min:=T.C[A];
      Best:=T.S[A]^;
    End;
  WriteLn(Min);
  WriteLn(Best);
End;

Procedure Work;
Var S : String6;
Begin
  Assign(Output,'output.txt');
  ReWrite(Output);
  If N<7 then Work2 else
  Begin
    { 1.Create table }
    A:=0;
    S:='IIIIII';
    Repeat
      Inc(A);
      T.V[A]:=CalN2(S);
      T.C[A]:=Calc(S);
      T.N[A]:=Calc2(S);
      New(T.S[A]);
      New(T.SN[A]);
      T.S[A]^:=S;
    Until GenNext(S);
    { 2.work }
    Work3;
    Close(Output);
  End;
End;

Procedure Done;
Begin
  Release(HeapOrg);
End;

Begin
  ReadFile;
  Work;
  Done;
End.