{$M 32768,0,655360}
program Number_Exchanger;
const MaxL=5000;
      g=10;
Type huge = record
             l:word;
             d:array[1..MaxL] of byte;
            end;
var n,m,i,t:integer;
    p:array[1..500] of integer;
    res,h1,h2,h3:Huge;
    c,a:array[1..3000] of integer;
    cs:integer;
procedure WriteHuge(var h:Huge);
var i:integer;
 begin
  for i:=h.l downto 1 do
   write(h.d[i]);
   writeln;
 end;

procedure AddHuge(var h1,h2:Huge);
var i,l:integer;
begin
if h1.l<h2.l then for i:=h1.l+1 to h2.l do h1.d[i]:=0;
if h2.l<h1.l then for i:=h2.l+1 to h1.l do h2.d[i]:=0;
if h1.l<h2.l then l:=h2.l else l:=h1.l;
h1.d[l+1]:=0;h2.d[l+2]:=0;
for i:=1 to l do
 begin
  inc(h1.d[i],h2.d[i]);
  if h1.d[i]>=g then begin dec(h1.d[i],g);inc(h1.d[i+1]);end;
 end;
l:=l+1;
while (h1.d[l]=0) and (l>1) do dec(l);
h1.l:=l;
end;

procedure MulHuge(var h1,h2,h3:huge);
var i,t,l:integer;
 begin
  for i:=1 to h1.l+h2.l+3 do h3.d[i]:=0;
  for i:=1 to h1.l do
  for t:=1 to h2.l do
   begin
    inc(h3.d[i+t-1],h1.d[i]*h2.d[t]);
    l:=i+t-1;
    while h3.d[l]>=g do
     begin
      inc(h3.d[l+1],h3.d[l] div g);
      h3.d[l]:=h3.d[l] mod g;
      inc(l);
     end;
   end;
 l:=h1.l+h2.l+3;
 while (h3.d[l]=0) and (l>1) do dec(l);
 h3.l:=l;
 end;

procedure MulHugeN(var h1:huge;mm:longint;var h3:huge);
var i,t,l:integer;
    m:longint;
 begin
  for i:=1 to h1.l+10 do h3.d[i]:=0;
  for i:=1 to h1.l do
   begin
    m:=mm;
    l:=i;
    while m>0 do
     begin
      inc(h3.d[l],(m mod 10)*h1.d[i]);
      inc(h3.d[l+1],h3.d[l] div g);
      h3.d[l]:=h3.d[l] mod g;
      m:=m div 10;
      inc(l);
     end;
   end;
 l:=h1.l+10;
 while (h3.d[l]=0) and (l>1) do dec(l);
 h3.l:=l;
 end;

procedure ReadAll;
var i:integer;
 begin
  Assign(input,'input.txt');reset(input);
  read(n,m);
  for i:=1 to m do
   begin
   read(p[i]);
   p[i]:=p[i]+1;
   end;
  close(input);
 end;

procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := p[(l+r) DIV 2];
  repeat
    while p[i] < x do i := i + 1;
    while x < p[j] do j := j - 1;
    if i <= j then
    begin
      y := p[i]; p[i] := p[j]; p[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure SortC(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := C[(l+r) DIV 2];
  repeat
    while C[i] < x do i := i + 1;
    while x < C[j] do j := j - 1;
    if i <= j then
    begin
      y := C[i]; C[i] := C[j]; C[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortC(l, j);
  if i < r then SortC(i, r);
end;



procedure KillBadP;
var r:array[1..3000] of boolean;
    b:array[1..500] of boolean;
    i,t:integer;
 begin
  for i:=1 to n do
   r[i]:=false;
  for i:=1 to m do
   b[i]:=false;
  for t:=1 to m do
   if r[p[t]] then b[t]:=true else
   begin
    i:=p[t];
    repeat
     r[i]:=true;
     i:=i+p[t];
    until i>n;
   end;
  t:=0;
  for i:=1 to m do
   if b[i]=false then
   begin
    inc(t);
    p[t]:=p[i];
   end;
  m:=t;
 end;

procedure CopyHuge(var so,ta:Huge);
 begin
  ta.l:=so.l;
  move(so.d,ta.d,so.l);
 end;

procedure Factorial(n:integer;var h3:Huge);
var i:integer;
    h4:Huge;
 begin
  h3.l:=1;h3.d[1]:=1;
  for i:=2 to n do
   begin
    MulHugeN(h3,i,h4);
    Copyhuge(h4,h3);
   end;
 end;

procedure Comps(t:integer);
var i:integer;
 begin
  a[t]:=cs;
  for i:=1 to m do
   begin
   if (((t-p[i])>=1) and (a[t-p[i]]=0)) then Comps(t-p[i]);
   if (((t+p[i])<=n) and (a[t+p[i]]=0)) then Comps(t+p[i]);
   end;
 end;

procedure Solve;
var i:integer;
    i1,i2:integer;
 begin
  Sort(1,m);
  KillBadP;
  if p[1]=1 then begin
                  Factorial(n,h3);
                  writeHuge(h3);
                  halt;
                 end;
  for i:=1 to n do a[i]:=0;
  cs:=0;
  for i:=1 to n do
    if a[i]=0 then begin
    Inc(cs);Comps(i);end;
  for i:=1 to cs do c[i]:=0;
  for i:=1 to n do
   inc(c[a[i]]);
  SortC(1,cs);
  h1.l:=1;h1.d[1]:=1;
  res.l:=1;res.d[1]:=1;
  i1:=1;
  i2:=1;
  while i1<=cs do
   begin
    for i:=i2+1 to c[i1] do
     begin
      MulHugeN(h1,i,h2);
      CopyHuge(h2,h1);
     end;
    i2:=c[i1];
    MulHuge(res,h1,h2);
    CopyHuge(h2,res);
    inc(i1);
   end;
  writehuge(res);
 end;

begin
ReadAll;
Assign(output,'output.txt');rewrite(output);
Solve;
close(output);
end.