PROGRAM  Rebus;  {$R+}
uses crt;

CONST  minch = 'A'{''}; maxch = ''{''}; _ = pred(minch);
       chars : set of char = [minch..maxch]; nn = 10;

TYPE  char = _..maxch; cifra = 0..10;
      arrz = array [char] of cifra;
      arrset = array [char] of set of cifra;

VAR  a,b,c,s : string; i,max,cnt  : integer;
     la,lb,lc : byte; pa,pb,pc : char;
     ZN : arrz; M : arrset; t : char;
     Free : array [0..9] of boolean; vars : set of char;

procedure err(s : string);
begin
  writeln(s); halt;
end;

procedure notfind;
begin
  err('襭 !');
end;

function limit(ch : char; i : cifra) : boolean;
begin
  if (ZN[ch]<>i) and ((ZN[ch]<>nn) or not Free[i] or not (i in M[ch])) then limit:=false
  else begin ZN[ch]:=i; Free[i]:=false; limit:=true end;
end;

function limit2(ch : char; i,j : cifra) : boolean;
begin
  if not (ZN[ch] in [nn,i,j]) then limit2:=false
  else begin
    if ZN[ch]<>nn then limit2:=true
    else begin
      if not (i in M[ch]) then limit2:=limit(ch,j) else
      if not (j in M[ch]) then limit2:=limit(ch,i) else
        begin M[ch]:=[i,j]; limit2:=true end;
    end;
  end;
end;

procedure let(ch : char; i : cifra);
begin
  if not limit(ch,i) then notfind;
end;

procedure let2(ch : char; i,j : cifra);
begin
  if not limit2(ch,i,j) then notfind;
end;

procedure swap(var a,b);
var x : byte;
begin x:=byte(a); byte(a):=byte(b); byte(b):=x end;

procedure Freech(ch : char);
begin
  Free[ZN[ch]]:=true; ZN[ch]:=nn;
end;

procedure print;
var i : integer;
begin
  for i:=la downto 1 do write(ZN[a[i]]); write('+');
  for i:=lb downto 1 do write(ZN[b[i]]); write('=');
  for i:=lc downto 1 do write(ZN[c[i]]); writeln; {readln;}
end;

procedure rec(i : byte; carry : byte);
var ca,cb,cc : char; za,zb,zc : cifra; qa,qb,qc : boolean;
    t,t1 : integer; {ta,tb,tc : cifra; na,nb,nc : cifra; ka,kb,kc : cifra;}
begin
  if i>max then begin if carry=ZN[c[i]] then print; exit end;
  ca:=a[i]; cb:=b[i]; cc:=c[i];
  za:=ZN[ca]; zb:=ZN[cb]; zc:=ZN[cc];
  qa:=za<>nn; qb:=zb<>nn; qc:=zc<>nn;

  if qa and qb and qc then begin
    t:=za+zb+carry; if t mod 10 = zc then rec(i+1,t div 10); exit;
  end;

  if qa and not qb then begin swap(ca,cb); swap(za,zb); swap(qa,qb) end;
  if not qa and qb and qc then begin
    t1:=zc-zb-carry; if t1>=0 then t:=t1 else t:=t1+10;
    if limit(ca,t) then begin rec(i+1,ord(t1<0)); Freech(ca) end;
    exit;
  end;
  if qa and qb and not qc then begin
    t:=za+zb+carry;
    if limit(cc,t mod 10) then begin rec(i+1,t div 10); Freech(cc) end;
    exit;
  end;

  for t:=0 to 9 do
    if limit(ca,t) then begin
      rec(i,carry); Freech(ca);
    end;

  ZN[ca]:=za; {ZN[cb]:=zb; ZN[cc]:=zc;}
end;

BEGIN
  repeat
    writeln('=>'); readln(s); if s='' then err('Thank you for used REBUS!');
    a:=''; b:=''; c:=''; s:=s+#0; i:=1;

    while s[i] in chars do begin a:=s[i]+a; inc(i) end;
    if (s[i]<>'+') or (a='') then err('訡  ࢮ ᫠!') else inc(i);

    while s[i] in chars do begin b:=s[i]+b; inc(i) end;
    if (s[i]<>'=') or (b='') then err('訡  ஬ ᫠!') else inc(i);

    while s[i] in chars do begin c:=s[i]+c; inc(i) end;
    if (s[i]<>#0) or (c='') then err('訡  㬬!') else inc(i);


    la:=length(a); lb:=length(b); lc:=length(c); cnt:=0; s:=a+b+c; vars:=[];
    for i:=1 to length(s) do
      if not (s[i] in vars) then begin vars:=vars+[s[i]]; inc(cnt) end;

    if cnt>10 then err('誮  ᨬ!');
    for i:=0 to 9 do Free[i]:=true;
    for t:=minch to maxch do begin ZN[t]:=nn; M[t]:=[0..9] end;


    ZN[_]:=0; pa:=a[la]; pb:=b[lb]; pc:=c[lc]; c:=c+_;

    if la>=lb then begin max:=la; for i:=lb+1 to la do b:=b+_ end
              else begin max:=lb; for i:=la+1 to lb do a:=a+_ end;

    if lc<max   then err('誮    㬬!');
    if lc>max+1 then err('誮    㬬!');

    if lc>max then let(pc,1);
    if (lc>lb) and (lb>la) then begin let(pb,9); let(c[lc-1],0) end;
    if (lc>la) and (la>lb) then begin let(pa,9); let(c[lc-1],0) end;

    if a[1]=c[1] then let(b[1],0);
    if b[1]=c[1] then let(a[1],0);
    for i:=2 to max do
      if a[i]=c[i] then limit2(b[i],0,9) else
      if b[i]=c[i] then limit2(a[i],0,9);

    rec(1,0);

  until false;

  {writeln('Thank you for used REBUS!');}
END.
