Uses Crt;
Type Line= array [1..3] of real;
    point= array [1..2] of real;
Const eps=1e-6;
Var i, j : integer;
    p : array [1..100] of Point;
    l : array [1..100] of line;
    t : array [1..100] of integer;
    N : integer;
function Det(a,b,c,d : real): real;
Begin
 det:=a*d-b*c;
End;
Procedure PToL(a,b : Point; Var r : Line);
Var aa : real;
Begin
 r[1]:=a[2]-b[2];
 r[2]:=b[1]-a[1];
 r[3]:=a[2]*b[1]-b[2]*a[1]; {r[1]*x+r[2]*y=r[3]}
 aa:=sqrt(sqr(r[1])+sqr(r[2]));
 r[1]:=r[1]/aa; r[2]:=r[2]/aa; r[3]:=r[3]/aa;
End;
Procedure LToP(a, b : Line; Var r : point);
Var c : real;
Begin
 r[1]:=1e37; r[2]:=1e37;
 c:=det(a[1],a[2],b[1],b[2]);
 if ABS(c)<EPS then exit;
 r[1]:=det(a[3],a[2],b[3],b[2])/c;
 r[2]:=det(a[1],a[3],b[1],b[3])/c;
End;
procedure readdata;
Var i : integer;
a,b : point;
Begin
 assign(input,'input.txt'); reset(input);
 read(n);
 for i:=1 to n do
  begin
   read(a[1],a[2],b[1],b[2]);
   PToL(a,b,l[i]);
  end;
End;
Function eq(a,b : real):boolean;
Begin
 if abs(a-b)<eps then eq:=true else eq:=false;
End;
Function Eqp(a,b : point) : boolean;
begin
 eqp:=eq(a[1],b[1]) and eq(a[2],b[2]);
end;
Var v, r : real;
Procedure Solve;
Var i,j,k : integer;
q: integer;
res : point;
Begin
v:=0;
 for i:=1 to N do
  begin
   q:=0; p[1][1]:=1e37;
   for j:=1 to N do
   if i<>j then
    begin
     LToP(l[i],l[j],res);
     if res[1]=1e37 then continue;
     k:=1;
     for k:=1 to q do
      begin
       if eqp(res,p[k]) then break;
      end;
      if eqp(res,p[k]) then begin inc(t[k]); continue; End;
      inc(q); p[q]:=res; t[q]:=2;
    end;
    for j:=1 to q do v:=v+1/t[j];
    r:=r+1+q;
  end;
End;
Procedure OutData;
Begin
assign(output,'output.txt'); Rewrite(output);
 Writeln(1-v+r:0:0);
End;
Begin
 readData;
 Solve;
 OutData;
End.