program fullshit;
uses crt;
type  wrd=string [8];
      atp=(_int,_chr,_bol,_str,_cnt);

const key_word:array [1..8] of wrd=('multi','optional',
      'define','sequence','type','constant','set','of');


      qnt=150;


type typ=record nam:wrd;
                tp:atp;
         end;
     con=record nam:wrd;
         end;

    idnt=record nam:wrd;
                val:byte;
                nx,pr:byte;
         end;

var sf:file of char;
    sfp:word; {Source file pointer}
    s_f_e:boolean; {End of source file}
    ch:char;
    w1,w2:wrd;
    yk:word;
    tps:array [1..qnt] of typ;
    cns:array [1..qnt] of con;
    tpp,cnp:word;
    idn:array [1..qnt] of idnt;
    idp:word;

procedure error (en:byte); forward;

function rc:char;
var c:char;
begin
  read (sf,c);
  inc (sfp);
  if (c=#10) or (c=#13) then begin
    read (sf,c);
    inc (sfp);
    rc:=#13;
    inc (yk);
    exit;
  end;
  rc:=c;
end;

procedure mov_f (d:integer);
begin
  sfp:=sfp+d;
  seek (sf,sfp);
end;

function rd_char:char;
var c1:char;
begin
  if eof (sf) then begin
    s_f_e:=true;
    rd_char:=' ';
    exit;
  end;
  c1:=rc;
  {Check for comment}
  if c1='/' then begin
    c1:=rc;
    if c1='/' then begin
      while c1<>#13 do c1:=rc;
      rd_char:=c1;
      exit;
    end else begin
      if c1>=' ' then mov_f (-1)
                 else begin
                   mov_f (-2);
                   dec (yk);
                 end;
      c1:='/';
      exit;
    end;
  end;
  case c1 of
    'A'..'Z',''..'': rd_char:=chr (ord (c1)+32);
    ''..'':          rd_char:=chr (ord (c1)+80);
    else               rd_char:=c1;
  end;
end;

procedure rd_wrd(var w:wrd);
var c:char;
begin
  w:='';
  repeat
    if s_f_e then exit;
    c:=rd_char;
  until c>' ';
  while not (c in [' ',#13,',',')','(',';','{','}','=']) do begin
    w:=w+c;
    c:=rd_char;
    if c='.' then error (2);
  end;
  if w[1] in ['0'..'9'] then begin
    if c=#13 then dec (yk);
    error (2);
  end;
  if not (c in [' ',#13]) then mov_f (-1);
end;

function find_idn (n:wrd):byte;forward;

procedure wait (c:char);
var c1:char;
begin
  repeat
    if s_f_e then error (7);
    c1:=rd_char;
  until not (c1 in [' ',#13]);
  if c1<>c then error (7);
end;

function _char(d:wrd):char;
var i:byte;
    r:char;
begin
  r:=d[1];
  if (r<>'''') and (r<>'"') then begin
    _char:=#0;
    exit;
  end;
  if (r<>d[2]) and (d[3]=r) then begin
    _char:=d[2];
    exit;
  end;
  if (r=d[2]) and (r=d[3]) and (r=d[4]) then begin
    _char:=r;
    exit;
  end;
  _char:=#0;
end;

function _pred:wrd;forward;
function _succ:wrd;forward;

function _ord:byte;
var w:wrd;
    i:byte;
    c:char;
begin
  wait ('(');
  rd_wrd (w);
  if w='pred' then w:=_pred;
  if w='succ' then w:=_succ;
  c:=_char (w);
  if c<>#0 then begin
    _ord:=ord (c);
    exit;
  end;
  i:=find_idn (w);
  if i=0 then error (6);
  _ord:=idn [i].val;
  wait (')');
end;

function _pred:wrd;
var w:wrd;
    i:byte;
    c:char;
begin
  wait ('(');
  rd_wrd (w);
  if w='succ' then w:=_succ;
  if w='pred' then w:=_pred;
  c:=_char (w);
  if c<>#0 then begin
    if c>' ' then _pred:=''''+pred (c)+''''
             else _pred:=''''+chr (255)+'''';
    exit;
  end;
  i:=find_idn (w);
  if i=0 then error (6);
  _pred:=idn [idn [i].pr].nam;
  wait (')');
end;

function _succ:wrd;
var w:wrd;
    i:byte;
    c:char;
begin
  wait ('(');
  rd_wrd (w);
  if w='pred' then w:=_pred;
  if w='succ' then w:=_succ;
  c:=_char (w);
  if c<>#0 then begin
    if ord (c)<255 then _succ:=''''+succ (c)+''''
                   else _succ:=''' ''';
    exit;
  end;
  i:=find_idn (w);
  if i=0 then error (6);
  _succ:=idn [idn [i].nx].nam;
  wait (')');
end;


procedure error;
var ef:text;
const max_err=7;
      ert:array [0..max_err] of string [50]=(
      'Define expected',
      'Type or Constant expected',
      'Invalid name of Type, Constant or Key-word',
      'Type already defined',
      'Constant already defined',
      'Duplicate identifier',
      'Unknown identifier',
      'Syntax error');

begin
  assign (ef,'program.err');
  rewrite (ef);
  if en>max_err then begin
    writeln ('Internal error ',en);
    writeln (ef,'Internal error ',en);
    close (ef);
    halt;
  end;
  writeln ('Error ',en,' in line ',yk,': ',ert [en]);
  writeln (ef,'Error ',en,' in line ',yk,': ',ert [en]);
  close (ef);
  halt;
end;

function find_typ (n:wrd):byte;
var i:byte;
begin
  for i:=1 to tpp do
    if tps [i].nam=n then begin
      find_typ:=i;
      exit;
    end;
  find_typ:=0;
end;

function find_con (n:wrd):byte;
var i:byte;
begin
  for i:=1 to cnp do
    if cns [i].nam=n then begin
      find_con:=i;
      exit;
    end;
  find_con:=0;
end;

function find_idn;
var i:byte;
begin
  for i:=1 to idp do
    if idn [i].nam=n then begin
      find_idn:=i;
      exit;
    end;
  find_idn:=0;
end;

procedure def_typ;
begin
  rd_wrd (w2);
  if find_typ (w2)<>0 then error (3);
  inc (tpp);
  tps [tpp].nam:=w2;
end;

procedure def_con;
begin
  rd_wrd (w2);
  if find_con (w2)<>0 then error (4);
  inc (cnp);
  cns [cnp].nam:=w2;
  writeln (_ord);
end;

procedure install_idn;
{array - idn, pointer - idp}
begin
  idn [1].nam:='false';
  idn [1].val:=0;
  idn [1].nx:=2;
  idn [1].pr:=2;
  idn [2].nam:='true';
  idn [2].val:=1;
  idn [2].nx:=1;
  idn [2].pr:=1;
  idp:=2;
end;

procedure install_typs;
{array - tps, pointer - tpp}
begin
  tps [1].nam:='integer';
  tps [1].tp:=_int;
  tps [2].nam:='char';
  tps [2].tp:=_chr;
  tps [3].nam:='boolean';
  tps [3].tp:=_bol;
  tps [4].nam:='string';
  tps [4].tp:=_str;
  tpp:=4;
end;

procedure install_consts;
{array - cns, pointer - cnp}
begin
  cnp:=0;
end;

procedure install_file;
begin
  clrscr;
  assign (sf,'program.ddl');
  reset (sf);
  sfp:=0;
  yk:=1;
  s_f_e:=false;
end;


begin
{  while not s_f_e do begin
    ch:=rd_char;
    if ch=#13 then writeln
    else write (ch);
  end;}

  install_file;
  install_idn;
  install_typs;
  install_consts;

  repeat
    rd_wrd (w1);
    if w1<>key_word [3] then error (0);
    rd_wrd (w1);
    if (w1<>key_word [5]) and (w1<>key_word [6]) then error (1);
    if w1=key_word [5] then def_typ;
    if w1=key_word [6] then def_con;
  until s_f_e;

  close (sf);
end.