{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+}
{$M 16384,0,655360}

program p0604_1;

const
  up                    : string = '';
  down                  : string = '㪥뢠஫ᬨ';

var
  s                     : string;
  hash                  : integer;

procedure CreateHash( a1,a2,a3,m1,m2,m3 : integer );
var
  k,k1,k2,k3            : real;
begin
  k := m1*m2*m3/255;
  k1 := m1 / k;
  k2 := m2 / k;
  k3 := m3 / k;
  a1 := a1 mod round(k1);
  a2 := a2 mod round(k2);
  a3 := a3 mod round(k3);

  hash := round( a1 + k1*a2 + k1*k2*a3 ) mod 255 + 1;
end;

function Id( c : char ) : integer;
var
  i                     : integer;
begin
  for i:=1 to length( down ) do if c = down[i] then begin
    Id := i;
    exit;
  end;
end;

procedure Solve;
var
  i,j                   : integer;
begin
  for i:=1 to length( s ) do
    for j:=1 to length( up ) do
      if s[i] = up[j] then s[i] := down[j];
  CreateHash( Id( s[1] ), Id( s[2] ), length( s ), 17,5,3 );
end;

procedure ReadData;
var
  i                     : integer;
begin
  readln( s );
end;

procedure WriteData;
begin
  writeln( hash );
end;

procedure Reassign;
begin
  assign( input, 'hash.in' );
  reset( input );

  assign( output, 'hash.out' );
  rewrite( output );

end;

begin
  Reassign;
  while not eof( input ) do begin
    ReadData;
    Solve;
    WriteData;
  end;
end.