{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
Program P0606_5;
Type
  TA = Array [1..1000,1..2] Of Integer;
  TR = Array [1..1000,1..2] of single;
Var
  A: TA;
  L,N: Integer;
  T: Single;
  R: TR;
{  }
Function FileExists(FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;  { Set file access to read only }
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }
{  }
Procedure OpenInputFile (FileName: String);
Var
  F: Text;
  i: Integer;
begin
  If Not FileExists(FileName) Then
    begin WriteLn (' ',FileName,'  !'); Halt end;
  Assign (F, FileName);  Reset (F);
  Read (F, L, N);
  for i:=1 to N do  Read (F, A[i,1], A[i,2]);
  Close (F);
end;
{  }
Function S (t: Single): single;
var
  i,k: integer;
  h: single;
begin
  If t < 0 Then begin S:=0; exit end;
  k:=0;
  for i:=1 to N do If R[i,1]<=t Then begin k:=i; end;
  If k=0 Then h := 3.4e38 else h := R[k,2] + (t-R[k,1])*A[k+1,2];
  If T < R[1,1] Then h := T*A[1,2];
  If T > R[N,1] Then h:= 3.4e38;
  s:=h;
end;
{  }
Function FOk (t: Single): Boolean;
var
  i:integer;
begin
  If S(t)<L Then begin FOk:=False; exit end;
  for I:=1 to N do
    begin
      If Abs(S(    t+R[i,1])  - R[i,2]) < L Then begin FOk:=False; Exit end;
      If Abs(S(Abs(t-R[i,1])) - R[i,2]) < L Then begin FOk:=False; Exit end;
    end;
  FOk:=True;
end;
{  }
Var
  F: Text;
  ss: String;
  i: integer;
  Up, Down,k: Single;
Begin
  OpenInputFile ('train.in');
  down:=0; {up:=A[1,1]*A[1,2]; }R[1,1]:=A[1,1];  R[1,2]:=A[1,2]*A[1,1];
  for i:=2 to N do
    begin
      R[i,1]:=R[i-1,1] + A[i,1];
      R[i,2]:=R[i-1,2] + A[i,2]*A[i,1];
    end;
  up:=R[N,1];
  If R[N,2]<L Then T:=Up + 0.001
  Else
    begin
      While Abs(Up - Down) > 0.001 do
        begin
          k:=(Down + Up) / 2;
          While     FOk(k) do
            begin  Up  :=k; k:=(Down + Up) / 2; {writeln(down:10:3, up:10:3) }end;
          While Not FOk(k) do
            begin  Down:=k; k:=(Down + Up) / 2; {writeln(down:10:3, up:10:3) }end;
        end;
      T := Up;
    end;
  While Not Fok(T) do T:=T+0.001;
  Assign (F,'train.out'); Rewrite (F);
  Str(T:30:3,ss); while Ss[1]=' ' do delete(ss,1,1);  Write(F, sS);
  Close (F);
End.