{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
program macro;

const
  MaxN  = 1000;
var
  MaxX, MaxY            : integer;
  X1, Y1, X2, Y2        : array [1..MaxN] of integer;
  H                     : array [1..MaxN] of boolean;
  N                     : integer;

procedure swap (var X, Y : integer);
var Z : integer;
begin
  Z := X;
  X := Y;
  Y := Z
end;

procedure MakeInput;
var i, j : integer;
begin
  read (MaxX, MaxY, N);
  if (MaxX <= 0) or (MaxY <= 0) or (MaxX > 10000) or (MaxY > 10000) or
    (N <= 0) or (N > MaxN) then runerror (239);
  i := 0;
  for j := 1 to N do
    begin
      inc (i);
      read (X1[i], Y1[i], X2[i], Y2[i]);
      if Y1[i] = Y2[i] then
        begin
          H[i] := true;
          if X1[i] > X2[i] then swap (X1[i], X2[i])
        end
      else if X1[i] = X2[i] then
        begin
          H[i] := false;
          if Y1[i] > Y2[i] then swap (Y1[i], Y2[i])
        end
      else runerror (239);
      if (X1[i] < 0) or (Y1[i] < 0) or (X2[i] > MaxX) or (Y2[i] > MaxY)
        then runerror (239);
      if (H[i] and ((Y1[i] = 0) or (Y1[i] = MaxY))) or
         ((not H[i]) and ((X1[i] = 0) or (X1[i] = MaxX))) then dec(i);
    end;
  N := i;
end;

procedure workwith (X0, Y0  : integer);
var
  i             : integer;
  Xs, Ys        : integer;
begin
  Xs := MaxX;
  Ys := MaxY;

  for i := 1 to N do
    if H[i] and (Y1[i]=Y0) and (X1[i] <= X0) and (X2[i] > X0) then
      begin Xs := X2[i]; break end;
  for i := 1 to N do
    if (not H[i]) and (X1[i]=X0) and (Y1[i] <= Y0) and (Y2[i] > Y0) then
      begin Ys := Y2[i]; break end;

  for i := 1 to N do
    if H[i] and (X1[i]=X0) and (Y1[i] > Y0) and (Y1[i] < Ys) then
      Ys := Y1[i];
  for i := 1 to N do
    if (not H[i]) and (Y1[i]=Y0) and (X1[i] > X0) and (X1[i] < Xs) then
      Xs := X1[i];

  writeln (X0, ' ', Y0, ' ', Xs, ' ', Ys)
end;

procedure work;
var i, j                 : integer;
    min, max, thx, thy   : integer;
begin
  for i := 1 to N do if H[i] then
    begin
      min := 0;
      max := MaxX;
      thy := Y1[i];
      for j := 1 to N do
        if (not H[j]) and (Y1[j] < thy) and (Y2[j] > thy) then
          begin
            thx := X1[j];
            if thx <= X1[i] then
              begin
                if min < thx then min := thx
              end
            else
              begin
                if max > thx then max := thx
              end
          end;
      X1[i] := min;
      X2[i] := max
    end;

  for i := 1 to N do if not H[i] then
    begin
      min := 0;
      max := MaxY;
      thx := X1[i];
      for j := 1 to N do
        if H[j] and (X1[j] < thx) and (X2[j] > thx) then
          begin
            thy := Y1[j];
            if thy <= Y1[i] then
              begin
                if min < thy then min := thy
              end
            else
              begin
                if max > thy then max := thy
              end
          end;
      Y1[i] := min;
      Y2[i] := max
    end;

  writeln (N+1);

  workwith (0, 0);
  for i := 1 to N do workwith (X1[i], Y1[i])
end;


begin
  assign (input, 'divide.in');
  reset (input);
  assign (output, 'divide.out');
  rewrite (output);
  makeinput;
  work
end.