{$A-,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
var
  OutFile,InFile:Text;

function Dif(C:Char):Byte;
begin
  case C of
    ''..'':Dif:=Ord(C)-Ord('') div 2+1;
    ''..'':Dif:=16 + Round(111/16*(Ord(C)-Ord('')));
    ''..'':Dif:=130 + Round(125/16*(Ord(C)-Ord('')));
    else Dif:=Ord(C);
  end;
end;

procedure Init;
begin
  Assign(InFile,'Hash.IN');
  Reset(InFile);
  Assign(OutFile,'Hash.OUT');
  Rewrite(OutFile);
end;

procedure Done;
begin
  Close(InFile);
  Close(OutFile);
end;

function CountHash(S:String):Byte;
var
  A,I,X:Byte;
  L:Byte;
begin
  L:=Length(S);
  for I:=1 to L do
    begin
      X:=Dif(S[I]);
      A:=A + X;
    end;
  CountHash:=A+L;
end;

procedure Run;
var
  S:String;
begin
  while not EOF(InFile) do
    begin
      Readln(InFile,S);
      Writeln(OutFile,CountHash(S));
    end;
end;

begin
  Init;
  Run;
  Done;
end.