{$A-,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
const
  MaxX = 45;
  MaxY = 41;
  Max = 6;
var
  Pole:array[1..MaxX,1..MaxY] of Byte;
  MyColor,Enemy,Color:Byte;

procedure Input;
var
  F:Text;
  I,J:Integer;
  S:String;
begin
  Assign(F,'Filya.IN');
  Reset(F);
  for I:=1 to MaxY do
    begin
      Readln(F,S);
      for J:=1 to MaxX do
        Pole[J,I]:=Ord(S[J])-48;
    end;
  Close(F);
  Enemy:=Pole[MaxX,MaxY];
  MyColor:=Pole[1,1];
end;

procedure Output;
var
  F:Text;
begin
  Assign(F,'Filya.OUT');
  Rewrite(F);
  Writeln(F,Color);
  Close(F);
end;

procedure Run;
var
  Colors:array[1..Max] of Word;
  I,J:Integer;
  function CountBlock(X,Y:Word):Word;
  var
    Src:Byte;
    function Cnt(X,Y:Word):Word;
    begin
      Cnt:=0;
      if (X<=0) or (Y<=0) or (X>MaxX) or (Y>MaxY) then Exit;
      if (Pole[X,Y]<1) or (Pole[X,Y]>6) then Exit;
      if Pole[X,Y]<>Src then Exit;
      Pole[X,Y]:=7;
      Cnt:=1+Cnt(X-1,Y)+Cnt(X,Y-1)+Cnt(X+1,Y)+Cnt(X,Y+1);
    end;
  begin
    Src:=Pole[X,Y];
    CountBlock:=Cnt(X,Y);
  end;

  procedure Go(X,Y:Word);
  var
    C:Byte;
  begin
    if (X<=0) or (Y<=0) or (X>MaxX) or (Y>MaxY) then Exit;
    if (Pole[X,Y]<1) or (Pole[X,Y]>6) then Exit;
    if Pole[X,Y]=MyColor then
      begin
        Pole[X,Y]:=0;
        Go(X-1,Y);
        Go(X,Y-1);
        Go(X+1,Y);
        Go(X,Y+1);
      end
    else
      begin
        C:=Pole[X,Y];
        Inc(Colors[C],CountBlock(X,Y));
      end;
  end;
begin
  for I:=1 to Max do Colors[I]:=0;
  Go(1,1);
  Color:=1;
  while (Color=Enemy) or (Color=MyColor) do Inc(Color);
  for I:=1 to Max do
    if I<>Enemy then
      if Colors[Color]<Colors[I] then Color:=I;
end;

begin
  Input;
  Run;
  Output;
end.