{$N+,G+,R-,I-,S-}
{$M 64384,0,655360}
program FTA;

type arr =array [1..5010] of integer;
var n, m, k, i, j: integer;
    l: array [1..5010,1..3] of integer;
   lc: array [1..5010,1..3] of byte;
   lf: array [1..5010] of byte;
    u: array [1..5010] of boolean;
   cv: array [1..5010] of byte;
   pp: ^arr;
    c: integer;

procedure ReadAll;
var i, j: integer;
begin
  assign (input, 'rail.in');
  reset (input);
  readln(n);
  for i := 1 to n do
    readln(l[i,1], l[i,2], l[i,3]);
  for i := 1 to n do
  for j := 1 to 3 do
   lc[i,j] := 0;
  for i := 1 to n do
    u[i] := false;
  close (input);
end;

procedure FillLink (x, y, c: integer);
var i: integer;
begin
  for i := 1 to 3 do
  begin
    if l[x,i] = y then begin lc [x,i] := c; inc (lf[x]); end;
    if l[y,i] = x then begin lc [y,i] := c; inc (lf[y]); end;
  end;
end;

procedure NewLink (x, y: integer);
var c: integer;
begin
  if lc [x,1] > 0 then c := lc[x,1] else
  if lc [x,2] > 0 then c := lc[x,2] else
  if lc [x,3] > 0 then c := lc[x,3];
 FillLink(x,y,3-c);
end;

procedure GoDeep (a: integer);
begin
  u[a] := true;
  inc (c);
  pp^[c] := a;
  if not u[l[a,1]] then
         begin
           FillLink (a, l[a,1], cv[a]);
           cv[l[a,1]] := 3-cv[a];
           GoDeep (l[a,1]);
         end;
  if not u[l[a,2]] then
         begin
           FillLink (a, l[a,2], cv[a]);
           cv[l[a,2]] := 3-cv[a];
           GoDeep (l[a,2]);
         end;
  if not u[l[a,3]] then
         begin
           FillLink (a, l[a,3], cv[a]);
           cv[l[a,3]] := 3-cv[a];
           GoDeep (l[a,3]);
         end;
end;

procedure ProcessPiece (a: integer);
var q, i, j: integer;
    added: boolean;
begin
  c := 0;
  cv[a] := 1;
  GoDeep (a);

  repeat
  Added := false;
  for q := 1 to c do
  if lf [pp^[q]] = 1 then
  begin
    i := pp^[q];
    if lc [i,1] = 0 then
        if lf[ l[i,1] ] = 2 then
          begin
            NewLink (i, l[i,1]);
            Added := true;
            continue;
          end;
    if lc [i,2] = 0 then
        if lf[ l[i,2] ] = 2 then
          begin
            NewLink (i, l[i,2]);
            Added := true;
            continue;
          end;
    if lc [i,3] = 0 then
        if lf[ l[i,3] ] = 2 then
          begin
            NewLink (i, l[i,3]);
            Added := true;
            continue;
          end;
  end;
  until not added;
end;

procedure Solve;
var i, j: integer;
begin
  for i := 1 to n do lf[i] := 0;
  for i := 1 to n do
    if u[i] = false then ProcessPiece (i);
end;

procedure PrintLink (x, i: integer);
begin
  if lc [x, i] = 1 then writeln(x, ' ', l[x,i]);
  FillLink (x,l[x,i],5);
end;

procedure PrintRes;
var i, j: integer;
begin
  assign (output, 'rail.out');
  rewrite (output);
  for i := 1 to n do
  for j := 1 to 3 do
    printLink (i,j);
  close (output);
end;

begin
  new(pp);
  ReadAll;
  Solve;
  PrintRes;
end.