{$N+,G+,R-,S-,I-}
{$M 16384,0,655360}

program FTA;
var n, k, i, j: integer;
    m: array [1..41] of string;
    h, a, back1, back2, back3, back4: array [0..46,0..42] of byte;
    cc1, cc2, c1, c2: integer;
    qx, qy: array [1..2000] of byte;
    me, him, qh, qt: integer;
    col1: array [1..6] of integer;
    col2: array [1..6] of integer;

type float = double;

procedure Answer(a: byte);
begin
  assign (output, 'filya.out'); rewrite(output);
    writeln(a);
  close(output);
end;

procedure ReadAll;
var j, i: integer;
begin
  assign (input,'filya.in'); reset (input);
  for i := 1 to 41 do
  readln(m[i]);
  for i := 1 to 41 do
    for j := 1 to 45 do
      a[j,i] := byte(m[i][j])-48;
  close(input);
end;

function FindIt (xx, yy: integer; q: byte): integer;
var x, y: integer;
    c: byte;
    l: integer;
begin
  c := a[xx, yy];
  qh := 1; qt := 1; h[xx,yy] := q; l := 1;
  qx[1] := xx; qy[1] := yy;

  while qh >= qt do
  begin
    x := qx[qt]; y := qy[qt];
    inc (qt);

    if (a[x-1,y] = c) and (h[x-1,y] = 0) then
             begin
               h[x-1,y] := q;
               inc (qh);
               qx[qh] := x-1;
               qy[qh] := y;
               inc (l);
             end;
    if (a[x+1,y] = c) and (h[x+1,y] = 0) then
             begin
               h[x+1,y] := q;
               inc (qh);
               qx[qh] := x+1;
               qy[qh] := y;
               inc (l);
             end;
    if (a[x,y-1] = c) and (h[x,y-1] = 0) then
             begin
               h[x,y-1] := q;
               inc (qh);
               qx[qh] := x;
               qy[qh] := y-1;
               inc (l);
             end;
    if (a[x,y+1] = c) and (h[x,y+1] = 0) then
             begin
               h[x,y+1] := q;
               inc (qh);
               qx[qh] := x;
               qy[qh] := y+1;
               inc (l);
             end;
  end;
  FindIt := l;
end;

procedure FindMe;
var i, j: integer;
    q, bst: integer;
begin
  Me := FindIt (1, 1, 255);
  for i := 1 to 6 do col1[i] := 0;

  for i := 1 to 45 do
    for j := 1 to 41 do
      if h[i,j] = 0 then
         if (h[i+1,j] = 255) or
            (h[i-1,j] = 255) or
            (h[i,j-1] = 255) or
            (h[i,j+1] = 255) then
            inc(col1[a[i,j]],  FindIt (i,j,a[i,j]));
end;

procedure FindHim;
var i, j: integer;
    q, bst: integer;
begin
  him := FindIt (45, 41, 254);
  for i := 1 to 6 do col2[i] := 0;

  for i := 1 to 45 do
    for j := 1 to 41 do
      if h[i,j] = 0 then
         if (h[i+1,j] = 254) or
            (h[i-1,j] = 254) or
            (h[i,j-1] = 254) or
            (h[i,j+1] = 254) then
            inc(col2[a[i,j]],  FindIt (i,j,a[i,j]+100));
end;

procedure Fill (xx, yy: integer; c: byte);
var cc: byte;
    x, y: integer;
    q: byte;
begin
  q := 100;
  cc := a[xx, yy];
  qh := 1; qt := 1; a[xx,yy] := c;
  qx[1] := xx; qy[1] := yy;

  while qh >= qt do
  begin
    x := qx[qt]; y := qy[qt];
    inc (qt);

    if (a[x-1,y] = cc) then
             begin
               a[x-1,y] := c;
               inc (qh);
               qx[qh] := x-1;
               qy[qh] := y;
             end;
    if (a[x+1,y] = cc) then
             begin
               a[x+1,y] := c;
               inc (qh);
               qx[qh] := x+1;
               qy[qh] := y;
             end;
    if (a[x,y-1] = cc) then
             begin
               a[x,y-1] := c;
               inc (qh);
               qx[qh] := x;
               qy[qh] := y-1;
             end;
    if (a[x,y+1] = cc) then
             begin
               a[x,y+1] := c;
               inc (qh);
               qx[qh] := x;
               qy[qh] := y+1;
             end;
  end;
end;

function Value (c: integer): longint;
var i: integer;
    v: longint;
    j, q: integer;
begin
  q := -1;
  for i := 1 to 6 do if (i<>c2) and (i<>c) then
     if col2[i] > q then q := col2[i];
  v := (me+col1[c]-q-him)*2;

  for i := 1 to 45 do
    for j := 1 to 41 do
      if (a[i, j] <> c) and (h[i, j] < 254) then
         if (h[i+1,j] = 255) or
            (h[i-1,j] = 255) or
            (h[i,j-1] = 255) or
            (h[i,j+1] = 255) or
            (h[i+1,j] = c  ) or
            (h[i-1,j] = c  ) or
            (h[i,j-1] = c  ) or
            (h[i,j+1] = c  ) then inc (v);

  Value := 100000+v;
end;

procedure Findbest (var val, best: longint);
var tmp, i, q, bst: longint;
begin
  q := -1; bst := 0;
  for i := 1 to 6 do
   if (i <> c1) and (i<>c2) then
     begin
       tmp := Value (i);
       if tmp > q then begin q := tmp; bst := i;end;
     end;
  val := q; best := bst;
end;

Procedure Appraise (var Val, Best: longint);
begin
  c1 := a[1,1];
  c2 := a[45,41];
  FillChar(h, sizeof(h),0);
  FindMe;
  FindHim;
  FindBest(val, best);
end;

Procedure SearchHim (var Val, Best, expec: longint);
var i, q, l: longint;
    v, b: longint;
begin
  best := 0; val := 2000000000;
  for i := 1 to 6 do
  if (i <> a[1,1]) and (i<> a[45, 41]) then
    begin
      Back2 := a;
      Fill (45, 41, i);
      Appraise (V, B);
      if v < Val then begin Val := v; best := i; end;
      if val < Expec then exit;
      a := Back2;
    end;
end;

Procedure SearchMe (var Val, Best, expec: longint);
var i, q, l: longint;
    v, b: longint;
begin
  best := 0; val := -2000000000;
  for i := 1 to 6 do
  if (i <> a[1,1]) and (i<> a[45, 41]) then
    begin
      Back1 := a;
      Fill (1, 1, i);
      SearchHim (V, B, val);
      if v > Val then begin Val := v; best := i; end;
      if val > Expec then exit;
      a := Back1;
    end;
end;

Procedure SearchHim2 (var Val, Best, expec: longint);
var i, q, l: longint;
    v, b: longint;
begin
  best := 0; val := 2000000000;
  for i := 1 to 6 do
  if (i <> a[1,1]) and (i<> a[45, 41]) then
    begin
      Back4 := a;
      Fill (45, 41, i);
      SearchMe (V, B, val);
      if v < Val then begin Val := v; best := i; end;
      if val < Expec then exit;
      a := Back4;
    end;
end;

Procedure SearchMe2 (var Val, Best: longint);
var i, q, l: longint;
    x, y: integer;
    v, b: longint;
begin
  best := 0; val := -2000000000;
  for i := 1 to 6 do
  if (i <> a[1,1]) and (i<> a[45, 41]) then
    begin
      Back3 := a;
      FillChar(h, Sizeof(h),0);FindMe; x := Me;
      Fill (1, 1, i);
      FillChar(h, Sizeof(h),0);FindMe; if me = x then
                                       begin
                                         a := Back3;
                                         continue;
                                       end;
      SearchHim2 (V, B,val);
      if v > Val then begin Val := v; best := i; end;
      a := Back3;
    end;
 if best = 0 then repeat inc(best);
                  until (best <> a[1,1]) and (best <> a[45,41]);
end;

procedure Solve;
var b: integer;
    val, best: longint;
begin
  cc1 := a[1,1];
  cc2 := a[45,41];
  c1 := cc1; c2 := cc2;
  FindMe;
  FindHim;
  SearchMe2 (val, best);
  Answer (best);
end;

begin
  randomize;
  ReadAll;
  Solve;
end.
