Program N2;
Var
  i,j,n,mx1,mx2,my1,my2 : integer;
  Hegth,Width : integer;
  Zasek : array [1..1000] of Record
                               x1,y1,x2,y2 : Integer;
                             End;
  f : text;
  GranZas : array [1..1000] of boolean;
  t,t1 : boolean;
  Rectangle : array [1..1000] of Record
                                   x1,y1,x2,y2 : Integer;
                                 End;
  HRectangle,RealRectangle : Integer;

Procedure ReadFile;
Begin
  Assign(f,'divide.in');
  Reset(f);
  Read(f,Width);
  Read(f,Hegth);
  Read(f,n);
  For i:=1 to n do
    Begin
      Read(f,Zasek[i].x1);
      Read(f,Zasek[i].y1);
      Read(f,Zasek[i].x2);
      Read(f,Zasek[i].y2);
      GranZas[i]:=false;
    End;
  Close(f);
End;

Function FindNotGranZas (k:integer) : integer;
Var
  i : integer;
Begin
  For i:=k to n do
    If not GranZas[i] then
      Begin
        FindNotGranZas:=i;
        Exit;
      End;
  FindNotGranZas:=0;
End;

Function ZasInBar (No,rx1,ry1,rx2,ry2:integer) : boolean;
Begin
  With Zasek[No] Do
    If (x1>=rx1) and (y1>=ry1) and (x2<=rx2) and (y2<=ry2)
       then ZasInBar:=true
       else ZasInBar:=false;
End;

Function Peres (i,j:integer) : boolean;
Var
  Z1,Z2,x,y : Integer;
Begin
  x:=Zasek[j].x1;
  y:=Zasek[j].y1;
  With Zasek[i] Do Z1:=(x-x1)*(y2-y1)-(y-y1)*(x2-x1);

  x:=Zasek[j].x2;
  y:=Zasek[j].y2;
  With Zasek[i] Do Z2:=(x-x1)*(y2-y1)-(y-y1)*(x2-x1);

  If Z1*Z2<0 then Peres:=true else Peres:=false;
End;

Procedure Rec (rx1,ry1,rx2,ry2 : integer);
Begin
  t1:=false;
  For i:=1 to n do
    If (not GranZas[i]) and (ZasInBar(i,rx1,ry1,rx2,ry2)) then
       Begin
         t1:=true;
         t:=true;
         For j:=1 to n do
           If (ZasInBar(j,rx1,ry1,rx2,ry2)) and (Peres(i,j))
             then t:=false;
         If t then Break;
       End;

  If not t1 then
    Begin     { !!!!!!!!!!!!!! }
      Inc(HRectangle);
      With Rectangle[HRectangle] Do
        Begin
          x1:=rx1;
          y1:=ry1;
          x2:=rx2;
          y2:=ry2;
        End;
      Exit;
    End;

  GranZas[i]:=true;
  For j:=1 to N do
    Begin
      With Zasek[j] Do
        Begin
          If (ZasInBar(j,rx1,ry1,rx2,ry2)) and (x1=rx1) and (x2=rx2)
             then GranZas[j]:=true;
        End;
    End;

  With Zasek[i] Do
    Begin
      If x1=x2 then
        Begin
          Rec(rx1,ry1,x1,ry2);
          Rec(x1,ry1,rx2,ry2);
          Exit;
        End;
      If y1=y2 then
        Begin
          Rec(rx1,ry1,rx2,y2);
          Rec(rx1,y2,rx2,ry2);
          Exit;
        End;
    End;
End;

Function ZasekInRebro(mx1,my1,mx2,my2 : integer):boolean;
Var
  l : integer;
  t : boolean;
Begin
  t:=false;
  For l:=1 to n do
    With Zasek[l] do
      Begin
        If (mx1=mx2) and (x1=x2) and
           (((my1<=y1) and (my2>=y1)) or ((my2<=y2) and (my2>=y2)))
             then t:=true;
        If (my1=my2) and (y1=y2) and
           (((mx1<=x1) and (mx2>=x1)) or ((mx2<=x2) and (mx2>=x2)))
             then t:=true;
      End;
  ZasekInRebro:=t;
End;

Function NormalRebro (mx1,my1,mx2,my2,j : integer) : boolean;
Var t:boolean;
Begin
  If ZasekInRebro(mx1,my1,mx2,my2) then
     Begin
       NormalRebro:=false;
       Exit;
     End;

  t:=false;
  With Rectangle[j] Do
    Begin
      If (mx1=x1) and (mx2=x2) and (my1=y2) then t:=true;
      If (mx1=x1) and (mx2=x2) and (my2=y1) then t:=true;
      If (my1=y1) and (my2=y2) and (mx2=x1) then t:=true;
      If (my1=y1) and (my2=y2) and (mx1=x2) then t:=true;
    End;
  NormalRebro:=t;
End;

Function ObRebro (i,j:integer) : boolean;
Begin
  If NormalRebro (Rectangle[i].x1,Rectangle[i].y1,
                  Rectangle[i].x2,Rectangle[i].y1,j) OR
     NormalRebro (Rectangle[i].x1,Rectangle[i].y2,
                  Rectangle[i].x2,Rectangle[i].y2,j) OR
     NormalRebro (Rectangle[i].x1,Rectangle[i].y1,
                  Rectangle[i].x1,Rectangle[i].y2,j) OR
     NormalRebro (Rectangle[i].x2,Rectangle[i].y1,
                  Rectangle[i].x2,Rectangle[i].y2,j)
                   then ObRebro:=true
                   else ObRebro:=false;
End;

Function Min (a,b:integer) : integer;
Begin
  If a<b then Min:=a else Min:=b;
End;

Function Max (a,b:integer) : integer;
Begin
  If a>b then Max:=a else Max:=b;
End;

BEGIN
  ReadFile;
  HRectangle:=0;
  Rec(0,0,Width,Hegth);
  RealRectangle:=HRectangle;
  For i:=1 to HRectangle-1 Do
    For j:=i+1 to HRectangle Do
      If ObRebro(i,j) then
        Begin
          Rectangle[i].x1:=Min(Rectangle[i].x1,Rectangle[j].x1);
          Rectangle[i].y1:=Min(Rectangle[i].y1,Rectangle[j].y1);
          Rectangle[i].x2:=Max(Rectangle[i].x2,Rectangle[j].x2);
          Rectangle[i].y2:=Max(Rectangle[i].y2,Rectangle[j].y2);
          Rectangle[j].x1:=0;
          Rectangle[j].y1:=0;
          Rectangle[j].x2:=0;
          Rectangle[j].y2:=0;
          Dec(RealRectangle);
        End;

  Assign(f,'divide.out');
  Rewrite(f);
  WriteLn(f,RealRectangle);
  For i:=1 to HRectangle Do
    Begin
      If (Rectangle[i].x1=0) And (Rectangle[i].y1=0) And
         (Rectangle[i].x2=0) And (Rectangle[i].y2=0)
            then Continue
            else With Rectangle[i] Do
                   Begin
                     WriteLn(f,x1,' ',y1,' ',x2,' ',y2);
                   End;
    End;
  Close(f);
END.