{$M 54384,0,655360}
Program Filya_Strateg;
Const
  WinX = 45;
  WinY = 41;
Var
  a : array [1..WinX,1..WinY] of char;
  b : array [1..WinX,1..WinY] of boolean;
  Score : array [1..WinX,1..WinY] of integer;
  i,j,Max,pi,pj,i1,j1,k : integer;
  f : text;
  ExitColor : char;

Procedure ReadFile;
Begin
  Assign(f,'filya.in');
  Reset(f);
  For j:=1 to WinY do
    For i:=1 to WinX do
      If i=WinX then ReadLn(f,a[i,j])
                else Read(f,a[i,j]);
  Close(f);
End;

Function OneColor (x,y : integer; Color : char) : integer;
Begin
  If (x<1) or (y<1) or (x>WinX) or (y>WinY) or b[x,y] then
     Begin
       OneColor:=0;
       Exit;
     End;

  b[x,y]:=true;
  If a[x,y]=Color then OneColor:=OneColor(x-1,y,Color)+
                                 OneColor(x+1,y,Color)+
                                 OneColor(x,y-1,Color)+
                                 OneColor(x,y+1,Color)+1
                  else OneColor:=0;
End;

Function CountScore (x,y:integer) : integer;
Var i,j : integer;
Begin
  If (a[x,y]=a[1,1]) Or (a[x,y]=a[WinX,WinY])
      then begin
             CountScore:=0;
             Exit;
           end;
  For i:=1 to WinX do
    For j:=1 to WinY do
      b[i,j]:=false;

  CountScore:=OneColor(x,y,a[x,y]);
End;

Function Min5El(a,b,c,d,e : integer):integer;
Begin
  If (a<=b) and (a<=c) and (a<=d) and (a<=e) then Min5El:=a else
    If (b<=a) and (b<=c) and (b<=d) and (b<=e) then Min5El:=b else
      If (c<=a) and (c<=b) and (c<=d) and (c<=e) then Min5El:=c else
        If (d<=a) and (d<=b) and (d<=c) and (d<=e) then Min5El:=d else
           Min5El:=e;
End;

Function Rast (x,y:integer; Color:char; i,j:integer) : integer;
Begin
  If (x<1) or (y<1) or (x>WinX) or (y>WinY) or (b[x,y]) or (a[x,y]<>Color)
                   then Begin
                          b[x,y]:=true;
                          Rast:=MaxInt;
                          Exit;
                        End;

                          b[x,y]:=true;
                          Rast:=Min5El(abs(i-x)+abs(j-y),
                                       Rast(x-1,y,Color,i,j),
                                       Rast(x+1,y,Color,i,j),
                                       Rast(x,y-1,Color,i,j),
                                       Rast(x,y+1,Color,i,j));
End;

Procedure Main;
Begin
  For i:=1 to WinX do
    For j:=1 to WinY do
      If (a[i,j]<>a[1,1]) and (a[i,j]<>a[WinX,WinY])
          then Score[i,j]:=CountScore(i,j);

  Max:=0; pi:=1; pj:=1;

  For i:=1 to WinX do
    For j:=1 to WinY do
      Begin
        If Score[i,j]>Max then
           Begin
             For i1:=1 to WinX do
               For j1:=1 to WinY do
                 b[i1,j1]:=false;
             k:=Rast(1,1,a[1,1],i,j);
             If k=1 then
                    begin
                      Max:=Score[i,j];
                      pi:=i;
                      pj:=j;
                    end;
          End;
      End;
  ExitColor:=a[pi,pj];
End;

Procedure PrintOut;
Begin
  Randomize;
  While (ExitColor=a[1,1]) Or (ExitColor=a[WinX,WinY]) Do
     ExitColor:=Chr(Random(6)+Ord('1'));

  Assign(f,'filya.out');
  Rewrite(f);
  Write(f,ExitColor);
  Close(f);
End;

BEGIN
  ReadFile;
  FillChar(Score,SizeOf(Score),0);
  Main;
  PrintOut;
END.