//#include <iostream.h>
#include <fstream.h>
//#include <stdlib.h>
//#include <math.h>
//#include <stdio.h>
//#include <process.h>

int N,Lev;
float L;
float V[1002];
float T[1002];
char f;

float fullT;
float fullS;

float S(float t);
char check(float t, float dt);
char check2(float t, float dt);
char checkdt(float dt);


float S(float t)
{
		float s = 0;
		int i = 0;

/*		while(t>fullT)
		{
			t-=fullT;
			s+=fullS;
		}
*/
		while(t >= T[i])
		{
			s+=T[i]*V[i];
			t-=T[i];
			i++;
		}
		s+=t*V[i];
		return s;
}

char check(float t, float dt)
{
        float s1, s2;
        s1 = S(t);
        s2 = S(t - dt);
	return  (s1 - s2) < L;
}
char check2(float t, float dt)
{
        float s1, s2;
        s1 = S(t);
        s2 = S(t + dt);
	return  (s2 - s1) < L;
}

char checkdt(float dt)
{
	float flag = 0;
        int i;
        float t = 0;
	for(i=0; i < N; i++)
	{
                if(t > dt)
                {
		        flag+=check(t, dt);
                }
                t+=T[i];
		if(flag > 0)
			return 1;
	}
        t=0;
	for(i=0; i < N; i++)
	{
                if(t < fullT - dt)
                {
		        flag+=check2(t, dt);
                }
                t+=T[i];
		if(flag > 0)
			return 1;
	}
	return 0;
}
float iter(float a, float b)
{
	Lev++;
	if(Lev > 1000)
		return (a+(b-a)/2);
	f = checkdt(a + (b-a)/2);
	if(f)
		return iter(a + (b-a)/2, b);
	else
		return iter(a, a + (b-a)/2);
}
void main(void)
{
	fullT = 0;
	fullS = 0;

	float dt;

	ifstream f1("train.in");
	ofstream f2("train.out");

	f1 >> L;
	f1 >> N;

	for(int i = 0; i < N; i++)
	{
		f1 >> T[i];
		f1 >> V[i];

		fullT+=T[i];
		fullS+=T[i]*V[i];
	}

        Lev = 0;
	dt = iter(0, fullT);

	f2 << dt << "\n";

	f1.close();
	f2.close();
}