{ ᥩ 줣, ᨡ᪠  - 襭  4 }

{$M 65520,0,655360}

const
	MaxDepth=4;
	Infinity=32767;

type
	TField=array [1..41] of string [45];

	PVisited=^TVisited;
	TVisited=array [1..41,1..45] of boolean;

var InF,OutF:Text;
	PF:TField;
	i,j:integer;
	M,BestMove:char;
	BestProfit,CurProfit:integer;
	Temp:longint;

function Join(var F:TField; X,Y:integer; C:char; V:PVisited):integer;
var Res:integer; i,j:integer;
begin
	V^[X,Y]:=True;
	Res:=1;
	if (X>1) and (not V^[X-1,Y]) and (F[X-1][Y]=C)
	then Inc(Res,Join(F,X-1,Y,C,V));
	if (Y>1) and (not V^[X,Y-1]) and (F[X][Y-1]=C)
	then Inc(Res,Join(F,X,Y-1,C,V));
	if (X<41) and (not V^[X+1,Y]) and (F[X+1][Y]=C)
	then Inc(Res,Join(F,X+1,Y,C,V));
	if (Y<45) and (not V^[X,Y+1]) and (F[X][Y+1]=C)
	then Inc(Res,Join(F,X,Y+1,C,V));
	Join:=Res
end;


function Repaint(var F:TField; X,Y:integer; C:char; V:PVisited):integer;
var Res:integer; From:char; i,j:integer;
begin
	if (X+Y=2) or (X+Y=86) then begin
		New(V);
		for i:=1 to 41 do for j:=1 to 45 do V^[i,j]:=False
	end;
	V^[X,Y]:=True;
	Res:=0;
	From:=F[X,Y];
	F[X,Y]:=C;
	if (X>1) and (not V^[X-1,Y]) then begin
		if F[X-1][Y]=From then Inc(Res,Repaint(F,X-1,Y,C,V))
		else if F[X-1][Y]=C then Inc(Res,Join(F,X-1,Y,C,V))
	end;
	if (Y>1) and (not V^[X,Y-1]) then begin
		if F[X][Y-1]=From then Inc(Res,Repaint(F,X,Y-1,C,V))
		else if F[X][Y-1]=C then Inc(Res,Join(F,X,Y-1,C,V))
	end;
	if (X<41) and (not V^[X+1,Y]) then begin
		if F[X+1][Y]=From then Inc(Res,Repaint(F,X+1,Y,C,V))
		else if F[X+1][Y]=C then Inc(Res,Join(F,X+1,Y,C,V))
	end;
	if (Y<45) and (not V^[X,Y+1]) then begin
		if F[X][Y+1]=From then Inc(Res,Repaint(F,X,Y+1,C,V))
		else if F[X][Y+1]=C then Inc(Res,Join(F,X,Y+1,C,V))
	end;
	Repaint:=Res;
	if (X+Y=2) or (X+Y=86) then Dispose(V)
end;

function Look(C:char; IsFirst:boolean; F:TField; Depth:byte):integer;
var Res:integer; i:char; BP,CP:integer;
begin
	if IsFirst then Res:=Repaint(F,1,1,C,nil)
	else Res:=-Repaint(F,41,45,C,nil);
	if Depth<MaxDepth then begin
		if IsFirst then BP:=-Infinity else BP:=Infinity;
		for i:='1' to '6' do if (i<>F[1][1]) and (i<>F[41][45]) then begin
			CP:=Look(i,not IsFirst,F,Depth+1);
			if CP>BP then BP:=CP
		end;
		if IsFirst then Temp:=longint(Res)+longint(BP) else
		Temp:=longint(Res)-longint(BP);
		if Abs(Temp)<=Infinity then Res:=Temp
		else if Temp>0 then Res:=Infinity else Res:=-Infinity
	end;
	Look:=Res
end;

begin
	Assign(InF,'filya.in');
	Assign(OutF,'filya.out');
	Reset(InF); Rewrite(OutF);
	for i:=1 to 41 do ReadLn(InF,PF[i]);
	BestProfit:=-Infinity;
	for M:='1' to '6' do if (M<>PF[1][1]) and (M<>PF[41][45]) then begin
		CurProfit:=Look(M,True,PF,1);
		if CurProfit>=BestProfit then begin
			BestProfit:=CurProfit;
			BestMove:=M
		end
	end;
	Write(OutF,BestMove);
	Close(InF); Close(OutF)
end.
