program s0707_5;

type TPart = record
  Time, Speed: single;
end;
var wayTime, wayLen, minDist: single;
    nParts: longint;
    timeDif: single;
    Parts: array [1..1000] of TPart;
    PartSTime, PartSPlace: array [1..1000] of single;

function Place(t: single): single;
var path: single;
    tm, sum: single;
    i: longint;
begin
  for i := 2 to nParts do begin
    if PartSTime[i] > t then begin
      Place := PartSPlace[i-1]+(t-PartSTime[i-1])*Parts[i-1].Speed;
      break;
    end
  end
end;

var sp, st, pl1, pl2, t: single;
    i: longint;
    tt: single;
    dis: single;

begin
  Assign(Input, 'train.in'); Reset(Input);
  {Assign(Output, 'train.out'); Rewrite(Output);}
  Read(minDist);
  Read(nParts);
  dis := nParts/1000;
  for i := 1 to nParts do begin
    Read(Parts[i].Time, Parts[i].Speed);
    wayTime := wayTime + Parts[i].Time;
  end;

  sp := 0;
  st := 0;
  for i := 1 to nParts do begin
    PartSPlace[i] := sp;
    PartSTime[i] := st;
    sp := sp + Parts[i].Speed*Parts[i].Time;
    st := st + Parts[i].Time;
  end;
  wayLen := Place(wayTime);

  timeDif := 0;
  tt := 0;
  while true do begin
    if tt >= wayTime then break;
    pl1 := Place(tt);
    pl2 := Place(tt-timeDif);
    while (pl2>0) and (pl1-pl2<minDist) do begin
      timeDif := timeDif+dis;
      {if tt-timeDif<0 then timeDif := tt;}
      pl1 := Place(tt);
      pl2 := Place(tt-timeDif);
    end;
    tt := tt+dis;
  end;
  Writeln(timeDif:0:2);
end.