{$UNDEF DEBUG}
{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 65520,0,0}
{$IFDEF DEBUG}
{$D+,L+,Y+,I+,S+,R+,O+}
{$ENDIF}
Const
  AppName='TRAIN';
  MaxN=1000;
Type
  Real=Extended;
Var
  Result:Real;
  L,N:Word;
  T,V:Array[0..MaxN]OF Word;
  Len:Array[0..MaxN]Of LongInt;
Procedure Init;
Var
  I:Word;
Begin
  Assign(Input,AppName+'.IN');
  Reset(Input);
  ReadLn(L);
  ReadLn(N);
  T[0]:=0;
  V[0]:=0;
  Len[0]:=0;
  For I:=1 To N Do Begin
    ReadLn(T[I],V[I]);
    Len[I]:=T[I]*V[I];
    T[I]:=T[I]+T[I-1];
  End;
  Close(Input);
End;
Function Bad:Boolean;
Var
  CP1,CP2:Word;
  CL1,CL2,CT1:Real;
Begin
  CP1:=0;
  CP2:=1;
  CL1:=0;
  CL2:=0;
  CT1:=0;
  While CT1<Result Do Begin
    Inc(CP1);
    If CP1>N Then Begin Bad:=False; Exit; End;
    CT1:=T[CP1];
    CL1:=CL1+Len[CP1];
  End;
  If CP1>0 Then CT1:=T[CP1-1];
  CL1:=CL1-Len[CP1]+V[CP1]*(Result-CT1);
  CT1:=Result;
  While (CP1<=N) And (CP2<=N) Do Begin
    If CL1-CL2<L Then Begin Bad:=True; Exit; End;
    If T[CP1]<T[CP2]+Result Then Begin
      CL1:=CL1+V[CP1]*(T[CP1]-CT1);
      CL2:=CL2+V[CP2]*(T[CP1]-CT1);
      CT1:=T[CP1];
      Inc(CP1);
    End Else Begin
      CL2:=CL2+V[CP2]*(T[CP2]+Result-CT1);
      CL1:=CL1+V[CP1]*(T[CP2]+Result-CT1);
      CT1:=T[CP2]+Result;
      Inc(CP2);
    End;
  End;
  Bad:=False;
End;
Procedure Run;
Var
  CurAdd:Real;
Begin
  If N=0 Then Begin Result:=0; Exit; End;
  CurAdd:=1E7;
  While CurAdd>1E-5 Do Begin
    While Bad Do Result:=Result+CurAdd;
    Result:=Result-CurAdd;
    CurAdd:=CurAdd/10;
  End;
End;
Procedure Done;
Begin
  Assign(Output,AppName+'.OUT');
  ReWrite(Output);
  WriteLn(Result:0:3);
  Close(Output);
End;
Begin
  Init;
  Run;
  Done;
End.