type TLine = record
               X1, Y1: word;
               X2, Y2: word;
               Cross: word;
             end;
     TSquare = record
                 X1, Y1: word;
                 X2, Y2: word;
               end;
var Lines: array [1..1000] of TLine;
    Squares: array [1..1000] of TSquare;
    X, Y: word;
    mX, mY: word;
    LCount: word;
    FCount: word;
procedure ReadData;
var Input: Text;
    i: integer;
begin
  Assign ( Input, 'divide.in');
  Reset ( Input);
  Read ( Input, mX, mY);
  Read ( Input, LCount);
  for i:=1 to LCount do
    with Lines[i] do
      begin
        Read ( Input, X1, Y1, X2, Y2);
        if X1>mX then X1:=mX;
        if X2>mX then X2:=mX;
        if Y1>mY then Y1:=mY;
        if Y2>mY then Y2:=mY;
      end;
  Close ( Input);
  FCount:=1;
  with Squares[1] do
    begin
      X1:=0; Y1:=0;
      X2:=mX; Y2:=mY;
    end;
end;
function InSquare ( Line: TLine; Square: TSquare): byte;
var Result: byte;
    aX1, aY1, aX2, aY2: word;
begin
  Result:=0;
  if Square.X1<Square.X2 then
    begin
      aX1:=Square.X1; aX2:=Square.X2;
    end
                         else
    begin
      aX1:=Square.X2; aX2:=Square.X1;
    end;
  if Square.Y1<Square.Y2 then
    begin
      aY1:=Square.Y1; aY2:=Square.Y2;
    end
                         else
    begin
      aY1:=Square.Y2; aY2:=Square.Y1;
    end;
  if ((Line.X1>=aX1) and (Line.X1<=aX2)) and ((Line.Y1>=aY1) and (Line.Y1<=aY2)) then Inc ( Result);
  if ((Line.X2>=aX1) and (Line.X2<=aX2)) and ((Line.Y2>=aY1) and (Line.Y2<=aY2)) then Inc ( Result);
  if Result=1 then
    begin
      if (((Line.X1>aX1) and (Line.X1<aX2)) and ((Line.Y1>aY1) and (Line.Y1<aY2))) or
         (((Line.X2>aX1) and (Line.X2<aX2)) and ((Line.Y2>aY1) and (Line.Y2<aY2))) then Result:=1
                                                                                       else Result:=0;
    end;
  if Line.X1=Line.X2 then
    begin
      if ((Line.Y1<aY1) and (Line.Y2>aY2)) or ((Line.Y2<aY1) and (Line.Y1>aY2)) then Result:=2;
    end
                     else
    begin
      if ((Line.X1<aX1) and (Line.X2>aX2)) or ((Line.X2<aX1) and (Line.X1>aX2)) then Result:=2;
    end;
  InSquare:=Result;
end;
procedure Counting;
var i, j, j1: integer;
begin
  for i:=1 to LCount do
    begin
      j:=1;
      while j<=FCount do
        begin
          case InSquare ( Lines[i], Squares[j]) of
            1: begin
{$R-}            j1:=j+1; while InSquare ( Lines[i], Squares[j1])<>1 do Inc ( j1);{$R+}
                 Inc ( FCount);
                 with Squares[FCount] do
                   begin
                     if Lines[i].X1=Lines[i].X2 then
                       begin
                         X1:=Lines[i].X1; X2:=Squares[j].X2;
                         if Squares[j].Y1<Squares[j1].Y1 then
                           begin
                             Y1:=Squares[j].Y1; Y2:=Squares[j1].Y2;
                           end
                                                         else
                           begin
                             Y1:=Squares[j1].Y1; Y2:=Squares[j].Y2;
                           end;
                         Squares[j].X2:=Lines[i].X1; Squares[j1].X2:=Lines[i].X1;
                       end
                                                else
                       begin
                         Y1:=Lines[i].Y1; Y2:=Squares[j].Y2;
                         if Squares[j].X1<Squares[j1].X1 then
                           begin
                             X1:=Squares[j].X1; X2:=Squares[j1].X2;
                           end
                                                         else
                           begin
                             X1:=Squares[j1].X1; X2:=Squares[j].X2;
                           end;
                         Squares[j].Y2:=Lines[i].Y1; Squares[j1].Y2:=Lines[i].Y1;
                       end;
                   end;
                 j:=FCount;
               end;
            2: begin
                 Inc ( FCount);
                 with Squares[FCount] do
                   begin
                     if Lines[i].X1=Lines[i].X2 then
                       begin
                         X1:=Lines[i].X1; X2:=Squares[j].X2;
                         Y1:=Squares[j].Y1; Y2:=Squares[j].Y2;
                         Squares[j].X2:=Lines[i].X1;
                       end
                                                else
                       begin
                         X1:=Squares[j].X1; X2:=Squares[j].X2;
                         Y1:=Lines[i].Y1; Y2:=Squares[j].Y2;
                         Squares[j].Y2:=Lines[i].Y1;
                       end;
                   end;
                 j:=FCount;
               end;
          end;
          Inc ( j);
        end;
    end;
end;
procedure CountCrosses;
var i, j: integer;
begin
  for i:=1 to LCount do
    for j:=1 to LCount do
      if i<>j then
        begin
          if Lines[i].X1=Lines[i].X2 then
            begin
              if Lines[j].Y1=Lines[j].Y2 then
                begin
                  if Lines[i].Y1<Lines[i].Y2 then
                    begin
                      if (Lines[i].Y1<Lines[j].Y1) and (Lines[i].Y2>Lines[j].Y2) then Inc ( Lines[i].Cross);
                    end
                                             else
                    begin
                      if (Lines[i].Y2<Lines[j].Y1) and (Lines[i].Y1>Lines[j].Y2) then Inc ( Lines[i].Cross);
                    end;
                end;
            end
                                     else
            begin
              if Lines[j].X1=Lines[j].X2 then
                begin
                  if Lines[i].X1<Lines[i].X2 then
                    begin
                      if (Lines[i].X1<Lines[j].X1) and (Lines[i].X2>Lines[j].X2) then Inc ( Lines[i].Cross);
                    end
                                             else
                    begin
                      if (Lines[i].X2<Lines[j].X1) and (Lines[i].X1>Lines[j].X2) then Inc ( Lines[i].Cross);
                    end;
                end;
            end;
        end;
end;
procedure SortByCrosses;
var Swaped: Boolean;
    i: integer;
    Temp: TLine;
begin
  Swaped:=True;
  while Swaped do
    begin
      Swaped:=False;
      for i:=1 to LCount-1 do
        if Lines[i].Cross<Lines[i+1].Cross then
          begin
            Temp:=Lines[i]; Lines[i]:=Lines[i+1]; Lines[i+1]:=Temp;
            Swaped:=True;
          end;
    end;
end;
procedure WriteResult;
var Output: Text;
    i: integer;
begin
  Assign ( Output, 'divide.out');
  Rewrite ( Output);
  WriteLn ( Output, FCount);
  for i:=1 to FCount do
    with Squares[i] do
      WriteLn ( Output, X1, ' ', Y1, ' ', X2, ' ', Y2);
  Close ( Output);
end;
begin
  ReadData;      {⥭   䠩 divide.in}
  CountCrosses;  { ⢠ 祭   }
  SortByCrosses; {஢   祭}
  Counting;      {ନ஢ אַ㣮 ⥩}
  WriteResult;   { १}
end.