#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define    min(a,b)    ((a)<(b)?(a):(b))

int l,n;
int mass[1000][2];
double mass1[1000][2];
double mass2[1001][2];

void input_data() {
	int i;
	FILE *file;
	file=fopen("train.in","r");

	if(file==NULL) {
		printf("CAN'T OPEN train.in\n");
		exit(-1);
	}
	fscanf(file,"%d %d",&l,&n);
	for(i=0;i<n;i++) {
		fscanf(file,"%d %d",&mass[i][0],&mass[i][1]);
		mass1[i][0]=mass[i][0];mass1[i][1]=mass[i][1];
		mass2[i+1][0]=mass1[i][0];
		mass2[i+1][1]=mass1[i][1];
	}
	fclose(file);
}

void output(double time) {
	FILE *file;
	file=fopen("train.out","w");

	if(file==NULL) {
		printf("CAN'T OPEN train.out\n");
		exit(-1);
	}
	fprintf(file,"%5.5f\n",(float)(time));
}
int test(double t) {
	double time,t_m;
	int flag=0;
	int p1=0,p2=0;
	long s1=0,s2=0;
	if(t==0) return -1;
	mass2[0][0]=t;
	t_m=0;
	while(p1<n && p2<n+1 /*&& t_m!=t*/) {
		//if(t_m==t) break;
		time=min(mass1[p1][0],mass2[p2][0]);
		t_m+=time;
		s1+=mass1[p1][1]*time;
		s2+=mass2[p2][1]*time;
		if(p2>0) {
			if(abs(s1-s2)<l) return -1;
			if(s1==s2) flag=1;
		}
		mass1[p1][0]-=time;
		mass2[p2][0]-=time;
		if(mass1[p1][0]==0) p1++;
		if(mass2[p2][0]==0) p2++;
	}
	if(abs(s1-s2)<l) return -1;
	if(s1==s2) flag=1;

	if(flag==0) return 1;
	return 0;
}
void make() {
	int i;
	for(i=0;i<1000;i++) {
		mass1[i][0]=mass[i][0];mass1[i][1]=mass[i][1];
		mass2[i+1][0]=mass1[i][0];
		mass2[i+1][1]=mass1[i][1];
	}
}
void initilize_mass() {
	int i;
	for(i=0;i<1000;i++) {
		mass1[i][0]=0;mass1[i][1]=0;
		mass2[i][0]=0;mass2[i][1]=0;
	}
	mass2[1001][0]=0;mass[1001][1]=0;
}

void main() {
	int res;
	double step=100.0;
	double time=0.0,last;
	last=0;
	//time+=step;
	initilize_mass();
	input_data();

	for(;;) {
		time=last;
		while((res=test(time))==-1) {
      make();
			//step=step/10;
			last=time;
			time+=step;

		}

		if(res==0) {
			output(time);
			return;
		}
		step=step/10;

		if(step==0.00001) {
			output(time);
			return;
		}
	}


}

