{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P+,Q-,R-,S-,T+,V-,X+}
{$M 16384,0,655360}
PROGRAM Task1;
  Const
    inp = 'hash.in';
    out = 'hash.out';
    arr : Array [1..62] Of Char =
    (
     '','','','','','','','','',
     '','','','','','','','','',
     '','','','','','','','','',
     '','','','','','','','','',
     '','','','','','','','','',
     '','','','','','','','','',
     '','','','','','','',''
    );
  Type
    TW = Array [1..255] Of Word;
  Var
    inf, ouf : Text;
    n        : Word;

  Procedure Init;
  Begin
    Assign(inf, inp); Assign(ouf, out);
    Reset(inf); ReWrite(ouf);
  End;

  Procedure ReadData(Var s : String);
  Begin
    ReadLn(inf, s); n := Length(s);
  End;

  Function StrToNum(s: Char): Word;
    Var i : Word;
  Begin
    i := 1; While (i<= 62) And (s<>arr[i]) Do inc(i);
    StrToNum := i;
  End;

  Function mo(Var w : TW):Real;
    Var
      e : Word;
      m : Real;
  Begin
    e := 0;
    Repeat
      inc(e);
      If (e + 1 <= n) And (n > 1) Then m := m + w[e]/w[e+1]*5
      Else m := 2;
      inc(e);
    Until e > n;
    mo := m / 3;
  End;

  Function GetNum(s: String): Word;
    Var w : TW;
        i, sum : Word;
        rez    : Real;
  Begin
    sum := 0;
    For i := 1 To Length(s) Do
    Begin
      w[i] := StrToNum(s[i]);
      inc(sum, w[i]);
    End;
    rez := sum / Length(s) * 5.11+abs(mo(w))+w[1];
    If rez < 155 Then
      If w[1] > 29 Then rez := rez + 100;
    GetNum := Round(rez);
  End;

  Procedure WriteNum(num: Word);
  Begin
    If Num > 255 Then Num := Num div 5;
    If SeekEof(inf) Then Write(ouf, num)
    Else WriteLn(ouf, num);
  End;

  Procedure Solve;
    Var s : String;
  Begin
    ReadData(s); WriteNum(GetNum(s));
  End;

  Procedure Done;
  Begin
    Close(ouf); Close(inf);
  End;

BEGIN
  Init;
  While Not SeekEof(inf) Do Solve;
  Done;
END.