program p1908_2;

 var xs,ys:integer;
     n,nh,nv:integer;
     hx0,hx1,hy,vx,vy0,vy1:array[0..1001] of integer;
 var m:integer;
     rx0,ry0,rx1,ry1:array[1..5000] of integer;

 function vclear(x,y0,y1:integer):boolean;
  var i:integer;
  begin
   for i:=1 to nh do
    if (hx0[i]<x) and (x<hx1[i]) and (hy[i]>y0) and (hy[i]<y1) then begin vclear:=false; exit end;
   vclear:=true;
  end;
 function vsclear(x,y0,y1:integer):boolean;
  var i:integer;
  begin
   for i:=1 to nv do if (vx[i]=x) and ((vy0[i]<y1) and (vy1[i]>y0)) then begin vsclear:=false; exit end;
   for i:=1 to nh do
    if (hx0[i]<=x) and (x<=hx1[i]) and (hy[i]>y0) and (hy[i]<y1) then begin vsclear:=false; exit end;
   vsclear:=true;
  end;
 function vvclear(x0,x1,y0,y1:integer):boolean;
  var i:integer;
  begin
   for i:=1 to nh do if (hy[i]>y0) and (hy[i]<y1) then
    if ((x0<=hx0[i]) and (hx0[i]<x1)) or
       ((x0<hx1[i]) and (hx1[i]<=x1)) then begin vvclear:=false; exit end;
   vvclear:=true;
  end;

 procedure swap(var a,b:integer);
  var t:integer;
  begin t:=a;a:=b;b:=t end;
 procedure vsort(l,r:integer);
 var i,j,x,y:integer;
 begin
  i:=l; j:=r; x:=vx[(l+r) div 2];
  repeat
   while vx[i]<x do inc(i);
   while x<vx[j] do dec(j);
   if i<=j then begin
    swap(vx[i],vx[j]);
    swap(vy0[i],vy0[j]);
    swap(vy1[i],vy1[j]);
    inc(i); dec(j);
   end;
  until i>j;
  if l<j then vsort(l,j);
  if i<r then vsort(i,r);
 end;
 procedure hsort(l,r:integer);
 var i,j,x,y:integer;
 begin
  i:=l; j:=r; x:=hy[(l+r) div 2];
  repeat
   while hy[i]<x do inc(i);
   while x<hy[j] do dec(j);
   if i<=j then begin
    swap(hy[i],hy[j]);
    swap(hx0[i],hx0[j]);
    swap(hx1[i],hx1[j]);
    inc(i); dec(j);
   end;
  until i>j;
  if l<j then hsort(l,j);
  if i<r then hsort(i,r);
 end;

 procedure addrect(x0,y0,x1,y1:integer);
  begin
   if x1<=x0 then exit;
   if y1<=y0 then exit;
   inc(m); rx0[m]:=x0; rx1[m]:=x1; ry0[m]:=y0; ry1[m]:=y1
  end;

 procedure addem(x0,y0,x1,y1:integer);
  var j,k:integer;
  begin
   k:=y0;
   for j:=1 to nh do if (hy[j]>=y0) and (hy[j]<=y1) and (hx0[j]>=x0) and (hx1[j]<=x1) then begin
    if k<>hy[j] then addrect(x0,k,x1,hy[j]);
    k:=hy[j];
   end;
   if k<y1 then addrect(x0,k,x1,y1);
  end;

 procedure process(n0,n1,y0,y1:integer); forward;

 procedure vmake(x0,x1,y0,y1,n0,n1:integer);
  var i,j,k,v0,v1:integer;
      i0,i1:boolean;
  begin
   for i:=1 to nh do if (hy[i]>y0) and (hy[i]<y1) then begin
    i0:=(hx0[i]<x0) and (x0<hx1[i]);
    i1:=(hx0[i]<x0+1) and (x0+1<hx1[i]);
    if not(i0) and i1 then break;
   end;


   if vy1[n0+1]<hy[i] then begin
    j:=n0+1;
    while (j<n1) and (vy1[j]<hy[i]) do inc(j);
    process(n0,j,y0,hy[i]);
    process(j,n1,y0,hy[i]);
    process(n0,n1,hy[i],y1);
   end else begin
    {vy0[n0+1]>hy[i]}
    j:=n0+1;
    while (j<n1) and (vy1[j]>hy[i]) do inc(j);
    process(n0,j,hy[i],y1);
    process(j,n1,hy[i],y1);
    process(n0,n1,hy[i],y1);
   end;

  end;

 procedure process(n0,n1,y0,y1:integer);
  var x0,x1,i,j,k,i0,i1:integer;
  begin
   if n0>=n1 then exit;
   if y0>=y1 then exit;
   x0:=vx[n0];
   x1:=vx[n1];
   for i0:=n0 to n1 do if not(vclear(vx[i0],y0,y1)) then break;
   if vclear(vx[i0],y0,y1) then inc(i0);
   for i:=n0 to i0-2 do begin
    j:=i+1;
    while (j<n1) and vsclear(vx[j],y0,y1) do inc(j);
    if vvclear(vx[i],vx[j],y0,y1)
     then addrect(vx[i],y0,vx[j],y1)
     else addem(vx[i],y0,vx[j],y1);
    i:=j-1;
   end;

   if i0>=n1 then exit;

   for i1:=i0+1 to n1 do if vclear(vx[i1],y0,y1) then break;
   if vclear(vx[i1],y0,y1) then dec(i1);

   if i0<n1 then vmake(vx[i0-1],vx[i1+1],y0,y1,i0-1,i1+1);

   if i1<n1-1 then process(i1+1,n1,y0,y1);

  end;

 var i,j,k,a,b,c,d:integer;
 begin
  assign(input,'divide.in');
  reset(input);
  readln(xs,ys);
  readln(n);
  nh:=0; nv:=0;
  for i:=1 to n do begin
   readln(a,b,c,d);
   if a=c then begin
    inc(nv);
    vx[nv]:=a;
    if b>d then swap(b,d);
    vy0[nv]:=b;
    vy1[nv]:=d;
   end else begin
    inc(nh);
    hy[nh]:=b;
    if a>c then swap(a,c);
    hx0[nh]:=a;
    hx1[nh]:=c;
   end;
  end;
  close(input);
  vx[0]:=0; vy0[0]:=0; vy1[0]:=ys;
  vx[nv+1]:=xs; vy0[nv+1]:=0; vy1[nv+1]:=ys;

  vsort(1,nv);
  hsort(1,nh);

  m:=0;
  if nv=0 then begin
   addrect(0,0,hy[1],xs);
   for i:=1 to nh-1 do addrect(0,hy[i],xs,hy[i+1]);
   addrect(0,hy[nh],xs,ys);
   halt;
  end;

  process(0,nv+1,0,ys);

  assign(output,'divide.out');
  rewrite(output);

  writeln(m);
  for i:=1 to m do writeln(rx0[i],' ',ry0[i],' ',rx1[i],' ',ry1[i]);

  close(output);
 end.
