{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}


Program P2107_2;
Const MaxN=1010;
      Eps=0.00001;

Type
     Tos=record
            x,y:LongInt;
          End;

      Line=record
            A,B,C:Real;
           End;
      Mas=array [1..MaxN,1..2] of Tos;
      Mas1=array [1..MaxN] of Line;

Var A,V,H:array [1..MaxN,1..2] of Tos;
      Lv,Lh:^Mas1;
      Nh:array [1..MaxN] of Byte;
      Out:^Mas;
    T:Tos;
    O:Integer;
    N,K,L:Integer;

Procedure MakeTos(Var T:Tos;X,Y:Integer);
Begin
  T.X:=X;
  T.Y:=Y;
End;

Procedure Init;
Var I:Integer;
Begin
  New(Lv);
  NeW(Lh);
  New(Out);
  O:=0;
  Assign(InPut,'Divide.In');
  ReSet(InPut);
  Assign(OutPut,'Divide.Out');
  ReWrite(OutPut);
  ReadLn(T.X,T.Y);
  ReadLn(N);
  For I:=1 to N do
    ReadLn(A[I,1].X,A[I,1].Y,A[I,2].X,A[I,2].Y);
  MakeTos(A[N+1,1],0,0);
  MakeTos(A[N+1,2],0,T.Y);
  MakeTos(A[N+2,1],0,T.Y);
  MakeTos(A[N+2,2],T.X,T.Y);
  MakeTos(A[N+3,1],T.X,T.Y);
  MakeTos(A[N+3,2],T.X,0);
  MakeTos(A[N+4,1],T.X,0);
  MakeTos(A[N+4,2],0,0);
  Inc(N,4);
  Close(InPut);
End;

Procedure TLine(Const T1,T2:Tos;Var R:Line);
Begin
  With R do
    Begin
      A:=T1.Y-T2.Y;
      B:=T2.X-T1.X;
      C:=T1.X*T2.Y-T1.Y*T2.X;
    End;
End;

Procedure PTos(const L1,L2:Line;Var Is:Boolean;Var P:Tos);
Var R:Real;
Begin;
  R:=L1.B*L2.A-L1.A*L2.B;
  IF Abs(R)>Eps Then
  With P do
    Begin
      Is:=True;
      X:=Trunc(Round((L1.C*L2.B-L1.B*L2.C)/R));
      Y:=Trunc(Round((L1.A*L2.C-L1.C*L2.A)/R));
    End
    Else Is:=False;
End;

Procedure SwapI(Var A,B:LongInt);
Var c:LongInt;
Begin
  C:=a;
  A:=b;
  B:=C;
End;

Procedure Swap(Var A,B:Tos);
Begin
  SwapI(A.X,B.X);
  SwapI(A.Y,B.Y);
End;

procedure QSort1(l, r: Integer);
var
  i, j,  y: integer;
  X:Integer;
begin
  i:=l;
  j:=r;
  x:=V[(l+r) DIV 2,1].X;
  repeat
    while V[i,1].X < x do Inc(I);
    while x < V[J,1].X do Dec(J);
    if i <= j then
    begin
      Swap(V[I,1],V[J,1]);
      Swap(V[I,2],V[J,2]);
      Inc(i);
      dec(J);
    end;
  until i > j;
  if l < j then QSort1(l, j);
  if i < r then QSort1(i, r);
end;

procedure QSort2(l, r: Integer);
var
  i, j,  y: integer;
  X:Integer;
begin
  i:=l;
  j:=r;
  x:=H[(l+r) DIV 2,1].Y;
  repeat
    while H[i,1].Y < x do Inc(I);
    while x < H[J,1].Y do Dec(J);
    if i <= j then
    begin
      Swap(H[I,1],H[J,1]);
      Swap(H[I,2],H[J,2]);
      Inc(i);
      dec(J);
    end;
  until i > j;
  if l < j then QSort2(l, j);
  if i < r then QSort2(i, r);
end;

Procedure Print(L,R,D,U:Integer);
Begin
  Inc(O);
  Out^[O,1].X:=V[L,1].X;
  Out^[O,1].Y:=H[D,1].Y;
  Out^[O,2].X:=V[R,1].X;
  Out^[O,2].Y:=H[U,1].Y;
End;

Function FindR(T,D,U:Integer):Integer;
Var I:Integer;
Begin
  For I:=1 to T-1 do
    IF Not ((V[I,1].Y>=H[U,1].Y) or (V[I,2].Y<=H[D,1].Y)) Then FindR:=I;
End;

Procedure Work(T:Integer);
Var  I:Integer;
     F:Integer;
     O:Integer;
     Is:Boolean;
     P:Tos;
Begin
  For I:=1 to L do
   IF Not (H[I,1].X>=V[T,1].X) Then
   IF Nh[I]<3 Then
     Begin
       PTos(Lv^[T],Lh^[I],Is,P);
       IF Is Then
       IF (P.Y<=V[T,1].Y) and (Nh[I]<>2) Then F:=I
  Else IF Nh[I]<>1 Then
       Begin
         IF H[F,2].X<=V[T,1].X Then Nh[F]:=Nh[F]+2;
         IF H[I,2].X<=V[T,1].X Then Nh[I]:=Nh[I]+1;
         O:=FindR(T,F,I);
         Print(O,T,F,I);
         IF H[F,1].Y<V[T,1].Y Then V[T,1].Y:=H[F,1].Y;
         IF H[I,1].Y>V[T,2].Y Then V[T,2].Y:=H[I,2].Y;
         F:=I;
         IF P.Y>=V[T,2].Y Then Break;
       End;
     End;
  IF H[F,2].X<=V[T,1].X Then Nh[F]:=Nh[F]+1;
End;

Procedure OutPrint;
Var I:Integer;
Begin
  WriteLn(O);
  For I:=1 to O do
    WriteLn(Trunc(Out^[I,1].X),' ',Trunc(Out^[I,1].Y),' ',Trunc(Out^[I,2].X),' ',Trunc(Out^[I,2].Y));
End;

Procedure Solve;
Var I:Integer;
Begin
  K:=0;
  L:=0;
  For I:=1 to N do
    IF A[I,1].X=A[I,2].X Then
       Begin
         Inc(K);
         V[K,1]:=A[I,1];
         V[K,2]:=A[I,2];
         IF V[K,1].Y>V[K,2].Y Then Swap(V[K,1],V[K,2]);
       End
       Else
       Begin
         Inc(L);
         H[L,1]:=A[I,1];
         H[L,2]:=A[I,2];
         IF H[L,1].X>H[L,2].X Then Swap(H[L,1],H[L,2]);
       End;
  QSort1(1,K);
  QSort2(1,L);
  For I:=1 to K do TLine(V[I,1],V[I,2],Lv^[I]);
  For I:=1 to L do TLine(H[I,1],H[I,2],Lh^[I]);
  FillChar(Nh,Sizeof(Nh),0);
  For I:=1 to K do
    IF V[I,1].X<>0 Then
    IF (V[I,1].X<>T.X) or (V[I,1].Y=T.Y) or (V[I,2].Y=T.Y) Then
        Work(I);
  OutPrint;
  Close(OutPut);
End;

Begin
  Init;
  Solve;
End.