#include <stdio.h>

//#define TEST

#if defined(TEST)
#define INPUT    "con"
#else
#define INPUT     "bal.in"
#endif
#define OUTPUT    "bal.out"

FILE *in, *out;

#define MAX_M 1000

unsigned long N;
int M;

static int side[MAX_M * 2];
int used = 0;
int women;
int f;
int remake = 0;

unsigned long k;

static int wall[MAX_M];

unsigned long atwalls;

int readdata (void)
{
        fscanf (in, "%d %lu", &M, &N);
        return 1;
}

void prepare (void)
{
        int i;

        for (used = k, i = 0; i < f * 2; i ++)
            side[i] = i < k ? 1 : 0;
}

int iterate (void)
{
        int i;

        int zero, val;

/*
        for (i = 0; i < M * 2; i ++)
        {
                if (!side[i])
                {
                   side[i] = 1;
                   women += i % 2 ? 2 : 1;
                   used ++;
                   break;
                }
                else
                {
                        side[i] = 0;
                        women -= i % 2 ? 2 : 1;
                        used --;
                }
        }

        return (used == 0) && (side[MAX_M * 2 - 1] == 0);
*/

        if (remake)
        {
                remake = 0;
                f --;
                if (f <= k)
                   return 0;

                prepare ();
        }

        for (zero = -1, i = f - 1; i >= 0; i --)
        {
                if (zero == -1)
                   if (!side[i])
                      zero = i;

                if (side[i] && zero != -1)
                {
                        side[zero] = 1;
                        side[i] = 0;
                        if (i == 0)
                           remake = 1;
                        break;
                }
        }

        return 0;
}


int check_wall (int wall)
{
        int qty = side[wall];
        int idx;

        idx = wall + 1;
        if (idx >= M * 2)
           idx = 0;

        qty += side[idx];

        idx = wall - 1;
        if (idx < 0)
           idx = M * 2 - 1;

        qty += side[idx];

        return qty;
}

int check_all (void)
{
        int i, wall;

        int cur = -1;

        for (i = 0; i < M * 2; i += 2)
        {
                wall = check_wall (i);
                if (cur == -1)
                   cur = wall;
                else
                    if (cur != wall)
                       return 0;
        }

        return 1;
}

void process (void)
{
        unsigned long int
                i,
                d,
                done = 1;


        k = N % M;
        d = N / M;

        if (k == 0)
        {
                //  砩.
                for (i = 0; i < M; i ++)
                    fprintf (out, "%lu 0\n", d);
                return;
        }

        if (k == 1)
        {
                //   砩.
                k += M;
                d --;
        }

        //  饬 ॡ஬.
        done = 0;
        f = M * 2 + 1;
        remake = 1;
        do
        {
                do
                {
                        if (iterate ())
                           done = 1;
                } while ((!done) && (used != k));

                if (!done)
                        if (check_all ())
                           done = 2;

        } while (!done);

        if (done == 1)
        {
           fprintf (out, "NO\n");
           return;
        }

        if (done == 2)
        {
                for (i = 0; i < M * 2; i ++)
                {
                        if (i % 2)
                                fprintf (out, "%d\n", side[i]);
                        else
                            fprintf (out, "%d ", side[i] + int(d));
                }
                return;
        }

}

int main (void)
{

        if ((in = fopen (INPUT, "rt")) == NULL)
        {
                printf ("Can't read "INPUT"\n");
                return 1;
        }

        if ((out = fopen (OUTPUT, "wt")) == NULL)
        {
                printf ("Can't create "OUTPUT"\n");
                fclose (in);
                return 2;
        }

        if (readdata ())
           process ();

        fclose (in);
        fclose (out);
        return 0;
}