{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
program P2110_2;
type
  pl=array[1..10000] of longint;
  lc=array[1..10000] of integer;
var
  lcount:integer;
  linesx1,linesy1,linesx2,linesy2:^lc;
  landx,landy:integer;
  pcount:integer;
  placesx1,placesy1,placesx2,placesy2:^lc;
  sqrs:^pl;
procedure ReadIn;
var
  f:text;
  i:integer;
  x1,x2,y1,y2:integer;
  t:integer;
begin
  assign(f,'divide.in');
  reset(f);
  read(f,landx,landy);
  read(f,lcount);
  for i:=1 to lcount do
    begin
      read(f,linesx1^[i],linesy1^[i],linesx2^[i],linesy2^[i]);
      if linesx1^[i]>linesx2^[i] then
        begin
           t:=linesx1^[i];
           linesx1^[i]:=linesx2^[i];
           linesx2^[i]:=t;
        end;
      if linesy1^[i]>linesy2^[i] then
        begin
           t:=linesy1^[i];
           linesy1^[i]:=linesy2^[i];
           linesy2^[i]:=t;
        end;
    end;
  close(f);
end;
function canplace(x1,y1,x2,y2:integer):boolean;
var
  i:integer;
begin
  if (x1<0) or (y1<0) OR (x2>landx) or (y2 > landy) then
    begin
      canplace:=false;
      Exit;
    end;
  for i:=1 to pcount do
    if ((placesx1^[i]>x1) and (placesx1^[i]<x2) and (placesy2^[i]>y1) and (placesy2^[i]<y2)) or
       ((placesx1^[i]>x1) and (placesx1^[i]<x2) and (placesy1^[i]>y1) and (placesy1^[i]<y2)) or
       ((placesx2^[i]>x1) and (placesx2^[i]<x2) and (placesy1^[i]>y1) and (placesy1^[i]<y2)) or
       ((placesx2^[i]>x1) and (placesx2^[i]<x2) and (placesy2^[i]>y1) and (placesy2^[i]<y2)) or
       ((x1>placesx1^[i]) and (x1<placesx2^[i]) and (y2>placesy1^[i]) and (y2<placesy2^[i])) or
       ((x1>placesx1^[i]) and (x1<placesx2^[i]) and (y1>placesy1^[i]) and (y1<placesy2^[i])) or
       ((x2>placesx1^[i]) and (x2<placesx2^[i]) and (y1>placesy1^[i]) and (y1<placesy2^[i])) or
       ((x2>placesx1^[i]) and (x2<placesx2^[i]) and (y2>placesy1^[i]) and (y2<placesy2^[i])) then
         begin
           canplace:=false;
           Exit;
         end;

  for i:=1 to lcount do
    begin
      if linesy1^[i]=linesy2^[i] then
      if (((linesx1^[i]>x1) and (linesx2^[i]<x1)) or ((linesx1^[i]<x1) and (linesx2^[i]>x1)) or
         ((linesx1^[i]>x2) and (linesx2^[i]<x2)) or ((linesx1^[i]<x2) and (linesx2^[i]>x2))) and
         ((linesy1^[i]>y1) and (linesy1^[i]<y1)) then
        begin
          canplace:=false;
          Exit;
        end;
      if linesx1^[i]=linesx2^[i] then
      if (((linesy1^[i]>y1) and (linesy2^[i]<y1)) or ((linesy1^[i]<y1) and (linesy2^[i]>y1)) or
         ((linesy1^[i]>y2) and (linesy2^[i]<y2)) or ((linesy1^[i]<y2) and (linesy2^[i]>y2))) and
         ((linesx1^[i]>x1) and (linesx1^[i]<x1)) then
        begin
          canplace:=false;
          Exit;
        end;
    end;
end;
procedure WriteOut;
var
  f:text;
  i:integer;
begin
  assign(f,'divide.out');
  rewrite(f);
  writeln(f,pcount);
  for i:=1 to pcount do
    writeln(f,placesx1^[i],' ',placesy1^[i],' ',placesx2^[i],' ',placesy2^[i]);
  close(f);
end;
procedure scansqrs;
begin
end;
procedure doit;
var
  x1,x2,y1,y2:integer;
  sx1,sx2,sy1,sy2:integer;
  i:integer;
begin
  for i:=1 to lcount do
    begin
      x1:=linesx1^[i];
      y1:=linesy1^[i];
      x2:=linesx2^[i];
      y2:=linesy2^[i];
      sx1:=0;sx2:=0;sy1:=0;sy2:=0;
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin inc(sx2); inc(sy2); end; dec(sx2); dec(sy2);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin inc(sy2); end; dec(sy2);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin inc(sx2); end; dec(sx2);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin dec(sy1); end; inc(sy1);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin dec(sx1); end; inc(sx1);
      if (x1+sx1<>x2+sx2) and (y1+sy1<>y2+sy2) and canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) and
         (x1+sx1>=0) and (x2+sx2>=0) and (y2+sy2>=0) and(y1+sy1>=0) then
        begin
          inc(pcount);
          placesx1^[pcount]:=x1+sx1;
          placesy1^[pcount]:=y1+sy1;
          placesx2^[pcount]:=x2+sx2;
          placesy2^[pcount]:=y2+sy2;
        end;
      sx1:=0;sx2:=0;sy1:=0;sy2:=0;
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin dec(sx1); dec(sy1); end; inc(sx1); inc(sy1);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin dec(sy1); end; inc(sy2);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin dec(sx1); end; inc(sx1);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin inc(sy2); end; dec(sy2);
      while not canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) do
        begin inc(sx2); end; dec(sx2);
      if (x1+sx1<>x2+sx2) and (y1+sy1<>y2+sy2) and canplace(x1+sx1,y1+sy1,x2+sx2,y2+sy2) and
         (x1+sx1>=0) and (x2+sx2>=0) and (y2+sy2>=0) and(y1+sy1>=0) then
        begin
          inc(pcount);
          placesx1^[pcount]:=x1+sx1;
          placesy1^[pcount]:=y1+sy1;
          placesx2^[pcount]:=x2+sx2;
          placesy2^[pcount]:=y2+sy2;
        end;
    end;
end;
begin
  pcount:=0;
  new(sqrs);
  new(linesx1);
  new(linesy1);
  new(linesx2);
  new(linesy2);
  new(placesx1);
  new(placesy1);
  new(placesx2);
  new(placesy2);
  readIn;
  DoIt;
  WriteOut;
  dispose(sqrs);
  dispose(linesx1);
  dispose(linesy1);
  dispose(linesx2);
  dispose(linesy2);
  dispose(placesx1);
  dispose(placesy1);
  dispose(placesx2);
  dispose(placesy2);
end.