Program Divide;
Type
  TRec = Record
    X1, Y1, X2, Y2: Word;
    T: (V, H);
  End;
  TRect = Record
    X1, Y1, X2, Y2: Word;
  End;
Var
  Fl: Array[0..1000] of TRec;
  Rect: Array[1..1000] of TRect;
  Pr: Array[1..1000] of Word;
  Nm, Xm, Ym, Nr: Word;
  N, T, Pn: Word;
  T1, T2, Dm, Dn: Word;

Procedure GetData;
Var
  F: Text;
  N: Word;
Begin
  Assign(F, 'divide.in');
  Reset(F);
  Read(F, Xm, Ym);
  Read(F, Nm);
  For N := 1 to Nm do
    With Fl[N] do
    Begin
      Read(F, X1, Y1, X2, Y2);
      If X1 = X2 then T := V
      Else T := H;
    End;
  Close(F);
End;

Procedure PutData;
Var
  F: Text;
  N: Word;
Begin
  Assign(F, 'divide.out');
  Rewrite(F);
  WriteLn(F, Nr);
  For N := 1 to Nr do
    With Rect[N] do
      WriteLn(F, X1, ' ', Y2, ' ', X2, ' ', Y1);
  CLose(F);
End;

Function Min(A, B: Word): Word;
Begin
  If A < B then Min := A
  Else Min := B;
End;

Function Max(A, B: Word): Word;
Begin
  If A > B then Max := A
  Else Max := B;
End;

Function Test(Const A, B: TRec): Boolean;
Begin
  Test := False;
  If (A.T = V) and (B.T = V) then
    If A.X1 = B.X1 then Test := True;
  If (A.T = H) and (B.T = H) then
    If A.Y1 = B.Y1 then Test := True;
  If (A.T = H) and (B.T = V) then
    If (Max(B.Y1, B.Y2) > A.Y1) and (Min(B.Y1, B.Y2) < A.Y1) then
      Test := True;
  If (A.T = V) and (B.T = H) then
    If (Max(B.X1, B.X2) >= A.X1) and (Min(B.X1, B.X2) <= A.X1) then
      Test := True;
End;

Function Test2(Const A, B: TRec): Boolean;
Begin
  Test2 := False;
  If (A.T = H) and (B.T = V) then
    If (Max(B.Y1, B.Y2) >= A.Y1) and (Min(B.Y1, B.Y2) < A.Y1) then
      Test2 := True;
End;

Procedure Change(Const A, B: TRec);
Begin
  If (A.T = V) and (B.T = V) then
    If Min(B.Y1, B.Y2) > Max(A.Y1, A.Y2) then
      T2 := Min(B.Y1, B.Y2)
    Else
      T1 := Max(B.Y1, B.Y2);
  If (A.T = H) and (B.T = H) then
    If Min(B.X1, B.X2) > Max(A.X1, A.X2) then
      T2 := Min(B.X1, B.X2)
    Else
      T1 := Max(B.X1, B.X2);
  If (A.T = H) and (B.T = V) then
    If B.X1 > Max(A.X1, A.X2) then
      T2 := B.X1
    Else
      T1 := B.X1;
  If (A.T = V) and (B.T = H) then
    If B.Y1 > Max(A.Y1, A.Y2) then
      T2 := B.Y1
    Else
      T1 := B.Y1;
End;

Begin
  GetData;
  For N := 1 to Nm do
  Begin
    T1 := 0;
    If Fl[N].T = V then T2 := Xm
    Else T2 := Ym;
    For T := 1 to Nm do
      If (T <> N) and Test(Fl[N], Fl[T]) then
        Change(Fl[N], Fl[T]);
    With Fl[N] do
      If T = V then
      Begin Y1 := T1; Y2 := T2 End
      Else
      Begin X1 := T1; X2 := T2 End;
  End;
  for n := 1 to nm do
  Nr := 0;
  With Fl[0] do
  Begin X1 := 0; Y1 := Ym; X2 := Xm; Y2 := Ym; T := H End;
  For N := 0 to Nm do
    If Fl[N].T = H then
    Begin
      Pn := 0;
      For T := 1 to Nm do
        If Fl[T].T = V then
          If Test2(Fl[N], Fl[T]) then
          Begin
            Inc(Pn);
            Pr[Pn] := Fl[T].X1;
          End;
      For T1 := 1 to (Pn - 1) do
      Begin
        Dn := T1; Dm := Pr[T1];
        For T2 := (T1 + 1) to Pn do
          If Pr[T2] < Dm then
          Begin Dn := T2; Dm := Pr[T2] End;
        Dm := Pr[T1]; Pr[T1] := Pr[Dn]; Pr[Dn] := Dm;
      End;
      T1 := 0;
      For T := 1 to (Pn + 1) do
      Begin
        T2 := Pr[T]; Dm := 0;
        If T > Pn then T2 := Xm;
        For Dn := 1 to Nm do
          If (Fl[Dn].T = H) and (Fl[Dn].Y1 < Fl[N].Y1) then
            If Fl[Dn].Y1 >= Dm then
              Dm := Fl[Dn].Y1;
        Inc(Nr);
        With Rect[Nr] do
        Begin X1 := T1; X2 := T2; Y1 := Fl[N].Y1; Y2 := Dm End;
        T1 := T2;
      End;
    End;
  PutData;
End.