Program Filya;
Type
  TFld = Array[1..45, 1..41] of Byte;
Var
  Fl: TFld;
  Best, C: Byte;
  Xm, Ym: Byte;
  Fill: Word;
  Tmp: Word;

Procedure GetData;
Var
  F: Text;
  X, Y: Byte;
  S: String[45];
Begin
  Assign(F, 'filya.in');
  Reset(F);
  For Y := 1 to 41 do
  Begin
    ReadLn(F, S);
    For X := 1 to 45 do
      Fl[X, Y] := Ord(S[X]) - Ord('0');
  End;
  Close(F);
End;

Procedure PutData;
Var
  F: Text;
Begin
  Assign(F, 'filya.out');
  Rewrite(F);
  WriteLn(F, Best);
  Close(F);
End;

Function FillCol(C: Byte): Word;
Var
  X, Y: Byte;
  Ch: Boolean;
  N: Word;
Begin
  Fl[1, 1] := 7; N := 0;
  Repeat
    Ch := False;
    For X := 1 to Xm do
      For Y := 1 to Ym do
        If Fl[X, Y] = C then
        Begin
          If (X > 1) and (Fl[X - 1, Y] = 7) then
          Begin Fl[X, Y] := 7; Ch := True;
          If X = Xm then Inc(Xm) End;
          If (Y > 1) and (Fl[X, Y - 1] = 7) then
          Begin Fl[X, Y] := 7; Ch := True;
          If Y = Ym then Inc(Ym) End;
          If (X < 45) and (Fl[X + 1, Y] = 7) then
          Begin Fl[X, Y] := 7; Ch := True End;
          If (Y < 41) and (Fl[X, Y + 1] = 7) then
          Begin Fl[X, Y] := 7; Ch := True End;
          If Ch then Inc(N);
        End;
   Until Not Ch;
   FillCol := N;
End;

Function GetBest(C1, C2, N: Byte; Var Fill: Word): Byte;
Var
  BArr: Array[1..6] of Word;
  Back: TFld;
  C, Cn: Byte;
  F, Cm: Word;
Begin
  Back := Fl;
  For C := 1 to 6 do
  Begin
    BArr[C] := 0;
    If (C <> C1) and (C <> C2) then
    Begin
      BArr[C] := FillCol(C);
      If N <> 0 then
      Begin
        Tmp := GetBest(C, 0, N - 1, F);
        Inc(BArr[C], F);
      End;
      Fl := Back;
    End;
  End;
  Fl := Back;
  Cn := 0; Cm := 0;
  For C := 1 to 6 do
    If BArr[C] > Cm then
    Begin Cn := C; Cm := BArr[C] End;
  GetBest := Cn;
  Fill := Cm;
End;

Begin
  Xm := 2; Ym := 2;
  GetData; C := Fl[1, 1];
  Tmp := FillCol(C);
  Case Tmp of
    0..184:    Best := GetBest(C, Fl[45, 41], 2, Fill);
    185..369:  Best := GetBest(C, Fl[45, 41], 1, Fill);
    370..1845: Best := GetBest(C, Fl[45, 41], 0, Fill);
  End;
  If Best = 0 then
    Repeat
      Best := Random(6) + 1;
    Until (C <> Best) and (Fl[45, 41] <> Best);
  PutData;
End.