Program Train;
Var
  L, N: Word;
  T, V: Array[1..1000] of Word;
  dT: Real;
  k: Word;
  S1, S2: Real;

Procedure GetData;
Var
  F: Text;
  k: Word;
Begin
  Assign(F, 'train.in');
  Reset(F);
  Read(F, L, N);
  For k := 1 to N do
    Read(F, T[k], V[k]);
  Close(F);
End;

Procedure PutData;
Var
  F: Text;
Begin
  Assign(F, 'train.out');
  Rewrite(F);
  WriteLn(F, dT);
  Close(F);
End;

Function GetS(k: Word; dT: Real): Real;
Var
  i: Word;
  S: Real;
Begin
  S := 0;
  For i := k downto 1 do
  Begin
    If dT < T[i] then
      S := S + V[i] * (T[i] - dT);
    dT := dT - T[i];
    If dT < 0 then dT := 0;
  End;
  GetS := S;
End;

Procedure GetdT;
Var
  t, S, d: Real;
  Ok: Boolean;
Begin
  d := 100;
  Repeat
    d := d / 10;
    t := 0; Ok := False;
    Repeat
      t := t + d;
      S := GetS(k, dT + t);
      If (S1 - S >= L) or (S = 0) then
      Begin Ok := True; dT := dT + t End;
    Until Ok;
    dT := dT - d;
  Until d <= 0.00001;
End;

Begin
  GetData;
  dT := 0;
  For k := 1 to N do
  Begin
    S1 := GetS(k, 0); S2 := GetS(k, dT);
    If S1 - S2 < L then
      GetdT;
  End;
  PutData;
End.