{$M 65520,0,655360}
Program Task_5; {}

 Const
       MaxN = 1000;

 Type
       TSource = Array [1..MaxN] Of Record
          T, V : Integer;
        End;

 Var
      Source : TSource;
      N, L   : Integer;
      MaxT   : Real;
      Sol    : Real;


 Procedure LoadDATA;
  Var
       F : Text;
       I : Integer;
  Begin
    Assign (F, 'train.in');
    ReSet (F);
    ReadLn (F, L);
    ReadLn (F, N);
    MaxT := 0;
    For I := 1 To N Do
     Begin
       ReadLn (F, Source [I].T, Source [I].V);
       MaxT := MaxT + Source [I].T;
     End;
    Close (F);
  End;

 Procedure SaveDATA;
  Var
       F : Text;
  Begin
    Assign (F, 'train.out');
    ReWrite (F);
    WriteLn (F, Sol:0:4);
    Close (F);
  End;

 Procedure Analyse;

  Function CheckTime (R : Real) : Boolean;
   Var
        I, J, K,
        x1, x2     : Integer;
        Pos1, Pos2,
        A, B, C    : Real;
   Begin
     A := R;
     I := 0;
     J := 1;

     Pos1 := 0;
     Pos2 := 0;

     While (TRUE) Do
      Begin
        If (Source [J].T > A) Then Break;
        Pos2 := Pos2 + Source [J].V * Source [J].T;
        A := A - Source [J].T;
        Inc (J);
      End;
     Pos2 := Pos2 + A * Source [J].V;

     If ((Pos2 - Pos1) < L) Then
      Begin
        CheckTime := FALSE;
        Exit;
      End;

     B := R;
     x1 := 1;
     x2 := J;

     While ((B < MaxT) And (x2 < N)) Do
      Begin
        Pos1 := Pos1 + Source [x1].T * Source [x1].V;
        C := A + Source [x1].T;
        While ((C > Source [x2].T) And (x2 < N)) Do
         Begin
           Pos2 := Pos2 + (Source [x2].T - A) * Source [x2].V;
           A := 0;
           C := C - Source [x2].T;
           Inc (x2);
         End;
        A := C;
        Pos2 := Pos2 + A * Source [x2].V;

        If (x2 > N) Then
         Begin
           CheckTime := TRUE;
           Exit;
         End;

        If ((Pos2 - Pos1) < L) Then
         Begin
           CheckTime := FALSE;
           Exit;
         End;
        B := B + Source [x1].T;
        Inc (x1);
      End;
     CheckTime := TRUE;
   End;

  Function Nearly (a, b : Real) : Boolean;
   Begin
     If (Round (a * 10000) = Round (b * 10000)) Then Nearly := TRUE Else Nearly := FALSE;
   End;

  Var
       sT, eT : Real;
       B1, B2 : Boolean;

  Begin
    {஢塞  ६  0  MaxT  }
    sT := 0;
    eT := MaxT;

    While (Not (Nearly (sT, eT))) Do
     Begin
       B1 := CheckTime (sT);
       B2 := CheckTime (eT);
       If (B1) Then
        Begin
          eT := sT;
          sT := sT / 2;
        End Else
       If (B2) Then
        Begin
          eT := eT - (eT - sT) / 2;
        End Else
        Begin
          sT := eT;
          eT := eT + (eT / 2);
        End;
     End;
    Sol := eT;
  End;

Begin
  LoadDATA;
  Analyse;
  SaveDATA;
End.