program Rail; {Russia Olymp'98 - Nikokoshev Ilia}{3}
{ $define DEBUG}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
{$ifdef DEBUG} {$R+,Q+} {$endif}

const
  InFile='rail.in';
  OutFile='rail.out';
var
  timer:longint absolute $0:$46c;
  tim:longint;

type TCity=record a,b,c:word; prev,next:integer; end;
var
  city:array[1..5000] of TCity;
  paths:array[1..5000] of word;
  Npaths:word;
  N:word;
  res:boolean;

procedure ReadData;
  var i:word;
  begin
  fillchar(city,sizeof(city),0);
  Assign(input,InFile);
  Reset(input);
  read(N);
  for i:=1 to N do
    with city[i] do read(a,b,c);
  Close(input);
  end;

procedure WriteSol;
  var i,a:word;
  begin
  Assign(output,OutFile);
  Rewrite(output);
  if res then
    for i:=1 to Npaths do
      begin
      a:=paths[i];
      while city[a].next>0  do
        begin
        writeln(a,' ',city[a].next);
        a:=city[a].next;
        end;
      end
  else writeln('NO SOLUTION');
  Close(output);
  end;

function FindNotMarked:word;
  var i:word;
  begin
  for i:=1 to N do
    if (city[i].next=0) and (city[i].prev=0) then
      begin
      FindNotMarked:=i;
      exit;
      end;
  FindNotMarked:=0;
  end;

function BuildPath(a:word):boolean;
   var ispoint:boolean;
   procedure Assign(var a:word; x:word); {links [a]->[x]}
     begin
     city[a].next:=x;
     city[x].prev:=a;
     a:=x;
     ispoint:=false;
     end;
{  function Lk(const x:TCity):boolean;
    begin
    with x do Lk:=(next=0) and (prev<>0);
    end;
  function
}  begin
  if timer>tim then begin res:=false; WriteSol; Halt; end;
  ispoint:=true;
  repeat
{    if Lk(city[(city[a].a)]) then Plus(city[a].a);
    if Lk(city[(city[a].b)]) then Plus(city[a].b);
    if Lk(city[(city[a].c)]) then Plus(city[a].c);
}   if city[(city[a].a)].next=0 then Assign(a,city[a].a) else
    if city[(city[a].b)].next=0 then Assign(a,city[a].b) else
    if city[(city[a].c)].next=0 then Assign(a,city[a].c) else
      break;
  until false;
  if ispoint then city[a].next:=-1;
  BuildPath:=not ispoint;
  end;

function TryInclude(c:word; nx:word):boolean;
  var i:word;
  begin
  TryInclude:=true;
  if city[nx].next=0 then halt(10);
  if city[nx].prev=0 then
    begin
    city[c].next:=nx;
    city[nx].prev:=c;
    for i:=1 to Npaths do
      if paths[i]=nx then
        paths[i]:=c;
    exit;
    end;
  if city[city[nx].prev].prev<>0 then
    begin
    city[city[nx].prev].next:=0;
    city[nx].prev:=c;
    city[c].next:=nx;
    inc(Npaths);
    paths[Npaths]:=c;
    exit;
    end;
  if city[city[nx].next].next<>0 then
    begin
    city[city[nx].next].prev:=0;
    inc(Npaths);
    paths[Npaths]:=city[nx].next;
    city[nx].next:=c;
    city[c].prev:=nx;
    city[c].next:=0;
    exit;
    end;

  TryInclude:=false;
  end;

function Run:boolean;
  var i,a:word;
  begin
  Npaths:=0;
  repeat
    inc(Npaths);
    a:=FindNotMarked;
    if a=0 then break;
    paths[Npaths]:=a;
    if not BuildPath(a) then dec(Npaths);
  until false;
  dec(Npaths);
  for i:=1 to N do
    if city[i].next=-1 then
      if not TryInclude(i,city[i].a) then
        if not TryInclude(i,city[i].b) then
          if not TryInclude(i,city[i].c) then
            begin
            Run:=false;
            exit;
            end;
  Run:=true;
  end;

procedure Swap;
  var i,j:word;
  begin
  for i:=1 to N do
    with city[i] do
      begin
      j:=a;
      a:=c;
      c:=j;
      end;
  end;

begin
tim:=timer+trunc(19.5*18.2);
ReadData;
res:=Run;
if not res then begin ReadData; Swap; res:=Run; end;
WriteSol;
end.
