program Train; {Russia Olimp'98 -II day}
{ $define DEBUG}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
{$ifdef DEBUG} {$R+,Q+} {$endif}

const
  InFile='train.in';
  OutFile='train.out';
var
  ML,N:longint;
  T,V:array[1..1000] of word;
  Time:double;
  CurTm,CurL:array[1..1000] of longint;
  Done:boolean;

procedure ReadData;
  var i:word;
  begin
  Assign(input,InFile);
  Reset(input);
  Read(ML,N);
  CurTm[1]:=0;
  CurL[1]:=0;
  for i:=1 to N do
    begin
    Read(T[i],V[i]);
    CurTm[i+1]:=CurTm[i]+T[i];
    CurL[i+1]:=CurL[i]+longint(T[i])*V[i];
    end;
  Close(input);
  end;

procedure WriteSol;
  begin
  Assign(output,OutFile);
  Rewrite(output);
  writeln(Time:3:3);
  Close(output);
  end;

procedure Try(cur:word; var cvr:word);
      function Shift(tm:double; what:boolean):boolean;
        var vol,d,l:double;
            i:word;
        begin {using cvr!}
        Shift:=true;
        if tm>CurTm[N+1] then Exit;
        i:=cvr;
        while (CurTm[i+1]<=tm) do
          begin
          inc(i);
          if i>N then begin done:=true; exit; end;
          end;
        l:=CurL[i]+V[i]*(tm-CurTm[i]);
        l:=l-(CurL[cur]+(tm-Time-CurTm[cur])*V[cur]);
        if l>=ML then exit;
        if what then vol:=V[i] else vol:=V[cur];
        if vol=0.0 then
          Time:=Time+CurTm[i+1]-tm
        else
          begin
          d:=(ML-l)/vol;
          if (d<0) or (d>CurTm[i+1]-tm) then d:=CurTm[i+1]-tm;
          Time:=Time+d;
          end;
        Shift:=abs(ML-l)<1e-10;
        end;
  begin {cvr = last line which has start<=start of cur}
  while not Shift(Time+CurTm[cur],true) do;
  if cur=N+1 then exit;
  while not Shift(Time+CurTm[cur+1],true) do;
  while CurTm[cvr]<Time+CurTm[cur] do begin inc(cvr); if cvr>N+1 then begin done:=true; exit; end; end;
  while CurTm[cvr]<Time+CurTm[cur+1] do
    begin
    Shift(CurTm[cvr],false);
    Inc(cvr); if cvr>N then break;
    while CurTm[cvr]<Time+CurTm[cur] do inc(cvr);
{    if done then e;}
    end;
  Dec(cvr);
  end;

procedure Run;
  var i,cvr:word;
  begin
  Time:=0.0;
  cvr:=1;
  Done:=False;
  for i:=1 to N do
    begin
    Try(i,cvr);
    if done then exit;
    end;
  Try(N+1,cvr);
  end;

begin
ReadData;
Run;
WriteSol;
end.