{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 49152,0,655360}
program _Filya_;
const InFile = 'FILYA.IN';
      OutFile = 'FILYA.OUT';
      Time = 89;
const MaxDepth = 2;
type TField = array [0..42, 0..46] of Byte;
const x0: array [1..2] of Byte = (1, 45);
      y0: array [1..2] of Byte = (1, 41);
var cnt: array [1..2] of Word;
var f0, f: TField;
    Turn: Byte;
    Inner: Boolean;
    Timer: LongInt absolute $0040: $006C;
    StTime: LongInt;

procedure Init;
var i, j: Word;
    S: String [45];
begin
 Assign (Input, InFile); Reset (Input);
 Assign (Output, OutFile); Rewrite (Output);
 for i := 1 to 41 do begin
  ReadLn (S);
  for j := 1 to 45 do f[i,j] := Byte (S[j]) and $0F;
 end;
end;

function Flood (x, y, c, nc: Byte): Word;

 procedure Rec (x, y: Integer);
 begin
  if (x >= 1) and (y >= 1) and (x <= 45) and (y <= 41) and
     ((f[y,x] = c) or (f[y,x] = nc)) then
  begin
   f[y,x] := 255;
   Rec (x-1, y);
   Rec (x+1, y);
   Rec (x, y-1);
   Rec (x, y+1);
  end;
 end;

var i, j: Byte;
    ct: Word;
begin
 Rec (x, y);
 ct := 0;
 if Inner then
  for i := 1 to 41 do
   for j := 1 to 45 do
     if (f[i, j] <> 255) and
        (f[i-1, j] = 255) and
        (f[i+1, j] = 255) and
        (f[i, j-1] = 255) and
        (f[i, j+1] = 255) then Inc (ct);
 for i := 1 to 41 do
  for j := 1 to 45 do
   if f[i, j] = 255 then begin
    f[i, j] := nc;
    Inc (ct);
   end;
 Flood := ct;
end;

procedure Done;
begin
 if Turn = 0 then begin
  f := f0;
  repeat
   Turn := Random (6) + 1;
  until (Turn <> f[1,1]) and (Turn <> f[41,45]);
 end;
 WriteLn (Turn);
 Halt;
end;

function Find (Depth: Byte; abcut: Integer; p: Byte): Integer;
var save: TField;
    c, en, our: Byte;
    ocnt: Word;
    oc, max: Integer;
begin
 if Depth = 0 then begin
  if p = 1 then Find := cnt[1]
           else Find := -cnt[1];
 end else begin
  save := f;
  our := f[y0[p], x0[p]];
  en := f[y0[3-p], x0[3-p]];
  max := -$8000;
  for c := 1 to 6 do
   if (c <> our) and (c <> en) then begin
    { Check time limit }
    if Timer - StTime >= Time then Exit;
    { Primary search engine }
    ocnt := cnt[p];
    cnt[p] := Flood (x0[p], y0[p], our, c);
    oc := - Find (Depth - 1, -max, 3-p);
    f := save;
    cnt[p] := ocnt;
    if oc > max then begin
     max := oc;
     if (p = 1) and (Depth = MaxDepth) then begin
      Turn := c;
     end;
    end;
    if max > abcut then Break;
   end;
  Find := max;
 end;
end;

procedure Solve;
var i: Byte;
    th, max: Word;
begin
 for i := 0 to 46 do begin
  f[0, i] := 255;
  f[42, i] := 255;
 end;
 for i := 0 to 42 do begin
  f[i, 0] := 255;
  f[i, 46] := 255;
 end;
 f0 := f;
 StTime := Timer;
 Inner := True;
 for i := 1 to 2 do
  cnt[i] := Flood (x0[i], y0[i], f[y0[i], x0[i]], f[y0[i], x0[i]]);
 if cnt[1] + cnt[2] = 41*45 then begin
  Inner := False;
  max := 0;
  for i := 1 to 6 do
   if (i <> f[1,1]) and (i <> f[41, 45]) then
   begin
    th := Flood (1, 1, f[1,1], i);
    if max < th then begin
     max := th;
     Turn := i;
    end;
    f := f0;
   end;
 end else begin
  Turn := 0;
  Find (MaxDepth, $7FFF, 1);
 end;
end;

begin
 Init;
 Solve;
 Done;
end.