{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
program _Trains_;
uses CRT;
type Real = Double;
const eps = 1.0e-7;
const InFile = 'TRAIN.IN';
      OutFile = 'TRAIN.OUT';
var t, v: array [1..1000] of Integer;
    n, l: Word;
    tt: Real;

procedure Init;
var i: Word;
begin
 Assign (Input, InFile); Reset (Input);
 Assign (Output, OutFile); Rewrite (Output);
 Read (l, n);
 for i := 1 to n do
  Read (t[i], v[i]);
end;

function Danger: Boolean;
var curt: Real;
    ti, tj: Real;
    xi, xj: Real;
    i, j: Word;
    ev: Byte;
    et: Real;

 procedure Try (_ev: Byte; _et: Real);
 begin
  if _et < et then begin
   ev := _ev;
   et := _et;
  end;
 end;

begin
 curt := 0;
 i := 1;
 j := 0;
 ti := 0;
 tj := 0;
 xi := 0;
 xj := 0;
 repeat
  if j = 0 then begin
   ev := 0;
   et := tt - curt;
  end else et := 1.0e+30;

  if (i <= n) then Try (1, t[i] - ti);
  if (j <= n) and (j > 0) then Try (2, t[j] - tj);

  ti := ti + et;
  xi := xi + et * v[i];
  if j > 0 then begin
   tj := tj + et;
   xj := xj + et * v[j];
  end;
  curt := curt + et;
  if (i >= 1) and (j >= 1) and
     (i <= n) and (j <= n) then
  begin
   if xi - xj < l then begin
    Danger := True;
    Exit;
   end;
  end;
  if ev = 1 then begin Inc (i); ti := 0; end else
   if ev = 2 then begin Inc (j); tj := 0; end else j := 1;
 until (i > n) or (j > n);
 Danger := False;
end;

procedure Solve;
var l, r: Double;
    i: Word;
begin
 l := 0;
 for i := 1 to n do r := r + t[i];
 repeat
  tt := (l + r) / 2;
  if Danger then l := tt else r := tt;
 until r - l <= eps;
 WriteLn (tt: 0: 4);
end;

begin
 Init;
 Solve;
end.