program SimpleFilya;
const
   maxx = 45;
   maxy = 41;
   infile = 'filya.in';
   outfile = 'filya.out';
   maxdeep = 2;
type
   TField = array [0..Maxx+1,0..maxy+1] of byte;
var
   inf,outf:text;
   x,y:byte;
   s:string;
   field:TField;
   c1,c2:byte; { // color of players }
   deep:byte;

function MarkNear(c:byte;var f:tfield):integer;
{ Marked x = x+128 }
const
   deltax : array [1..4] of shortint = (0, 1, 0, -1);
   deltay : array [1..4] of shortint = (1, 0, -1, 0);
var
   i,j,k:integer;
   dx,dy:integer;
   n:integer;
begin
   n:=0;
   for I:=1 to maxx do
      for j:=1 to maxy do
        { if found marked }
        if f[i,j] and 128 > 0 then
           for k:=1 to 4 do begin
             dx:=deltax[k];
             dy:=deltay[k];
             if f[i+dx,j+dy]=c then begin
               f[i+dx,j+dy]:=f[i+dx,j+dy] or 128;
               n:=n+1;
             end;
           end;
   MarkNear:=n;
end;

function BestMove(f:tfield):Byte;
var
   tst,tmp:tfield;
   c,myc,opc:byte;
   d,cnt:integer;
   maxd,maxc:integer;
begin
   tst:=f;
   myc:=tst[1,1];
   opc:=tst[maxx,maxy];
   tst[1,1]:=myc or 128;
   cnt:=1;
   repeat
     d:=MarkNear(myc,tst);
     cnt:=cnt+d;
   until d=0;
   { // count numbers of cells and mark it }
   tmp:=tst;
   maxd:=-1;
   maxc:=1;
   for c:=1 to 6 do begin
      if c=myc then continue;
      if c=opc then continue;
      tmp:=tst;
      d:=MarkNear(c,tmp);
      if d>maxd then begin maxc:=c; maxd:=d; end;
   end;
   BestMove:=maxc;
end;

begin
   assign(inf,infile);
   assign(outf,outfile);
   reset(inf);
   rewrite(outf);
   for x:=0 to maxx+1 do
      for y:=0 to maxy+1 do field[x,y]:=0;
   for y:=1 to maxy do begin
      readln(inf,s);
      for x:=1 to maxx do
        field[x,y]:=byte(s[x])-byte('0');
   end;
   Writeln(outf,BestMove(field));
   close(inf);
   close(outf);
end.
