program Railroad;
{   - ᠬ     ! }
const
   max = 1000;
   infile = 'train.in';
   outfile = 'train.out';
type
   ltimerec = record
     time:real;
     dist:longint;
   end;
var
   inf,outf:text;
   i,j,l,n:integer;
   v:array [1..max] of integer;
   lng,tm:real;
   rec_cnt:integer;
   t:array [1..max] of longint;
   ct,cd:array [0..max] of longint;
   { control time and distances }
   ltime:array [0..max*2] of ltimerec;
   { 0 + back + front }

begin
   assign(inf,infile);
   assign(outf,outfile);
   reset(inf);
   rewrite(outf);
   readln(inf,l);
   readln(inf,n);
   for i:=1 to n do
      readln(inf,t[i],v[i]);
   cd[0]:=0;
   ct[0]:=0;
   { create control times and distances array }
   for i:=1 to n do begin
      ct[i]:=ct[i-1]+t[i];
      cd[i]:=cd[i-1]+t[i]*v[i];
   end;
   rec_cnt:=0;
   { create new array, contating L-back and L-up time }
   with ltime[0] do begin
      time:=0;
      dist:=0;
   end;
   { create L-up time }
   for i:=0 to n do begin
      if cd[i]+L>=cd[n] then continue;
      { calculate up-time for L }
      lng:=L;
      j:=i+1;
      tm:=0;
      while (lng>0) or (v[j]=0) do begin
         if lng>=v[j]*t[j] then begin
            tm:=tm+t[j];
            lng:=lng-v[j]*t[j];
         end else begin
            tm:=tm+lng/v[j];
            break;
         end;
         inc(j);
      end;
      ltime[i].dist:=cd[i]+L;
      ltime[i].time:=tm;
   end;
   { create L-back time array }
   for i:=1 to n do begin
      { calculate back-time for L }
      if cd[i]<L then continue;
      lng:=L;
      j:=i;
      tm:=0;
      while (lng>0) or (v[j]=0) do begin
         if lng>=v[j]*t[j] then begin
            tm:=tm+t[j];
            lng:=lng-v[j]*t[j];
         end else begin
            tm:=tm+lng/v[j];
            break;
         end;
         dec(j);
      end;
      ltime[n+i].dist:=cd[i];
      ltime[n+i].time:=tm;
   end;
   { find minimal }
   tm:=0;
   for i:=1 to 2*n do
      if ltime[i].time>tm then tm:=ltime[i].time;
   { write to file }
   writeln(outf,tm:12:5);
   close(inf);
   close(outf);
end.