Program Just_Filya;
Const
  StX           : Array[1..4] of Integer = (1,0,-1,0);
  StY           : Array[1..4] of Integer = (0,1,0,-1);

Var
  A, Q, TA      : Array[0..42,0..46] of Byte;
  FN            : Text;
  i, j, T       : Integer;
  Col           : Set of 1..6;
  VChar         : Char;
  N, MaxN       : Integer;
  OutCol        : Integer;

{}
Function SumArea : Integer;
  Var
    vSum                : Integer;
    Si, Sj              : Integer;
  Begin
    vSum:=0;
    For Si:=1 to 41 do
      For Sj:=1 to 45 do
        If A[Si, Sj] <> 0 Then
          Inc(vSum);
    SumArea:=vSum;
  End;

{}
Procedure RestoreArea;
  Var
    Ri, Rj              : Integer;
  Begin
    For Ri:=0 to 42 do
      For Rj:=0 to 46 do
        A[Ri, Rj]:=TA[Ri,Rj];
  End;
{}
Procedure FillCloseArea(X,Y  : Integer);
  Var
    Fi          : Integer;
  Begin
    For Fi:=1 to 4 do
      Begin
        A[X,Y]:=Q[X,Y];
        If (Q[X+StX[Fi],Y+StY[Fi]] = Q[X,Y])and(A[X+StX[Fi],Y+StY[Fi]] = 0)
        Then
          Begin
            A[X+StX[Fi],Y+StY[Fi]]:=Q[X,Y];
            FillCloseArea(X+StX[Fi],Y+StY[Fi]);
          End;
      End;
  End;

{}
Procedure CopyCloseArea(X,Y  : Integer);
  Var
    Ci, Cj      : Integer;
  Begin
    For Ci:=0 to 42 do
      For Cj:=0 to 46 do
        TA[Ci,Cj]:=A[Ci,Cj];

    FillCloseArea(X,Y);
  End;

{}
Function NearArea(X,Y  : Integer)  : Boolean;
  Var
    Flag    : Boolean;
  Begin
    Flag:=False;
    If (A[X+1,Y] = Q[1,1]) or
       (A[X-1,Y] = Q[1,1]) or
       (A[X,Y+1] = Q[1,1]) or
       (A[X,Y-1] = Q[1,1]) Then Flag:=True;
    NearArea:=Flag;
  End;
{}
Procedure Fill(X,Y  : Integer);
  Var
    Fi          : Integer;
  Begin
    For Fi:=1 to 4 do
      Begin
        A[X,Y]:=Q[1,1];
        X:=X+StX[Fi];
        Y:=Y+StY[Fi];
        If (Q[X,Y] = Q[1,1]) and (A[X,Y] = 0) Then
          Begin
            A[X,Y]:=Q[1,1];
            Fill(X,Y);
          End;
        X:=X-StX[Fi];
        Y:=Y-StY[Fi];
      End;
  End;

{}
Procedure CopyArea;
  Var
    Ci, Cj      : Integer;
  Begin
    FillChar(A,SizeOf(A),10);
    For Ci:=1 to 41 do
      For Cj:=1 to 45 do
        A[Ci,Cj]:=0;

    Fill(1,1);
  End;

{}
Begin
  FillChar(Q,SizeOf(Q),10);
  FillChar(TA,SizeOf(TA),0);

  Assign(FN,'filya.in');
  Reset(FN);

  For i:=1 to 41 do
    Begin
      For j:=1 to 45 do
        Begin
          Read(FN,VChar);
          Val(VChar,Q[i,j],T);
        End;
      ReadLn(FN);
    End;
  Close(FN);


  CopyArea;  MaxN:=0;  OutCol:=0;
  Col:=[1..6];
  Exclude(Col,Q[1,1]);
  Exclude(Col,Q[41,45]);
  For i:=1 to 41 do
    For j:=1 to 45 do
      Begin
        If (Q[i,j] in Col)and(A[i,j] = 0)and(NearArea(i,j)) Then
          Begin
            CopyCloseArea(i,j);
            T:=SumArea;
            If (T > MaxN) Then
              Begin
                MaxN:=T;
                OutCol:=Q[i,j];
              End;

            RestoreArea;
          End;
      End;

  Assign(FN,'filya.out');
  Rewrite(FN);
  If OutCol <> 0
    Then Write(FN,OutCol)
    Else
      Begin
        For i:=1 to 6 do
          If i in Col Then OutCol:=i;
        Write(FN,OutCol)
      End;
  Close(FN);
End.