Program Ball_of_the_Damned;
Const
  MaxM   = 1000;
Var
  FN            : Text;
  M, N          : LongInt;
  A             : Array[1..MaxM*2] of LongInt;
  i, j          : LongInt;
  Wall          : LongInt;
  Enough, Found : Boolean;

{}
Procedure TrySimple;
  Var
    Ti          : LongInt;
  Begin
    If M = N Then
      Begin
        Found:=True;
        For Ti:=1 to M do
          A[Ti*2]:=1;
      End;

    If M = N*2 Then
      Begin
        Found:=True;
        For Ti:=1 to M div 2 do
          A[Ti*4]:=1;
      End;

    If N = 0 Then
      Begin
        Found:=True;
      End;

  End;

{}
Function ThatsAllRight  : Boolean;
  Var
    Flag          : Boolean;
    Ti, S         : LongInt;
  Begin
    Flag:=True;
    S:=A[2*M]+A[1]+A[2];
    If (S = 0) Then Flag:=False;
    For Ti:=2 to M do
      Begin
        If (A[2*Ti-1-1]+A[2*Ti-1]+A[2*Ti-1+1] <> S) Then Flag:=False;
      End;
    ThatsAllRight:=Flag;
  End;

{}
Procedure Search(P : Integer);
  Var
     Si         : Integer;
  Begin
    If (Not Found) Then
    For Si:=1 downto 0 do
      Begin
        If (Not Found) Then
          Begin
            A[P]:=Si;
            If (Si = 1) Then N:=N-1;

            If (N <> 0)and(P < 2*M)
              Then Search(P+1)
              Else If (N = 0) and ThatsAllRight Then Found:=True;

            If (Si = 1) Then N:=N+1;
            If (Not Found) Then A[P]:=0;
          End;
      End;
  End;

{}
Begin
  FillChar(A,SizeOf(A),0);

  Assign(FN,'bal.in');
  Reset(FN);
  ReadLn(FN,M,N);
  Close(FN);


  Wall:=0;
  While N >= 2*M do
    Begin
      Wall:=Wall+1;
      N:=N-M;
    End;

  If (N < M/2) Then Enough:=False Else Enough:=True;

  Found:=False;

  TrySimple;

  If (Not Found) and (N <> 0) and Enough Then Search(1);

  For i:=1 to M do
    A[i*2-1]:=A[i*2-1]+Wall;

  Assign(FN,'bal.out');
  Rewrite(FN);

  If Found and Enough Then
    Begin
      For i:=1 to M do
        Begin
          WriteLn(FN,A[2*i-1],' ',A[2*i]);
        End;
    End
    Else WriteLn(FN,'NO');
  Close(FN);
End.