{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}

const n = 45;
      m = 41;
type  tField = array[1..m,1..n] of integer;
      tGran = array[1..m*n] of record x,y : integer end;
var   pl : tField;
      move,own,prot,col : integer;
      gran,null : tGran; gr_last : integer;

procedure read_data(s : string);
var i,j,c : integer; f : text; st : string;
begin
     assign(f,s); reset(f);
     for i := 1 to m do begin
         readln(f,st);
         for j := 1 to n do
             val(st[j], pl[i,j], c);
     end;
     close(f);
end;

procedure koni(var gr : tGran; var lst : integer; x,y : integer);
var i,col,l1,l2,j : integer;
    next1,next2 : tGran;

    procedure insert(xx,yy : integer);
    begin
         if (xx > 0) and (xx < m+1) and (yy > 0) and (yy < n+1) and
            (pl[xx,yy] = col) and (pl[xx,yy] <> 0)
            then begin
                 inc(l1); next1[l1].x := xx; next1[l1].y := yy;
                 pl[xx,yy] := 0;
            end;
    end;

begin
     inc(lst); gr[lst].x := x; gr[lst].y := y;
     col := pl[x,y]; pl[x,y] := 0;
     next2[1].x := x; next2[1].y := y; l2 := 1; l1 := 0;
     while l2 <> 0 do begin
           for i := 1 to l2 do begin
               x := next2[i].x; y := next2[i].y;
               insert(x-1,y);
               insert(x+1,y);
               insert(x,y-1);
               insert(x,y+1);
           end;

           for j := 1 to l1 do begin
               inc(lst); gr[lst] := next1[j];
           end;

           l2 := l1; next2 := next1; l1 := 0;
     end;
end;

procedure init_data;
begin
     prot := pl[41,45]; own := pl[1,1];
     koni(gran, gr_last, 1, 1);
end;

procedure next_move;
var color : array[1..6] of integer;
    i,j,mx,x,y,col,tot : integer;

    function valid(x,y : integer) : boolean;
    begin
         if (x = 0) or (x > m) or (y = 0) or (y > n) or (pl[x,y] = prot) or
            (pl[x,y] = col) or (pl[x,y] = 0) or (pl[x,y] = own)
            then valid := false
            else valid := true;
    end;

    procedure count(x,y : integer);
    var c : integer;
    begin
         if valid(x,y)
            then begin
                 tot := 0;
                 c := pl[x,y];
                 koni(null, tot, x, y);
                 color[c] := color[c] + tot;
            end;
    end;

begin
     for i := 1 to 6 do color[i] := 0;

     for i := 1 to gr_last do begin
         x := gran[i].x; y := gran[i].y;
         count(x-1,y); count(x+1,y);
         count(x,y-1); count(x,y+1);
         if i > gr_last then break;
     end;

     mx := 0; j := 0;
     for i := 1 to 6 do begin
         if color[i] > mx
            then begin
                 mx := color[i];
                 j := i;
            end;
     end;
     move := j;
end;

procedure check(var k : integer);
var prot, i : integer;
    s : set of byte;
begin
     prot := pl[41,45];
     if (k <> 0) and (k <> prot) and (k <> own) then exit;
     s := [1,2,3,4,5,6] - [prot,own];
     i := 1;
     while not(i in s) do inc(i);
     k := i;
end;

procedure write_data(s : string);
var f : text;
begin
     assign(f, s); rewrite(f);
     writeln(f,move);
     close(f);
end;

begin
     read_data('filya.in');
     init_data;
     next_move;
     check(move);
     write_data('filya.out');
end.
