{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}

const max = 1000;
      out = 'bal.out';
type  tCorner = array[1..max+1] of 0..1;
var   m,n : longint;
      con : tCorner;

procedure init_data;
var i : integer;
begin
     for i := 1 to max do con[i] := 0;
end;

function gen_next(var con : tCorner; k : integer) : boolean;
var i : integer;
begin
     i := 1; gen_next := false;
     while (con[i] = 1) and (i < k) do begin
           con[i] := 0; inc(i);
     end;
     if (i = k) and (con[k] = 1) then exit;
     gen_next := true;
     con[i] := 1;
end;

procedure read_data(s : string);
var f : text;
begin
     assign(f,s); reset(f);
     read(f,m,n); close(f);
end;

procedure process_data;
var t_con : tCorner; i,sum,k,treb,mx : integer;
    side  : array[1..max] of integer;
    mark  : array[0..2] of integer;
    f     : text;

    procedure answer;
    var i : integer;
    begin
         assign(f,out); rewrite(f);
         for i := 1 to m do
             if side[i] = k then break;
         mx := side[i] + round((n-treb-sum)/m);
         for i := 1 to m do
             writeln(f, mx-side[i], ' ', t_con[i+1]);
         close(f);
         halt(0);
    end;

begin
     if n mod m = 0
        then begin
             assign(f,out); rewrite(f);
             mx := round(n/m);
             for i := 1 to m do
                 writeln(f, mx, ' ', 0);
             close(f); halt(0);
        end;

     while gen_next(con, m+1) do begin
           for i := 0 to 2 do mark[i] := 0;
           t_con := con; t_con[m+1] := t_con[1];
           sum := 0;

           for i := 1 to m do begin
               side[i] := t_con[i] + t_con[i+1];
               inc(mark[side[i]]);
               sum := sum + t_con[i];
           end;
           i := 2; while mark[i] = 0 do dec(i);
           k := i; treb := 0;
           for i := k-1 downto 0 do
               treb := treb + (k-i)*mark[i];
           if ((n-treb-sum) mod m = 0) and (n-treb-sum > 0)
              then answer;
     end;
     assign(f,out); rewrite(f);
     writeln(f, 'NO'); close(f);
end;

begin
     read_data('bal.in');
     process_data;
end.
