/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N^2 * D) */

#include <stdio.h>
#include <string.h>
#include <math.h>
#define filein "prefix.in"
#define fileout "prefix.out"
#define maxn 1000001

char s[maxn];

int main()
{
int t, d, lim, i, j, k, m, n;

freopen(filein, "r", stdin);
freopen(fileout, "w", stdout);

for (scanf("%d ", &t); t; t--)
  {
  gets(s);
  
  for (n = strlen(s), i = n; i > 1; i--)
    {
      /* verify whether the prefix 0..i is periodic */
      lim = (int)(sqrt(i));
      for (j = 1; j <= lim; j++)
        if (i%j == 0)
          {
            m = i/j;
            if (m <= (i>>1) && m != j)
              {
                for (k = m; k < i; k++)
                  if (s[k] != s[k-m])
                    break;
    
                if (k == i)
                  break;
              }
          }

      if (j <= lim)
        break;

      for (j = 1; j <= lim; j++)
        if (i%j == 0)
          {
            for (k = j; k < i; k++)
              if (s[k] != s[k-j])
                break;

            if (k == i)
              break;
          }

      if (j <= lim)
        break;
    }

  if (i == 1)
    i--;

  printf("%d\n", i);
  }

return 0;
}
