#include <cstdio>

using namespace std;

#define maxN 32000
#define modulo 32173

int B[maxN * 2], viz1[maxN], viz2[maxN];
int N, nr_min, nr_pos; //numarul de masini, numarul minim de pompe, numarul de posibilitati de servire

void read_data()
{
	int i, x, y;
	FILE *f = fopen("ben.in", "rt");
	fscanf(f, "%d", &N);

	for (i = 0; i < N; ++ i) {
		fscanf(f, "%d %d", &x, &y);
		if (viz1[x]) printf("naspa!\n");
		if (viz2[y]) printf("naspa!\n");
		B[x] ++;
		B[y] --;
		viz1[y] = 1;
		viz2[x] = 1;
	}

	fclose(f);
}

void solve()
{
	int i, sol = 0, nr_liber;
	nr_min = 0;
	nr_pos = 1;

	// Vom determina momentul cand sunt cele mai multe masini (simultan) in benzinarie
	// Acest numar va fi numarul minim de pompe necesare, nr_min. Pentru a numara posibilitatile 
	// vom afla pentru fiecare masina cate pompe de alimentare sunt libere la sosirea ei 
	// in benzinarie. Numarul de posibilitati va fi produsul acestor numere

	for (i = 0; i <= 30000; i ++) {
		sol += B[i];
		if (nr_min < sol) nr_min = sol;
	}

	nr_liber = nr_min;
	for (i = 0; i <= 30000; i ++) {
		while (B[i] > 0) {
			nr_pos = (nr_pos * nr_liber) % modulo;
			nr_liber --;
			B[i] --;
		}
		if (B[i] < 0) nr_liber -= B[i];
	}
}

void write_data()
{
	FILE *f = fopen("ben.out", "wt");
	fprintf(f, "%d %d\n", nr_min, nr_pos);
	fclose(f);
}

int main()
{
	read_data();
	solve();
	write_data();
	return 0;
}

