/*
Solution By Algostorm
Time Complexity: O(NlogN)
Memory space: N + 2*K
*/

#include <cstdio>
#include <string>
#include <cstdlib>

using namespace std;

#define ll long long

int N, K, C;
int *cnt, *viz;
ll A, B;

int main()
{
	int nr_t, a, b, c, i, j, first, last;
	FILE *FIN, *FOUT;

	FIN = fopen("reg.in", "rt");
	FOUT = fopen("reg.out", "wt");

	for (fscanf(FIN, "%d", &nr_t); nr_t; -- nr_t) {

		fscanf(FIN, "%d %d %d %d %d", &a, &b, &c, &N, &K);

		/* init */
		A = a, B = b, C = c;

		cnt = (int *) realloc(cnt, sizeof(int) * (C + 10));
		viz = (int *) realloc(viz, sizeof(int) * (C + 10));

		memset(cnt, 0, sizeof(int) * (C + 10));
		memset(viz, 0, sizeof(int) * (C + 10));

		/* solve */
		int l, r, sol, mid, crt, no_ocup, mx;
		
		for (l = 1, r = N; l <= r; ) {
			mid = (l + r) >> 1;

			memset(cnt, 0, sizeof(int) * (C + 10));
			memset(viz, 0, sizeof(int) * (C + 10));

			for (crt = i = 1; i <= mid; i ++) {
				cnt[crt] ++;
				crt = (int) (( A * crt + B * (i + 1) ) % C);
			}

			mx = no_ocup = 0;
			for (crt = i = 1; i <= mid; i ++) {
				if (viz[crt] == 0) viz[crt] = 1, no_ocup ++;

				if (no_ocup > mx) mx = no_ocup;
				if (mx > K) break;
				
				cnt[crt] --;
				if (cnt[crt] == 0) no_ocup --;
				crt = (int) (( A * crt + B * (i + 1) ) % C);
			}

			if (mx <= K) sol = mid, l = mid + 1;
			else r = mid - 1;
		}

		fprintf(FOUT, "%d\n", sol);

#ifdef STATICS
		for (i = 1; i <= N; ++ i)
			fprintf(FOUT, "%d\n", X[i]);
#endif
	}

	fclose(FIN);
	fclose(FOUT);

	return 0;
}

