{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
program Fontain;
const   maxN=100;
        max=maxN-1;
        inf=1e38;
type    coort=real;
        vectype=record
         x:coort;
         y:coort
        end;

var     N : integer;
        dot : array[0..maxN] of vectype;
        vec : array[0..max] of vectype;
        pp : array[0..max,0..max] of shortint;
        sv : array[0..max,0..max] of boolean;
        mi : array[0..max] of coort;
        otk : array[0..max] of integer;
        de:array[0..max] of boolean;
        f : text;
        i,uk,a,b: integer;
        be,en:integer;
        hv:vectype;
        eps:coort;

function det(d1,d2:vectype):coort;
begin
 det:=d1.x*d2.y-d1.y*d2.x
end;

procedure d2v(d1,d2:vectype;var vv:vectype);
begin
 with vv do
  begin
   x:=d2.x-d1.x;
   y:=d2.y-d1.y
  end
end;

function sgn(a:coort):shortint;
begin
 if a>0 then sgn:=1 else if a<0 then sgn:=-1 else sgn:=0
end;

procedure mkpp;
var i,j : integer;
    hv : vectype;
begin
 for i:=0 to N do
  for j:=0 to N do
   begin
    d2v(dot[i],dot[j],hv);
    pp[j,i]:=sgn(det(vec[i],hv))
   end
end;

function per(a,b,t:integer;vab:vectype):boolean;
var      g,h:vectype;
begin
 per:=false;
 if (pp[a,t]*pp[b,t]=-1) then
  begin
   d2v(dot[a],dot[t],g);
   d2v(dot[a],dot[t+1],h);
   per:=(sgn(det(vab,g))*sgn(det(vab,h))=-1)
  end
end;

function bel(dv:vectype):boolean;
var s,f:boolean;
    i:integer;
    a,b,c,d:coort;
    t:shortint;
begin
 s:=false;
 f:=true;
 with dv do
  for i:=0 to N do
   begin
    c:=x-dot[i].x;
    d:=dot[i+1].x-x;
    if c<0 then begin c:=-c; d:=-d end;
    if d>0 then
     begin
      a:=dot[i].y-y;
      b:=dot[i+1].y-y;
      if a*d+b*c>0 then s:=not s
     end
   end;
 bel:=s
end;

procedure msv;
var i,j,k : byte;
    s:boolean;
    hv,h2:vectype;

begin
 for i:=0 to N do
  sv[i,i]:=false;
 for i:=0 to N-1 do
  begin
   sv[i,i+1]:=true;
   sv[i+1,i]:=true
  end;
 for i:=2 to N do
  for j:=0 to i-2 do
   begin
    d2v(dot[j],dot[i],hv);
    s:=true;
    for k:=0 to N do
     if per(i,j,k,hv) then
      begin
       s:=false;
       k:=N
      end;
     if s then
      begin
       with h2 do
        begin
         x:=(dot[i].x+dot[j].x)/2;
         y:=(dot[i].y+dot[j].y)/2;
       for k:=0 to N do
        if dot[k].x=x then
         begin
          k:=N;
          x:=x+eps;
          s:=bel(h2)
         end
        end
      end;
     sv[i,j]:=s;
     sv[j,i]:=s
   end;
 sv[0,N]:=true;
 sv[N,0]:=true
end;

function rast(a,b:integer):coort;
begin
 rast:=sqrt(sqr(dot[a].x-dot[b].x)+sqr(dot[a].y-dot[b].y))
end;


procedure volna;
var i,j:integer;
    q:boolean;
    y,z:coort;
begin
 if sv[be,en] then
  begin
   otk[en]:=be;
   mi[en]:=rast(be,en)
  end
else
begin
 for i:=0 to N do
  begin
   de[i]:=false;
   mi[i]:=inf;
   otk[i]:=-1
  end;
 mi[be]:=0;
 de[be]:=true;
 otk[be]:=0;
 repeat
  q:=true;
  for i:=0 to N do
   if de[i] then
    begin
     de[i]:=false;
     y:=mi[i];
     for j:=0 to N do
      if sv[i,j] then
       begin
        z:=rast(i,j)+y;
        if z<mi[j] then
         begin
          mi[j]:=z;
          otk[j]:=i;
          de[j]:=true;
          q:=false
         end
       end
    end;
 until q
end
end;



procedure feps;
var i,j:integer;
    q:coort;
begin
 eps:=1;
 for i:=0 to N do
  for j:=0 to N do
   begin
    q:=abs(vec[i].x-vec[j].x);
    if q>0 then if q<eps then eps:=q
   end;
 eps:=eps/500
end;


begin
 assign (f,'INPUT.TXT');
 reset (f);
 read (f,N);
 for i:=1 to N do
  with dot[i] do
   read (f,x,y);
 read (f,be,en);
 close (f);
 be:=be mod N;
 en:=en mod N;
 dot[0]:=dot[N];
 dec(N);
 feps;
 for i:=0 to N do
  d2v(dot[i],dot[i+1],vec[i]);
 mkpp;
 msv;
 volna;
 assign(f,'OUTPUT.TXT');
 rewrite(f);
 writeln (f,mi[en]);
 close(f)
end.

