uses Objects,CRT;
const
 Symbs:Set of Char = ['A'..'Z','a'..'z',''..'',''..''];
 UpC:String[59]='QWERTYUIOPASDFGHJKLZXCVBNM';
 LoC:String[59]='qwertyuiopasdfghjklzxcvbnm㪥뢠஫ᬨ';
type
 PText=^TText;
 TText=Array[1..$FFFF] of Char;

 PTopic=^TTopic;
 TTopic=record
  Name:String[80];
  TxtLen:Word;
  Txt:PText;
 end;

 PTopicColl=^TTopicColl;
 TTopicColl=object(TCollection)
  TN:String[80];
  procedure FreeItem(Item: Pointer); virtual;
 end;

var
 NF,CurF:Word;
 Files:Array[1..200] of PTopicColl;
 NLR:Word;
 LastRefs:Array[1..40] of String[80];


procedure Trim(var S:String);
begin
 If S='' then Exit;
 While ((S[1]=' ')and(Length(S)>0)) do
  Delete(S,1,1);
 While ((S[Length(S)]=' ')and(Length(S)>0)) do
  Delete(S,Length(S),1);
end;

procedure TTopicColl.FreeItem;
begin
 FreeMem(PTopic(Item)^.Txt,PTopic(Item)^.TxtLen);
 Dispose(PTopic(Item));
end;

function UpCaseR(C:Char):Char;
var
 B:Byte;
begin
 B:=Pos(C,LoC);
 If B>0 then UpCaseR:=UpC[B] else UpCaseR:=C;
end;

function UpCaseStr(S:String):String;
var
 I:Byte;
begin
 If Length(S)>0 then
  for I:=1 to Length(S) do
   S[I]:=UpCaseR(S[I]);
 UpCaseStr:=S;
end;

procedure Warp(Txt:PText;Len:Word);
var
 I,I2:Word;
 Sz:Byte;
begin
 If Len=0 then Exit;
 Sz:=0;
 For I:=1 to Len do
  begin
   Inc(Sz);
   If Txt^[I]=#13 then Txt^[I]:=' ';
   If Sz>=80 then begin
    repeat
     Dec(I);
    until (Txt^[I]=' ')and(Txt^[I-1]<>' ');
    Txt^[I]:=#13;
    Sz:=0;
   end;
  end;
end;

procedure ReadData;
var
 T1,T2:Text;
 S:String;
 I:Word;
 C:Char;
 NOK:Boolean;
 TArr:Array[1..10240] of Char;
 Topic:PTopic;
begin
 Assign(T1,'input.txt');
 Reset(T1);
 NF:=0;
 repeat
  Readln(T1,S);
  If S='' then Continue;
  Inc(NF);
  New(Files[NF],Init(5,5));
  Files[NF]^.TN:=S;
  Assign(T2,S+'.txt');
  Reset(T2);
  repeat
   NOK:=False;
   S:='';
   I:=0;
   While not EOLN(T2) do begin
    Read(T2,C);
    If (EOF(T2))and(S='') then Break;
    If C=' ' then NOK:=True;
    If not NOK then S:=S+C;
    Inc(I);
    TArr[I]:=C;
   end;
   Readln(T2);
   If (EOF(T2))and(S='') then Break;
   New(Topic);
   Topic^.Name:=S;
   Topic^.TxtLen:=I;
   GetMem(Topic^.Txt,I);
   Move(TArr,Topic^.Txt^,I);
   Warp(Topic^.Txt,I);
   Files[NF]^.Insert(Topic);
  until EOF(T2);
  Close(T2);
 until EOF(T1);
 Close(T1);
 CurF:=1;
end;

procedure CmdDir;
var
 I:Integer;
begin
 For I:=1 to NF do
  Writeln(Files[I]^.TN);
 Writeln;
end;

procedure CmdVol(V:String);
var
 I:Integer;
begin
 V:=UpCaseStr(V);
 For I:=1 to NF do
  If UpCaseStr(Files[I]^.TN)=V then begin
   CurF:=I;
   Exit;
  end;
 Writeln('  ');
end;

procedure CmdList(Prms:String);
var
 I,CF:Word;
 T:PTopic;
begin
 NLR:=0;
 CF:=CurF;
 If Prms<>'' then begin
  CF:=0;
  Prms:=UpCaseStr(Prms);
  For I:=1 to NF do
   If UpCaseStr(Files[I]^.TN)=Prms then begin
    CF:=I;
   end;
  If CF=0 then begin Writeln('  '); exit; end;
 end;
 For I:=1 to Files[CF]^.Count do begin
  T:=Files[CF]^.At(I-1);
  Inc(NLR);
  LastRefs[NLR]:=Files[CF]^.TN+':'+T^.Name;
  Writeln(I,'. ',T^.Name);
 end;
end;

procedure CmdCls;
begin
 ClrScr;
end;

function TypeT(T:PText;L:Word;OutP:Boolean;CurT:Word):Boolean;
var
 I,I2,OldNLR:Word;
 IP:Byte;
 InRef:Boolean;
 Ref:String;
 Dn:Boolean;
begin
 OldNLR:=NLR;
 NLR:=0;
 If L=0 then Exit;
 InRef:=False;
 For I:=1 to L do begin
  If OutP then
   If T^[I]=#13 then Writeln else
    Write(T^[I]);
  If ((InRef)and(T^[I]=')')) then begin
   Trim(Ref);
{   Write(')');}
   Ref:=Ref+':';
   Dn:=False;
   InRef:=False;
   I2:=I;
   IP:=Length(Ref)+1;
   repeat
    If (InRef)and(T^[I2] in Symbs) then
     Insert(T^[I2],Ref,IP);
    If (T^[I2]='(')and(not InRef) then InRef:=True;
    Dec(I2);
{    If (InRef)and(Length(Ref)=IP) then Dn:=False else if}
   until (InRef)and(not (T^[I2] in Symbs))and(Length(Ref)>IP-1);
   Inc(NLR);
   LastRefs[NLR]:=Ref;
   InRef:=False;
  end;
  If InRef then Ref:=Ref+T^[I];
  If (I<L-3)and(T^[I]='(')and(T^[I+1]='')and(T^[I+2]='')and(T^[I+3]='.') then begin
   InRef:=True;
   Ref:='';
   If OutP then Write(T^[I+1],T^[I+2],T^[I+3]);
   Inc(I,3);
   If T^[I+1]=')' then Ref:=Files[CurT]^.TN;
  end;
 end;
 TypeT:=False;
 If (OutP)and(NLR=0) then begin
  TypeT:=True;
  NLR:=OldNLR;
 end;
 If OutP then Writeln;
end;

procedure CmdType(P:String);
var
 B:Byte;
 I:Word;
 Tm:String;
 CurFL:Word;
 Fnd:Boolean;
 Tpc:PTopic;
begin
 B:=Pos(':',P);
 P:=UpCaseStr(P);
 CurFL:=CurF;
 If B>0 then begin
  Tm:=Copy(P,1,B-1);
  Delete(P,1,B);
  Fnd:=False;
  For I:=1 to NF do
   If UpCaseStr(Files[I]^.TN)=Tm then begin
    CurFL:=I;
   Fnd:=True;
   break;
  end;
  If not Fnd then begin
   Writeln('  ');
   Exit;
  end;
 end;
 Tpc:=nil;
 For I:=1 to Files[CurFL]^.Count do
  begin
   Tpc:=Files[CurFL]^.At(I-1);
   If UpCaseStr(Tpc^.Name)=P then Break else
   Tpc:=nil;
  end;
 If Tpc=nil then begin
  Writeln('  ');
  Exit;
 end;
 If TypeT(Tpc^.Txt,Tpc^.TxtLen,True,CurFL) then Exit;
 If NLR>0 then begin
  Writeln;
  For I:=1 to NLR do begin
   P:=LastRefs[I];
   B:=Pos(':',P);
   CurFL:=CurF;
{   Delete(P,1,B);}
   Write(I,'. ',Copy(P,B+1,Length(P)));
   Tm:=Copy(P,1,B-1);
   If UpCaseStr(Tm)<>UpCaseStr(Files[CurF]^.TN) then Write(', ⮬ ',Tm);
   Writeln;
  end;
 end;
end;

procedure CmdRef(P:String);
var
 Num:Word;
 C:Word;
 T:PTopic;
begin
 If NLR=0 then Exit;
 Val(P,Num,C);
 If C<>0 then begin
  Writeln('訡!');
  Exit;
 end;
 If (Num>NLR)or(Num=0) then begin
  Writeln('  뫪');
  Exit;
 end;
 CmdType(LastRefs[Num]);
end;


procedure CmdVerify;
var
 OK:Boolean;
 SList:Pointer;
 OldNLR:Word;
 CurI:Word;

 function RefExists(P:String):Boolean;
 var
  I,SI:Word;
  Tm:String;
  T:PTopic;
  B:Byte;
 begin
  RefExists:=False;
  B:=Pos(':',P);
  P:=UpCaseStr(P);
  Tm:=Copy(P,1,B-1);
  Delete(P,1,B);
  T:=nil;
  For I:=1 to NF do
   If UpCaseStr(Files[I]^.TN)=Tm then begin T:=Files[I]^.At(I-1); SI:=I; end;
  If T=nil then Exit;
  RefExists:=True;
  For I:=1 to Files[SI]^.Count do begin
   T:=Files[SI]^.At(I-1);
   If P=UpCaseStr(T^.Name) then Exit;
  end;
  RefExists:=False;
 end;

 procedure Verify(N1,N2:Word);
 var
  B:Byte;
  CurL,I:Word;
  Bl:Boolean;
  T:PTopic;
 begin
  T:=Files[N1]^.At(N2-1);
  TypeT(T^.Txt,T^.TxtLen,False,N1);
  If NLR=0 then Exit;
  For I:=1 to NLR do
   if not RefExists(LastRefs[I]) then
    begin
     If Ok then begin
      Writeln(' 騥 뫪');
      Ok:=False;
     end;
     Inc(CurI);
     Writeln(CurI,'.  ',Files[N1]^.TN,':',PTopic(Files[N1]^.At(N2-1))^.Name,
     ' 뫪  ',LastRefs[I]);
    end;
 end;
var
 N1,N2,OldCurF:Word;

begin
 CurI:=0;
 OK:=True;
 GetMem(SList,SizeOf(LastRefs));
 Move(LastRefs,SList^,SizeOf(LastRefs));
 OldNLR:=NLR;
 for N1:=1 to NF do
  for N2:=1 to Files[N1]^.Count do
   begin
    OldCurF:=CurF;
    CurF:=N1;
    Verify(N1,N2);
    CurF:=OldCurF;
   end;
 Move(SList^,LastRefs,SizeOf(LastRefs));
 NLR:=OldNLR;
 FreeMem(SList,SizeOf(LastRefs));
 If OK then Writeln(' 뫪 ४');
end;

procedure ProcessCmds;
var
 Inp,Params:String;
begin
 repeat
  Write(Files[CurF]^.TN,'>');
  Readln(Inp);
  Trim(Inp);
  If Pos(' ',Inp)<>0 then begin
   Params:=Copy(Inp,Pos(' ',Inp),Length(Inp));
   Trim(Params);
  end else
   Params:='';
  If UpCaseStr(Copy(Inp,1,3))='DIR' then CmdDir
   else
  If UpCaseStr(Copy(Inp,1,6))='VOLUME' then CmdVol(Params)
   else
  If UpCaseStr(Copy(Inp,1,4))='LIST' then CmdList(Params)
   else
  If UpCaseStr(Copy(Inp,1,3))='CLS' then CmdCls
   else
  If UpCaseStr(Copy(Inp,1,4))='TYPE' then CmdType(Params)
   else
  If UpCaseStr(Copy(Inp,1,3))='REF' then CmdRef(Params)
   else
  If UpCaseStr(Copy(Inp,1,6))='VERIFY' then CmdVerify
   else
  If ((UpCaseStr(Inp)<>'EXIT')and(Inp<>'')) then
   Writeln(' ⠪ ');
 until UpCaseStr(Inp)='EXIT';
end;

begin
 Writeln('ਢ!');
 NLR:=0;
 ReadData;
 ProcessCmds;
 Writeln(' ᢨ!');
 Writeln;
 Writeln('  ஢');
 Writeln('FidoNet: 2:5003/32.20, E-mail:vld@ubbs.komi.ru, BBS: (82147)-13802');
end.