Program Task_5_0702;
Type
	TLets=Set of Char;
Const
	EncLen=20000;
	AllRefs=1000;
	LetSet=['A'..'Z']+['a'..'z']+[''..'']+[''..''];
Var
	Rf:Array [1..AllRefs] of String[41];
	Fi,Fv:Text;
	CVol:String;


Function UpString(A:String):String;
Var
	B:String;
	i:Integer;
Begin
	B:=A;
	For i:=1 to Length(B) do
		B[i]:=UpCase(B[i]);
	UpString:=B;
End;

Procedure OpenVolume(Vol:String);
Begin
	Assign(Fv,Vol+'.TXT');
	Reset(Fv);
End;

Procedure CloseVolume;
Begin
	Close(Fv);
End;

Procedure ClearRef;
Var
	i:Integer;
Begin
	For i:=1 to AllRefs do
		Rf[i]:='                                         ';
End;

Procedure DoCLS;
Var
	i:Integer;
Begin
	For i:=1 to 100 do
		WriteLn;
End;

Procedure Init;
Begin
	Assign(Fi,'INPUT.TXT');
	Reset(Fi);
	ReadLn(Fi,CVol);
	CVol:=UpString(CVol);
	DoCLS;
	WriteLn('ਢ!');
End;

Procedure DoExit;
Begin
	Close(Fi);
	WriteLn(' ᢨ.');
	Halt;
End;

Procedure Error(Mes:String);
Begin
	WriteLn(Mes);
End;

Procedure DoVolume(NVol:String);
Var
	Vol:String;
Begin
	While NVol[Length(NVol)]=' ' do Dec(NVol[0]);
	Reset(Fi);
	While Not EOF(Fi) do Begin
		ReadLn(Fi,Vol);
		If UpString(Vol)=UpString(NVol) Then Begin
			CVol:=UpString(NVol);
			Exit;
		End;
	End;
	Error('  ');
End;

Procedure DoDir;
Var
	Vol:String;
Begin
	Reset(Fi);
	While Not EOF(Fi) do Begin
		ReadLn(Fi,Vol);
		WriteLn(UpString(Vol));
	End;
End;

Procedure DoList(NVol:String);
Var
	Buf,Now:PChar;
	Num:Integer;
	TMP:String;
Begin
	ClearRef;
	Num:=1;
	GetMem(Buf,EncLen);
	OpenVolume(NVol);
		While not EOF(Fv) do Begin
			Now:=Buf;
			While not EOLn(Fv) do Begin
				Read(Fv,Now^);
				Now:=Now+1;
			End;
			ReadLn(Fv);
			Now:=Buf;
			Write(Num,'. ');
			TMP:='';
			While Now^<>' ' do Begin
				TMP:=TMP+Now^;
{				Write(Now^); }
				Now:=Now+1;
			End;
			Rf[Num]:=TMP;
			WriteLn(Rf[Num]);
{			WriteLn; }
			Inc(Num);
		End;
	CloseVolume;
	FreeMem(Buf,EncLen);
End;

Procedure MakeRefs(Buff:PChar;FromV:String);
Var
	TMP,NewRef,NewVol:String;
	A,B,Num:Integer;
	Buf,Now,SN:PChar;
Begin
	ClearRef;
	Num:=1;
	Buf:=Buff;
	While Buf^<>#255 do Begin
		Now:=Buf+1;
		TMP:='';
		SN:=Now-1;
		If SN^=' ' Then
			While (Now^<>#255) and (Length(TMP)<=3) do Begin
				TMP:=TMP+Now^;
				Now:=Now+1;
			End;
		If TMP='(.' Then Begin
			While (Now^<>#255) and (Length(TMP)<=12) do Begin
				TMP:=TMP+Now^;
				Now:=Now+1;
			End;
			A:=Pos(')',TMP);
			If A<>0 Then Begin
				Now:=Buf-1;
				NewRef:='';
				While (Now>=Buff) and (Now^ in LetSet) do Begin
					NewRef:=Now^+NewRef;
					Now:=Now-1;
				End;
				B:=Pos('.',TMP);
				NewVol:=Copy(TMP,B+1,A-B-1);
				If UpString(NewVol)=UpString(FromV) Then NewVol:='';
				Rf[Num]:=NewRef;
				If NewVol<>'' Then Rf[Num]:=NewVol+':'+NewRef;
				Num:=Num+1;
			End;
		End;
		Buf:=Buf+1;
	End;
End;

Procedure DoType(Arg:String);
Var
	Vol,NV:String;
	Art,TMP:String;
	RV,RA:String;
	A,i:Integer;
	Now,Buf:PChar;
	SymLeft:Integer;
Begin
	While Arg[Length(Arg)]=' ' do Dec(Arg[0]);
	If Pos(':',Arg)=0 Then Begin
		Vol:=CVol;
		Art:=Arg;
	End Else Begin
		A:=Pos(':',Arg);
		Vol:=Copy(Arg,1,A-1);
		Art:=Copy(Arg,A+1,Length(Arg)-A);
	End;
	GetMem(Buf,EncLen);
	Reset(Fi);
	While Not EOF(Fi) do Begin
		ReadLn(Fi,NV);
		If UpString(Vol)=UpString(NV) Then Begin
			OpenVolume(Vol);

				ClearRef;
					While not EOF(Fv) do Begin
						Now:=Buf;
						While not EOLn(Fv) do Begin
							Read(Fv,Now^);
							Now:=Now+1;
						End;
						Now^:=#255;
						ReadLn(Fv);
						Now:=Buf;
						TMP:='';
						While Now^<>' ' do Begin
							TMP:=TMP+Now^;
							Now:=Now+1;
						End;
						If TMP=Art Then Begin
							Now:=Buf;
							SymLeft:=80;
							While Now^<>#255 do Begin
								TMP:='';
								While (Now^<>' ') and (Now^<>#255) do Begin
									TMP:=TMP+Now^;
									Inc(Now);
									Dec(SymLeft);
								End;
								If Now^=' ' Then Inc(Now);
								If SymLeft>=0 Then Write(TMP);
								If SymLeft<0 Then Begin
									WriteLn;
									Write(TMP);
									SymLeft:=SymLeft+80;
								End;
								If Now^=#255 Then Begin
									If SymLeft<>0 Then WriteLn;
									MakeRefs(Buf,Vol);
									If Rf[1][1]<>' ' Then Begin
										WriteLn;
										i:=1;
										While Rf[i][1]<>' ' do Begin
											A:=Pos(':',Rf[i]);
											RV:=Copy(Rf[i],1,A-1);
											RA:=COpy(Rf[i],A+1,Length(Rf[i]));
											If RV='' Then
												WriteLn(i,'. ',RA)
											Else
												WriteLn(i,'. ',RA,', ⮬ ',RV);
											Inc(i);
										End;
									End;
									FreeMem(Buf,EncLen);
									Exit;
								End;
								If SymLeft=0 Then Begin
									SymLeft:=80
								End Else If SymLeft=1 Then Begin
									Write(' ');
									SymLeft:=80;
								End Else If SymLeft>1 Then Begin
									Write(' ');
									SymLeft:=SymLeft-1;
								End;
							End;
						End;
					End;

			CloseVolume;
			FreeMem(Buf,EncLen);
			Error('  ');
			Exit;
		End;
	End;
	FreeMem(Buf,EncLen);
	Error('  ');
End;

Procedure DoRef(Arg:String);
Var
	RNum,Err:Integer;
	Tp:String;
Begin
	While Arg[Length(Arg)]=' ' do Dec(Arg[0]);
	Val(Arg,RNum,Err);
	If (Err<>0) or (Rf[RNum][1]=' ') Then Begin
		ClearRef;
		Error('  뫪');
		Exit;
	End;
	Tp:=Rf[RNum];
	ClearRef;
	DoType(Tp);
End;

Function SeekArt(Arg,DefVol:String):Boolean;
Var
	Fi2,Fv2:Text;
	A:Integer;
	Vl,Ar:String;
	TMP,NewV:String;
	Buf,Now:PChar;
Begin
	Assign(Fi2,'INPUT.TXT');
	Reset(Fi2);
	A:=Pos(':',Arg);
	If A=0 Then Begin
		Ar:=Arg;
		Vl:=DefVol;
	End Else Begin
		Vl:=Copy(Arg,1,A-1);
		Ar:=Copy(Arg,A+1,Length(Arg)-A);
	End;
	While not EOF(Fi2) do Begin
		ReadLn(Fi2,NewV);
		If UpString(NewV)=UpString(Vl) Then Begin
			Assign(Fv2,Vl+'.TXT');
			Reset(Fv2);

			GetMem(Buf,EncLen);
			While not EOF(Fv2) do Begin
				Now:=Buf;
				While not EOLn(Fv2) do Begin
					Read(Fv2,Now^);
					Now:=Now+1;
				End;
				Now^:=#255;
				ReadLn(Fv2);
				Now:=Buf;
				TMP:='';
				For A:=1 to Length(Ar) do Begin
					TMP:=TMP+Now^;
					Now:=Now+1;
				End;
				If TMP=Ar Then Begin
					Close(Fi2);
					Close(Fv2);
					SeekArt:=True;
					FreeMem(Buf,EncLen);
					Exit;
				End;
			End;

			FreeMem(Buf,EncLen);
			Close(Fv2);

		End;
	End;
	Close(Fi2);
	SeekArt:=False;
End;

Procedure DoVerify;
Var
	Vol,NowA:String;
	Buf,Now:PChar;
	i,Num:Integer;
	OK:Boolean;
Begin
	Reset(Fi);
	Num:=1;
	While Not EOF(Fi) do Begin
		ReadLn(Fi,Vol);

		OpenVolume(Vol);
		GetMem(Buf,EncLen);
		ClearRef;
		While not EOF(Fv) do Begin
			Now:=Buf;
			While not EOLn(Fv) do Begin
				Read(Fv,Now^);
				Now:=Now+1;
			End;
			Now^:=#255;
			ReadLn(Fv);
			NowA:='';
			Now:=Buf;
			While Now^<>' ' do Begin
				NowA:=NowA+Now^;
				Now:=Now+1;
			End;

			MakeRefs(Buf,Vol);
			i:=1;
			While Rf[i][1]<>' ' do Begin
				OK:=SeekArt(Rf[i],Vol);
				If OK=False Then Begin
					If Pos(':',Rf[i])=0 Then
						WriteLn(Num,'.  ',Vol,':',NowA,' 뫪  ',Vol,':',Rf[i])
					Else
						WriteLn(Num,'.  ',Vol,':',NowA,' 뫪  ',Rf[i]);
					Num:=Num+1;
				End;
				i:=i+1;
			End;

		End;
		FreeMem(Buf,EncLen);
		CloseVolume;

	End;
End;

Procedure GetCommand;
Var
	Arg,Inp,Com:String;
	A:Integer;
	Well:Boolean;
Begin
	WriteLn;
	Write(UpString(CVol),'>');
	ReadLn(Inp);
	Inp:=Inp+' ';
	A:=Pos(' ',Inp);
	Com:=Copy(Inp,1,A-1);
	Arg:=Copy(Inp,A+1,Length(Inp)-1);
	Com:=UpString(Com);
	Well:=False;
	If Com='EXIT' Then Begin
		DoExit;
		Well:=True;
	End;
	If Com='CLS' Then Begin
		ClearRef;
		DoCLS;
		Well:=True;
	End;
	If Com='VOLUME' Then Begin
		ClearRef;
		If Arg='' Then Arg:=CVol;
		DoVolume(Arg);
		Well:=True;
	End;
	If Com='DIR' Then Begin
		ClearRef;
		DoDir;
		Well:=True;
	End;
	If Com='LIST' Then Begin
		If Arg='' Then Arg:=CVol;
		DoList(Arg);
		Well:=True;
	End;
	If Com='TYPE' Then Begin
		DoType(Arg);
		Well:=True;
	End;
	If Com='REF' Then Begin
		DoRef(Arg);
		Well:=True;
	End;
	If Com='VERIFY' Then Begin
		DoVerify;
		ClearRef;
		Well:=True;
	End;
	If Well=False Then Begin
		Error(' ⠪ ');
	End;
End;

Begin
	Init;
	While True do
		GetCommand;
End.