Program SimpleWeights;
var
  Sim: array[0..32]of set of 0..255;
  N, i, j, k, l, m: longint;
  f: text;
  Hirz: array[0..32] of set of 0..255;
  mink: longint;
  BP, Pairs: array[1..4096] of record l, r: integer; end;

procedure GetMax(k:integer);
var
  i, j: longint;
  a, c, d, b: longint;
begin
  for i:=1 to N do
    begin
      a:=i div 256;
      b:=i-a;
      if b in Hirz[a] then
        for j:=i+1 to N do
          begin
            c:=j div 256;
            d:=j-c;
            if d in Hirz[c] then
              if ((i+j)mod 256) in Sim[(i+j) div 256] then
                begin
                  Hirz[a]:=Hirz[a]-[b];
                  Hirz[c]:=Hirz[c]-[d];
                  Pairs[(N-k)div 2+1].l:=i;
                  Pairs[(N-k)div 2+1].r:=j;
                  GetMax(k-2);
                  Hirz[c]:=Hirz[c]+[d];
                  Hirz[a]:=Hirz[a]+[b];
                end;
          end;
    end;
  if k<mink then begin mink:=k; BP:=Pairs; end;
end;

Begin
  Assign(f,'input.txt');
  Reset(f);
  Read(f,N);
  Close(f);
  if N>8192 then begin writeln('Too big N! N must not be bigger than 8192.'); exit; end;
  mink:=N;
  for i:=0 to (N div 256)+1 do
    Sim[i]:=[0..255];
  for i:=0 to (N div 256)+1 do
    Hirz[i]:=[0..255];
  for i:=2 to trunc(sqrt(2*N))+1 do
    begin
      k:=i;
      for j:=2 to 2*N div i do
        begin
          k:=i+k;
          l:=k div 256;
          m:=k-l;
          Sim[l]:=Sim[l]-[m];
        end;
    end;
  GetMax(N);
  Assign(f,'output.txt');
  Rewrite(f);
  for i:=1 to (N-mink)div 2 do
    writeln(f,BP[i].l,' ',BP[i].r);
  Close(f);
End.