Program Encyclopedia;
uses Crt;
var
  f: text;
  Vols: array[1..100] of string[9];
  i, j, k, l, kolvols: integer;
  CurrVol: array[1..100] of record name: string[33]; val: string; end;
  kolnames, kolrefs, MyVol: integer;
  Refs: array[1..100] of record fromn: integer; ton: string[33]; tovol: string[9]; end;
  CurrRefs: array[1..100] of integer;
  currrefvol: string;
  kcr, kolerr: integer;
  com, op, op1: string;
  aa: boolean;

function ToUpper(S:string):string;
var
  res: string;
  i:integer;
begin
  res:=S;
  for i:=1 to Length(res) do
    if res[i] in ['a'..'z'] then
      res[i]:=Chr(Ord(res[i])-Ord('a')+Ord('A'));
  ToUpper:=res;
end;

function VolOpen(vol:string):boolean;
var
  i, j, k: integer;
  res: boolean;
  S: string;
begin
  res:=False;
  for i:=1 to kolvols do
    if ToUpper(Vols[i])=ToUpper(vol) then
      begin res:=True; break; end;
  if res then
    begin
      Assign(f,Vols[i]+'.txt');
      kolnames:=0;
      kolrefs:=0;
      Reset(f);
      MyVol:=i;
      while not EOF(f) do
        begin
          Readln(f,S);
          if S<>'' then
            begin
              i:=1;
              while S[i]<>' ' do Inc(i);
              Inc(kolnames);
              CurrVol[kolnames].name:=Copy(S,1,i-1);
              S:=Copy(S,i+1,Length(S));
              CurrVol[kolnames].val:=S;
              i:=1;
              while i<Length(S) do
              begin

              while (not (S[i] in ['A'..'Z','a'..'z',''..'',''..'']))and (i<Length(S)) do
                Inc(i);
              if S[i] in ['A'..'Z','a'..'z',''..'',''..''] then
              begin
              j:=i;
              while (S[j]in ['A'..'Z','a'..'z',''..'',''..''])and(j<Length(S)) do Inc(j);
              if S[j]=' ' then
              begin
              if j<Length(S) then
              begin
              Inc(j);
              if Copy(S,j,4)='(.' then
                begin
                  k:=j+4;
                  while (S[k]<>')')and(k<Length(S)) do Inc(k);
                  if S[k]=')' then
                  begin
                  Inc(kolrefs);
                  Refs[kolrefs].fromn:=kolnames;
                  Refs[kolrefs].ton:=Copy(S,i,j-i-1);
                  Refs[kolrefs].tovol:=Copy(S,j+4,k-j-4);
                  end;
                  i:=k;
                end
              else i:=j-1;
              end;
              end;
              end;
              Inc(i);
              end;
            end;
        end;
      Close(f);
    end;
  VolOpen:=res;
end;

procedure PutPrompt;
begin
  writeln;
  write(Vols[MyVol],'>');
end;

procedure SetRefs(n:integer);
var
  i: integer;
begin
  kcr:=0;
  for i:=1 to kolrefs do
    if Refs[i].fromn=n then
      begin
        Inc(kcr);
        CurrRefs[kcr]:=i;
      end;
  if kcr<>0 then writeln;
  for i:=1 to kcr do
    if Refs[CurrRefs[i]].tovol='' then
      writeln(i,'. ',Refs[CurrRefs[i]].ton)
    else
      writeln(i,'. ',Refs[CurrRefs[i]].ton,', ⮬ ',Refs[CurrRefs[i]].tovol);
  currrefvol:=Vols[MyVol];
end;

procedure TypeCurrVol(stat:string);
var
  i, j, k: integer;
  s: string;
begin
  for i:=1 to kolnames do
    if CurrVol[i].Name=stat then break;
  if CurrVol[i].Name<>stat then begin writeln('  '); kcr:=0; end
  else
    begin
      s:=CurrVol[i].Name+' '+CurrVol[i].val;
      while 81<=Length(s) do
        begin
          k:=81;
          while s[k]<>' ' do Dec(k);
          while s[k]=' ' do Dec(k);
          if k=80 then
            write(Copy(s,1,k))
          else
            writeln(Copy(s,1,k));
          s:=Copy(s,k+1,Length(s));
          while s[1]=' ' do
            s:=Copy(s,2,Length(s));
        end;
      writeln(s);
      SetRefs(i);
    end;
end;

procedure TypeStat(vol,stat:string);
var
  n: integer;
begin
  if vol='' then
    TypeCurrVol(stat)
  else
    begin
      n:=MyVol;
      if not VolOpen(vol) then
        writeln('  ')
      else
        TypeCurrVol(stat);
      VolOpen(Vols[n]);
    end;
end;

procedure MakeAA;
begin
  if not aa then
    begin
      aa:=True;
      writeln(' 뫪  騥 :');
      kolerr:=0;
    end;
end;

procedure TestRef(a,b,c,d:string);
var res:boolean; i:integer;
begin
  res:=False;
  for i:=1 to kolnames do
    if CurrVol[i].name=d then begin res:=True; break; end;
  if not res then
    begin
      MakeAA;
      Inc(kolerr);
      writeln(kolerr,'.  ',a,':',b,' 뫪  ',c,':',d);
    end;
end;

Begin
  Assign(f,'input.txt');
  Reset(f);
  kolvols:=0;
  while not EOF(f) do
    begin
      Readln(f,Vols[kolvols+1]);
      if Vols[kolvols+1]<>'' then Inc(kolvols);
    end;
  Close(f);
  writeln('ਢ!');
  VolOpen(Vols[1]);
  kcr:=0;
  Repeat
    PutPrompt;
    Readln(com);
    i:=1;
    while (com[i]<>' ')and(i<=Length(com)) do Inc(i);
    op:=Copy(com,i,Length(com));
    com:=ToUpper(Copy(com,1,i-1));
    i:=1;
    while (op[i]=' ')and(i<=Length(op)) do Inc(i);
    op:=Copy(op,i,Length(op));
    if com='DIR' then
      begin
        for i:=1 to kolvols do
          writeln(Vols[i]);
      end
    else
      if com='LIST' then
        begin
          if op<>'' then
            begin
              j:=MyVol;
              if not VolOpen(op) then
                writeln('  ')
              else
                begin
                  for i:=1 to kolnames do
                    writeln(i,'. ',CurrVol[i].name);
                  for i:=1 to kolrefs do
                    CurrRefs[i]:=i;
                  kcr:=-1;
                  currrefvol:=op;
                  VolOpen(Vols[j]);
                end
            end
          else
            begin
              for i:=1 to kolnames do
                writeln(i,'. ',CurrVol[i].name);
              kcr:=-1;
              currrefvol:=Vols[MyVol];
            end;
        end
      else
        if com='VOLUME' then
          begin
            if not VolOpen(op) then
              writeln('  ');
          end
        else
          if com='TYPE' then
            begin
              i:=Pos(':',op);
              if i=0 then
                TypeStat('',op)
              else
                TypeStat(Copy(op,1,i-1),Copy(op,i+1,Length(op)));
            end
          else
            if com='CLS' then ClrScr
            else
              if com='REF' then
                begin
                  Val(op,i,j);
                  if kcr=-1 then
                    begin
                      j:=MyVol;
                      VolOpen(currrefvol);
                      if (i<1) or (i>kolnames) then
                        begin writeln('  뫪'); kcr:=0; end
                      else
                          TypeStat(CurrRefVol,CurrVol[i].name);
                      VolOpen(Vols[j]);
                    end
                  else
                  if (j<>0)or(i<1)or(i>kcr) then
                    begin writeln('  뫪'); kcr:=0; end
                  else
                    begin
                      j:=MyVol;
                      VolOpen(currrefvol);
                      TypeStat(Refs[CurrRefs[i]].tovol,Refs[CurrRefs[i]].ton);
                      VolOpen(Vols[j]);
                    end;
                end
              else
                if com='VERIFY' then
                  begin
                    aa:=False;
                    k:=MyVol;
                    for i:=1 to kolvols do
                      begin
                        VolOpen(Vols[i]);
                        for j:=1 to kolrefs do
                          begin
                            op:=Refs[j].ton;
                            op1:=CurrVol[Refs[j].fromn].name;
                            if Refs[j].tovol<>'' then
                              begin
                                if not VolOpen(Refs[j].tovol) then
                                  begin
                                    MakeAA;
                                    Inc(KolErr);
                                    writeln(kolerr,'.  ',Vols[i],':',CurrVol[Refs[j].fromn].name,' 뫪  ',Refs[j].tovol,
                                            ':',Refs[j].ton);
                                  end
                                else
                                  begin
                                    TestRef(Vols[i],op1,Vols[MyVol],op);
                                    VolOpen(Vols[i]);
                                  end
                              end
                            else
                              begin
                                TestRef(Vols[i],op1,Vols[i],op);
                              end
                          end;
                      end;
                    VolOpen(Vols[k]);
                    if not aa then writeln(' 뫪 ४');
                  end
                else
                  if com<>'EXIT' then writeln(' ⠪ ');
    if (com<>'TYPE')and(com<>'REF')and(com<>'LIST') then kcr:=0;
  Until com='EXIT';
  writeln(' ᢨ.');
End.
