program DICTIONARY_5; {1997 Russia olimpiada} {Nikokoshev Ilia - SUNC MGU}
{$DEFINE Debug}
{$M 16384,0,655360}
{$IFDEF Debug}
  {$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$ELSE}
  {$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$ENDIF}
uses Dos;
var
  h,m,s,ss:Word;

const
  InFile='input.txt';
  Vol:string='';
  Command:string[12]='';
  All:Boolean=False;
  ItemNum:Byte=0;
  RefsNum:Byte=0;
  LastVol:string='';
  st4:string='';
  st5:string='';
var
  ch:Char;
  i,j,k:Integer;
  u:Byte;
  st,st2:string;
  ff,gg,tt,xx:Text;
  Item:array[1..25] of string[80];
  Refs:array[1..25] of string[20];

function UpStr(x:string):string;        forward;
function FindNextRef:Boolean;           forward;
function NextChar:Boolean;              forward;
function PrevChar:Boolean;              forward;

function FirstWord(x:string):string;
  var
    st:string;
  begin
  st:='';
  for i:=1 to Length(x) do
    if x[i]=' ' then
      Break
    else
      st:=st+x[i];
  FirstWord:=st;
  end;

function Exists(x:string):Boolean;
  begin
  Reset(ff);
  repeat
    ReadLn(ff,st2);
    if UpStr(x)=UpStr(st2) then
      Break;
  until EOF(ff);
  Exists:=False;
  if UpStr(x)=UpStr(st2) then
    Exists:=True
  else
    WriteLn('  ⮬');
  end;

function OtherPart(x:string):string;
  var
    st:string;
  begin
  i:=1;
  while i<>Length(x)+1 do
    if x[i]=' ' then
      Break
    else
      Inc(i);
  st:='';
  for j:=i+1 to Length(x) do
    st:=st+x[j];
  OtherPart:=st;
  end;

function AssignVol(var v:Text;x:string):Boolean;
  begin
  if x='' then
    x:=Vol;
  AssignVol:=true;
  if Exists(x) then
    begin
    Assign(v,x+'.txt');
{$I-}
    Reset(v);
    if IOResult<>0 then
      begin
      WriteLn('    '+st+'.txt?');
      RunError(2);
      end;
    end
  else
    AssignVol:=False;
  end;

procedure Format;
  begin
  Inc(ItemNum);
  Item[ItemNum]:=Item[ItemNum]+Copy(st,1,79-Length(Item[ItemNum]));
  i:=79;
  if Length(Item[ItemNum])<79 then
    Exit;
  if st[80]<>' ' then
    while Item[ItemNum,i]<>' ' do
      Dec(i)
  else
    Inc(i);
  Item[ItemNum,0]:=Chr(i);
  Inc(ItemNum);
  st:=Copy(st,i+1,Length(st));
  if st[80]=' 'then
    Item[ItemNum]:=Copy(st,1,80)
  else
    Item[ItemNum]:=Copy(st,1,79);
  if Length(st)<79 then
    i:=Length(st)
  else
    begin
    i:=79;
    if st[80]<>' ' then
      while (i>1) and (Item[ItemNum,i]<>' ') do
        Dec(i)
    else
      Inc(i);
    end;
  Item[ItemNum,0]:=Chr(i);
  st:=Copy(st,i+1,Length(st));
  if st='' then
    Exit;
  Item[ItemNum+1]:=st;
  i:=Length(st);
  end;

function NoItem(x:string):Boolean;
  var
    st6:string;
  begin
  NoItem:=True;
  while not EOF(xx) do
    begin
    ReadLn(xx,st6);
    if FirstWord(st6)=x then
      begin
      NoItem:=False;
      Close(xx);
      Exit;
      end;
    end;
  Close(xx);
  end;

procedure VerifyItem;
  begin
  k:=1;
  j:=1;
  RefsNum:=0;
  while FindNextRef do
    begin
    Inc(RefsNum);
    PrevChar;
    repeat
      PrevChar;
    until not (Item[k,j] in ['A'..'Z','a'..'z',''..'',''..'']);
    NextChar;
    st5:='';
    repeat
      st5:=st5+Item[k,j];
      NextChar;
    until Item[k,j]=' ';
    for i:=1 to 5 do
      NextChar;
    st:='';
    while Item[k,j]<>')' do
      begin
      st:=st+Item[k,j];
      NextChar;
      end;
    if st='' then
      st:=st4;{$B-}
    if (not AssignVol(xx,st4)) or NoItem(st5) then
      WriteLn(' '+st4+':'+FirstWord(Item[1])+' 뫪  '+st+':'+st5);
    end;
  end;

procedure GetItem(var gg:Text);
  begin
  ItemNum:=0;
  for i:=1 to 25 do
    Item[i]:='';
  j:=1;
  while not EOLN(gg) do
    begin
    st:='';
    for i:=1 to 158 do
      if EOLN(gg) then
        Break
      else
        begin
        Read(gg,ch);
        st:=st+ch;
        end;
    Format;
    end;
  ReadLn(gg);
  end;

procedure RunVerify;
  var
    w:Byte;
  begin
  Reset(ff);
  while not EOF(ff) do
    begin
    ReadLn(ff,st);
    AssignVol(tt,st);
    st4:=st;
    u:=1;
    Assign(tt,st4+'.txt');
    Reset(tt);
    repeat
      Close(tt);
      Reset(tt);
      for w:=1 to u do
        GetItem(tt);
      VerifyItem;
      Inc(u);
    until EOF(tt);
    Close(tt);
    end;
  end;

function NextChar:Boolean;
  begin
  NextChar:=True;
  if j>=Length(Item[k]) then
    if k>=ItemNum then
      NextChar:=False
    else
      begin
      j:=1;
      Inc(k);
      end
  else
    Inc(j);
  end;

function PrevChar:Boolean;
  begin
  PrevChar:=True;
  if j=1 then
    if k=1 then
      PrevChar:=False
    else
      begin
      Dec(k);
      j:=Length(Item[k]);
      end
  else
    Dec(j);
  end;

function MyCopy(ak,aj,n:Byte):string;
  var
    sk,sj:Word;
    st:string;
  begin
  st:='';
  sk:=k;
  sj:=j;
  k:=ak;
  j:=aj;
  for i:=1 to n do
    begin
    st:=st+Item[k,j];
    NextChar;
    end;
  k:=sk;
  j:=sj;
  MyCopy:=st;
  end;

procedure WriteRef;
  begin
  Inc(RefsNum);
  PrevChar;
  repeat
    PrevChar;
  until not (Item[k,j] in ['A'..'Z','a'..'z',''..'',''..'']);
  Write(RefsNum,'. ');
  NextChar;
  Refs[RefsNum]:='';
  repeat
    Refs[RefsNum]:=Refs[RefsNum]+Item[k,j];
    NextChar;
  until Item[k,j]=' ';
  Write(Refs[RefsNum]);
  for i:=1 to 5 do
    NextChar;
  st:='';
  while Item[k,j]<>')' do
    begin
    st:=st+Item[k,j];
    NextChar;
    end;
  if LastVol<>'' then
    st:=LastVol;
  if st<>'' then
    Write(', ⮬ '+st)
  else
    st:=Vol;
  Refs[RefsNum]:=st+':'+Refs[RefsNum];
  WriteLn;
  end;

function FindNextRef:Boolean;
  begin
  for i:=1 to (ItemNum+1)*79 do
    begin
    if not NextChar then
      Break;
    if MyCopy(k,j,4)='(.' then
      begin
      FindNextRef:=True;
      Exit;
      end;
    end;
  FindNextRef:=False;
  end;

procedure WriteRefs;
  begin
  k:=1;
  j:=1;
  RefsNum:=0;
  while FindNextRef do
    WriteRef;
  end;

procedure RunType;
  var
    st3:string;
  begin
  st3:=OtherPart(st);
  k:=Pos(':',st3);
  LastVol:='';
  if k=0 then
    AssignVol(gg,Vol)
  else
    if not AssignVol(gg,Copy(st3,1,k-1)) then
      Exit
    else
      if Vol<>Copy(st3,1,k-1) then
        LastVol:=Copy(st3,1,k-1);
  st3:=Copy(st3,k+1,Length(st)-k);
  while not EOF(gg) do
    begin
    GetItem(gg);
    if FirstWord(Item[1])=st3 then
      begin
      for i:=1 to ItemNum do
        if Length(Item[i])=80 then
          Write(Item[i])
        else
          WriteLn(Item[i]);
      Break;
      end;
    i:=0;
    end;
  if i=0 then
    WriteLn('  ')
  else
    WriteRefs;
  Close(gg);
  end;

procedure RunRef;
  begin
  st:=OtherPart(st);
  Val(st,j,i);
  if (j<=0) or (j>RefsNum) then
    WriteLn('  뫪')
  else
    begin
    st:='TYPE '+Refs[j];
    RunType;
    end;
  end;

procedure RunList;
  var
    st3:string;
  begin
  LastVol:='';
  st:=OtherPart(st);
  if st='' then
    st3:=Vol
  else
    begin
    st3:=st;
    LastVol:=st;
    end;
  if AssignVol(gg,st) then
    begin
    RefsNum:=0;
    k:=0;
    While not EOF(gg) do
      begin
      Inc(RefsNum);
      Inc(k);
      ReadLn(gg,st);
      Refs[RefsNum]:=st3+':'+FirstWord(st);
      WriteLn(k,'. ',FirstWord(st));
      end;
    Close(gg);
    end;
  end;

procedure RunVolume;
  begin
  st:=OtherPart(st);
  if Exists(st) then
    Vol:=st;
  end;

procedure RunDir;
  begin
  Reset(ff);
  while not EOF(ff) do
    begin
    ReadLn(ff,st);
    WriteLn(st);
    end;
  Close(ff);
  end;

procedure RunCommand;
  begin
  if (Command='EXIT') and (Length(st)=4) then
  else
    if (Command='DIR') and (Length(st)=3) then
      RunDir
    else
      if (Command='CLS') and (Length(st)=3) then
        for i:=1 to 25 do
          WriteLn
      else
        if Command='VOLUME' then
          RunVolume
        else
          if Command='LIST' then
            RunList
          else
            if Command='TYPE' then
               RunType
            else
              if Command='REF' then
                RunRef
              else
                if Command='VERIFY' then
                  RunVerify
                else
                  WriteLn(' ⠪ ');
  end;

function UpStr(x:string):string;
  var
    st:string;
  begin
  for i:=1 to Length(x) do
    st[i]:=UpCase(x[i]);
  st[0]:=x[0];
  UpStr:=st;
  end;

procedure ReadData;
  begin
  ReadLn(ff,Vol);
  end;

procedure Run;
  begin
  repeat
    WriteLn;
    Write(Vol,'>');
    ReadLn(st);
    Command:=FirstWord(st);
    Command:=UpStr(Command);
    RunCommand;
  until Command='EXIT';
  end;

begin
  Assign(ff,InFile);
  Reset(ff);
  ReadData;
  Close(ff);
  for i:=1 to 25 do
    WriteLn;
  GetTime(h,m,s,ss);
  WriteLn(' ',h,':',m,':',s);
  WriteLn('. (C) Nikokoshev Ilia-P0903');
  WriteLn('ਢ!');
  Run;
  WriteLn(' ᢨ!!!');
end.
