{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P+,Q-,R-,S+,T+,V+,X+,Y+}
{$M 16384,0,655360}
program P2106_1;
const
    Sym:array[1..3] of char = ('I','N','W');
type
    BadWord = record
      word      : string[6];
      len       : byte;
      pay       : byte;
    end;
var
    BadWords    : array[1..100] of BadWord;
    N,M,MaxLen  : byte;
    Pr,Min      : string;
    MinPay,PrPay: longint;
    SCh,SMIN    : array[1..100] of longint;
procedure ReadData;
var inf         : text;
      i         : integer;
      c         : char;
begin
  assign(inf,'INPUT.TXT'); reset(inf);
  readln(inf,N); readln(inf,M);
  MaxLen:=0;
  for i:=1 to M do
    with BadWords[i] do
    begin
      Word:='';
      read(inf,c);
      while c<>' ' do
      begin
        Word:=Word+c;
        read(inf,c);
      end;
      readln(inf,Pay);
      len:=Length(Word);
      if len>MaxLen then MaxLen:=len;
    end;
  close(inf);
end;
function SummPay(source:string):longint;
var i,j,l:integer;
      res:longint;
begin
  l:=length(source)+1;
  res:=0;
  for i:=1 to M do
    with BadWords[i] do
      for j:=1 to l-len do
        if copy(source,j,len)=Word then inc(res,Pay);
  SummPay:=res;
end;
function SummChange(l1:integer):longint;
var st,i,j,l:integer;
   res:longint;
begin
  if l1=0 then SummChange:=SummPay(pr)
  else
  begin
    st:=l1-MaxLen; if st<1 then st:=1;
    res:=0;
    for i:=1 to M do
      with BadWords[i] do
        if len<=l1+1 then
          if copy(pr,l1-len+2,len)=Word then inc(res,Pay);
    SummChange:=res;
  end;
end;
procedure GenAll(what:integer);
var i,mini:integer;
begin
  if what>N then
  begin
    if PrPay<MinPay then
    begin
      MinPay:=PrPay; Min:=Pr;
    end;
    Exit;
  end;
  for i:=1 to 3 do
  begin
    Pr[what]:=Sym[i];
    SCh[what]:=SummChange(what-1);
    inc(PrPay,SCh[what]);
    if PrPay<SMIN[what] then
    begin
      SMIN[what]:=PrPay;
      if PrPay<MinPay then GenAll(what+1);
    end;
    dec(PrPay,SCh[what]);
    inc(mini); if mini>3 then mini:=1;
    if what=1 then
      for mini:=1 to N do SMIN[mini]:=MaxLongint;
  end;
  Pr[What]:=' ';
  SCh[what]:=0;
end;
procedure Solve;
var q:integer;
begin
  FillChar(Pr,N+1,' ');pr[0]:=Chr(N);
  Min:=''; MinPay:=maxlongint;
  FillChar(SCh,400,0); PrPay:=0;
  for q:=1 to N do SMIN[q]:=MaxLongint;
  GenAll(1);
end;
procedure OutSolution;
var ouf:text;
begin
  assign(ouf,'OUTPUT.TXT'); rewrite(ouf);
  writeln(ouf,MinPay);
  writeln(ouf,Min);
  close(ouf);
end;
BEGIN
  ReadData;
  Solve;
  OutSolution;
END.
