{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program P2106_6;
type
     Vertex = record
       X,Y:real;
     end;
var
     Graf             : array[1..100,1..100] of real;
     V                : array[1..100] of Vertex;
     Path             : set of byte;
     N,V1,V2,Deep     : integer;
     Len,Pr           : real;
procedure ReadDate;
var i:integer;
begin
  assign(input,'INPUT.TXT'); reset(input);
  read(N);
  for i:=1 to N do read(V[i].X,V[i].Y);
  read(V1,V2);
  close(input);
end;
procedure Swap(var a1,a2:real);
var t:real;
begin
  t:=a1; a1:=a2; a2:=t;
end;
function Crossed(t1,t2,nl:integer):boolean;
var x1,y1,x2,y2,x3,y3,x4,y4,a1,a2,c1,c2:real;
begin
  x1:=V[t1].X; y1:=V[t1].Y;
  x2:=V[t2].X; y2:=V[t2].Y;
  x3:=V[nl].X; y3:=V[nl].Y;
  if nl=N then
  begin
    x4:=V[1].X; y4:=V[1].Y;
  end
  else
  begin
    x4:=V[nl+1].X; y4:=V[nl+1].Y;
  end;
  if (x3=x4) then
  begin
    swap(x1,x3); swap(x2,x4); swap(y1,y3); swap(y2,y4);
  end;
  if (y1<y2) then
  begin
    swap(x1,x2); swap(y1,y2);
  end;
  if (y3<y4) then
  begin
    swap(x3,x4); swap(y3,y4);
  end;
  if (x1=x2) then  { ᫨  १ - ⨪ }
  begin
    if (x3=x4) then { ᫨ ன - ⮦ }
    begin
      Crossed:=false; Exit;
    end;
    a2:=(y4-y3)/(x4-x3);
    c2:=y3-a2*x3;
    if (y1-x1*a2-c2)*(y2-x2*a2-c2)<0 then
      Crossed:=true
    else
      Crossed:=false;
    Exit;
  end;
  a1:=(y2-y1)/(x2-x1); c1:=y1-a1*x1;
  a2:=(y4-y3)/(x4-x3); c2:=y3-a2*x3;
  if a1=a2 then
  begin
    Crossed:=false; Exit;
  end;
  if ((y1-x1*a2-c2)*(y2-x2*a2-c2)<0) and
     ((y3-x3*a1-c1)*(y4-x4*a1-c1)<0) then
    Crossed:=true
  else
    Crossed:=false;
end;
function Rasst(t1,t2:integer):real;
begin
  Rasst:=sqrt(sqr(V[t1].X-V[t2].X)+sqr(V[t1].y-V[t2].y));
end;
function Sign(ss:real):integer;
begin
  if ss<0 then Sign:=-1
  else
    if ss=0 then Sign:=0
    else
      Sign:=1;
end;
function InFontan(t1,t2:integer):boolean;
var x1,y1,x2,y2,a,c:real;
    i,dir,sd:integer;
       bb:boolean;
begin
  x1:=v[t1].x; y1:=v[t1].y;
  x2:=v[t2].x; y2:=v[t2].y;
  if (x1=x2) then
  begin
    dir:=2; bb:=true;
    for i:=1 to N do
      if (i<>t1) and (i<>t2) then
        if dir>1 then dir:=Sign(v[i].x-x1)
        else
          begin
            sd:=Sign(v[i].x-x1);
            if sd<>0 then
              if sd<>dir then
              begin
                bb:=false; break;
              end;
          end;
    InFontan:=not bb; Exit;
  end;
  a:=(y2-y1)/(x2-x1); c:=y1-a*x1;
  dir:=2;
  bb:=true;
  for i:=1 to N do
    if (i<>t1) and (i<>t2) then
      if dir>1 then dir:=Sign(v[i].y-a*v[i].x-c)
      else
        begin
            sd:=Sign(v[i].y-a*v[i].x-c);
            if sd<>0 then
              if sd<>dir then
              begin
                bb:=false; break;
              end;
        end;
  InFontan:=not bb;
end;
procedure BuildGraf;
var i,j,k:integer;
       cr:boolean;
begin
  for i:=1 to N do
    for j:=1 to N do Graf[i,j]:=0;
  for i:=1 to N-1 do Graf[i,i+1]:=Rasst(i,i+1);
  Graf[N,1]:=Rasst(N,1);
  for i:=1 to N do
    for j:=1 to N do
      if Graf[i,j]=0 then
      begin
        cr:=false;
        for k:=1 to N do
          if Crossed(i,j,k) then
            if Rasst(i,j)<>0 then
            begin
              cr:=true; break;
            end;
        if not cr then
          if InFontan(i,j) then Graf[i,j]:=Rasst(i,j);
      end;
end;
procedure GoSearch(sv:byte);
var i:byte;
begin
  if sv=v2 then
    if (Len=0) or (Pr<Len) then
    begin
      Len:=Pr; Exit;
    end;
  if Deep>=N then Exit;
  inc(Deep);
  Path:=Path+[sv];
  for i:=1 to N do
    if (graf[sv,i]>0) and not (i in Path) then
    begin
      Pr:=Pr+graf[sv,i];
      GoSearch(i);
      Pr:=Pr-graf[sv,i];
    end;
  Path:=Path-[sv];
  dec(Deep);
end;
procedure Solve;
begin
  Pr:=0; Len:=0; Deep:=0; Path:=[];
  GoSearch(v1);
end;
procedure OutSolution;
begin
  assign(output,'OUTPUT.TXT'); rewrite(output);
  writeln(Len:0:7);
  close(output);
end;
BEGIN
  ReadDate;
  BuildGraf;
  Solve;
  OutSolution;
END.