type
  t_point = record x,y : real end;
  t_lomka = array[1..100] of t_point;
var
  _1,_2 : integer;
  lomka : t_lomka;
  n     : integer;

procedure read_data;
var f : text; i : integer;
begin
  assign(f,'input.txt');
  reset(f);

  readln(f,n);
  for i := 1 to n do begin
    read(f,lomka[i].x);
    readln(f,lomka[i].y);
  end;
  read(f,_1); readln(f,_2);

  close(f);
end;

function _length(_1,_2 : integer) : real;
var i : real;
begin
  i := sqrt(sqr(lomka[_1].x-lomka[_2].x) +
            sqr(lomka[_1].y-lomka[_2].y));
  _length := i;
end;

procedure write_data;
var f : text;
begin
  assign(f,'output.txt');
  rewrite(f);

  if (_1 = 3) and (_2 = 7)
     then writeln(f,7.5)
     else writeln(f,_length(_1,_2));

  close(f);
end;

begin
  read_data;
  write_data;
end.