program Enc;
uses crt;
const max_com=5;
      max_ref=256;
var tl:text;
    tm:text;
    ct:string [8];
    com:string;
    cm:array [1..max_com] of string;
    cmc:byte;
    i:word;
    err:boolean;
    cmf:boolean;
    ref:array [1..max_ref] of record nam:string [20];
                                     tom:string [8];
    end;
    rfc:word;

procedure clrref;
begin
  for i:=1 to max_ref do
    ref [i].nam:='';
  rfc:=1;
end;

procedure conv(var c_s:string);
var c_c:byte;
begin
  for c_c:=1 to length (c_s) do begin
    if c_s [c_c] in ['a'..'z'] then c_s [c_c]:=chr (ord (c_s [c_c])-32);
    if c_s [c_c] in [chr ($a0)..chr ($af)] then c_s [c_c]:=chr (ord (c_s [c_c])-$20);
    if c_s [c_c] in [chr ($e0)..chr ($ef)] then c_s [c_c]:=chr (ord (c_s [c_c])-$50);
  end;
end;

function tom_nam(tmn:string):string;
var v_s,v_s1:string;
begin
  conv (tmn);
  tom_nam:='';
  assign (tl,'input.txt');
  reset (tl);
  err:=true;
  while not eof (tl) do begin
    readln (tl,v_s);
    v_s1:=v_s;
    conv (v_s);
    if v_s=tmn then begin
      err:=false;
      tom_nam:=v_s1;
      break;
    end;
  end;
  if err then writeln ('  ');
  close (tl);
end;

procedure volum;
var vls:string;
begin
  vls:=tom_nam (cm [2]);
  if vls<>'' then ct:=vls;
  cmf:=false;
end;

function rd_stn(var f1:text):string;
var rds:string;
    rdc:char;
begin
  rds:='';
  rd_stn:=rds;
  if eoln (f1) then exit;
  repeat
    read (f1,rdc);
    if rdc<>' ' then rds:=rds+rdc;
  until eoln (f1) or (rds<>'') and ((rdc<'A') and (rdc<>'(') and (rdc<>')') and ((rdc>'9') or (rdc<'0')));
  rd_stn:=rds;
end;

procedure list;
var lst:string;
    lsn:word;
begin
  lst:=ct;
  if cmc>1 then begin
    lst:=tom_nam (cm [2]);
    if lst='' then exit;
  end;
  assign (tm,lst+'.txt');
  reset (tm);
  lsn:=1;
  while not eof (tm) do begin
    lst:=rd_stn (tm);
    writeln (lsn,'. ',lst);
    readln (tm);
    inc (lsn);
  end;
  close (tm);
  cmf:=false;
end;

function cop (cs:string;cn:byte):string;
var cs1:string;
    cn1:byte;
begin
  cs1:='';
  for cn1:=cn to length (cs) do begin
    if cs [cn1]=')' then break;
    cs1:=cs1+cs [cn1];
  end;
  cop:=cs1;
end;


procedure ptype;
var tms,tm2,tm3:string;
    j:word;
    fnd:boolean;
    stn:string;
    col:byte;
    crtt:string;
begin
  if cmc=1 then begin
    writeln ('  ');
    exit;
  end;
  tms:='';
  stn:=cm [2];
  fnd:=false;
  for j:=1 to length (cm [2]) do
    if cm [2,j]=':' then begin
                      fnd:=true;
                      stn:=copy (cm [2],j+1,length (cm [2])-j);
                      break;
                    end
                    else tms:=tms+cm [2,j];
  if not fnd then tms:=ct;
  tms:=tom_nam (tms);
  if tms='' then exit;
  crtt:=tms;
  conv (crtt);
  assign (tm,tms+'.txt');
  reset (tm);
  fnd:=false;
  conv (stn);
  while not eof (tm) do begin
    tms:=rd_stn (tm);
    tm2:=tms;
    conv (tm2);
    if tm2=stn then begin
      fnd:=true;
      write (tms,' ');
      col:=length (tms)+1;
      break;
    end;
    readln (tm);
  end;
  if not fnd then begin
    writeln ('  ');
    exit;
  end;
  clrref;
  tms:=rd_stn (tm);
  tm2:=rd_stn (tm);
  while tms<>'' do begin
    tm3:=rd_stn (tm);
    if length (tm2)>=4 then
      if copy (tm2,1,4)='(.' then begin
        ref [rfc].nam:=tms;
        if (length (tm2)>4) and (tm2 [5]=')') then ref [rfc].tom:=crtt
        else
        if length (tm2)>4 then ref [rfc].tom:=cop (tm2,5) {copy (tm2,5,length (tm2)-5)}
        else
        ref [rfc].tom:=cop (tm3,1); {copy (tm3,1,length (tm3)-1);}
        inc (rfc);
      end;

    if col+length (tms)>78 then begin
      writeln;
      col:=0;
    end;
    write (tms,' ');
    col:=col+length (tms)+1;
    tms:=tm2;
    tm2:=tm3;
  end;
  writeln;
  if rfc>1 then begin
    writeln;
    for j:=1 to rfc-1 do begin
      write (j,'. ',ref [j].nam);
      tms:=ref [j].tom;
      conv (tms);
      if tms<>crtt then write (', ⮬ ',ref [j].tom);
      writeln;
    end;
  end;
  close (tm);
  cmf:=false;
end;

procedure rd_com;
begin
  repeat
    for i:=1 to max_com do
      cm [i]:='';
    writeln;
    write (ct,'>');
    readln (com);
    cmc:=0;
    com:=com+' ';
    for i:=1 to length (com) do
      if com [i] = ' ' then inc (cmc)
      else if com [i] in ['a'..'z'] then cm[cmc+1]:=cm[cmc+1]+chr (ord (com [i])-32)
                                    else cm[cmc+1]:=cm[cmc+1]+com [i];
  until length (cm[1])<>0;
{  writeln;}
{  writeln (cmc,' ',cm[1],cm[2]);}
end;

procedure print_str (var f1:text);
var ps_s:string;
    ps_c:byte;
    ps_l:char;
begin
  ps_s:='';
  ps_c:=0;
  while not eoln (f1) do begin
    read (f1,ps_l);
    ps_s:=ps_s+ps_l;
    if ps_l=' ' then begin
      if ps_c+length (ps_s)>79 then begin
        writeln;
        ps_c:=0;
      end;
      write (ps_s);
      ps_c:=ps_c+length (ps_s);
      ps_s:='';
    end;
  end;
  if ps_c+length (ps_s)>79 then writeln;
  if ps_s<>'' then writeln (ps_s);
  readln (f1);
end;

procedure reff;
var num,stat:integer;
begin
  val (cm [2],num,stat);
  if (stat<>0) or ((stat=0) and  (num>rfc-1)) then begin
    writeln ('  뫪');
    exit;
  end;
  cm[2]:=ref [num].tom+':'+ref [num].nam;
  clrref;
  ptype;
  cmf:=false;
end;

begin
  textcolor (15);
  textbackground (0);
  clrscr;
  writeln ('Hello !');
  assign (tl,'input.txt');
  reset (tl);
  readln (tl,ct);
  if ct='' then begin
    writeln ('    ⮬');
    halt (0);
  end;
  close (tl);

  repeat
    rd_com;
    cmf:=true;

    if cm[1]='REF' then begin
      cmf:=false;
      reff;
    end;

    if cmf then clrref;

    if cm[1]='EXIT' then begin
      writeln ('Good Bye !');
      halt (0);
    end;

    if cm[1]='DIR' then begin
      assign (tl,'input.txt');
      reset (tl);
      repeat
        print_str (tl);
      until eof (tl);
      close (tl);
      cmf:=false;
    end;

    if cm[1]='CLS' then begin
      clrscr;
      cmf:=false;
    end;

    if cm[1]='VOLUME' then begin
      cmf:=false;
      volum;
    end;

    if cm[1]='LIST' then begin
      cmf:=false;
      list;
    end;

    if cm[1]='TYPE' then begin
      cmf:=false;
      ptype;
    end;

    if cmf then writeln (' ⠪ ');
  until 0>0;
end.