Uses Objects,Crt;

Type PNoSortColl=^TNoSortColl;
     TNoSortColl=Object(TStringCollection)
      Function Compare(key1,key2:Pointer):Integer; virtual;
     End;

Var I:PDosStream;
    RazRef,Ready,InitS:Boolean;
    Vol,Com,T:String;
    PS:PString;
    MText,Vols,Ssylk:PNoSortColl;

Const Err:Array [1..5] of String=(
      ' ⠪ ',
      '  ',
      '  ',
      '  뫪',
      ' 맮 ');
      Commands:Array [1..8] of String=(
      'DIR',
      'VOLUME',
      'LIST',
      'TYPE',
      'REF',
      'CLS',
      'VERIFY',
      'EXIT');

Function TNoSortColl.Compare;
Begin
 Compare:=-1;
End;

Procedure UpCaseS(var S:String);
Var A:Byte;
Begin
 For A:=1 to Length(S) Do
  S[A]:=UpCase(S[A]);
End;

Function StrToLong(S:String):LongInt;
Var Code:Integer;
    L:Longint;
Begin
 Val(S,L,Code);
 StrToLong:=L;
End;

Procedure Error(A:Byte);
Begin
 Writeln(Err[A]);
 Ready:=False;
End;

Function GetCom(S:String):String;
Var R:String;
    A:Byte;
    Raz:Boolean;
Begin
 R:='';
 A:=0;
 Repeat
  Inc(A);
  If S[A]=' ' Then R:=Copy(S,1,A-1);
 Until (R<>'') Or (A=Length(S));
 If R='' Then R:=S;
 UpCaseS(R);
 Raz:=False;
 For A:=1 to 8 Do
  If R=Commands[A] Then Raz:=True;
 If Raz=False Then Error(1);
 GetCom:=R;
End;

Procedure OpenS(S:String);
Var R:Boolean;
    F:File;
Begin
 R:=True;
 Assign(F,S);
 {$I-}
 Reset(F);
 If IOResult>0 Then Begin
                     R:=False;
                     Error(2);
                    End;
 {$I+}
 If R Then I:=New(PDosStream,Init(S,stOpen));
 InitS:=R;
End;

Procedure CloseS;
Begin
 If InitS Then Dispose(I,Done);
 InitS:=False;
End;

Procedure Welcome;
Begin
 Writeln('ਢ!');
End;

Procedure Goodbye;
Begin
 Writeln(' ᢨ!');
 CloseS;
End;

Procedure Dir;
Var A:Word;
    PS:PString;
Begin
 For A:=0 to Vols^.Count-1 Do Begin
  PS:=Vols^.At(A);
  Writeln(PS^);
 End;
End;

Procedure ReadSsylk;
Var Size,Pos:Longint;
    PreC,C:Char;
    S:String;
    Raz:Boolean;
Begin
 Ssylk^.FreeAll;
 Size:=I^.GetSize;
 I^.Seek(0);
 Raz:=True;
 S:='';
 C:=' ';
 Repeat
  PreC:=C;
  I^.Read(C,1);
  Pos:=I^.GetPos;
  If (C=' ') And Raz Then Begin
                           Raz:=False;
                           Ssylk^.Insert(NewStr(S));
                           S:='';
                          End;
  If PreC=#10 Then Raz:=True;
  If Raz Then S:=S+C;
 Until Pos=Size;
End;

Procedure List(S:String);
Var A:Word;
    PS:PString;
    OldVol:String;
Begin
 If S='' Then Begin
               OpenS(Vol+'.txt');
               ReadSsylk;
               CloseS;
              End
         Else Begin
               OldVol:=Vol;
               Vol:=S;
               OpenS(Vol+'.txt');
               If Ready Then ReadSsylk;
               CloseS;
               Vol:=OldVol;
              End;
 If Ready Then Begin
  If Ssylk^.Count>1 Then
   For A:=0 to Ssylk^.Count-1 Do Begin
    PS:=Ssylk^.At(A);
    Writeln(A+1,'. ',PS^);
   End;
  RazRef:=True;
 End;
End;

Procedure FormatText;
Var A:Byte;
    B:LongInt;
    S:String;
    PS:PString;
Begin
 For B:=0 to MText^.Count-1 Do Begin
  PS:=MText^.At(B);
  S:=PS^;
  A:=0;
  Repeat
   Inc(A);
   If (S[A]=' ') And (Length(S)<80) Then Begin
                                          S:=Copy(S,1,A)+Copy(S,A,Length(S)-A+1);
                                          Inc(A);
                                         End;
   If A=Length(S) Then A:=0;
  Until (Length(S)=80) Or (B=MText^.Count-1);
  MText^.AtPut(B,NewStr(S));
 End;
End;

Procedure ReadSsylkInText;
Var B:Word;
    C,A,Sm,Space:Byte;
    S,MVol:String;
    Raz:Boolean;

Function Razdel(C:Char):Boolean;
Var R:Boolean;
Begin
 Case C Of
  '.':R:=True;
  ' ':R:=True;
  ',':R:=True;
  ':':R:=True;
  ';':R:=True;
  Else R:=False;
 End;
 Razdel:=R;
End;

Function Form(S:String):String;
Var A:Byte;
    SS:String;
Begin
 SS:=S;
 Raz:=False;
 A:=0;
 Repeat
  Inc (A);
  If S[A]=' ' Then Begin
                    SS:=Copy(SS,1,A-1);
                    Raz:=True;
                   End;
 Until (A=Length(S)) Or Raz;
 Form:=SS;
End;

Begin
 Ssylk^.FreeAll;
 For B:=0 to MText^.Count-1 Do Begin
  PS:=MText^.At(B);
  If Copy(PS^,1,4)='(.' Then
   If PS^[5]=')' Then Begin
                       PS:=MText^.At(B-1);
                       C:=Length(PS^)+1;
                       Repeat
                        Dec(C);
                       Until Razdel(PS^[C]) Or (C=1);
                       If C=1 Then Ssylk^.Insert(NewStr(Form(PS^)))
                              Else Ssylk^.Insert(NewStr(Form(Copy(PS^,C+1,Length(PS^)-C))));
                       PS:=MText^.At(B);
                      End
                 Else Begin
                       A:=1;
                       C:=A+3;
                       Repeat
                        Inc(C);
                       Until PS^[C]=')';
                       MVol:=Copy(PS^,A+4,C-A-4);
                       If MVol=Vol Then MVol:=''
                                   Else MVol:=', ⮬ '+MVol;
                       PS:=MText^.At(B-1);
                       C:=Length(PS^)+1;
                       Repeat
                        Dec(C);
                       Until Razdel(PS^[C]) Or (C=1);
                       If C=1 Then Ssylk^.Insert(NewStr(Form(PS^)+MVol))
                              Else Ssylk^.Insert(NewStr(Form(Copy(PS^,C+1,Length(PS^)-C))+MVol));
                       PS:=MText^.At(B);
                      End;
  For A:=2 to Length(PS^)-4 Do Begin
   S:=Copy(PS^,A,4);
   If Copy(PS^,A,4)='(.' Then
    If PS^[A+4]=')' Then Begin
                          C:=A-1;
                          Raz:=False;
                          Repeat
                           Dec(C);
                           If Razdel(PS^[C]) Then Begin
                                                   Ssylk^.Insert(NewStr(Form(Copy(PS^,C+1,A-C-1))));
                                                   Raz:=True;
                                                  End;
                          Until Raz Or (C=1);
                          If C=1 Then Ssylk^.Insert(NewStr(Form(Copy(PS^,1,A-C))));
                         End
                    Else Begin
                          C:=A+3;
                          Repeat
                           Inc(C);
                          Until PS^[C]=')';
                          MVol:=Copy(PS^,A+4,C-A-4);
                          If MVol=Vol Then MVol:=''
                                      Else MVol:=', ⮬ '+MVol;
                          C:=A-1;
                          Raz:=False;
                          Repeat
                           Dec(C);
                           If RazDel(PS^[C]) Then Begin
                                                   Ssylk^.Insert(NewStr(Form(Copy(PS^,C+1,A-C-1))+MVol));
                                                   Raz:=True;
                                                  End;
                          Until Raz Or (C=1);
                          If C=1 Then Ssylk^.Insert(NewStr(Form(Copy(PS^,1,A-C))+MVol));
                         End;
  End;
 End;
End;

Procedure ReadText(S:String);
Var Raz,Raz2:Boolean;
    A:Byte;
    SS:Word;
    St:String;
    Sc,Pos,Size:LongInt;
    PreC,C:Char;
    L,LastSpace:Longint;
Begin
 MText^.FreeAll;
 ReadSsylk;
 Raz:=False;
 For A:=0 to Ssylk^.Count-1 Do Begin
  PS:=Ssylk^.At(A);
  If PS^=S Then Begin
                 Raz:=True;
                 SS:=A;
                End;
 End;
 If Raz=False Then Error(3);
 If Ready Then Begin
                I^.Seek(0);
                Size:=I^.GetSize;
                Raz:=False;
                St:='';
                C:=' ';
                Sc:=0;
                Repeat
                 PreC:=C;
                 Pos:=I^.GetPos;
                 I^.Read(C,1);
                 If PreC=' ' Then LastSpace:=Pos-1;
                 If PreC=#10 Then Inc(Sc);
                 If Sc=SS Then Begin
                                Raz2:=True;
                                If (PreC=' ') And (Length(St+C)>80) Then Begin
                                                                          I^.Seek(LastSpace+1);
                                                                          L:=Length(St);
                                                                          St:=Copy(St,1,Length(St)-1);
                                                                          MText^.Insert(NewStr(St));
                                                                          St:='';
                                                                          Raz2:=False;
                                                                         End;
                                If Raz2 Then St:=St+C;
                               End;
                 If Sc>SS Then Raz:=True;
                Until (Pos=Size) Or Raz;
                If St<>'' Then MText^.Insert(NewStr(Copy(St,1,Length(St)-1)));
                ReadSsylkInText;
                FormatText;
               End;
End;

Procedure MType(S:String);
Var Dw,A:Byte;
    RazVol:Boolean;
    OldVol:String;
    PS:PString;
Begin
 RazRef:=False;
 If S='' Then Error(5);
 For A:=1 to Length(S) Do
  If (S[A]=' ') And Ready Then Error(5);
 If Ready Then Begin
                RazVol:=False;
                Dw:=0;
                For A:=1 to Length(S) Do
                 If S[A]=':' Then Begin
                                   RazVol:=True;
                                   Dw:=A;
                                  End;
                If RazVol Then Begin
                                OldVol:=Vol;
                                Vol:=Copy(S,1,Dw-1);
                                OpenS(Vol+'.txt');
                                If Ready Then ReadText(Copy(S,Dw+1,Length(S)-Dw));
                                CloseS;
                                Vol:=OldVol;
                               End
                          Else Begin
                                OpenS(Vol+'.txt');
                                ReadText(S);
                                CloseS;
                               End;
                If Ready Then Begin
                               For A:=0 to MText^.Count-1 Do Begin
                                PS:=MText^.At(A);
                                Write(PS^);
                               End;
                               Writeln('');
                               If Ssylk^.Count>0 Then Begin
                                 Writeln('');
                                 For A:=0 to Ssylk^.Count-1 Do Begin
                                  PS:=Ssylk^.At(A);
                                  Writeln(A+1,'. ',PS^);
                                 End;
                                 RazRef:=True;
                                End;
                              End;
               End;
End;

Procedure Ref(S:String);
Var A,Sl:Byte;
    PS:PString;
    Raz:Boolean;
    Zp:Byte;
    S1,S2:String;
Begin
 If RazRef=False Then Error(4);
 If Ready And (S='') Then Error(5);
 If Ready Then Begin
                Sl:=StrToLong(S);
                If Sl>Ssylk^.Count Then Error(4);
                If Ready Then Begin
                               PS:=Ssylk^.At(Sl-1);
                               Raz:=False;
                               For A:=1 to Length(PS^) Do
                                If PS^[A]=',' Then Begin
                                                    Raz:=True;
                                                    Zp:=A;
                                                   End;
                               If Raz Then MType(Copy(PS^,Zp+6,Length(PS^)-Zp-4)+':'+Copy(PS^,1,Zp-1))
                                      Else MType(Vol+':'+Copy(PS^,1,Zp-1));
                              End;
               End;
 RazRef:=Ready;
End;

Procedure Verify;
Var A,B,C,Zp:Word;
    D:Integer;
    KudVol,KudS,TmpVol,TmpS,OtkVol,OtkS:PNoSortColl;
    PS2,PS1,PS:PString;
    S:String;
    Raz:Boolean;
Begin
 OtkVol:=New(PNoSortColl,Init(10,10));
 OtkS:=New(PNoSortColl,Init(10,10));
 TmpVol:=New(PNoSortColl,Init(10,10));
 TmpS:=New(PNoSortColl,Init(10,10));
 KudS:=New(PNoSortColl,Init(10,10));
 KudVol:=New(PNoSortColl,Init(10,10));
 For A:=0 to Vols^.Count-1 Do Begin
  PS:=Vols^.At(A);
  S:=PS^;
  OpenS(PS^+'.txt');
  ReadSsylk;
  For B:=0 to Ssylk^.Count-1 Do Begin
   PS:=Ssylk^.At(B);
   TmpVol^.Insert(NewStr(S));
   TmpS^.Insert(NewStr(PS^));
  End;
  CloseS;
 End;
 For A:=0 to TmpVol^.Count-1 Do Begin
  PS:=TmpVol^.At(A);
  S:=PS^;
  PS1:=TmpS^.At(A);
  OpenS(S+'.txt');
  ReadText(PS1^);
  ReadSsylkInText;
  For B:=0 to Ssylk^.Count-1 Do Begin
   OtkVol^.Insert(NewStr(S));
   OtkS^.Insert(NewStr(PS1^));
   PS:=Ssylk^.At(B);
   Raz:=False;
   For C:=1 to Length(PS^) Do
   If PS^[C]=',' Then Begin
                       Raz:=True;
                       Zp:=C;
                      End;
   If Raz Then Begin
                KudVol^.Insert(NewStr(Copy(PS^,Zp+6,Length(PS^)-Zp-4)));
                KudS^.Insert(NewStr(Copy(PS^,1,Zp-1)));
               End
          Else Begin
                KudVol^.Insert(NewStr(S));
                KudS^.Insert(NewStr(Copy(PS^,1,Zp-1)));
               End;
  End;
  CloseS;
 End;
 D:=-1;
 Repeat
  Inc(D);
  PS1:=KudVol^.At(D);
  S:=PS1^;
  PS1:=KudS^.At(D);
  For A:=0 to TmpVol^.Count-1 Do Begin
   If A>TmpVol^.Count-1 Then PS:=TmpVol^.At(A);
   If A>TmpS^.Count-1 Then PS2:=TmpS^.At(A);
   If (PS^=S) And (PS2^=PS1^) Then Begin
                                    KudS^.AtFree(D);
                                    KudVol^.AtFree(D);
                                    OtkVol^.AtFree(D);
                                    OtkS^.AtFree(D);
                                   End;
  End;
 Until D=KudVol^.Count-1;
 If KudS^.Count>1 Then Begin
                        For A:=0 to OtkVol^.Count-1 Do Begin
                         PS:=OtkVol^.At(A);
                         S:=PS^;
                         PS:=OtkS^.At(A);
                         PS1:=KudS^.At(A);
                         PS2:=KudVol^.At(A);
                         Writeln(A+1,'. ',S,':',PS^,' 뫪  ',PS1^,':',PS2^);
                        End;
                       End
                  Else Writeln(' 뫪 ४');
 Dispose(OtkVol,Done);
 Dispose(OtkS,Done);
 Dispose(TmpS,Done);
 Dispose(TmpVol,Done);
 Dispose(KudS,Done);
 Dispose(KudVol,Done);
End;

Procedure Run(S:String);
Var Com:String;
Begin
 Com:=GetCom(S);
 If Com='CLS' Then Begin
                    ClrScr;
                    RazRef:=False;
                   End;
 If Com='DIR' Then Dir;
 If Com='LIST' Then List(Copy(S,6,Length(S)-5));
 If Com='TYPE' Then MType(Copy(S,6,Length(S)-5));
 If Com='REF' Then Ref(Copy(S,5,Length(S)-4));
 If Com='VERIFY' Then Verify;
End;

Procedure ReadVol;
Var F:Text;
    S:String;
Begin
 Assign(F,'input.txt');
 Reset(F);
 Repeat
  Readln(F,S);
  Vols^.Insert(NewStr(S));
 Until EOF(F);
End;

Begin
 Vols:=New(PNoSortColl,Init(10,10));
 Ssylk:=New(PNoSortColl,Init(10,10));
 MText:=New(PNoSortColl,Init(10,10));
 InitS:=False;
 Ready:=True;
 RazRef:=False;
 ClrScr;
 Welcome;
 ReadVol;
 PS:=Vols^.At(0);
 Vol:=PS^;
 Repeat
  Writeln('');
  Write(Vol,'>');
  Readln(T);
  Com:=GetCom(T);
  If Ready Then Run(T);
  Ready:=True;
 Until Com='EXIT';
 Goodbye;
 Dispose(Vols,Done);
 Dispose(Ssylk,Done);
 Dispose(MText,Done);
End.