Program Task3;

 Uses
      Crt;

 Type
     TPoint = Record
        X, Y : Extended;
      End;
     TBassein = Array [1..100] Of TPoint;
     PtrBassein = ^TBassein;


 Var
     PBas        : PtrBassein;
     N, K, L, I  : Byte;
     TotalLength : Extended;

 Procedure ReadSource;
  Var
       F : Text;
       I : Byte;
  Begin
    New (PBas);
    Assign (F, 'INPUT.TXT');
    ReSet (F);
    ReadLn (F, N);
    For I := 1 To N Do ReadLn (F, PBas^ [I].X, PBas^ [I].Y);
    ReadLn (F, K, L);
    Close (F);
  End;

 Procedure WriteDest;
  Var
       F : Text;
  Begin
    Assign (F, 'OUTPUT.TXT');
    ReWrite (F);
    WriteLn (F, TotalLength:1:6);
    Close (F);
  End;

 Function Cross (P, P1, P2 : TPoint) : Byte;
  Var
       dX1, dX2,
       dY1, dY2 : Extended;
  Begin
    dX1 := P.X - P1.X; dX2 := P.X - P2.X;
    dY1 := P.Y - P1.Y; dY2 := P.Y - P2.Y;
    If (dX1 = 0) Then
     Begin
       If (P2.X > P1.X) Then Cross := 2 Else
       If (P2.X < P1.X) Then Cross := 1 Else Cross := 0;
       Exit;
     End;
    If (dX2 = 0) Then
     Begin
       If (P2.X > P1.X) Then Cross := 2 Else
       If (P2.X < P1.X) Then Cross := 1 Else Cross := 0;
       Exit;
     End;
    If (dY1/dX1 > dY2/dX2) Then Cross := 1 Else
    If (dY1/dX1 < dY2/dX2) Then Cross := 2 Else Cross := 0;
  End;

 Function LineLength (P1, P2 : TPoint) : Extended;
  Begin
    LineLength := Sqrt (Sqr (P1.X - P2.X) + Sqr (P1.Y - P2.Y));
  End;

 Procedure CheckSource;
  Var
       I, J  : Byte;
       CurrL : Byte;
  Begin
    I := L + 1;
    If (I > N) Then I := 1;

    J := L - 1; CurrL := L;
    While ((I <> K) And (J <> K)) Do
     Begin {᫨ K1>K2,  Cross = 1}
       If (Cross (PBas^ [CurrL], PBas^ [K], PBas^ [J]) = 2) Then
        Begin
          TotalLength := TotalLength + LineLength (PBas^ [CurrL], PBas^ [J]);
          CurrL := J;
        End;
       Dec (J);
       If (Cross (PBas^ [CurrL], PBas^ [K], PBas^ [I]) = 1) Then
        Begin
          TotalLength := TotalLength + LineLength (PBas^ [CurrL], PBas^ [I]);
          CurrL := I;
        End;
       Inc (I);
       If (I > N) Then I := 1;
     End;
    TotalLength := TotalLength + LineLength (PBas^ [CurrL], PBas^ [K]);
  End;

Begin
  ReadSource;
  TotalLength := 0;
  If (L = K) Then
   Begin
     WriteDest; Halt;
   End;
  If (K > L) Then
   Begin
     I := L; L := K; K := I;
   End; {⥯ L > K}
  CheckSource;
  WriteDest;
End.