{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q+,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
 var F:text; S:string; Error:integer;
     N, Number, v1, v2, i, j:byte;
     Crd:array [1..100, 1..2] of extended;
     Order:array [1..100] of byte;
     Len:extended;
     Loop, Stat:boolean;

procedure Intersect(xx, yy, x1, y1, x2, y2:extended; var Cross:boolean; var Side:boolean);
 var xs:extended;
     k, b:extended;
     Min, Max:extended;
begin
 if x1=x2 then
 begin
  if y1<y2 then begin Min:=y1; Max:=y2; end else
                begin Min:=y2; Max:=y1; end;
  Cross:=(yy>Min) and (yy<Max);
 end else
 begin
  k:=(y2-y1)/(x2-x1);
  b:=y1-k*x1;
  if (x2<>x1) and (k=0) then Cross:=false else
  begin
   if x1<x2 then begin Min:=x1; Max:=x2; end else
                 begin Min:=x2; Max:=x1; end;
   xs:=(yy-b)/k;
   if (xs>Min) and (xs<Max) then
   begin
    Cross:=true;
    Side:=xs>xx;
   end;
  end;
 end;
end;

function Inside(x, y:extended):boolean;
 var t1, t2:boolean;
     l, r, i:byte;
     x1, y1, x2, y2:extended;
begin
 l:=0; r:=0;
 for i:=1 to N do
 begin
  x1:=Crd[i, 1]; y1:=Crd[i, 2];
  if i<N then
  begin
   x2:=Crd[i+1, 1]; y2:=Crd[i+1, 2];
  end else
  begin
   x2:=Crd[1, 1]; y2:=Crd[1, 2];
  end;
  Intersect(x, y, x1, y1, x2, y2, t1, t2);
  if t1 then
  case t2 of
   true:Inc(r);
   false:Inc(l);
  end;
 end;
 Inside:=(r mod 4 <> 0) or (l mod 4 <> 0);
end;

function SegCross(ax1, ay1, ax2, ay2, bx1, by1, bx2, by2:extended):boolean;
 var k1, k2, b1, b2:extended;
     xs, ys, Min, Max, Min2, Max2:extended;
begin
 if (ax1=ax2) and (bx1=bx2) then SegCross:=false else
 begin
  if (ax1=ax2) then
  begin
   xs:=ax1;
   k1:=(by2-by1)/(bx2-bx1);
   b1:=by1-k1*bx1;
   ys:=k1*xs+b1;
   if ay1<ay2 then begin Min:=ay1; Max:=ay2; end else
                   begin Min:=ay2; Max:=ay1; end;
   if by1<by2 then begin Min2:=by1; Max2:=by2; end else
                   begin Min2:=by2; Max2:=by1; end;
   SegCross:=(ys>Min) and (ys<Max) and (ys>Min2) and (ys<Max2);
  end else
  if (bx1=bx2) then
  begin
   xs:=bx1;
   k1:=(ay2-ay1)/(ax2-ax1);
   b1:=ay1-k1*ax1;
   ys:=k1*xs+b1;
   if ay1<ay2 then begin Min:=ay1; Max:=ay2; end else
                   begin Min:=ay2; Max:=ay1; end;
   if by1<by2 then begin Min2:=by1; Max2:=by2; end else
                   begin Min2:=by2; Max2:=by1; end;
   SegCross:=(ys>Min) and (ys<Max) and (ys>Min2) and (ys<Max2);
  end else
  begin
   k1:=(ay2-ay1)/(ax2-ax1);
   b1:=ay1-k1*ax1;
   k2:=(by2-by1)/(bx2-bx1);
   b2:=by1-k2*bx1;
   if k1=k2 then SegCross:=false else
   begin
    xs:=(b2-b1)/(k1-k2);
    if bx1<bx2 then begin Min:=bx1; Max:=bx2; end else
                    begin Min:=bx2; Max:=bx1; end;
    if ax1<ax2 then begin Min2:=ax1; Max2:=ax2; end else
                    begin Min2:=ax2; Max2:=ax1; end;
    SegCross:=(xs>Min) and (xs<Max) {and (xs>Min2) and (xs<Max2)};
   end;
  end;
 end;
end;

function Inner(x1, y1, x2, y2:extended):boolean;
 var ax, bx, ay, by:extended;
     i:byte; Stat:boolean;
begin
 i:=1; Stat:=Inside((x1+x2)/2, (y1+y2)/2);
 while Stat and (i<=N) do
 begin
  ax:=Crd[i, 1]; ay:=Crd[i, 2];
  if i<N then
  begin
   bx:=Crd[i+1, 1]; by:=Crd[i+1, 2];
  end else
  begin
   bx:=Crd[1, 1]; by:=Crd[1, 2];
  end;
  Stat:=not SegCross(ax, ay, bx, by, x1, y1, x2, y2);
  Inc(i);
 end;
 Inner:=Stat;
end;

function Dist(x, y:byte):extended;
 var x1, y1, x2, y2:extended;
begin
 x1:=Crd[Order[x], 1]; x2:=Crd[Order[y], 1];
 y1:=Crd[Order[x], 2]; y2:=Crd[Order[y], 2];
 Dist:=Sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
end;

BEGIN
 Assign(F, 'input.txt'); Reset(F); ReadLn(F, S);
 Val(S, N, Error);
 for i:=1 to n do
 begin
  ReadLn(F, S);
  j:=1; while S[j]<>' ' do Inc(j);
  Val(Copy(S, 1, j-1), Crd[i, 1], Error);
  Val(Copy(S, j+1, Length(S)-j), Crd[i, 2], Error);
 end;
 ReadLn(F, S); i:=1; while S[i]<>' ' do Inc(i);
 Val(Copy(S, 1, i-1), v1, Error); Val(Copy(S, i+1, Length(S)-i), v2, Error);
 Close(F);

 for i:=v1 to v2 do Order[i-v1+1]:=i; Number:=v2-v1+1;
 Loop:=true;
 while Loop do
 begin
  Loop:=false; Stat:=true; i:=1;
  if Number>2 then
  while (i<=Number-2) and Stat do
  begin
   if Inner(Crd[Order[i], 1], Crd[Order[i], 2], Crd[Order[i+2], 1], Crd[Order[i+2], 2]) then
   begin
    Loop:=true;
    for j:=i+1 to Number-1 do Order[j]:=Order[j+1];
    Stat:=false; Dec(Number);
   end;
   Inc(i);
  end;
 end;
 Len:=0;
 for i:=1 to Number-1 do Len:=Len + Dist(i, i+1);
 Assign(F, 'output.txt'); Rewrite(F);
 Str(Len, S); WriteLn(F, S); Close(F);
END.




