{$M 65520,0,0}
program Gen;

const MaxM = 500; MaxN=3000;

type T1 = array[1..16384] of byte;

var N,M : word; P : array[1..MaxM] of word;
    K : longint;
    A : array[1..MaxN] of word; {⥫  ਭ ॣ}
    E : array[1..MaxN] of word; {⢮ ᥫ   ॣ}
    Factr : T1; FLength : word;
    Reslt : T1; ResLength : word;

procedure InputData;
var F : text; i : word;
begin
  assign(F,'INPUT.TXT');
  reset(F);
  read(F,N,M);
  for i := 1 to M do read(F,P[i]);
  close(F);
end;

procedure CountK; {⠥ ⢮ ਠ⮢   ⠭}
var i : word;
begin
  K := 0;
  for i := 1 to M do
    inc(K,N-P[i]-1);
end;

procedure Exclude(v : word);
var i : word;
begin
  for i := 1 to M-1 do
    P[i]:=P[i+1];
  dec(M);
end;

procedure SortP;
var i,i2 : word; i3 : boolean;
begin
  repeat
    i3 := true;
    for i := 1 to M-1 do
      if P[i+1]<P[i] then begin i2:=P[i+1]; P[i+1]:=P[i]; P[i]:=i2; i3:=false end;
  until i3;
  for i := 1 to M-1 do
    if P[i+1] = P[i] then Exclude(i+1);
end;

procedure Change(Source, Dest : word);
var I : word;
begin
  for i := 1 to N do if A[i]=Source then A[i]:=Dest
end;

procedure CountRegions;
var i,i1,i2,i3 : word;
label lab1;
begin
  for i:=1 to MaxN do A[i]:=0;
  i2:=1;
  A[1]:=1;
  for i := 1 to N do {  ᫠-誠}
    if A[i]=0 then {  章}
      begin
        inc(i2);
        A[i]:=i2; goto lab1
      end else
      begin
lab1:   for i1 := 1 to M do  {  "㧠"}
          begin
            i3 := P[i1];
            repeat
              if i3+i+1>N then break else
                if A[i3+i+1]=0 then A[i3+i+1]:=A[i] else if A[i3+i+1]<>A[i] then Change(A[i3+i+1],A[i]);
              inc(i3,P[i1]);
            until false;
          end;
      end;
  for i := 1 to MaxN do E[i]:=0;
  for i := 1 to MaxN do inc(E[A[i]]);
end;

procedure CountFactr(G : word);
var i,i2 : word; Ost : word;
begin
  FLength:=1;
  Factr[1]:=1;
  if G < 2 then exit;
  Ost := 0;
  for i := 2 to G do    { Factr  i}
    begin
      for i2:=1 to 16384 do
        begin
          if FLength<i2 then FLength:=i2;
          Ost:=Factr[i2]*i+Ost;
          Factr[i2]:=Ost mod 10; Ost := Ost div 10;
          if (Ost=0) and (FLength<=i2) then break;
        end;
{      if Ost <> 0 then begin writeln('䬥᪮ ९.'); halt(0) end;}
    end;
end;

procedure ResMulFactr; { Reslt  Factr  १ ࠭  Reslt}
var T : T1;
    i,i2 : word; Ost : word;
begin
  {1.    ࠧ 䠪ਠ  १ 뢠  T1}
  for i := 1 to 16384 do begin T[i]:=0; end;
  for i := 1 to FLength do
    begin
      Ost := 0;
      for i2 := 1 to ResLength do
        begin
          Ost := Ost+Factr[i]*Reslt[i2];
          Ost := Ost+T[i+i2-1];
          T[i+i2-1]:=Ost mod 10;
          Ost := Ost div 10;
        end;
    end;
  Reslt:=T;
  for i := 16384 downto 1 do if Reslt[i]>0 then begin ResLength:=i; break end;
end;

procedure CountResult;
var i : word;
    F : text;
begin
  for i := 2 to 16384 do Reslt[i]:=0; Reslt[1]:=1; ResLength:=1;
  for i := 1 to MaxN do
    if E[i]>0 then
      begin
        CountFactr(E[i]);
        ResMulFactr;
      end;
  while Reslt[ResLength]=0 do dec(ResLength);
  assign(F,'OUTPUT.TXT');
  rewrite(F);
  for i := ResLength downto 1 do write(F,Reslt[i]);
  close(F);
end;

begin
  InputData;
  CountK;
  CountRegions;
  CountResult;
  write('');
end.