program p3105_5;

uses Crt;

const UCase : array[0..255] of char=#0#1#2#3#4#5#6#7#8#9#10#11#12#13#14#15#16#17#18#19#20#21#22#23#24#25#26#27#28#29#30#31+
  ' !"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`ABCDEFGHIJKLMNOPQRS'+
  'TUVWXYZ{|}~ߐ'+
  '';
const Command : array[1..8] of string[6] = ('DIR','VOLUME','LIST','TYPE','REF','CLS','VERIFY','EXIT');
const VolNF : string[13]='  ';
      ErrorCmd : string[17]=' ⠪ ';
      TitleNF : string[17]='  ';
      Unsupported : string[30] = '   ॠ';
var CurVolume : string[8];

function UC(st1 : string) : string;
var i : byte; st:string;
begin
  st := st1;
  for i := 1 to length(st) do
    begin
      st[i]:=UCase[ord(st[i])];
    end;
  UC := st;
end;

procedure SetupFirstVolume;
var F : text;
begin
  assign(F,'INPUT.TXT');
  reset(F);
  if EOF(F) then CurVolume:='' else readln(F,CurVolume);
  close(F);
  CurVolume:=UC(CurVolume);
end;

procedure PrintVolumes;
var F : text; st : string;
begin
  assign(F,'INPUT.TXT');
  reset(F);
  while not(EOF(F)) do
    begin
      readln(F,st);
      writeln(UC(st));
    end;
  close(F);
end;

function ChangeVolume(Command : string) : boolean;
var F : text; st : string;
label lab1;
begin
  if (Command[0]>#0) and (Command[1]<>' ') then begin writeln(ErrorCmd); ChangeVolume:=false; exit end;
  delete(Command,1,1);
  if Command[0]=#0 then begin writeln(VolNF); ChangeVolume:=false; exit end;
  Command := UC(Command);
  assign(F,'INPUT.TXT');
  reset(F);
  while not(EOF(F)) do
    begin
      readln(F,st);
      st:=UC(st);
      if st=Command then begin CurVolume := st; ChangeVolume:=true; goto lab1 end;
    end;
  writeln(VolNF); ChangeVolume:=false;
lab1:
  close(F);
end;

procedure List(Command : string);
var VolArchive : string[8];
    F : text; st : string; cnt : word;
begin
  if Command <> '' then
    begin
      if (Command[0]>#0) and (Command[1]<>' ') then begin writeln(ErrorCmd); exit end;
      delete(Command,1,1);
      if Command[0]=#0 then begin writeln(VolNF); exit end;
      Command := ' '+Command;
      VolArchive := CurVolume;
      if not(ChangeVolume(Command)) then exit;
    end;
  assign(F,CurVolume+'.TXT');
  reset(F);
  cnt := 0;
  while not(eof(F)) do
    begin
      inc(cnt);
      readln(F,st);
      st[0]:=chr(pos(' ',st));
      if st[0]>#0 then dec(st[0]);
      writeln(cnt, '. ', st);
    end;
  close(F);
  if Command <> '' then ChangeVolume(' '+VolArchive);
end;

procedure TypeTxt(Command : string);
var NewVolume : string[8]; title : string[32];
    VolArc : string[8]; f : file;
    P : array[1..10240] of char; PSize : word;
begin
  if command[0]=#0 then begin writeln(TitleNF); exit end;
  if command[1]<>' ' then begin writeln(ErrorCmd); exit end;
  delete(command,1,1);
  if command[0]=#0 then begin writeln(TitleNF); exit end;
  if pos(':', Command)>0 then
    begin
      NewVolume := UC(copy(Command,1,pos(':',Command)-1));
      delete(Command,1,pos(':', Command));
    end else NewVolume:='';
  if command[0]=#0 then begin writeln(TitleNF); exit end;
  Title:=Command; VolArc := CurVolume;
  if NewVolume<>'' then if not(ChangeVolume(' '+NewVolume)) then exit;
  assign(F,CurVolume+'.TXT'); reset(F);
  BlockRead(F,P,10240,PSize);

  if NewVolume<>'' then ChangeVolume(' '+VolArc);
end;

function ReadCommand : string;
var st : string;
begin
  write(#13#10, CurVolume, '>'); readln(st);
  ReadCommand := st;
end;

procedure Main;
var CurCom : string;
    i : byte;
label lab1;
begin
  repeat
    CurCom:=ReadCommand;
    {।塞,   }
    for i := 1 to 8 do
      begin
        if UC(copy(CurCom,1,length(Command[i])))=Command[i] then goto lab1;
      end;
    writeln(ErrorCmd);
    continue;
lab1:{ N i}
    delete(CurCom,1,length(Command[i]));
    case i of
      1 : if CurCom='' then PrintVolumes else writeln(ErrorCmd); {DIR}
      2 : ChangeVolume(CurCom); {VOLUME}
      3 : List(CurCom); {LIST}
      4 : writeln(Unsupported); {TYPE}
      5 : writeln(Unsupported); {REF}
      6 : ClrScr;
      7 : writeln(Unsupported); {Verify}
      8 : break; {EXIT}
    end;
  until false;
end;

begin
  writeln('ਢ!');
  SetupFirstVolume;
  Main;
  writeln(' ᢨ.');
end.