uses crt;
type TTome=array[1..200] of string;
type PTList=^TTList;
     TTList=record
     obj:string;
     tobj:string;
     Next:PTList;
     end;
type TList=object
     Root:TTList;
     constructor Init;
     procedure Delete;
     procedure Add(o,ot:string);
     function get(n:integer;var T:string):string;
     destructor Done;
     end;


var curtome:string;
    curstate:string;
    f,f1:text;
    tome:^TTome;
    nt:integer;
    i,k,j:integer;
    List:TList;

constructor TList.Init;
begin
Root.obj:='';
Root.tobj:='';
Root.Next:=nil;
end;

procedure TList.Delete;
var temp,cp:PTList;
begin
if Root.Next<>nil then
   begin
   temp:=Root.next;
   while temp<>nil do
      begin
      cp:=temp^.next;
      Dispose(temp);
      temp:=cp;
      end;
   Root.Next:=nil;
   end;
end;

procedure TList.Add;
var temp:PTList;
begin
temp:=root.next;
if root.next=nil then
   begin
   new(root.next);
   root.next^.obj:=o;
   root.next^.tobj:=ot;
   root.next^.next:=nil;
   end
else
   begin
   while temp^.next<>nil do temp:=temp^.next;
   new(temp^.next);
   temp^.next^.obj:=o;
   temp^.next^.tobj:=ot;
   temp^.next^.next:=nil;
   end;
end;

function TList.Get;
var u:integer;
    temp:PTList;
begin
temp:=Root.Next;
for u:=2 to n do
    if temp<> nil then temp:=temp^.next;
if temp<>nil then
   begin
   T:=temp^.tobj;
   Get:=temp^.obj;
   end
else
   begin
   Get:='';
   T:='';
   end
end;

destructor TList.Done;
begin
Delete;
end;

function IsChar(c:char):boolean;
var res:boolean;
begin
res:=false;
if c in ['A'..'Z','a'..'z'] then res:=true;
if Pos(c,'㪥௠ᬨ')>0
   then res:=true;
isChar:=res;
end;

function UpCaseS(s:string):string;
var u:integer;
    res:string;
begin
res:='';
res[0]:=s[0];
for u:=1 to Byte(s[0]) do
    res[u]:=UpCase(s[u]);
UpCaseS:=res;
end;

function GetOp(s:string;var n:integer):string;
var res:string;
    u:integer;
    w:integer;
begin
u:=n;
res:='';
while s[u]=' ' do Inc(u);
w:=1;
res[0]:=#0;
while (s[u]<>' ') and (u<=Byte(s[0])) do
      begin
      res[w]:=s[u];
      Inc(Byte(res[0]));
      Inc(u);
      inc(w);
      end;
while s[u]=' ' do Inc(u);
n:=u;
GetOp:=res;
end;

function GetTome(s:string;n:integer):string;
var res:string;
begin
res:='';
while s[n]<>'.' do Inc(n);
n:=n+1;
while isChar(s[n]) do
      begin
      res:=res+s[n];
      inc(n);
      end;
getTome:=res;
end;

procedure main;
var inp:string;
    cn:integer;
    ts:string;
    found:boolean;
    ct:string;
    t,t1:string;
    refcode:boolean;


procedure mlist;forward;
procedure mtype(a:string);forward;
procedure mref;forward;
procedure mverify;forward;

procedure mtype(a:string);
begin
   List.Delete;
   ts:=a;
   found:=false;
   if Pos(':',ts)>0 then
      begin
      ct:=Copy(ts,1,Pos(':',ts)-1);
      ts:=Copy(ts,Pos(':',ts)+1,Length(ts));
      ct:=UpCaseS(ct);
      for i:=1 to nt do if tome^[i]=ct then found:=true;
      end
   else
      begin
      ct:=curtome;
      found:=true;
      end;
   if found then
      begin
      Assign(f,ct+'.TXT');
      Reset(f);
      found:=false;
      while not found and not eof(f) do
            begin
            Readln(f,t);
            cn:=1;
            t1:=GetOp(t,cn);
            if t1=ts then
               found:=true;
            end;
      Close(f);
      if found then
         begin
         if Length(t)<=80 then Writeln(t) else
            begin
            i:=0;
            k:=i+1;
            while i<=Length(t) do
               begin
               k:=i+1;
               i:=i+80;
               if i>=Length(t) then i:=length(t)+1 else
               while t[i]<>' ' do
                  Dec(i);
               t1:=Copy(t,k,i-k);
               Writeln(t1);
               end;
            end;
         Writeln;
         k:=Pos(' (.',t);
         j:=1;
         while k>0 do
               begin
               i:=k-1;
               while t[i]=' ' do Dec(i);
               while isChar(t[i]) do Dec(i);
               while t[k]<>')' do Inc(k);
               t1:=Copy(t,i+1,k-i);
               Delete(t,1,k);
               cn:=1;
               ts:=GetOp(t1,cn);
               if GetTome(t1,cn)='' then
                  begin
                  Writeln(j,'. ',ts);
                  List.Add(ts,curtome);
                  end
               else
                  begin
                  Writeln(j,'. ',ts, ', ⮬ ',GetTome(t1,cn));
                  List.Add(ts,GetTome(t1,cn));
                  end;
               Inc(j);
               k:=Pos(' (.',t);
               end;
         end
      else Writeln('  ');
      end
   else Writeln('  ');

end;

procedure mlist;
begin
      List.Delete;
      ts:=GetOp(inp,cn);
      ts:=UpCaseS(ts);
      if ts='' then
         begin
         ts:=curtome;
         found:=true;
         end
      else
         begin
         found:=false;
         for i:=1 to nt do if tome^[i]=ts then found:=true;
         end;
      if found then
         begin
         Assign(f,ts+'.TXT');
         ct:=ts;
         ReSet(f);
         i:=1;
         while not eof(f) do
               begin
               Readln(f,ts);
               cn:=1;
               ts:=GetOp(ts,cn);
               Writeln(i,'. ',ts);
               List.Add(ts,ct);
               inc(i);
               end;
         end
      else Writeln('  ');

end;

procedure mref;
var mn:integer;
    Code:integer;
    o,ot:string;
begin
ts:=GetOp(inp,cn);
Val(ts,mn,Code);
if Code=0 then
   begin
   o:=List.Get(mn,ot);
   if (o='') or (ot='') then Writeln('  뫪')
   else
      begin
      mtype(ot+':'+o);
      end;
   end
else Writeln('  뫪');
end;

procedure mverify;
var ms,ms1:string;
    fou:boolean;
    ex:boolean;
    r:integer;
    y:integer;
    foun:boolean;
begin
ex:=false;
j:=1;
for r:=1 to nt do
    begin
    Assign(f,tome^[r]+'.TXT');
    ReSet(f);
    while not eof(f) do
          begin
          Readln(f,t);
          cn:=1;
          ct:=GetOp(t,cn);
          k:=Pos(' (.',t);
          while k>0 do
                begin
                i:=k-1;
                while t[i]=' ' do Dec(i);
                while isChar(t[i]) do Dec(i);
                while t[k]<>')' do Inc(k);
                t1:=Copy(t,i+1,k-i);
                Delete(t,1,k);
                cn:=1;
                ts:=GetOp(t1,cn);
                fou:=false;
                if GetTome(t1,cn)='' then
                   begin
                   ms1:=tome^[r];
                   Assign(f1,tome^[r]+'.TXT');
                   ReSet(f1);
                   while not eof(f1) do
                         begin
                         Readln(f1,ms);
                         cn:=1;
                         ms:=GetOp(ms,cn);
                         if ms=ts then fou:=true;
                         end;
                   Close(f1);
                   end
                else
                   begin
                   ms1:=GetTome(t1,cn);
                   ms1:=UpCaseS(ms1);
                   foun:=false;
                   for y:=1 to nt do if tome^[y]=ms1 then foun:=true;
                   if foun then
                      begin
                      Assign(f1,GetTome(t1,cn)+'.TXT');
                      ReSet(f1);
                      while not eof(f1) do
                            begin
                            Readln(f1,ms);
                            cn:=1;
                            ms:=getOp(ms,cn);
                            if ms=ts then fou:=true;
                            end;
                      Close(f1);
                      end;
                   end;
                if not fou then
                   begin
                   if not ex then
                      begin
                      Writeln(' 뫪  騥 :');
                      ex:=true;
                      end;
                   Writeln(j,'.  ',tome^[r],':',ct,' 뫪  ',ms1,':',ts);
                   Inc(j);
                   end;
                k:=Pos(' (.',t);
                end;

          end;
    Close(f);
    end;
if not ex then Writeln(' 뫪 ४');
end;

begin
refcode:=false;
inp:='';
curtome:=tome^[1];
repeat
Writeln;
Write(curtome,'>');
Readln(inp);
cn:=1;
ts:=getOp(inp,cn);
ts:=UpCaseS(ts);
if ts='DIR' then
   begin
   for i:=1 to nt do Writeln(tome^[i]);
   refcode:=false;
   end else
if ts='VERIFY' then
   begin
   refcode:=false;
   mverify;
   end else
if ts='CLS' then
   begin
   refcode:=false;
   ClrScr
   end else
   begin
   if ts='VOLUME' then
      begin
      refcode:=false;
      ts:=GetOp(inp,cn);
      ts:=UpCaseS(ts);
      found:=false;
      for i:=1 to nt do
          if tome^[i]=ts then found:=true;
      if found then curtome:=ts else Writeln('  .');
      end
   else
   if ts='LIST' then
      begin
      refcode:=true;
      mlist;
      end else
   if ts='TYPE' then
      begin
      refcode:=true;
      ts:=GetOp(inp,cn);
      mtype(ts);
      end else
   if ts='REF' then
      begin
      if refcode then
         begin
         mref;
         refcode:=true;
         end
      end
   else
      begin
      inp:=UpCaseS(inp);
      if inp<>'EXIT' then
      Writeln(' ⠪ ');
      refcode:=false;
      end;
   end;
until inp='EXIT';
end;

procedure startup;
begin
New(tome);
Writeln('ਢ!');
Assign(f,'INPUT.TXT');
ReSet(f);
nt:=0;
while not eof(f) do
      begin
      Inc(nt);
      readln(f,tome^[nt]);
      tome^[nt]:=UpCaseS(tome^[nt]);
      end;
Close(f);
List.Init;
end;

begin
startup;
if nt=0 then halt(1);
main;
Writeln(' ᢨ.');
Dispose(tome);
List.Done;
end.