{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
{$D-,I-,R-,Q-,S-}
uses crt;
const
  maxvol=50;
  max=50;
var
  volnum: integer;
  allvol: array [1..maxvol] of string;

  lastref: array [1..max,1..4] of string;

function findref (vol, art: string): boolean;
var
  f: text;
  ok: boolean;
  s, o: string;
  i, j: integer;
begin
  assign(f, vol+'.txt');
  {$I-}
  reset(f);
  {$I+}
  if IOResult<>0 then begin
    findref:=false;
    exit;
  end;

  ok:=false;
  {for j:=1 to length(art) do art[j]:=upcase(art[j]);}
  while not seekeof(f) do begin
    readln(f, s);
    o:=copy(s, 1, pos(' ', s)-1);
    {for j:=1 to length(o) do o[j]:=upcase(o[j]);}
    if o=art then begin
      ok:=true;
      break;
    end;
  end;

  close(f);
  findref:=ok;
end;

procedure printrefart (vol, art:string; var num: integer; check: boolean);
var
  f: text;
  s, o, ps, vn: string;
  i, j, c: integer;
  ok: boolean;
begin
  assign(f, vol+'.txt');
  reset(f);
  {for j:=1 to length(art) do art[j]:=upcase(art[j]);}
  while not seekeof(f) do begin
    readln(f, s);

    ps:=copy(s, 1, pos(' ', s)-1);
    {for j:=1 to length(ps) do ps[j]:=upcase(ps[j]);}
    if art=ps then begin

    ps:=s;
    while true do begin
      i:=pos('(.',ps); if i=0 then break;
      ok:=false;
      for j:=i-2 downto 1 do
        if (ps[j]=' ') or
           (ord(ps[j])=9) or
           (ps[j]='-') or
           (ps[j]=',') or
           (ps[j]='.') or
           (ps[j]=';') or
           (ps[j]=')') or
           (ps[j]='"') or
           (ps[j]=':')
        then begin
          ok:=true;
          break;
        end;
      if ok then vn:=copy(ps, j+1, (i-2)-j)
      else begin
        delete(ps, i, 4);
        break;
      end;

      ok:=false;
      for j:=i to length(ps) do
        if ps[j]=')' then begin
          ok:=true;
          break;
        end;
      for c:=1 to num do
        if (lastref[num][1]=vn) then begin
          ok:=false;
          break;
        end;
      if ok then begin
        inc(num);
        if not check then write(num, '. ',vn);
        lastref[num][1]:=vn;
        vn:=copy(ps, i+4, (j-1)-(i+4)+1);
        if vn<>'' then begin
          if not check then write(', ⮬ ', vn);
          lastref[num][2]:=vn;
        end else
          lastref[num][2]:=vol;
        if not check then writeln;
        if check then begin
          if not findref(lastref[num][2],lastref[num][1]) then begin
            lastref[num][3]:=art;
            lastref[num][4]:=vol;
          end else
            dec(num);
        end;
      end;
      delete(ps, i, 4);
    end;

    break;
    end;
  end;
  close(f);

  lastref[num+1][1]:='';
end;

procedure printref (vol: string; check: boolean; var num: integer);
var
  f: text;
  s, a: string;
begin
  assign(f, vol+'.txt');
  reset(f);
  while not seekeof(f) do begin
    readln(f, s);
    s:=copy(s, 1, pos(' ', s)-1);
    printrefart(vol,s, num, check);
  end;
  close(f);
end;

procedure print (vol, art: string);
var
  f: text;
  ok: boolean;
  s, ps, vn: string;
  i,j,cw: integer;
  num: integer;
begin
  assign(f, vol+'.txt');
  {$I-}
  reset(f);
  {$I+}
  if IOResult<>0 then begin
    writeln('  ');
    exit;
  end;
  ok:=false; i:=0;
  {for j:=1 to length(art) do art[j]:=upcase(art[j]);}
  while not seekeof(f) do begin
    inc(i);
    readln(f, s);
    ps:=copy(s, 1, length(art));
    {for j:=1 to length(ps) do ps[j]:=upcase(ps[j]);}
    if ps=art then begin
      ok:=true;
      break;
    end;
  end;
  if not ok then
    writeln('  ')
  else begin
    reset(f);
    for j:=1 to i-1 do
      readln(f);
    readln(f, s);

    i:=0; ps:=s; cw:=79;
    if ps[ord(ps[0])]<>' ' then ps:=ps+' ';
    while ps<>'' do begin
      if cw-pos(' ', ps)<0 then begin
        writeln;
        cw:=79;
      end;
      cw:=cw-pos(' ', ps);
      write(copy(ps, 1, pos(' ', ps)));
      delete(ps,1,pos(' ',ps));
    end;
    writeln;

    cw:=0; printrefart(vol, art, cw, false);
  end;
  close(f);
end;


procedure run;
var
  s, curvol, o: string;
  i, j: integer;
  ok, refavail: boolean;
  f: text;
begin
  writeln('ਢ!'); writeln;
  curvol:=allvol[1]; refavail:=false;
  while true do begin
    write(curvol,'>');
    readln(s); for i:=1 to length(s) do s[i]:=upcase(s[i]);
    if s='EXIT' then break;
    if s='DIR' then begin
      for i:=1 to volnum do
        writeln(allvol[i]);
      refavail:=false;
      continue;
    end;
    if s='CLS' then begin
      clrscr;
      refavail:=false;
      continue;
    end;
    if copy(s, 1, 6)='VOLUME' then begin
      delete(s, 1, 7);
      ok:=false;
      for i:=1 to volnum do
        if allvol[i]=s then begin
          ok:=true;
          break;
        end;
      if ok then
        curvol:=allvol[i]
      else
        writeln('  ');
      refavail:=false;
      continue;
    end;
    if copy(s, 1, 4)='LIST' then begin
      if s='LIST' then
        o:=curvol
      else begin
        delete(s, 1, 5);
        o:=s;
      end;
      assign(f, o+'.txt');
      reset(f);
      i:=0;
      while not seekeof(f) do begin
        readln(f, s);
        delete(s, pos(' ',s), length(s)-pos(' ', s)+1);
        inc(i);
        writeln(i, '. ',s);
      end;
      close(f);
      refavail:=true;
      {writeln;    !!!!!!!!!!  ਬ ⮣ , ⮬ ⪫祭 !!!!!
      printref(o);}
      continue;
    end;
    if copy(s, 1, 4)='TYPE' then begin
      delete(s, 1, 5);
      if s<>'' then begin
        if pos(':', s)=0 then
          print(curvol, s)
        else
          print(copy(s, 1, pos(':', s)-1),
                copy(s, pos(':', s)+1, length(s)-pos(':', s)+1));
      end else
        writeln('  ....');
      refavail:=true;
      continue;
    end;
    if copy(s, 1, 3)='REF' then begin
      if not refavail then
        writeln('  뫪')
        {writeln('   믮 ⮫쪮 ᫥  LIST, TYPE  REF')}
      else begin
        delete(s, 1, 4);
        val(s, i, j);
        ok:=true;
        for j:=1 to i do
          if lastref[j][1]='' then begin
            ok:=false;
            break;
          end;
        if not ok then begin
          writeln('  뫪');
          refavail:=false;
        end else
          print(lastref[i][2],lastref[i][1]);
      end;
      continue;
    end;
    if copy(s, 1, 6)='VERIFY' then begin
      {);}
      j:=0;
      for i:=1 to volnum do
        printref(allvol[i], true, j);
      if j=0 then
        writeln(' 뫪 ४')
      else
        for i:=1 to j do begin
          writeln(i,
                '.  ',
                lastref[i][4],
                ':',
                lastref[i][3],
                ' 뫪  ',
                lastref[i][2],
                ':',
                lastref[i][1]);
        end;
      continue;
    end;
    writeln(' ⠪ ');
  end;
  writeln(' ᢨ.');
end;

procedure init;
var
  f: text;
  i: integer;
begin
  assign(f, 'input.txt');
  reset(f);
  volnum:=0;
  while not seekeof(f) do begin
    inc(volnum);
    readln(f, allvol[volnum]);
    for i:=1 to length(allvol[volnum]) do
      allvol[volnum][i]:=upcase(allvol[volnum][i]);
  end;
  close(f);
end;

procedure done;
var
  f: text;
begin
  assign(f, 'output.txt');
  rewrite(f);
  close(f);
end;

begin
  init;
  run;
  {done;}
end.