{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{ Russia 97 N6 }

const max=100;
      delta=0.000001;

type TPoint=record
             x,y:real;
            end;

     TPoints=record
              num:byte;
              d:array[1..Max]of TPoint;
             end;

     TLine=record
            A,B,C:real;
           end;

     f_ar=array[1..max,1..max]of boolean;

var n,k,l:byte;
    t:TPoints;
    a:array[1..max,1..max]of real;
    f:^f_ar;
    dis:array[1..max]of real;

procedure Init;
 begin
  FillChar(a,SizeOf(a),0);
  new(f);
  FillChar(f^,SizeOf(f_ar),false);
  assign(input,'input.txt');
  assign(output,'output.txt');
  reset(input);
  readln(n);
  with t do
   begin
    num:=0;
    while num<n do
     begin
      inc(num);
      with d[num] do readln(x,y);
     end;
   end;
  readln(k,l);
  close(input);
 end;

function Equal(x,y:real):boolean;
 begin
  Equal:=(abs(x-y)<delta);
 end;

function EqPoint(a,b:TPoint):boolean;
 begin
  EqPoint:=Equal(a.x,b.x)and Equal(a.y,b.y);
 end;

procedure Point2Line(P1,P2:TPoint;var l:TLine);
 begin
  L.A:=P1.Y-P2.Y;
  L.B:=P2.X-P1.X;
  L.C:=P1.X*P2.Y-P1.Y*P2.X;
 end;

function Line2Point(L1,L2:TLine; var p:TPoint):boolean;
 var z:real;
 begin
  z:=(L1.A*L2.B-L2.A*L1.B);
  if Equal(z,0) then Line2Point:=false
                else begin
                      Line2Point:=true;
                      P.X:=(L1.B*L2.C-L2.B*L1.C)/z;
                      P.Y:=(L2.A*L1.C-L1.A*L2.C)/z;
                     end;
 end;

function Direction(P1,P2,P3:TPoint):shortint;
 var r:real;
 begin
  r:=(P2.Y-P1.Y)*(P3.X-P1.X)-(P2.X-P1.X)*(P3.Y-P1.Y);
  if Equal(r,0) then Direction:=0
   else if r>0 then Direction:=1
    else Direction:=-1;
 end;

function Can(a,b:byte):boolean;
 var L,L2:TLine;
     P:TPoint;
     i:byte;
 begin
  if f^[a,b]=true then begin Can:=true; exit; end;
  if abs(a-b)>1 then
   with t do if ((a<b)and(Direction(d[a],d[a+1],d[b])=1))or
                ((a>b)and(Direction(d[b],d[b+1],d[a])=1)) then
              begin Can:=false; exit; end;
  Point2Line(t.d[a],t.d[b],L);
  for i:=1 to n-1 do if not(((a=i)and(b=i+1))or((a=i+1)or(b=i))) then
   begin
    Point2Line(t.d[i],t.d[i+1],L2);
    if Line2Point(L,L2,P) then with t do
     begin
      if EqPoint(P,d[i])and not(EqPoint(P,d[a])or EqPoint(P,d[b])) then
       begin Can:=Can(a,i)and Can(i,b); exit; end;
      if EqPoint(P,d[i+1])and not(EqPoint(P,d[a])or EqPoint(P,d[b])) then
       begin
        Can:=Can(a,i+1)and Can(i+1,b);
        exit;
       end;
      if (((P.x-d[a].x>0)=(P.x-d[b].x<0))and
          ((P.y-d[a].y>0)=(P.y-d[b].y<0))and
          ((P.x-d[i].x>0)=(P.x-d[i+1].x<0))and
          ((P.y-d[i].y>0)=(P.y-d[i+1].y<0)))and not(
          EqPoint(P,d[a])or EqPoint(P,d[b]))
           then begin Can:=false; exit; end;
     end;
   end;
  Point2Line(t.d[1],t.d[n],L2);
  with t do if (((P.x>d[a].x)=(P.x<d[b].x))and
    ((P.y>d[a].y)=(P.y<d[b].y))) then begin Can:=false; exit; end;
  Can:=true;
 end;

procedure Find;
 var min:real;
     u,i:byte;
     s:set of 1..max;
 begin
  Dis[k]:=0;
  for i:=1 to n do if i<>k then if f^[k,i] then Dis[i]:=A[k,i]
                                           else Dis[i]:=1.7e38;
  S:=[1..n]-[k];
  while S<>[] do
   begin
    i:=1;
    while not(i in s) do inc(i);
    min:=Dis[i];
    u:=i;
    for i:=1 to n do
     if (i in S)and(Dis[i]<min) then begin min:=Dis[i]; u:=i; end;
    S:=S-[u];
    for i:=1 to n do if i in s then
     if F^[u,i] and (Dis[i]>Dis[u]+A[u,i]) then Dis[i]:=Dis[u]+A[u,i];
   end;
 end;

procedure Solve;
 var i,j:byte;
 begin
  for i:=1 to n-1 do for j:=i+1 to n do if Can(i,j) then
   begin
    f^[i,j]:=true; f^[j,i]:=true;
    with t do a[i,j]:=sqrt(sqr(d[i].x-d[j].x)+sqr(d[i].y-d[j].y));
    a[j,i]:=a[i,j];
   end;
  Find;
 end;

procedure Done;
 begin
  rewrite(output);
  writeln(dis[l]);
  close(output);
  dispose(f);
 end;

Begin
 Init;
 Solve;
 Done;
End.