program p3116_6;
const
  maxn=101;
  eps=0.0000001;
var
  n,k,l,i,nverts:integer;
  x,y:array[1..maxn] of real;
  tx:text;
  verts:array[1..maxn] of integer;
  next:array[1..maxn] of integer;
  s1,s2:real;

function det(a,b,c,d:real):real;
begin det:=a*d-b*c; end;

function sign(a:real):integer;
begin
  if a>0 then sign:=1 else begin
    if a<0 then sign:=-1 else sign:=0;
  end;
end;

function inter(x1,y1,x2,y2,x3,y3,x4,y4:real):boolean;
var xp,yp,d,d1,dx,dy,k1,k2,b1,b2:real;s1,s2:integer;
begin
  inter:=false;
  if x1=x2 then begin
    s1:=sign(x1-x3);
    s2:=sign(x1-x4);
    inter:=not((s1=0) or (s2=0) or (s1=s2));
    exit;
  end else begin
      if x3=x4 then begin
      s1:=sign(x1-x3);
      s2:=sign(x2-x3);
      inter:=not((s1=0) or (s2=0) or (s1=s2));
      exit;
    end else begin
      if y1>y2 then begin
        yp:=y1;y1:=y2;y2:=yp;
        xp:=x1;x1:=x2;x2:=xp;
      end;
      if y3>y4 then begin
        yp:=y3;y3:=y4;y4:=yp;
        xp:=x3;x3:=x4;x4:=xp;
      end;
      dy:=y2-y1;
      dx:=x2-x1;
      k1:=dy/dx;
      b1:=y1-k1*x1;
      dy:=y4-y3;
      dx:=x4-x3;
      k2:=dy/dx;
      b2:=y3-k2*x3;
      if k1=k2 then exit;
      d:=det(k1,-1.0,k2,-1.0);
      d1:=det(k1,-b1,k2,-b2);
      yp:=d1/d;
      if (yp<=y1) or (yp>=y2) or (yp<=y3) or (yp>=y4) then exit;
    end;
  end;
  inter:=true;
end;


function direct(a,b,c:integer):boolean;
var i,j:integer;
    xp,yp,x1,dx,dy:real;
    sq,sq1,sq2,sq3,sq4,xi,yi,xii,yii,t:real;
begin
  direct:=false;

  for i:=1 to n do begin
    if inter(x[i],y[i],x[i+1],y[i+1],
             x[a],y[a],x[c],y[c]) then exit;
  end;

  xp:=(x[a]+x[c])/2.0;
  yp:=(y[a]+y[c])/2.0;
  j:=0;
  for i:=1 to n do begin
    xi:=x[i];yi:=y[i];
    xii:=x[i+1];yii:=y[i+1];
    if yi>yii then begin t:=yi;yi:=yii;yii:=t;end;
    if (yi<yp) and (yii>yp) then begin
      dx:=xii-xi;
      dy:=yii-yi;
      x1:=dx/dy*(yp-yi)+xi;
      if x1<xp then inc(j);
    end;
  end;
  if (j mod 2)=0 then exit;

  direct:=true;
end;

function calcs:real;
var i:integer;
    s:real;
    x1,y1,x2,y2:real;
begin
  s:=0.0;
  x1:=x[verts[1]];
  y1:=y[verts[1]];

  for i:=2 to nverts do if verts[i]<>0 then begin
    x2:=x[verts[i]];
    y2:=y[verts[i]];
    s:=s+sqrt(sqr(x1-x2)+sqr(y1-y2));
    y1:=y2;x1:=x2;
  end;
  calcs:=s;
end;

procedure process;
var f:boolean;i,j,k,q:integer;
begin
  repeat
    f:=false;
    for i:=1 to nverts-2 do if verts[i]<>0 then begin
      j:=verts[i];
      if next[i]=0 then continue;
      k:=verts[next[i]];
      if k=0 then continue;
      if next[next[i]]=0 then continue;
      q:=verts[next[next[i]]];
      if q=0 then continue;
      if direct(j,k,q) then begin
        for k:=i+1 to next[next[i]]-1 do verts[k]:=0;
        next[i]:=next[next[i]];
        f:=true;
      end;
    end;
  until not f;
end;

begin
  assign(tx,'input.txt');
  reset(tx);
  readln(tx,n);
  for i:=1 to n do readln(tx,x[i],y[i]);

  x[n+1]:=x[1];y[n+1]:=y[1];inc(n);

  readln(tx,k,l);
  close(tx);
  if k>l then begin i:=k;k:=l;l:=i;end;

  nverts:=l-k+1;

  for i:=1 to l-k+1 do begin
    verts[i]:=k+i-1;
    next[i]:=i+1;
  end;
  next[l-k+2]:=0;verts[l-k+2]:=0;
  process;
  s1:=calcs;

  for i:=l-k+1 downto 1 do begin
    verts[i]:=k+i-1;
    next[i]:=i+1;
  end;
  next[l-k+2]:=0;verts[l-k+2]:=0;
  process;
  s2:=calcs;

  assign(tx,'output.txt');
  rewrite(tx);
  if s1<s2 then writeln(tx,s1) else writeln(tx,s2);
  close(tx);
end.