Const
 s = 1;
Type
 TLine = record
  Line: Real;
  D: Real;
 end;
Var
 N, M, L: Integer;
 Tt: Real;
 A: Array [1..30, 1..30] of Real;
 D: array [1..30] of Real;
 Lines: array [1..30] of TLine;
 W: array [1..30] of Integer;
 P: array [1..30] of Integer;
 Time: Real;
 Last: Integer;

Procedure ReadData;
 var
  F: Text;
  i: integer;
  x, y: Integer;
 begin
  For x := 1 to 30 do for y := 1 to 30 do A[x,y] := 1.7e30;
  Assign (F, 'input.txt'); Reset (F);
  Read (F, N);
  Read (F, M);
  Read (F, L);
  Read (F, Tt);
  For i := 1 to m do begin
   Read (F, x);
   Read (F, y);
   Read (F, A[x,y]);
   A[y,x] := A[x,y];
  end;
  Close(F);
 end;

Function Max (A, B: Real): Real;
 begin
  If A > B then Max := A else Max := B;
 end;

Procedure FindOpt (bA, sA, bB, sB: Real; n: Integer; var x, y: Integer; var S: Real);
 var
  m: Integer;
  s1: Real;
 begin
  If (bB > 1.7e29) or (sB > 1.7e29) then begin
   x := n;
   s := bA + sA*n;
   y := 0;
   exit;
  end;
  If (bA > 1.7e29) or (sA > 1.7e29) then begin
   x := 0;
   s := bB + sB*n;
   y := n;
   exit;
  end;
  S := bA + sA*n; x := n; y := 0;
  While True do begin
    s1 := Max(S-sB, bB+sB);
    If s1 < s then begin
     Dec (X); Inc (Y); S := s1;
    end else Break;
  end;
 end;

Procedure Distance;
 var
  v, u: integer;
  x, y: Integer;
  T: set of 1..30;
  Cl: Real;
  Line: Real;
  Time: Real;

   Function MinimumD: Integer;
    var
     i, j: integer;
     Best: Real;
     Res: Integer;
    begin
     Best := 1.7e30; Res := 0;
     for i := 1 to n do if i in T then
      if D[i] < Best then begin Best := d[i]; res := i end;
     MinimumD := Res;
    end;

   function Min (A, B: Real): Real;
    begin
     if A < B then Min := A else Min := B;
    end;

 begin
  for v := 1 to n do D[v] := A[s,v]*L+tt;
  for v := 1 to n do begin Lines[v].Line := A[v,s]; Lines[v].D := 0 end;
  for v := 1 to n do P[v] := s;
  D[s] := 0; T := [1..N] - [s];
  while T <> [] do begin
   u := MinimumD;
   T := T - [u];
   for v := 1 to n do if (v in T) and (A[u,v] < 1.7e30) then begin { D[v] := min(D[v], D[u]+A[u,v]);}
    Line := A[u,v];
    Cl := L;

    FindOpt (Lines[v].D, Lines[v].Line, d[u], Line, L, x, y, Time);
    If D[u] < Lines[v].D then begin
     Lines[v].D := D[u];
     Lines[v].Line := Line;
    end else;
    D[v] := Time + TT;

   end;

  end;

 end;

Function Way(t: integer): Integer;
 var
  v, u: integer;
  Stack: Array [1..30] of Byte;
  Pos: Byte;

  function Find: Byte;
   var i: Byte;
   begin
    for i := 1 to n do
     if D[v] = D[i] + A[i,v] then Break;
    Find := i;
   end;

 begin
  Pos := 1;
  Stack[pos] := t; v := t;
  while v <> s do begin
   u := Find;
   Inc (pos); Stack[pos] := v;
   v := u;
  end;
  Way := Pos-1;
 end;

Procedure GetAllWays;
 var i: Integer;
 begin
  for i := 1 to n do W[i] := Way(i);
 end;

Procedure GetLast;
 var
  i: Integer;
  Max: Real;
  Res: Integer;
 begin
  Max := 0; Res := 1;
  For i := 2 to n do
   if D[i] > Max then begin Res := i; Max := D[i] end;
  Last := Res;
  Time := Max-tt;
 end;

var
 i,j: Integer;
 F: Text;
Begin
 ReadData;
 for i := 1 to n do D[i] := 1.7e30;
 Distance;
 GetLast;
 Assign (F, 'output.txt'); Rewrite (F);
 WriteLn (F, Time);
 Write (F, Last);
 Close (F);
End.