#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
#include <sys/stat.h>

char *Toms[100];
char *TomsUp[100];
char Tom[15000];
unsigned char *Arts[100];
long ArtPtr[100];
char Refs[100][50];
char RefToms[100][50];
long TomLen;
int NumToms;
int ParamPos;
int CurTom;
int NumArts;
int RefNum;

void UpperStr( char *Str )
{
   int len=strlen(Str);
   for(int i=0;i<len;i++)
      if ( (Str[i] >= 'a') && (Str[i] <= 'z') )
	 Str[i] = _toupper( Str[i] );
}

int Input( unsigned char *Str )
{
   int Pos=0;
   unsigned char ch;
   ParamPos=0;
   while( (ch=getch())!=13 )
   {
      if( ch==' ' )
      {
	 ParamPos=Pos;
	 Str[Pos++]=0;
	 printf("%c",ch);
      }
      if( ch>32 )
      {
	 printf("%c",ch);
//	 if ( (ch >= 'a') && (ch <= 'z') )
//	    ch = _toupper( ch );
	 Str[Pos++]=ch;
      }
      if( ch<32 )
      {
	 if( ch==8 && Pos>0  )
	 {
	    printf("%c %c",ch,ch);
	    Pos--;
	 }
      }
   }
   Str[Pos]=0;
   printf("\n");
   return Pos;
}

void ReadCurTom( void )
{
   unsigned TomPos=0;
   int h, ArtPos=0,i=0;
   char Str[20];
   strcpy(Str, Toms[CurTom] );
   strcat(Str, ".txt");
   h=open(Str,O_RDWR|O_BINARY);
   TomLen=filelength( h );
   read(h,Tom,TomLen);
   close( h );
   NumArts=0;
   while( TomPos<TomLen )
   {
      Arts[i]=(char *) malloc( 100 );
      ArtPos=0;
      ArtPtr[i] = TomPos;
      while( Tom[TomPos]!=' ' && TomPos<TomLen)
      {
	 Arts[i][ArtPos++]=Tom[TomPos++];
      }
      Arts[i][ArtPos]=0;
      i++; NumArts++;
      while( Tom[TomPos++]!=0x0D && TomPos<TomLen);
      TomPos++;
   }
}

void List( char *Str )
{
   int i=0,found=0,OldTom;
   if( ParamPos==0 )
   {
      for(i=0;i<NumArts;i++)
      {
	 printf("%d. %s\n",i+1,Arts[i]);
      }
   }
   else
   {
    do
    {
      if( !strcmp( &Str[ParamPos+1], TomsUp[i] ) )
      {
	 found=1;
	 OldTom=CurTom;
	 CurTom=i;
	 ReadCurTom();
	 for(i=0;i<NumArts;i++)
	 {
	    printf("%d. %s\n",i+1,Arts[i]);
	 }

	 CurTom=OldTom;
	 ReadCurTom( );
      }
      i++;
    }while( found==0 && i<NumToms );
    if( found==0 )
       printf( "  \n" );
   }
}

void ReadToms( void )
{
   FILE *f;
   int i=0,q,k,len;
   f=fopen("input.txt","r");
   do
   {
      Toms[i]=(char *)malloc(10);
      TomsUp[i]=(char *)malloc(10);
      q=fscanf( f,"%s", Toms[i] );
      len=strlen( Toms[i] );
      for( k=0;k<=len;k++)
      {
	 if ( (Toms[i][k] >= 'a') && (Toms[i][k] <= 'z') )
	    TomsUp[i][k] = _toupper( Toms[i][k] );
	 else
	    TomsUp[i][k] = Toms[i][k];
      }
      i++;
   }while( q!=EOF );
   fclose( f );
   NumToms=i-1;
}

void Volume( char *Str )
{
   int found=0,i=0;
   UpperStr( &Str[ParamPos+1] );
   if( ParamPos==0 ) return;
   do
   {
      if( !strcmp( &Str[ParamPos+1], TomsUp[i] ) )
      {
	 CurTom=i;
	 found=1;
	 ReadCurTom();
      }
      i++;
   }while( found==0 && i<NumToms );
   if( found==0 )
   {
      printf( "  \n" );
   }
}

void Dir( void )
{
   int i;
   for(i=0;i<NumToms;i++)
   {
      printf( "%s\n", Toms[i] );
   }
}

void Type( unsigned char *Str )
{
   int found=0,i=0,Pos,ArPos,OldTom,k,RefPos=0,RefFnd;
   unsigned char *Pars=&Str[ParamPos+1];
   RefNum=0;
   if( ParamPos!=0 )
   {

      do
      {
	 if( Pars[i]==':' ) found=1;
	 i++;
      }

      while( found==0 && i<strlen(Pars) );

      if( found==1 )
      {
	 Pars[i-1]=0;
	 ArPos=i;
	 UpperStr(Pars);
	 found=0; i=0;
	 do
	 {
	   if( !strcmp( &Str[ParamPos+1], TomsUp[i] ) )
	   {
	      found=1;
	      OldTom=CurTom;
	      CurTom=i;
	      ReadCurTom();

	      found=0; i=0;
	      do
	      {
		if( !strcmp( &Pars[ArPos], Arts[i] ) )
		{
		   found=1;
		   Pos=ArtPtr[i];
		   while( Tom[Pos]!=0x0D )
		   {
		      if(Tom[Pos]=='(' && Tom[Pos+1]=='' && Tom[Pos+2]=='' && Tom[Pos+3]=='.' )
		      {
			 RefPos=Pos-2;
			 while( Tom[RefPos]!=' '&&Tom[RefPos]!='-'&&Tom[RefPos]!=',' ) RefPos--;
			 RefPos++;
			 k=0;
			 while( Tom[RefPos]!=' ' ) Refs[RefNum][k++]=Tom[RefPos++];
			 Refs[RefNum][k]=0;
			 if( Tom[Pos+4]!=')')
			 {
			    RefPos=Pos+4;
			    k=0;
			    while( Tom[RefPos]!=')' )
			       RefToms[RefNum][k++]=Tom[RefPos++];
			 }
			 else RefToms[RefNum][0]=0;
			 RefNum++;
		      }
		      printf("%c",Tom[Pos++]);
		   }
		   printf("\n");
		   for(k=0;k<RefNum;k++)
		   {
		      printf("%d. %s",k+1,&Refs[k][0]);
		      if( RefToms[k][0]!=0 )
		      {
			 printf(", ⮬ %s\n",&RefToms[k][0]);
		      }
		      else printf("\n");
		   }
		}
		i++;
	      }while( found==0 && i<NumArts );

	      if( found==0 )
		 printf("  \n");
	      found=1;

	      CurTom=OldTom;
	      ReadCurTom( );
	   }
	   i++;
	 }while( found==0 && i<NumToms );
	 if( found==0 )
	    printf( "  \n" );
      }
      else
      {
       found=0; i=0;
       do
       {
	 if( !strcmp( &Str[ParamPos+1], Arts[i] ) )
	 {
	    found=1;
	    Pos=ArtPtr[i];
	    while( Tom[Pos]!=0x0D )
	    {
	       if(Tom[Pos]=='(' && Tom[Pos+1]=='' && Tom[Pos+2]=='' && Tom[Pos+3]=='.' )
	       {
		  RefPos=Pos-2;
		  while( Tom[RefPos]!=' '&&Tom[RefPos]!='-'&&Tom[RefPos]!=',' ) RefPos--;
		  RefPos++;
		  k=0;
		  while( Tom[RefPos]!=' ' ) Refs[RefNum][k++]=Tom[RefPos++];
		  Refs[RefNum][k]=0;
		  if( Tom[Pos+4]!=')')
		  {
		     RefPos=Pos+4;
		     k=0;
		     while( Tom[RefPos]!=')' )
			RefToms[RefNum][k++]=Tom[RefPos++];
		  }
		  else RefToms[RefNum][0]=0;
		  RefNum++;
	       }
	       printf("%c",Tom[Pos++]);
	    }
	    printf("\n");
	    for(k=0;k<RefNum;k++)
	    {
	       printf("%d. %s",k+1,&Refs[k][0]);
	       if( RefToms[k][0]!=0 )
	       {
		  printf(", ⮬ %s\n",&RefToms[k][0]);
	       }
	       else printf("\n");
	    }

	 }
	 i++;
      }while( found==0 && i<NumArts );
      if( found==0 )
	 printf("  \n");
      }
   }
}

void Ref( unsigned char *Str )
{
   int Ref;
   char String[80];
   if( ParamPos!=0 )
   {
      Ref=atoi( &Str[ParamPos+1] );
      if( Ref<=RefNum && Ref>0 )
      {
	 ParamPos=1;
	 Ref--;
	 strcpy( String, "  ");
	 if(RefToms[Ref][0]!=0)
	    strcat( String,&RefToms[Ref][0] );
	 else
	    strcat( String, TomsUp[CurTom] );
	 strcat( String,":");
	 strcat( String, &Refs[Ref][0] );
	 RefNum=0;
	 Type( String );
      }
      else
      {
	 RefNum=0;
	 printf("  뫪.\n");
      }
   }
}

int EnterCommand( void )
{
   unsigned char Str[80];
   int length,i;
   int found=0;
   printf("\n%s>",Toms[CurTom]);
   Input( Str );
   UpperStr( Str );
   if( !strcmp( Str,"CLS" ) )
   {
      clrscr();
      found=1;
   }
   if( !strcmp( Str,"DIR" ) )
   {
      Dir();
      found=1;
   }
   if( !strcmp( Str,"EXIT" ) )
   {
      return(0);
   }
   if( !strcmp( Str,"REF" ) )
   {
      found=1;
      Ref( Str );
   }
   if( !strcmp( Str,"VOLUME" ) )
   {
      found=1;
      Volume( Str );
   }
   if( !strcmp( Str,"LIST" ) )
   {
      found=1;
      List( Str );
   }
   if( !strcmp( Str,"TYPE" ) )
   {
      found=1;
      Type( Str );
   }
   if( found==0 )
   {
      printf(" ⠪ .\n");
   }
   return 1;
}

void main( void )
{
   int i;
   ReadToms();
   CurTom=0;
   RefNum=0;
   ReadCurTom();
   clrscr();
   printf("ਢ!\n");
   while( EnterCommand()==1 );
   printf(" ᢨ.\n");
}