const
 maxn=30;
 no=1e15;
 e=1e-6;
type
  real=extended;
  reg=(inp,out,wait);
  times=array[1..maxn] of real;
var
  a:array[1..maxn,1..maxn] of real;
  next:times;
  tp:array[1..maxn] of reg;
  comm:array[1..maxn] of times;  { begin to translate }
  time:real;
  n,m,last:integer;
  l:longint;
  s,ss,wh,sl:set of 1..maxn;    { ok }
  t:real;                 { tormoz }

function eq(a,b:real):boolean;
 begin
   eq:=abs(a-b)<e;
 end;

function get_min(tt:times;var k:integer):real;
 var
   r:real;
   j:integer;
 begin
   r:=no;
   for j:=1 to n do
    if tt[j]<r then  begin  r:=tt[j];k:=j;end;
   get_min:=r;
 end;

{-----------------------------------}

procedure init_time(k:integer);

function can(t:real):integer;
  var
    j:integer;
    ll:real;
  begin
    ll:=0;
    for j:=1 to n do
     if (a[j,k]<>no)and(comm[k,j]<t) then ll:=ll+int((e+t-comm[k,j])/a[j,k]);
   if round(ll)<l then can:=1 else if round(ll)>l then can:=-1 else
         can:=0;
 end;

var
  p:boolean;
  tt:times;
  tm:real;
  i:longint;
  j,sm,ml:integer;

function dec_t(t:real):real;
 var
   tt,tb,tmin:real;
   j:integer;
 begin
   tmin:=no;
   for j:=1 to n do
    if (comm[k,j]<>no)and(a[k,j]<>no) then begin
                      tt:=comm[k,j]+a[j,k]*int((e+t-comm[k,j])/a[j,k]);
                      if eq(t,tt) then tt:=tt-a[j,k];
                      if t-tt<tmin then begin tmin:=t-tt;tb:=tt;end;
                     end;
   dec_t:=tb;
 end;


function inc_t(t:real):real;
 var
   tt,tb,tmin:real;
   j:integer;
 begin
   tmin:=no;
   for j:=1 to n do
    if (comm[k,j]<>no)and(a[k,j]<>no) then begin
                      tt:=comm[k,j]+a[j,k]*int((e+t-comm[k,j])/a[j,k]);
                      if eq(tt,t) then begin inc_t:=t;exit;end;
                      tt:=tt+a[j,k];
                      if tt-t<tmin then begin tmin:=tt-t;tb:=tt;end;
                      end;
   inc_t:=tb;
 end;

procedure find(t1,t2:real);
 var
    r:integer;
    tt1:real;
 begin
  tt1:=inc_t((t1+t2)/2);
  if eq(tt1,t2) then
        begin tt1:=dec_t(t2);
             if eq(tt1,t1) then begin tm:=t2;exit;end;end;
  r:=can(tt1);
  case r of
        0:begin tm:=tt1;exit;end;
       -1:find(t1,tt1);
       1: find(tt1,t2);
 end;
end;

 begin
   sm:=0;
   p:=false;
   for j:=1 to n do
     if a[j,k]<>no then
     if eq(a[j,k],0) then begin next[k]:=comm[k,j];exit;end
      else if (j in wh) then
                        begin inc(sm);ml:=j;p:=true;end;
   if not(p) then exit;
   if (sm=1)and(eq(next[k],no)) then
     begin
       next[k]:=comm[k,ml]+a[k,ml]*l;
       exit;
     end;
 find(comm[k,ml],comm[k,ml]+a[k,ml]*l);
 next[k]:=tm;
end;
{---------------------------------------------- }

procedure new_next;
 var j,i:integer;
 begin
   for j:=1 to n do
    if eq(time,next[j]) then
    case tp[j] of
     inp:begin last:=j;ss:=ss+[j];tp[j]:=wait;next[j]:=time+t;end;
     wait:begin
            s:=s+[j];
            tp[j]:=out;next[j]:=no;
            wh:=wh+[j];
            for i:=1 to n do
              if not eq(a[j,i],no) then comm[i,j]:=time;
            end;
     end;
  end;

procedure can;
 var j,i:integer;
 begin
  for j:=1 to n do
   if tp[j]=inp then init_time(j);
 end;

procedure solve;
 var j,k:integer;
 begin
   for j:=2 to n do
     comm[j,1]:=0;
   for j:=2 to n do tp[j]:=inp;
   tp[1]:=out;
   s:=[1];ss:=[1];
   wh:=[1];
   can;
   repeat
    time:=get_min(next,k);
    wh:=[];
    new_next;
    if wh<>[] then can;
   until ss=[1..n];
  end;

procedure done;
 var j:integer;
 begin
   assign(output,'output.txt');
   rewrite(output);
   writeln(time:10:2);
   writeln(last);
 end;

procedure init;
 var j,i,k,kk:integer;
     r:real;
 begin
   assign(input,'input.txt');
   reset(input);
   read(n,m,l,t);
   for j:=1 to n do
     next[j]:=no;
   for j:=1 to n do for i:=1 to n do
    begin
      a[j,i]:=no;
      comm[j,i]:=no;
    end;
  for j:=1 to m do
   begin
     read(k,kk,r);
     a[kk,k]:=r;
     a[k,kk]:=r;
  end;
 close(input);
end;

begin
 init;
 solve;
 done;
end.