program Encyclopedia;
{$M 32768,0,655360}
uses crt;
const nocmd=' ⠪ ';
const notom='  ';
const nostat='  ';
const BadRef='  뫪';
const se:string=
'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
type TCommand= (Dir_,Volume_,List_,Type_,Ref_,Cls_,Verify_,Exit_,Error_);
     TStat=record
            name:string[32];
            l:word;
            d:array[1..10000] of char;
           end;
     PStat=^TStat;
     TTom = record
             name:String[8];
             cs:integer;
             ps:array[1..10000] of PStat;
            end;
     PTom = ^TTom;

var i,t:integer;
    bad:integer;
    nt:integer;
    curT:integer;
    tm:array[1..10000] of PTom;
    cmd:string;
    rc:integer;
    ref:array[1..3000] of PStat;
    reft:array[1..3000] of integer;
    lc:TCommand;
    CCmd:TCommand;
procedure Error(s:string);
 begin
  writeln(s);
 end;
var f:text;

procedure ReadStat(var cs:integer;var p:PStat);
var zu:array[1..10000] of char;
    i,t:integer;
    s:string;ch:char;
 begin
  inc(cs);
  read(f,ch);s:='';
  while ch<>' ' do
   begin
   s:=s+ch;read(f,ch);
   end;
  i:=0;
  read(f,ch);
  while (ch<>#13) and (not eof(f)) do
   begin
    inc(i);
    zu[i]:=ch;
    read(f,ch);
   end;
  Getmem(p,35+(i+5));
  with p^ do
   begin
    l:=i;
    name:=s;
    for t:=1 to i do
    d[t]:=zu[t];
   end;
  read(f,ch);
 end;

procedure ReadTom(s:string);
var i,t:integer;
    ch:char;
 begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  Assign(f,s+'.TXT');reset(f);
  t:=0;
  while not eof(f) do
   begin
    read(f,ch);
    if ch=#13 then inc(t);
   end;
  close(f);
  reset(f);
  inc(nt);
  GetMem(tm[nt],11+(t+4)*4);
  with tm[nt]^ do
  begin
  name:=s;
  cs:=0;
  while not Eof(f) do
    ReadStat(cs,ps[cs+1])
   end;
  close(f);
 end;

procedure ReadAll;
var ff:text;
    s:string;
 begin
  assign(ff,'input.txt');
  reset(ff);nt:=0;curt:=1;
   while not SeekEof(ff) do
    begin
     ReadLn(ff,s);
     if s<>'' then
      begin
       ReadTom(s);
      end;
    end;
  close(ff);
 end;

procedure GetCommand;
 begin
  writeln;
  write(TM[CurT]^.name,'>');
  readln(cmd);
 end;


procedure MustBeCommand(s:string);
var i:integer;
 begin
  for i:=1 to byte(s[0]) do
   s[i]:=upcase(s[i]);
  if s='DIR' then CCmd:=dir_ else
  if s='VOLUME' then CCmd:=Volume_ else
  if s='LIST' then CCmd:=list_ else
  if s='TYPE' then CCmd:=type_ else
  if s='REF' then CCmd:=ref_ else
  if s='CLS' then CCmd:=cls_ else
  if s='VERIFY' then CCmd:=verify_ else
  if s='EXIT' then CCmd:=exit_ else
     begin
      CCmd:=Error_;
      cmd:=' ⠪ ';
     end;

 end;

procedure ChangeTom(s:string);
var i:integer;
 begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  for i:=1 to nt do
   begin
    if tm[i]^.name=s then begin curt:=i;exit;end;
   end;
  Error(NoTom);
 end;

function  GetTomN(s:string):integer;
var i:integer;
 begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  for i:=1 to nt do
    if tm[i]^.name=s then begin GetTomN:=i;exit;end;
  Error(NoTom);GetTomN:=0;
 end;
function  GetTomNs(s:string):integer;
var i:integer;
 begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  for i:=1 to nt do
    if tm[i]^.name=s then begin GetTomNs:=i;exit;end;
  GetTomNs:=0;
 end;

function  GetStN(t:integer;s:string):integer;
var i:integer;
 begin
  with tm[t]^ do begin
  for i:=1 to cs do
    if ps[i]^.name=s then begin GetStN:=i;exit;end;
  end;
  Error(NoStat);GetStN:=0;
 end;
function  GetStNs(t:integer;s:string):integer;
var i:integer;
 begin
  with tm[t]^ do begin
  for i:=1 to cs do
    if ps[i]^.name=s then begin GetStNs:=i;exit;end;
  end;
  GetStNs:=0;
 end;


procedure List(s:string);
var i,t:integer;
 begin
  t:=GetTomN(s);
  if t>0 then
  with tm[t]^ do
   begin
    for i:=1 to cs do
     begin
      writeln(i,'. ',ps[i]^.name);
      inc(rc);
      ref[rc]:=ps[i];
      reft[rc]:=t;
     end;
   end;
 end;

 function Letter(c:char):boolean;
  var i:integer;
  begin
   Letter:=true;
   for i:=1 to length(se) do
    if se[i]=c then exit;
   Letter:=false;
  end;

procedure FindReferences(var st:TStat;tt:integer;wr:boolean);
var i,t,q:integer;
    s,s1:string;
label 1;
 begin
  with st do
    for t:=2 to l-4 do
      if (d[t-1]=' ')and(d[t]='(') and (d[t+1]='') and (d[t+2]='') and (d[t+3]='.') then
         begin
          for i:=t+4 to l do
           if d[i]=')' then goto 1;
           continue;
          1:s:='';
            for q:=t+4 to i-1 do
             s:=s+d[q];
          s1:='';
          q:=t-2;
          while (Letter(d[q]) and (length(s1)<33) and (q>0)) do
           begin
            s1:=d[q]+s1;
            dec(q);
           end;
          if length(s1)<33 then
           begin
            inc(rc); {new ref}
          if s='' then s:=tm[tt]^.name;
            i:=GetTomNs(s);
            if (rc=1) and wr then writeln;
            if wr then begin
                        write(rc,'. ',s1);
                        if (i=tt) then writeln else
                         writeln(', ⮬ ',s);
                       end;
            if i>0 then q:=GetStNs(i,s1);
            if (not wr) then
             if (i=0) or (q=0) then
             begin
    if bad=0 then writeln(' 뫪  騥 :');
    inc(Bad);
    write(bad,'.  ',tm[tt]^.Name,':',st.name,' 뫪  ');
    writeln(s,':',s1);
             end;
            reft[rc]:=i;
            if (i>0) and (q>0) then
             begin
              ref[rc]:=tm[i]^.ps[q];
             end else Ref[rc]:=nil;
            end;
         end;
 end;

procedure Typst(var st:TStat;tt:integer);
var i,t:integer;
    s:string;
begin
if @st=nil then begin Error(Nostat);exit;end;
with st do
 begin
  s:=name+#32;
  t:=0;
  while t<l do
   begin
    inc(t);
    s:=s+d[t];
    if length(s)>80 then begin
                          i:=length(s);
                          while s[i]<>' ' do dec(i);
                           begin
                            write(copy(s,1,i-1));
                            if i-1<80 then writeln;
                            s:=Copy(s,i,255);
                            while (length(s)>0) and (s[1]=' ') do
                            s:=copy(s,2,255);
                           end;
                         end;
   end;
  if s<>'' then writeln(s);
 end;
 rc:=0;
 FindReferences(st,tt,true);
end;

procedure Typ(s1:string;s2:string);
var i,t,i1,i2:integer;
 begin
  i1:=GetTomN(s1);
  if i1=0 then exit;
  with tm[i1]^ do
   begin
    i2:=GetStn(i1,s2);
    if i2>0 then Typst(ps[i2]^,i1);
   end;
 end;

procedure CheckStat(t:TStat;tt:integer);
var i:integer;
 begin
  FindReferences(t,tt,false);
 end;
procedure CheckTom(tt:integer);
var i:integer;
 begin
  with tm[tt]^ do
  for i:=1 to cs do
  CheckStat(ps[i]^,tt);

 end;

procedure ProcessCommand;
var q,i,t:integer;
    s:string;
 begin
  t:=pos(' ',cmd);
  if t=0 then t:=length(cmd)+1;
  MustBeCommand(copy(cmd,1,t-1));
  s:=copy(cmd,t+1,255);
  if ccmd=Error_ then begin Error(cmd);exit;end;
 case CCmd of
 Exit_: begin
  rc:=0;
         if cmd[0]<>#4 then Error(NoCmd);
         writeln(' ᢨ.');
         halt;
        end;
 Dir_: begin
  rc:=0;
        for i:=1 to nt do
         writeln(tm[i]^.name);
       end;
 Cls_: begin
  rc:=0;
         if cmd[0]<>#3 then Error(NoCmd);
         clrscr;
        end;
 Volume_: begin
  rc:=0;
           ChangeTom(s);
          end;
 List_: begin
  rc:=0;
         if s='' then s:=tm[Curt]^.Name;
         List(s);
        end;
 Ref_: begin
        val(s,i,t);
        if (t<>0) or (i<1) or (i>rc) then begin Error(BadRef);rc:=0;end else
         begin
          rc:=0;
          if reft[i]=0 then error(notom) else
          Typst(ref[i]^,reft[i]);
         end;
       end;
 Type_: begin
  rc:=0;
         i:=pos(':',s);
         if i=0 then typ(tm[Curt]^.name,s) else
                     typ(copy(s,1,i-1),copy(s,i+1,255));
        end;
 Verify_:
  begin
   bad:=0;
   for i:=1 to nt do
     CheckTom(i);
   if bad=0 then writeln(' 뫪 ४');
  end;

 end;
 lc:=CCmd;
 end;

procedure Solve;
 begin
  Lc:=Error_;
  repeat
   GetCommand;
   ProcessCommand;
  until false;
 end;

 begin
  ReadAll;
  writeln('ਢ!');
  Solve;
 end.