program FonTann;
{$N+,G+}
type real=double;
var n,k,l:integer;
    x,y:array[1..101] of real;
    aa,bb,cc:array[1..100] of real;
    d:array[1..100] of real;
    b:array[1..100] of boolean;
const eps=1e-7;
procedure ReadAll;
var i,t:integer;
 begin
  assign(input,'input.txt');reset(input);
  read(n);
  for i:=1 to n do
  read(x[i],y[i]);
  read(k,l);
  x[n+1]:=x[1];y[n+1]:=y[1];
  close(input);
 end;

var x1,y1,a1,b1,c1,d1:real;

function max(a,b:real):real;
 begin
  if a>b then max:=a else max:=b;
 end;

function equ(a,b:real):boolean;
 begin
  equ:=abs(a-b)<Eps;
 end;

var kk,bbz:real;

function less(a,b:real):Boolean;
 begin
  less:=(b-a)>Eps;
 end;
function OutSide(x2,y2:real):boolean;
var i,t:integer;
    c:byte;

  procedure HNDIntersect(i:integer);
   begin
    if equ(y[i],y[i+1]) then exit;
    if equ(max(y[i],y[i+1]),y2) then exit;
    if Less(y[i],y2) and Less(y[i+1],y2) then exit;
    if Less(y2,y[i]) and Less(y2,y[i+1]) then exit;
    kk:=(x[i+1]-x[i])/(y[i+1]-y[i]);
    bbz:=x[i]-kk*y[i];
    x1:=kk*y2+bbz;
    if x1<x2+Eps then inc(c);
   end;

 begin
  c:=0;
  for i:=1 to n do
  HNDIntersect(i);
  if c mod 2=1 then OutSide:=false else outside:=true;
 end;

function Impos(a,b:integer):boolean;
var i:integer;
 begin
  Impos:=true;
  for i:=1 to n do
   begin
    a1:=y[b]-y[a];
    b1:=x[a]-x[b];
    c1:=y[a]*x[b]-y[b]*x[a];
    d1:=aa[i]*b1-a1*bb[i];
    if abs(d1)<eps then continue;
    x1:=-(cc[i]*b1-c1*bb[i])/d1;
    y1:=-(aa[i]*c1-a1*cc[i])/d1;
    if (((x1>x[a]+eps) and (x1<x[b]-eps)) or
        ((x1>x[b]+eps) and (x1<x[a]-eps)) or
        ((y1>y[a]+eps) and (y1<y[b]-eps)) or
        ((y1>y[b]+eps) and (y1<y[a]-eps))) and
       (((x1>x[i]+eps) and (x1<x[i+1]-eps)) or
        ((x1>x[i+1]+eps) and (x1<x[i]-eps)) or
        ((y1>y[i]+eps) and (y1<y[i+1]-eps)) or
        ((y1>y[i+1]+eps) and (y1<y[i]-eps))) then exit;
   end;
  if outSide((x[a]+x[b])/2,(y[a]+y[b])/2) then exit;
  Impos:=false;
 end;


procedure CalcAbc;
var i:integer;
 begin
  for i:=1 to n do
   begin
    aa[i]:=y[i+1]-y[i];
    bb[i]:=x[i]-x[i+1];
    cc[i]:=y[i]*x[i+1]-y[i+1]*x[i];
   end;
 end;

procedure Solve;
var i,t,bi:integer;
    bst:real;
               procedure UpgradeDistance(a,b:integer);
                var i:integer;
                    dd:real;
                begin
                 dd:=sqrt(sqr(x[a]-x[b])+sqr(y[a]-y[b]));
                 if bst+dd>=d[a] then Exit;
                 if (abs(a-b)<>1) and (abs(a-b)<>n-1)
                    and Impos(a,b) then exit;
                 d[a]:=bst+dd;
                end;

 begin
  CalcABC;
  for i:=1 to n do
   d[i]:=1e+36;
  for i:=1 to n do
   b[i]:=true;
  d[k]:=0;

  for t:=1 to n do
   begin
    bst := 1e+36;bi:=0;
    for i:=1 to n do
     if (b[i]) and (d[i]<bst) then begin bst:=d[i]; bi:=i;end;
    if bi=l then
      begin
       Assign(output,'output.txt');rewrite(output);
       writeln(d[l]);
       close(output);
       halt;
      end;
    b[bi]:=false;
    for i:=1 to n do
     if b[i] then UpgradeDistance(i,bi);
   end;
 end;

 begin
  ReadAll;
  Solve;
 end.