Program Macro;
{$Q-,I-,O-,G+,F-,S-,R-}

{ Problem 3
  by Nick V. Durov }

Type
   PrArr = Array [1..168] of Integer;
Const
   Primes : PrArr = (
        2,    3,    5,    7,   11,   13,   17,   19,   23,   29,   31,
       37,   41,   43,   47,   53,   59,   61,   67,   71,   73,   79,
       83,   89,   97,  101,  103,  107,  109,  113,  127,  131,  137,
      139,  149,  151,  157,  163,  167,  173,  179,  181,  191,  193,
      197,  199,  211,  223,  227,  229,  233,  239,  241,  251,  257,
      263,  269,  271,  277,  281,  283,  293,  307,  311,  313,  317,
      331,  337,  347,  349,  353,  359,  367,  373,  379,  383,  389,
      397,  401,  409,  419,  421,  431,  433,  439,  443,  449,  457,
      461,  463,  467,  479,  487,  491,  499,  503,  509,  521,  523,
      541,  547,  557,  563,  569,  571,  577,  587,  593,  599,  601,
      607,  613,  617,  619,  631,  641,  643,  647,  653,  659,  661,
      673,  677,  683,  691,  701,  709,  719,  727,  733,  739,  743,
      751,  757,  761,  769,  773,  787,  797,  809,  811,  821,  823,
      827,  829,  839,  853,  857,  859,  863,  877,  881,  883,  887,
      907,  911,  919,  929,  937,  941,  947,  953,  967,  971,  977,
      983,  991,  997);
Var
  Squares : Array [1..168] Of LongInt;

Function IsPrime (N : LongInt) : Boolean;
Var i : Integer;
Begin
  For i:=1 To 168 Do
    If Squares[i]>N Then Begin IsPrime := True; Exit End Else
    If (N Mod Primes[i])=0 Then Begin IsPrime := False; Exit End;
  IsPrime := True
End;

Const
  BS            = 32768;
Var
  N, CN         : LongInt;
  i, p          : LongInt;
  F             : File;
  Buf           : Array [1..BS] Of Char;
  Pw            : Word;

Procedure Ou(C : Char);
Begin
  Inc(Pw);
  Buf[Pw] := C;
  If Pw=BS Then
    Begin
      BlockWrite (F, Buf, Pw);
      Pw := 0
    End
End;

Var
  St  : String;
Procedure WrDec (N : LongInt);
Var i : Integer;
Begin
  Str (N, St);
  For i:=1 To Length(St) Do Ou(St[i])
End;

Begin
  For i:=1 To 12*14 Do Squares[i] := Sqr (LongInt(Primes[i]));
  Assign (Input, 'INPUT.TXT');
  ReSet (Input);
  Assign (F, 'OUTPUT.TXT');
  ReWrite (F, 1);
  Pw := 0;
  Read (N);
  if N>=2 then
  repeat
    p := 2*N-1;
    while (p>2) and (not isprime(p)) do p:=p-2;
    if N>=p then N:=p-1;
    CN := p-N-1;
    For i:=p-N To N Do
      If Odd(i) Then
        Begin
          WrDec (i);
          Ou (' ');
          WrDec (p-i);
          Ou (#13);
          Ou (#10);
{         WriteLn(F,i,' ',p-i);}
        End;
    N := CN;
  Until N<2;
  BlockWrite (F, Buf, Pw);
  Close (F);
End.
