Program Polynoms;
Uses BigInts;

Const MaxN = 50;

Var A : Array [0..MaxN] Of BigInt;
    B,C : Array [1..MaxN] Of Integer;
    P,N,NN : Integer;

Procedure ReadData;
Begin
  Write('N = ');
  ReadLn(NN);
  Write('P = ');
  ReadLn(P);
End;

Procedure Make(t : Integer);
Var P,Q : BigInt;
    i : Integer;
Begin
  InitBig(P,1);
  For i:=1 To t Do
  Begin
    Q:=A[B[i]]; AddInt(Q,C[i]-1);
    BinomBigInt(Q,Q,C[i]);
    MultBig(P,Q);
  End;
  SubBig(A[N],P);
End;

Procedure Rec(S,max,t : Integer);
Var i,k : Integer;
Begin
  If S=0 Then Begin Make(t-1); Exit End;
  For i:=max DownTo 2 Do
    For k:=S Div i DownTo 1 Do
    Begin
      B[t]:=i; C[t]:=k;
      Rec(S-k*i,i-1,t+1);
    End;

  If max<>0 Then Begin B[t]:=1; C[t]:=S; Make(t) End;
End;

Procedure Solve;
Var T : BigInt;
Begin
  InitBig(T,1); A[0]:=T;
  For N:=1 To NN Do
  Begin
    Write(^M'N = ',N,': ');
    MultInt(T,P); A[N]:=T;
    Rec(N,N-1,1);
  End;
End;

Procedure PrintAnswer;
Begin
  PrintBig(A[N]);
  WriteLn(' ਢ ');
End;

Begin
  ReadData;
  Solve;
  PrintAnswer;
End.