                                                                                Program P07_12_0;{
Unit Erase;                                                                                            }
                                                                                  Uses

Dos;
                                                                                        Const
                                                                                        MaxLexem =
100                                                                                              ;
      BigL :                                 String = 'QWERTYUIOPLKJHGFDSAZXCVBNM';
      SmalL:                                String = 'qwertyuioplkjhgfdsazxcvbnm㪥௠ᬨ';
      symbol = ['a'..'z','A'..'Z',''..'',''..'','_'];
                                                                                allop =
      ['a'..'z','A'..'Z',''..'',''..'','_','.','0'..'9','$','?','(',')',#39,'"','{','}'];
                                                                                                              MaxIden = 150;

Type                                                                                                          Nothing = Byte;
     TBuf = Array[1
                   ..
                     32000
                          ]
                                of
                                        nothing                                                     ;
     Lexem = (_DefConst,  _DefType, _Name,  _seq,  _set,   _of,    _int,
              _char,      _string,  _bool,  _left, _right, _comma, _point,
              _semicolon, _plus,    _minus, _mul,  _div,   _equal, _more,
              _less,      _error,   _null,  _express);
     TLexem =                                                                   record
                                                                                            L : Lexem;
                                                                                                                  X : Integer;
                                                                                            S : String;
            Line : LongInt;
                                                                                     End;
                                                                   TWaitFlag = (_define, _afterdef, _iden, _eq, _expr, _semi);
     IdenStr
                                                                                        =
     String[8];

                                                                                        Var
NR : Word;
Sp : LongInt;
S : String;
OldExit : Pointer;
WaitFlag : TWaitFlag;
Buf : ^TBuf;
CurFOfs : LongInt;
CurLine : LongInt;
F : File;
L : TLexem;
All : Array[1..MaxLexem] of TLexem;
CurLex : LongInt;
A : LongInt;
B : Byte;
Ch : Char;
I : Array[1..MaxIden] of IdenStr;
Co : Array[1..MaxIden] of LongInt;
V : Array[1..MaxIden] of String[100];
NCo : LongInt;
NI : LongInt;
Lex : Lexem;

Procedure Error(S : String;Line : LongInt);
Var FF : Text;S1:String;
Begin
  Close(F);
  Assign(FF,'program.ddl');
  ReSet(FF);
  WriteLn('訡  ணࠬ');
  For A:=1 to Line do
    ReadLn(FF,S1);
  ReadLn(FF,S1);
  Close(FF);
  WriteLn('訡  ப :');
  WriteLn(S1);
  WriteLn(S);
  Assign(Output,'program.err');
  ReWrite(Output);
  WriteLn('訡  ப :');
  WriteLn(S1);
  WriteLn(S);
  Close(Output);
  Halt(0);
End;

Function LowerC(C : Char) : Char;
Var A : Byte;
Begin
  For A:=1 to Length(BigL) do
    If C=BigL[A] then C:=SmalL[A];
  LowerC:=C;
End;

Function Lower (S : String) : String;
Var  A: Byte;
Begin
  For A:=1 to Length(S) do S[A]:=LowerC(S[A]);
  Lower:=S;
End;

Function GetNext : Byte;
Var Get : Byte;
Begin
  If (CurFOfs=NR) and (EOF(F)) then Get:=0 else
  Begin
    Inc(CurFOfs);
    If CurFOfs>NR then
    Begin
      BlockRead(F,Buf^,SizeOf(Buf^),NR);
      CurFOfs:=1;
      Get:=Buf^[1];
    End else
      Get:=Buf^[CurFOfs];
  End;
  If (Get<>0) and (Get<>10) and (Get<>13) and (Get<32) then Error('⨫  ᨬ  32',CurLine);
  If Get=13 then
    Inc(CurLine);
  GetNext:=Get;
End;

Procedure OpenProgram;
Begin
  New(Buf);
  Assign(F,'program.ddl');
  ReSet(F,1);
  BlockRead(F,Buf^,SizeOf(Buf^),NR);
  CurFOfs:=0;
  CurLine:=0;
End;

Procedure Skip;
Begin
  While B in [32,13,10] do B:=GetNext;
  While Char(B)='/' do
  Begin
    B:=GetNext;
    If Char(B)<>'/' then Error(' 䨪ࠬ ࠢ ᨬ "/"',CurLine);
    While Not (B in [13,10]) do B:=GetNext;
    While (B in [13,10]) do B:=GetNext;
  End;
End;

Function AddIden(S : String) : Integer;
Var A: Byte;
Begin
  If Not (S[1] in Symbol) and (S[1]<>'.') and (S[1]<>'$') and (S[1]<>'?') then Error(' 䨪 "'+S+'"',CurLine);
  For A:=2 to Length(S) do
    If Not (S[A] in Symbol) and (S[A]<>'$') and (S[A]<>'$') and (S[A]<>'?') and Not(S[A] in ['0'..'9']) then
      Error(' 䨪 "'+S+'"',CurLine);
  S:=Copy(S,1,8);
  If (S='or') or (S='and') or
     (S='optional') or (S='constant') or (S='of') or (S='set') or (S='multi')
     or (S='sequence') or (S='ord') or (S='pred') or
     (S='string') or (S='integer') or (S='char') or (S='boolean') then
    Error('䨪 "'+S+'" 㦥 ।',CurLine);
  For A:=1 to NI do
    If I[A]=S then Begin AddIden:=A;Exit;End;
  Inc(NI);
  I[NI]:=S;
  AddIden:=NI;
End;

Procedure GetNextLex;
Begin
  L.L:=_null;
  While L.L=_null do
  Begin
    Skip;
    If (WaitFlag=_semi) and (char(b)<>';') then Error(' ";" ᫥ "'+S+'"',All[CurLex-1].Line);
    S:='';
    While (WaitFlag=_define) and (Char(b)=';') do
    Begin
      B:=GetNext;
      Skip;
    End;
    If (WaitFlag=_define) and (b=0) then Exit;
    If (WaitFlag<>_define) and (b=0) then Error('  ணࠬ',CurLine);
    If (WaitFlag=_semi) and (Char(b)=';') then
    Begin
      L.L:=_semicolon;
      WaitFlag:=_define;
      B:=GetNext;
      Exit;
    End;
    If char(B)='=' then Begin S:='='; B:=GetNext; Skip; End else
    If (WaitFlag=_expr) then
    While Not(Char(B) in [';',#0]) do
    Begin
      S:=S+Char(B);
      B:=GetNext;
      While char(B) in [#10,#13] do B:=GetNext;
      If (Length(S)>1) and (S[Length(S)]='/') and (S[Length(S)-1]='/') then Begin Delete(S,Length(S)-1,2); break; End;
    End else
    While Char(B) in allop do
    Begin
      S:=S+Char(B);
      B:=GetNext;
    End;
    Case WaitFlag of
    _define:
      If Lower(S)<>'define' then Error(' 祢 ᫮ "DEFINE"',CurLine) else
      Begin
        WaitFlag:=_afterdef;
      End;
    _afterdef:
      If Lower(S)='constant' then
      Begin
        L.L:=_defconst;
        WaitFlag:=_iden;
      End else
      If Lower(S)='type' then
      Begin
        L.L:=_deftype;
        WaitFlag:=_iden;
      End else Error('᫥ 祢 ᫮ "DEFINE" 祭 ᫮ "'+S+'"',CurLine);
    _iden:
      Begin
        L.X:=AddIden(Lower(S));
        L.L:=_name;
        WaitFlag:=_eq;
      End;
    _eq:
      If S<>'=' then Error(' "="  "'+S+'"',CurLine) else
      Begin
        WaitFlag:=_expr;
      End;
    _expr:
      Begin
        L.L:=_express;
        L.S:=S;
        WaitFlag:=_semi;
      End;
    End;
  End;
End;

Procedure CreateAllLexems;
Begin
  WaitFlag:=_define;
  CurLex:=0;
  B:=GetNext;
  While Not(B=0) do
  Begin
    Inc(CurLex);
    GetNextLex;
    L.Line:=CurLine;
    All[CurLex]:=L;
  End;
  if (WaitFlag<>_semi) and (WaitFlag<>_define) then
    Error('  ணࠬ',CurLine);
End;

Procedure CheckErr;
Begin
  {$I-}
  Assign(F,'program.err');
  ReSet(F,1);
  {$I+}
  If IOResult=0 then
  Begin
    Close(F);
    Erase(F);
  End;
End;

Procedure MyExit;
Begin
  ExitProc:=OldExit;
  If ErrorAddr<>nil then
  Begin
    Error('஢ 訡',CurLine);
  End;
  Halt(0);
End;

Procedure OptimizeExpress(Var S1 : String);
Var S : String;
Begin
  S:=S1;
  While S[Length(S)]=' ' do Delete(S,Length(S),1);
  S1:=S;
End;

Function SimpleCalc(S : String) : LongInt;
Var A,B,C,D : Byte;
Begin
  B:=0;
  C:=0;
  For A:=1 to Length(S) do
  Begin
    If S[A]='(' then
    Begin
      Inc(B);
      If B>C then
      Begin
        C:=B;D:=A;
      End;
    End else
    If S[A]=')' then Dec(B);
    If B<0 then Error('ࠢ쭮 - ᪮  ࠦ "'+S+'"',All[P07_12_0.A].Line);
  End;
  If B<>0 then Error('ࠢ쭮 - ᪮  ࠦ "'+S+'"',All[P07_12_0.A].Line);
  If C=0 then
  Begin
  End else
  Begin
    A:=C;
    While S[A]<>')' do Inc(A);
    SimpleCalc:=SimpleCalc(Copy(S[A],C+1,A-1));
  End;
End;

Procedure CalcExpr(NumI : LongInt;S : String);
Var C : Byte;
Begin
  For C:=1 to NCo do
    If NumI=Co[C] then Error('⪠ ८। ⠭ "'+I[C]+'"',All[A].Line);
  Inc(NCo);
  Co[NCo]:=NumI;
  Str(SimpleCalc(S),V[NCo]);
End;

Procedure AnalyseLexems;
Begin
  For A:=1 to CurLex do
  If All[A].L=_express then
    OptimizeExpress(All[A].S);
  For A:=1 to CurLex do
  If All[A].L=_defconst then
  Begin
    Inc(A,2);
    CalcExpr(All[A-1].X,All[A].S);
  End;
End;

Begin
  OldExit:=ExitProc;
  ExitProc:=@MyExit;
  CheckErr;
  OpenProgram;
  CreateAllLexems;
  AnalyseLexems;
  Close(F);
  Dispose(Buf);
End.



Do you want to restart computer [Yes/No]:Yes
Restarting computer... please wait...
Loading TR-DOS version 5.3T
restarting...
(C)1982 Sinclair Research LTD.
LOAD ""
program:warcraft2.B
code:warmain.D
loading complete in 5 minutes
your computer is too slow to play war2, restarting in PENTIUM emulation
...starting MS-DOS pentium emulation on sinclair (C)1998...
loading mouse driver ... mouse not found - using sound blaster...
sound blaster not found - using keyboard
searching SVGA... not found - using black/white TV in resoultion 587x476x251
starting C:\MS_DOS\WAR2\war2.sinclair
bad file name
starting C:\MS_DOS\WAR2\war2.exe
path not found - you have no hard disk, especially C:)
starting A:\WAR2\war2.exe
loading univbe...
loading warcraft2...
Your computer doesn't support 640x480x256 resolution - using MONO-TEXT-MODE
Main Menu:
SINGLE PLAYER GAME
MULTIPLAYER GAME
REPLAY INTRODUCTION
SHOW CREDITS
EXIT TO DOS
Select menu item:
MULTIPLAYER GAME selected...
SELECT:
DIRECT LINK GAME
MODEM GAME
IPX GAME
... IPX GAME Selected...
You have not any IPX networks connected to your computer... sorry,...
but you can't play war2 by IPX
... MODEM GAME Selected...
You have no any modems connected to your computer, using............
MS-DOS session failed, starting sinclair...