{
 DDL, ( ন 樨 
plus/minus/mul  ⢠) 
}
{
Copright (c) 08.07.97 by Sandler Mark  
all comments please send to sandler@spb.runnet.ru
}

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 8000,0,655360}
Program DDL;
Const let: set of char=['a'..'z',''..'',''..'','?','$','_','0'..'9'];
Const _seq=1;
      _string=2;
      _integer=4;
      _set=8;
      _boolean=16;
      _un=9;
      _setof=40; {_setof+set}
      _msetof=72; {_msetof+set}
      _seqof=129; {_seq + seqof}
      _char=256;
      _ordinal=512;
      _limited=1024;
Type _Types=word;

Type str8=string[8];
Type  PVariable=^variable;
      Ppsv=^Psv;
           PRec=^Rec;
      pstring=^string;
      PSv=record
       _Type : _Types;
        link : integer;
                case integer of
                         _boolean : ( b : boolean );
                         _string  : ( s : PString );
                         _integer : ( i : integer );
                         _seq     : (seq : pRec; sl : integer);
       end;
       variable=record
       _name : str8;
       r     : Psv;
       end;
     Rec=array [1..100] of Psv;
Type
   PTyp=^typ;
   ptrec=^trec;
   Typ=record
      _Type : integer;
      _opt : boolean;
      case integer of
       0 : ( seq : PTRec;  sl : integer);
       1: ( f, e : integer; link : integer);
     End;
   Trec=array [1..100] of Ptyp;
   PStype=^SType;
   Stype= record _name : str8; r : Typ; End;
   Tlink= array [0..100] of str8;
   Plink=^Tlink;
Var

  vars  : array [1..1000] of Pvariable;
  types : array [1..1000] of PSType;
  links : array [1..1000] of PLink;
  llen  : array [1..1000] of integer;
  tctr, tptr : integer;
  testmode   : boolean;
  lptr : integer;
  vctr, vptr : integer;
  CLineNumber : integer;
Procedure Readconst(Var v : PSV); Forward;
Procedure ReadQConst(var v: psv); forward;
Procedure Readtype(Var v :Typ); Forward;
function downcase(ch : char): char;
Var u: char;
Begin
 if ch in ['A'..'Z',''..''] then downcase:=chr(ord(ch)+32) else
 if ch in [''..''] then downcase:=chr(ord(ch)+80) else downcase:=ch;
end;
Procedure AddNewVar(Var v:  Variable);
begin
 inc(vptr);
 new(vars[vptr]); vars[vptr]^:=v;
end;
Function QExist(ss : string):boolean;
Var i, j : integer;
Begin
 Qexist:=true;
 if length(ss)>8 then ss:=copy(ss,1,8);
 for i:=1 to vptr do
  begin
   if vars[i]^._name=ss then exit;
  end;
 for i:=1 to Tptr do
  begin
   if types[i]^._name=ss then exit;
  end;
 for i:=1 to lptr do
   for j:=0 to llen[i] do
    if ss=links[i]^[j] then   exit;
 Qexist:=false;
End;
Function ordExist(ss : string; var c : PSV):boolean;
Var i, j : integer;
Begin
 ordexist:=true;
 for i:=1 to lptr do
   for j:=0 to llen[i] do
    if ss=links[i]^[j] then
     begin c.link:=i; c.i:=j; c._type:=_ordinal; exit; End;
 ordexist:=false;
End;
Procedure error(s : string);
Var f :text;
Begin
 Close(output); Assign(output,'program.out'); Rewrite(output);
 assign(f,''); Rewrite(f);
 writeln('ப : ',clinenumber,' ',s);
 Writeln(f,'ப ',clinenumber,' : ',s); Halt;
end;
Type lexem=(_Mul, _Div, _plus, _minus, _int, _define, _constant, _Type,
   _lsk, _rsk, _lfs, _rfs, _value, _ident, _optional, _eof, _sk, _zap, _eq,
   _less, _great, _lessEq, _greatEq, _comment, _strng, _setPlus, _setMul, _setMinus,
   _SeqUn, _mod, _sequence, _of, __set, _toch, _dvt, _bool,  _str, _chr,
  _multi, _true, _false, _ord, _pred, _succ, __char, _neq, _and, _not,_or);
{ ᭮}
Var ch : char;
   curLex : lexem;
  value : integer;
  ss    : string;

Procedure NextCh;
Begin
 if ch=#13 then inc(ClineNumber);
 if eof then ch:=#26;
 repeat
  read(ch);
 until ch<>#10;
 if ch=#9 then ch:=#32;
end;
Procedure SkipCCr;
Begin
 while (ch<>#13) and (ch<>#26) do nextCh;
 while (ch=#13) do nextCh;
end;
Procedure NextLex;
Var s : string;
code : integer;
 st : char;
label 10;
begin
repeat
 s:='';
 while ch in [' ',#13,#9] do nextCh;
 ch:=downcase(ch);
 case ch of
  '*': begin curLex:=_Mul; NextCh; End;
  '/': Begin
        curlex:=_div; nextCh;
        if ch='/' then begin skipCCR; curlex:=_comment; End;
       End;
  '+': Begin curlex:=_plus; NextCh; End;
  '@': begin curlex:=_seqUn; NextCh; End;
  '-': Begin curlex:=_minus; NextCh; end;
  '(': begin curlex:=_lsk; NextCh; End;
  ')': begin curlex:=_rsk; NextCh; End;
  '{': Begin curlex:=_lfs; Nextch; end;
  '}': begin curlex:=_rfs; NextCh; End;
  ';': begin curlex:=_sk; Nextch; end;
  ',': begin curlex:=_zap; NextCh; End;
  '=': begin curLex:=_eq; Nextch; End;
  '<': begin curlex:=_less; nextCh;
        if ch='=' then begin curlex:=_lessEq; NextCh; End;
        if ch='>' then begin curlex:=_neq; NextCh; End;
       End;
  '>': begin curlex:=_Great; nextCh;
        if ch='=' then begin curlex:=_greatEq; NextCh; end;
       End;
  #26: begin CurLex:=_eof; End;
  '0'..'9':
   begin
    while ch in ['0'..'9'] do begin s:=s+ch; NextCh; End;
    val(s,value,code); curlex:=_value;
    if code<>0 then Error('Invalid numeric format');
   End;
  'a'..'z',''..'',''..'','.','?','$','_' :
    begin
     s:=ch;
     nextch;
     while (ch in let) do
      begin
       s:=s+(ch);
       nextch; ch:=downcase(ch);
      end;
     if s+ch='..' then begin curlex:=_dvt; NextCh; End else
     if s='define' then curlex:=_define else
     if s='ord' then curlex:=_ord else
     if s='succ' then curlex:=_succ else
     if s='pred' then curlex:=_pred else
     if s='constant' then curlex:=_constant else
     if s='sequence' then curlex:=_sequence else
     if s='of' then curlex:=_of else
     if s='set' then curlex:=__set else
     if s='type' then curlex:=_type else
     IF S='plus' then curlex:=_setPlus else
     if s='minus' then curLex:=_setMinus else
     if s='mul' then curlex:=_setMul else
     if s='mod' then curlex:=_mod else
     if s='integer' then curlex:=_int else
     if s='string' then curlex:=_str else
     if s='boolean' then curlex:=_bool else
     if s='chr' then curlex:=_chr else
     if s='true' then curlex:=_true else
     if s='false' then  curlex:=_false else
     if s='optional' then curlex:=_optional else
     if s='multi' then curlex:=_multi else
     if s='char' then curlex:=__char else
     if s='and' then curlex:=_and else
     if s='not' then curlex:=_not else
     if s='or' then curlex:=_or else
      begin curlex:=_ident; ss:=s; end
    end;
  '''','"' :
   begin
    st:=ch; nextch;
    if ch=st then goto 10;
    repeat
       repeat
         s:=s+ch; nextch;
       until ch=st;
10:
        nextch;
    until ch<>st;
    curlex:=_strng; ss:=s;
   end;
  else error('Unrecognized character');
 end
until curlex<>_comment;
End;
Procedure ReadSeq(Var v: Psv);
Var first : boolean;
begin
   first:=true;
   v._type:=_un;
   new(v.seq); v.sl:=0;
   repeat
    case curlex of
     _rfs : begin break; end;
     _zap : begin
             if first then Error('ࠢ쭮 ᠭ ᫥⥫쭮/⢠ (  ,} ) ');
              first:=true; nextlex; Continue; End;
     else begin
           inc(v.sl);
           readconst(v.seq^[v.sl]);
           first:=false;
          End;
    end;
   until curlex=_rfs;
   nextlex;
End;
procedure Neg(Var v : PSV);
Var i : integer;
begin
 if testmode then exit;
 if v._type=_integer then begin v.i:=-v.i; Exit; End else
 if (v._type and _seq)<>0  then
 begin
  for i:=1 to v.sl do neg(v.seq^[i]);
  v._type:=_seq;
 end  else error('  ᯮ짮   ⨯');
End;
procedure Add(Var a, b, c : psv);
Var i : integer;
Begin
 if testmode then exit;
 if (a._type and b._type)=0 then error('樨 +/- ।  ⠪ ⠭ ⨯ ');
 if a._type=_integer then c.i:=a.i+b.i else
 if a._type=_string then c.s^:=a.s^+b.s^ else
 if (a._type and _seq)<>0 then
  if a.sl<>b.sl then error('樨 +/- ।  ᫥⥫쭮ﬨ ࠧ筮 ') else
   begin for i:=1 to a.sl do add(a.seq^[i], b.seq^[i], c.seq^[i]); c._type:=_seq; End
 else error('樨 +/- ।  ⠪ ⨯ ');
End;
procedure comp(Var a, b, c : psv; what : lexem);
Var i : integer;
Begin
 if testmode then exit;
 if (a._type and b._type)=0 then error('樨 <> ।  ⠪ ⠭ ⨯ ');
 if (a._type=_integer) or (a._type=_ordinal) then
  begin case  what of
         _neq:  c.b:=(a.i<>b.i);
         _eq:   c.b:=(a.i=b.i);
         _less: c.b:=(a.i<b.i);
         _lessEq:c.b:=(a.i<=b.i);
         _great: c.b:=(a.i>b.i);
         _greatEq: c.b:=a.i>=b.i;
        End;
        c._type:=_boolean;
        exit;
  end;
 if a._type=_string then
  begin
     case what of
      _eq:   c.b:=(a.s^=b.s^);
      _neq : c.b:=(a.s^<>b.s^);
      _less: c.b:=(a.s^<b.s^);
      _lessEq:c.b:=(a.s^<=b.s^);
      _great: c.b:=(a.s^>b.s^);
      _greatEq: c.b:=a.s^>=b.s^;
     End;
     c._type:=_boolean;
     exit;
  End;
 if a._type=_boolean then
  begin
     case what of
      _eq     : c.b:=(a.b=b.b);
      _neq    : c.b:=(c.b<>b.b);
      _less   : c.b:=(a.b<b.b);
      _lessEq : c.b:=(a.b<=b.b);
      _great  : c.b:=(a.b>b.b);
      _greatEq: c.b:=(a.b>=b.b);
     End;
     c._type:=_boolean;
     exit;
  end;
 if (a._type and _seq)<>0 then
  if a.sl<>b.sl then error('樨 <> ।  ᫥⥫쭮ﬨ ࠧ筮 ') else
   begin for i:=1 to a.sl do add(a.seq^[i], b.seq^[i], c.seq^[i]); c._type:=_seq; End
 else error('樨 comp- ।  ⠪ ⨯ ');
End;
procedure umnog(Var a, b, c : psv);
Var i : integer;
Begin
 if testmode then exit;
 if (a._type and b._type)=0 then error(' * ।  ⠪ ⠭ ⨯ ');
 if a._type=_integer then c.i:=a.i*b.i else
 if (a._type and _seq)<>0 then
  if a.sl<>b.sl then error(' * ।  ᫥⥫쭮ﬨ ࠧ筮 ') else
   begin for i:=1 to a.sl do umnog(a.seq^[i], b.seq^[i], c.seq^[i]); c._type:=_seq; End
 else error(' * ।  ⠪ ⨯ ');
End;
procedure aand(Var a, b, c : psv);
Var i : integer;
Begin
 if testmode then exit;
 if (a._type and b._type)=0 then error(' and ।  ⠪ ⠭ ⨯ ');
 if a._type=_boolean then c.b:=a.b and b.b else
 if (a._type and _seq)<>0 then
  if a.sl<>b.sl then error(' and ।  ᫥⥫쭮ﬨ ࠧ筮 ') else
   begin for i:=1 to a.sl do aand(a.seq^[i], b.seq^[i], c.seq^[i]); c._type:=_seq; End
 else error(' and ।  ⠪ ⨯ ');
End;
procedure oor(Var a, b, c : psv);
Var i : integer;
Begin
 if testmode then exit;
 if (a._type and b._type)=0 then error(' or ।  ⠪ ⠭ ⨯ ');
 if a._type=_boolean then c.b:=a.b or b.b else
 if (a._type and _seq)<>0 then
  if a.sl<>b.sl then error(' or ।  ᫥⥫쭮ﬨ ࠧ筮 ') else
   begin for i:=1 to a.sl do aand(a.seq^[i], b.seq^[i], c.seq^[i]); c._type:=_seq; End
 else error(' or ।  ⠪ ⨯ ');
End;
procedure nnot(Var a : psv);
Var i : integer;
Begin
 if testmode then exit;
 if a._type=_boolean then a.b:=not a.b else
 if (a._type and _seq)<>0 then
   begin for i:=1 to a.sl do nnot(a.seq^[i]); a._type:=_seq; End
 else error(' not ।  ⠪ ⨯ ');
End;
procedure delit(Var a, b, c : psv);
Var i : integer;
Begin
 if testmode then exit;
 if (a._type and b._type)=0 then error(' / ।  ⠪ ⠭ ⨯ ');
 if a._type=_integer then
 begin if b.i=0 then error('  0');c.i:=a.i div b.i; end else
 if (a._type and _seq)<>0 then
  if a.sl<>b.sl then error(' / ।  ᫥⥫쭮ﬨ ࠧ筮 ') else
   begin for i:=1 to a.sl do delit(a.seq^[i], b.seq^[i], c.seq^[i]); c._type:=_seq; End
 else error(' / ।  ⠪ ⨯ ');
End;
Procedure Release(Var c : psv);
Begin
 if c._Type=_string then dispose(c.s);
 if c._type=_seq then dispose(c.seq);
End;
procedure Find(ss : str8; Var c : psv);
Var i : integer;
Begin
 for i:=1 to vptr do if vars[i]^._name=ss then
  begin c:=vars[i]^.r;
       if (c._type and _un)<>0 then
         begin new(c.seq); c.seq^:=vars[i]^.r.seq^; End;
       if (c._type=_string) then begin new(c.s); c.s^:=vars[i]^.r.s^; end;
       Exit;
  End;
error('⭠ ६');
End;
function FindType(ss : str8; Var c : Typ): boolean;
Var i : integer;
Begin
 for i:=1 to Tptr do if types[i]^._name=ss then
  begin c:=types[i]^.r; findtype:=true;
       Exit;
  End;
findtype:=false;
End;
procedure MakeOrd(var v : psv);
Begin
  if testmode then exit;
 case v._type of
  _ordinal, _limited :
   begin
    if v.link=-1 then error('ORD  ।  ⠪ ⨯');
    v._type:=_integer; v.link:=-1;
   end;
  _string :
   begin
     if length(v.s^) >1 then error(' ord  ।  ⠪ ⨯');
     dispose(v.s);
     v._type:=_integer; v.i:=ord(v.s^[1]);v.link:=-1;
   end;
   else error('ORD  ।  ⠪ ⨯');
 End;
End;
procedure MakeCHR(var v : psv);
Var q : integer;
Begin
 if testmode then exit;
 case v._type of
  _limited :
   begin
    if v.link<>-1 then error('chr  ।  ⠪ ⨯');
    if (v.i>255) or (v.i<0) then error('Overflow in chr');
   end;
  _integer :
   begin
     if (v.i<0) or (v.i >255) then error('Overflow in chr');
   end;
   else error('ORD  ।  ⠪ ⨯');
 End;
 v._type:=_string; q:=v.i;
 new(v.s); v.link:=-2;
 v.s^:=chr(q);
End;
Procedure MakePred(Var v : psv);
Begin
 if testmode then exit;
 if (v._type<>_ordinal) and (v._type<>_limited) then
  error('PRED  ।  ⠪ ⨯');
 if v.link=-1 then error('pred  ।  ⠪ ⨯');
 dec(v.i); if v.i<0 then v.i:=llen[v.link];
End;
Procedure MakeSucc(Var v : psv);
Begin
 if testmode then exit;
 if (v._type<>_ordinal) and (v._type<>_limited) then
  error('SUCC  ।  ⠪ ⨯');
 inc(v.i); if v.i>llen[v.link] then v.i:=0;
End;
procedure readMult(Var v : psv);
Var i : integer;
cur, c2 : psv;
sav : lexem;
first : boolean;
Begin
 first:=true;
 Repeat
  case curlex of
    _ident: begin
             if not OrdExist(ss,cur) then
             if first then find(ss,cur)  else
                error('  ');
             first:=false; nextlex;
            End;
    _true   : begin cur._type:=_boolean; cur.b:=true; nextlex;End;
    _false  : begin cur._type:=_boolean; cur.b:=false; nextlex; End;
    _lsk, _succ, _ord, _pred, _chr:
     begin
      sav:=curlex;
      if first then
       begin
        if curlex in [_chr, _succ, _ord, _pred, _strng] then
         begin nextlex; if curlex<>_lsk then error(' ᪮'); end;
        Nextlex; readconst(cur);
       End else
      error('  ');
      if curlex<>_rsk then error(' )');
      nextlex;
      first:=false;
{஢塞  ࠢ쭮 ⨯}
      case sav of
       _ord: makeOrd(cur);
       _chr: makeChr(cur);
       _pred: makePred(cur);
       _Succ: makesucc(cur);
      End;
     end;
    _lfs:
     begin
     if first then
      begin nextLex; ReadSeq(cur);End else error('  ');
      first:=false;
     end;
    _value:
     begin
     if first then begin nextLex; cur._type:=_integer; cur.i:=value; cur.link:=-1; End
      else error('  ');
     first:=false;
     End;
    _strng:
    begin
     if first then
      begin nextlex; cur._type:=_string; new(cur.s); cur.s^:=ss;
            cur.link:=-2; End
     else error('  ');
     first:=false;
    end;
    _mul, _div, _and:
    begin
     sav:=curlex;
     if first then error(' 뢠 㭠 */');
     nextlex;
     case curlex of
      _lsk: begin nextlex; readconst(c2);
       if curlex<>_rsk then error(' ᪮ ');
       nextlex;
       End;
      _not: begin readconst(c2); End;
      _lfs: begin nextlex; ReadSeq(c2);
      End;
      _value : begin nextLex; c2._type:=_integer; c2.i:=value; c2.link:=-1; End;
      _strng: begin nextlex; c2._type:=_string; new(c2.s); c2.s^:=ss; c2.link:=-2; End;
      _ord  :
           begin
            nextlex;
            if curlex<>_lsk then error('ࠢ쭮 ᠭ ord');
            nextlex;
            readconst(c2);
            makeOrd(c2);
           End;
      _ident: begin nextlex; find(ss, c2); end;
      else error(' ண ࠭  *');
     End;
     case sav of
      _mul: umnog(cur,c2,cur);
      _div: delit(cur,c2,cur);
      _and: aand(cur,c2,cur);
     end;
     release(c2);
    end;
    else begin v:=cur; Exit; End;
   End;
 until false;
End;
procedure Union(var a,b : PSV);
Var i : Integer;
Begin
 if (b._type and _seq)=0 then error(' @ ਬ ⮫쪮  ᫥⥫쭮');
 if (a._type and _seq)=0 then error(' @ ਬ ⮫쪮  ᫥⥫쭮');
 for i:=1 to b.sl do a.seq^[a.sl+i]:=b.seq^[i];
 a.sl:=a.sl+b.sl;
End;
procedure UnionTypes(var a,b : Typ);
Var i : Integer;
Begin
 if (b._type and _seq)=0 then error(' @ ਬ ⮫쪮  ᫥⥫쭮');
 if (a._type and _seq)=0 then error(' @ ਬ ⮫쪮  ᫥⥫쭮');
 for i:=1 to b.sl do a.seq^[a.sl+i]:=b.seq^[i];
 a.sl:=a.sl+b.sl;
End;
Procedure ReleaseType(q:typ);
begin
 dispose(q.seq);
 { 室 㭨⮦ ⥤  seq}
End;

Procedure ReadQConst(Var v : PSV);
Var cur, c2: PSV;
first : boolean;
Begin
 first:=true;
 repeat
 Case CurLex of
  _seqUn: begin
           if first then error(' @ 㭠ୠ');
           nextlex;
           readmult(c2);
           Union(cur,c2); Release(c2);
          end;
  _plus:
       begin
        if first then begin nextlex; readMult(cur) End
         else begin
           nextlex;
           readMult(c2);
           add(cur,c2, cur); release(c2);
          End;
          first:=false;
       end;
  _or  : begin
          if first then error('or  㭠ୠ ');
          nextlex;
          readmult(c2);
          oor(cur,c2,cur); release(c2);
         End;
  _minus:
      Begin
      nextlex;
       if first then begin readMult(cur); neg(cur); End
        else begin readMult(c2); neg(c2); add(cur, c2, cur); release(c2);  End;
       first:=false;
      End;
   _not :
    begin
     nextlex;
     if not first then
       error('ࠢ쭮 ᯮ짮 NOT');
     case curlex of
      _lsk:
       begin
        nextlex;
        readConst(cur);
        nextlex;
        if curlex<>_rsk then error(' )');
       End;
      _rfs: begin nextlex; readSeq(cur); End;
      _ident: begin find(ss,cur); nextlex; End;
      _true: begin cur._type:=_boolean; cur.b:=true;nextlex; End;
      _false : begin cur._type:=_boolean; cur.b:=false; nextlex;End;
      else error('ࠢ쭮 ᯮ짮 Not');
     End;
     first:=false;
     nnot(cur);
    end;
  _lsk, _lfs, _value,_ident, _strng, _ord, _chr, _succ, _pred, _true, _false :
            begin
              if first then
               begin readMult(cur); first:=false; end
             else error(' ⥬᪠ ');
            end;

  else begin if first then error(' ࠦ '); v:=cur; exit; End;
 end;
 until false;
End;
Procedure readConst(var v : psv);
Var cur, c2 : psv;
first       : boolean;
save        : lexem;
Begin
 first:=true;
 repeat
  if curlex in [_rsk, _rfs, _zap, _sk, _eof, _define, _dvt] then
   begin
    if first then error(' ࠦ '); v:=cur; exit;
   end;
  case curlex of
   _less, _great, _eq, _neq, _lesseq, _greatEq:
   begin
    if first then error(' ࠦ ');
    save:=curlex;
    nextlex;
    readQconst(c2);
    comp(cur, c2, cur, save); release(c2);
   End;
   else
    begin
     if first then readQconst(cur);
     first:=false;
    End;
  end;
 until false;
End;
Procedure check(s : string;a,b : integer);
Var i : integer;
Begin
 for i:=1 to vptr-a do
  begin
   if vars[i]^._name=s then error(' '+s+' 㦥 ।ee');
  end;
 for i:=1 to tptr-b do
  begin
   if types[i]^._name=s then error(' '+s+' 㦥 ।ee');
  end;
End;
function exist(s : string): boolean;
Var i : integer;
Begin
 exist:=false;
 for i:=1 to vptr-1 do
  begin
   if vars[i]^._name=s then begin exist:=true; exit; End;
  end;
End;
Procedure ReadCDef(Var v : variable);
Begin
 if curlex<>_ident then error('  ६');
{ v._name:=copy(ss,1,8);
 check(v._name);}
 nextlex;
 if curlex<>_eq then Error('  =');
 NEXTLEX;
 readconst(v.r);
End;
Procedure ReadSeqType(Var v: Typ);
Var first : boolean;
optional : boolean;
begin
   nextLex; { ய᪠ ᪮ }
   first:=true; optional:=false;
   new(v.seq); v.sl:=0;
   repeat
    case curlex of
     _rsk : begin  nextlex; break; End;
     _optional:
       begin
        if v._type<>_seq then error('ࠢ쭮 ᯮ짮 optional');
        optional:=true; nextlex;
       end;
     _zap : begin
             if first then Error('ࠢ쭮 ᠭ ⨯ ᫥⥫쭮/⢠ (  ,} ) ');
              first:=true; nextlex; optional:=false; Continue; End;
     else begin
           inc(v.sl);
           new(v.seq^[v.sl]);
           readType(v.seq^[v.sl]^);
           v.seq^[v.sl]^._opt:=optional;
           first:=false;
          End;
    end;
   until curlex=_rsk;
   nextlex;
End;

Procedure Readtype(Var v :Typ);
Var c1, c2 : PSV;
q : Typ;
first : boolean;
procedure readOfType;
Begin
 getmem(v.seq, sizeof(ptyp));
 new(v.seq^[1]); nextlex;
 readType(v.seq^[1]^);
End;
Procedure ReadLimited;
Begin
   if (curlex=_value)  or (curlex=_strng) or (not findtype(ss, v)) then
              begin
               readConst(c1);
               if curlex<>_dvt then error(' ..');
               nextlex;
               readconst(c2);
               if testmode then exit;
               if (c1._type<>c2._type) or ((c1._type<>_ordinal) and
                (c1._type<>_integer) and (c1._type<>_string)) then error('ࠢ쭮 ᠭ ᫨ ⨯');
               if (c1._type=_string) and (length(c1.s^)<>1) and
                (length(c2.s^)<>1) then
                 error('ࠢ쭮 ᠭ ࠭祭 ⨯');
               if (c1._type=_ordinal) and (c1.link<>c2.link) then
                error('ࠢ쭮 ᠭ ࠭祭 ⨯');
               v._type:=_limited;
               if c1._type=_string then
                begin v.f:=ord(c1.s^[1]); v.e:=ord(c2.s^[1]); End
                else begin v.f:=c1.i; v.e:=c2.i; End;
               v.link:=c1.link;
              end
             else begin nextlex; exit; End;
End;
Begin
repeat
 case curlex of
  _seqUn    :
    begin nextlex; readType(q); unionTypes(v, q); end;
  _int      : begin v._type:=_integer; nextlex; End;
  _str      : begin v._type:=_string; nextlex; End;
  _bool     : begin v._type:=_boolean; nextlex; End;
  __char      : begin v._type:=_char; nextlex; End;
  _sequence :
         begin
           Nextlex;
           case curlex of
             _lsk : begin v._type:=_seq; ReadSeqType(v); end;
             _of  : begin
                      v._type:=_seqof;
                      readoftype;
                    end;
           End;
         End;
  _multi : begin
            nextlex; if curlex<>__set then error(' ᫮ SET');
            nextlex; if curlex<>_of then error(' ᫮ OF');
            v._Type:=_msetof;
            readOfType;
           End;
  __set   : begin
            nextlex;
            case curlex of
             _of  : Begin v._Type:=_setof; ReadOFType; End;
             _lsk  : begin v._type:=_set; ReadSeqType(v); End;
            end;
           End;
  _ident, _value, _strng :  readLimited;
   _lsk: begin nextlex;
               if (curlex<>_ident) or ((curlex=_ident) and exist(ss)) then
                begin
                  readConst(c1);
                  if curlex<>_rsk then error(' ) ( 騩 䨪)');
                  nextlex;
                  if curlex<>_dvt then error(' ..');
                  nextlex;
                  readconst(c2);
                  if testmode then exit;
                  if (c1._type<>c2._type) or ((c1._type<>_ordinal) and
                   (c1._type<>_integer)) then error('ࠢ쭮 ᠭ ᫨ ⨯');
                  if (c1._type=_ordinal) and (c1.link<>c2.link) then
                   error('ࠢ쭮 ᠭ ࠭祭 ⨯');
                  v._type:=_limited;
                  v.f:=c1.i;
                  v.e:=c2.i; v.link:=c1.link;
                end
               else if findtype(ss,v) then
                begin
                 nextlex;
                 if curlex<>_rsk then error('ࠢ쭮 ᠭ ⨯');
                 nextlex;
                End else {⠥ ᫨ ⨯}
                begin
                  inc(lptr); new(links[lptr]); llen[lptr]:=-1;
                  first:=true;
                  repeat
                   case curlex of
                    _ident:
                         begin
                          if first=false then error(' 墠⠥ ࠧ⥫');
                          if (testmode) and QExist(ss) then error('७ 䨪');
                          inc(llen[lptr]);
                          links[lptr]^[llen[lptr]]:=ss;
                          first:=false;
                          nextlex;
                         End;
                    _zap  :
                       begin
                        if first then error(' ');
                        nextlex; first:=true;
                       End;
                    _rsk: if first then error('ࠢ쭮 ᠭ ⨯');
                   End;
                  until curlex=_rsk;
                 nextlex; v._type:=_ordinal; v.link:=lptr;
                End;
         end
    else error(' ᠭ ⨯');
 End;
 until curlex<>_seqUn;
End;
Procedure ReadTDef(Var v : SType);
Var i : integer;
Begin
 if curlex<>_ident then error('  ६');
{ v._name:=copy(ss,1,8);
 check(v._name);}
 nextlex;
 if curlex<>_eq then Error('  =');
 NEXTLEX;
 readType(v.r);
End;
Procedure ReadConsts;
Begin
 while curlex<>_eof do
  begin
   case curLex of
    _define :
    begin
        nextLex;
        case curlex of
         _constant : begin
                      NextLex;
                      inc(vctr);
                    {  new(vars[vptr]);}
                      readCDef(vars[vctr]^);
                      if (curlex<>_eof) and (curlex<>_sk) then
                       error(' ;');
                      nextlex;
                     End;
         _Type :
          begin repeat
                  nextlex;
                 until (curlex=_define) OR (CURLEX=_EOF); continue; End;
         else error(' constant  type ');
        end;
    End;
    _comment: begin nextlex; continue; End;
    else error(' define');
   End;
  end;
End;

Procedure Readtypes;
Begin
  while curlex<>_eof do
  begin
   case curLex of
    _define :
    begin
        nextLex;
        case curlex of
         _constant : begin
                      repeat
                        nextlex;
                      until (curlex=_define) OR (CURLEX=_EOF); continue;
                     End;
         _Type :
          begin
            NextLex;
            inc(tctr);
            {new(types[tptr]);}
            readTDef(types[tctr]^);
            if (curlex<>_eof) and (curlex<>_sk) then
            error(' ;');
            nextlex;
          end;
         else error(' constant  type ');
        end;
    End;
    _comment: begin nextlex; continue; End;
    else error(' define');
   End;
  end;
End;
Procedure ReadAllNames;
Begin
  while curlex<>_eof do
  begin
   case curLex of
    _define :
    begin
        nextLex;
        case curlex of
         _constant : begin
                      NextLex;
                      inc(vptr);
                      new(vars[vptr]);
                      if curlex<>_ident then error('  ६');
                      vars[vptr]^._name:=copy(ss,1,8);
                      check(vars[vptr]^._name,1,0);
                      repeat
                        nextlex;
                      until (curlex=_define) OR (CURLEX=_EOF); continue;
                     End;
         _Type :
          begin
            NextLex;
            inc(tptr);
            new(types[tptr]);
            if curlex<>_ident then error('  ६');
            types[tptr]^._name:=copy(ss,1,8);
            check(types[tptr]^._name,0,1);
            repeat
             nextlex;
            until (curlex=_define) OR (CURLEX=_EOF); continue;
          end;
         else error(' constant  type ');
        end;
    End;
    _comment: begin nextlex; continue; End;
    else error(' define');
   End;
  end;
End;
Procedure Out(Var v : psv);
Var i : integer;
Begin
 case v._type of
  _string: begin
            write('"');
            for i:=1 to length(v.s^) do
             begin write(v.s^[i]); if v.s^='"' then write('"'); End;
            write('"');
           end;
  _integer: write(v.i);
  _limited: begin
             if v.link=-1 then write(v.i) else
             if v.link=-2 then write(chr(v.i)) else
             write(links[v.link]^[v.i]);
            End;
  _ordinal: write(links[v.link]^[v.i]);
  _boolean: case v.b of
             true: write('true');
             false: write('false');
            end;
  _seq, _un, _set :
    begin write('{');
          for i:=1 to v.sl do
           begin
            out(v.seq^[i]); if i<v.sl then Write(', ');
           End;
          write('}');
    End;
  End;
End;
Procedure MakeType(Var v : psv);
Var i : integer;
Begin
 case v._type of
  _string: write('string');
  _integer: write('integer');
  _boolean: write('boolean');
  _seq, _un, _set :
    begin if v._type in [_seq, _un] then write('sequence (') else
          write('set (');
          if v.sl=0 then write('optional integer)');
          for i:=1 to v.sl do
           begin
            makeType(v.seq^[i]); if i<v.sl then Write(', ') else write(')');
           End
    End;
  End;
End;
Function eq(var s : PSV; t: Typ): boolean;
Var i,j   :  integer;
    a,b     : array [0..100] of byte;
Function search(q : integer):boolean;
Var j  : integer;
Begin
 for j:=1 to t.sl do
  begin
   if (b[a[j]]=0) and (eq(s.seq^[q], t.seq^[j]^)) then
    begin
     if a[j]=0 then begin a[j]:=q; exit; end;
     b[a[j]]:=1; if (search(a[j]))  then begin a[j]:=q; exit; end;
    end;
  end;
  search:=false;
End;
Begin
 if ((s._type =_ordinal) or (s._type=_integer)) and (t._type=_limited) and (s.link=t.link) and
  (s.i>=t.f) and (s.i<=t.e) then begin eq:=true; Exit; End;
 if (t._type=_limited) and (t.link=-2) and (s._type=_string) and
  (length(s.s^)=1) and (ord(s.s^[1])>=t.f) and (ord(s.s^[1])<=t.e)
   then begin eq:=true; Exit; End;
 if (t._type=_char) and (length(s.s^)=1) then begin eq:=true; exit; end;
 if (s._type and t._type) =0  then begin eq:=false; Exit; end;
 if ((s._type =_ordinal) or (s._type=_limited)) and (s.link<>t.link) then
  begin eq:=false; exit; end;
 if (s._type=t._type) and (s._type<>_seq) and (s._type<>_un) and (s._type<>_set) then
 Begin eq:=true; exit; End;
 case t._type of
  _seqOf, _msetof, _setof :
    begin
      for i:=1 to s.sl do
       if not eq( s.seq^[i], t.seq^[1]^) THEN BEGIN EQ:=FALSE; Exit; End;
     eq:=true;
    end;
  _seq   :
    begin
     a[0]:=0;
     fillchar(a, sizeof(a),0);
     fillchar(b, sizeof(b), 0); b[0]:=1; a[0]:=0;
     if s.sl=0 then
      begin
       for i:=1 to t.sl do
        if not t.seq^[i]^._opt then Begin eq:=false; exit; End;
       eq:=true;
       exit;
      end;
     for i:=1 to s.sl do
     begin
      for j:=1 to t.sl do
       begin
        if t.seq^[j]^._opt then a[j]:=a[j-1] else a[j]:=0;
         a[j]:=a[j] or (b[j-1] and byte(eq(s.seq^[i],t.seq^[j]^)));
       end;
       b:=a;
     end;
     eq:=(a[t.sl]=1);
    end;
{ ந ᨬ쭮 ⠭}
  _set :
   begin
    fillchar(a, sizeof(a), 0);
    b[0]:=0;
    for i:=1 to s.sl do
     begin
      fillchar(b, sizeof(b), 0);
      if not SEARCH(i) then begin eq:=false; exit; end;
     end;
   end;
  else eq:=false;
 End;

End;
Procedure Done;
Var i,j  : integer;
was : boolean;
begin
 for i:=1 to vptr do
  begin
   was:=false;
   write(vars[i]^._name,' : ');
   for j:=1 to tptr do
    begin
     if eq(vars[i]^.r, types[j]^.r) then
      begin write(types[j]^._name,' '); was:=true; End;
    end;
   if not was then Maketype(vars[i]^.r);
   write('= ');
   out(vars[i]^.r);
   writeln;
  end;
End;
Procedure Init;
Begin
 assign(input,'program.ddl'); Reset(input);
 assign(output,'program.out'); Rewrite(output);
 NextCh; Nextlex;
end;
Procedure SortTypes(l, r: integer);
Var i, j : integer;
 x : str8;
 y : PSType;
Begin
  i := l; j := r; x := types[(l+r) DIV 2]^._name;
  repeat
    while types[i]^._name < x do i := i + 1;
    while x < types[j]^._name do j := j - 1;
    if i <= j then
    begin
      y := types[i]; types[i] := types[j]; types[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortTypes(l, j);
  if i < r then SortTypes(i, r);
End;
Procedure Sortnames(l, r : integer);
Var i, j : integer;
   x : str8;
   y : PVariable;
begin
  i := l; j := r; x := vars[(l+r) DIV 2]^._name;
  repeat
    while vars[i]^._name < x do i := i + 1;
    while x < vars[j]^._name do j := j - 1;
    if i <= j then
    begin
      y := vars[i]; vars[i] := vars[j]; vars[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortNames(l, j);
  if i < r then SortNames(i, r);
End;
Procedure ResetData;
Begin
  close(input); reset(input);
 clinenumber:=1; nextch; nextlex;
End;
Begin
 clinenumber:=1;
 init; testmode:=true;
 readAllNames; resetData;
 {⠥ । ᫨ ⨯}
 readTypes; resetData;
 {_______________________________}
 testmode:=false;
 ReadConsts;  ResetData;
 lptr:=0; tctr:=0;
 ReadTypes;
 if vptr>1 then SortNames(1, Vptr);
 if tptr>1 then SortTypes(1,Tptr);
 Done;
End.


