Program BinaryWords; {$M 65521,0,0}

Const NMax = 10000;

Type TStr = Array [1..NMax] Of Char;

Var A,B : TStr;
    N : Integer;

Procedure Init;
Var i : Integer;
Begin
  Assign(Input,'Input.Txt');
  Reset(Input);
  ReadLn(N);
  For i:=1 To N Do Read(A[i]);
  ReadLn;
  For i:=1 To N Do Read(B[i]);
  Close(Input);

  Assign(Output,'Output.Txt');
  Rewrite(Output);
  WriteLn('YES');
End;

Procedure Reverse(Var S : TStr; i,j : Integer);
Var ch : Char;
Begin
  While i<j Do
  Begin
    ch:=S[i]; S[i]:=S[j]; S[j]:=ch;
    Inc(i); Dec(j);
  End;
End;

Procedure Normalize(Var S : TStr; b : Boolean);
Var A : Array [1..NMax] Of Integer;
    i,j,Cnt : Integer;
Begin
  Cnt:=0;
  For i:=1 To N Do
    If S[i]='1' Then Inc(Cnt);

  For i:=1 To Cnt-1 Do
    If S[i]='1' Then A[i]:=0
    Else Begin
      j:=i;
      Repeat Inc(j) Until S[j]='1';
      Repeat Inc(j) Until S[j]='1';
      Reverse(S,i,j);
      A[i]:=j;
    End;

  If b Then
    For i:=1 To Cnt-1 Do
      If A[i]<>0 Then WriteLn(i,' ',A[i]) Else
  Else
    For i:=Cnt-1 DownTo 1 Do
      If A[i]<>0 Then WriteLn(i,' ',A[i]);
End;

Procedure Solve;
Begin
  Normalize(A,True);
  Normalize(B,False);
End;

Procedure Done;
Var i : Integer;
    Ok : Boolean;
Begin
  Ok:=True;
  For i:=1 To N Do Ok:=Ok And (A[i]=B[i]);
  If Not Ok Then
  Begin
    Rewrite(Output);
    WriteLn('NO');
  End;
  Close(Output);
End;

Begin
  Init;
  Solve;
  Done;
End.