{ 1995-1996 ACM International Collegiate Programming Contest }
{                  Western European Regional                 }

Program Donkey2; { Full searching }

Const MaxN = 4;

Var P : Array [1..MaxN] Of Integer;
    M,N,First : Integer;

Procedure Init;
Begin
  Assign(Input,'Input.Txt');
  Reset(Input);
  Assign(Output,'Output.Txt');
  Rewrite(Output);
End;

Procedure ReadData;
Var i : Integer;
Begin
  Read(M,N);
  For i:=1 To N Do Read(P[i]);
  Read(First);
End;

Function Rec(Who : Integer) : Real;
Var i,j,k,t,Old : Integer;
    S : Real;
Begin
  If Who>N Then Who:=1;
  Old:=P[Who]; S:=0;

  For i:=1 To 6 Do
  Begin
    k:=Old+i-1;
    Repeat
      Inc(k); j:=1;
      While (j<=N) And (P[j]<>k) Do Inc(j);
    Until j>N;

    If k>M Then S:=S+Ord(Who=1)
    Else Begin
      P[Who]:=k;
      S:=S+Rec(Who+1);
      P[Who]:=Old;
    End;
  End;
  Rec:=S/6;
End;

Procedure Solve;
Var K,i : Integer;
Begin
  {ReadLn(K);} K:=1;
  For i:=1 To K Do
  Begin
    ReadData;
    {WriteLn('Game ',i,':the probability that player 1 wins = ',Rec(First):5:3);}
    WriteLn(Rec(First):5:3);
  End;
End;

Procedure Done;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  Init;
  Solve;
  Done;
End.