Program Divide;

Const
  Nmax=1002;

Type
    Point = Record
              x,y : integer;
            End;
      Otr = Record
              a,b : Point;
              G : Boolean;
            End;

     Map = Array [1..NMax] of Otr;
Var Kn,P  : Map;
    M1,M2 : Point;
    N,M   : Integer;

Function Bol(a,b : Point) : boolean;
Begin
  If A.y>B.y
    Then Bol:=True
    Else
      If A.y<B.y then Bol:=False
                 else Bol:=A.x<B.x;
End;

Procedure Swap(VAr a,b : Point);
VAr c : Point;
Begin
  c:=a;
  a:=b;
  b:=c;
End;

Procedure Init;
Var inp : text;
    i,j : Integer;
Begin
  Assign(inp,'divide.in');
  Reset(inp);
  Readln(inp,M2.x,M2.y);
  Readln(inp,N);
  For i:=1 to n do
    Begin
      Read(inp,Kn[i].a.x);
      Read(inp,Kn[i].a.y);
      Read(inp,Kn[i].b.x);
      Read(inp,Kn[i].b.y);
      Kn[i].G:=Kn[i].a.y=Kn[i].b.y;
      If Bol(Kn[i].b,Kn[i].a) then Swap(Kn[i].b,Kn[i].a);
    End;
  Close(inp);
End;


Procedure Print;
Var out : text;
      i : Integer;
Begin
  Assign(out,'divide.out');
  Rewrite(out);
  Writeln(out,M);
  For i:=1 to M do
    Begin
     Write(out,P[i].a.x,' ');
     Write(out,P[i].a.y,' ');
     Write(out,P[i].b.x,' ');
     WriteLn(out,P[i].b.y);
    End;
  Close(out);
End;

Procedure Sort;
Var i,j : integer;
      c : boolean;
Begin
  For i:=1 to n do
    For j:=n-1 downto i do
      If Bol(Kn[j+1].a,Kn[j].a) then
        Begin
          Swap(Kn[j+1].a,Kn[j].a);
          Swap(Kn[j+1].b,Kn[j].b);
          c:=Kn[j+1].g;
          Kn[j+1].g:=Kn[j].g;
          Kn[j].g:=c;
        End;

End;

Procedure Solve;
Var i,j : integer;
Begin
  Sort;
  M:=1;
  M1.x:=0;
  M1.y:=0;
  For i:=1 to N do
    Begin
      If Kn[i].g
        Then
          Begin
           P[i].a.x:=M1.x;
           P[i].a.y:=Kn[i].a.y;
           P[i].b:=M2;
           M2.y:=Kn[i].a.y
          End
        Else
         Begin
           P[i].a:=M1;
           P[i].b.x:=Kn[i].a.x;
           P[i].b.y:=M2.y;
           M1.x:=Kn[i].a.x
         End;
      Inc(M);
    End;
  P[m].a:=M1;
  P[m].b:=M2;
End;


Begin
  Init;
  Solve;
  Print;
End.