{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+}
{$M 65520,0,655360}

Program Rail;

Const MaxN=5000;

Type
       Path = Array [1..MaxN] of Integer;
       Road = Record
                w : integer;
                c : boolean;
              End;
        Map = Array [1..MaxN,1..3] of Road;



Var  Need : Boolean;
       Rd : Map;
    Timer : Longint Absolute $40:$6C;
    Saved : Longint;
        N : Integer;
        P : Path;

Procedure Init;
Var inp : text;
    i,j : integer;
Begin
  Assign(inp,'rail.in');
  Reset(inp);
  Readln(inp,N);
  For i:=1 to n do
    For j:=1 to 3 do
      Begin
        Read(inp,Rd[i,j].w);
        Rd[i,j].c:=False;
      End;
  Close(inp);
End;


Procedure Print;
Var out : text;
    i,j : integer;
Begin
  Assign(out,'rail.out');
  Rewrite(out);
  For i:=1 to N do
    For j:=1 to 3 do
      If (Rd[i,j].c) and (i<Rd[i,j].w) then
        Writeln(out,i,' ',Rd[i,j].w);
  Close(out);
  Halt;
End;



Function FindBad : integer;
Var i : integer;
Begin
  i:=1;
  While ((Rd[i,1].c<>Rd[i,2].c) or (Rd[i,2].c<>Rd[i,3].c)) and (i<=n)
    do Inc(i);
  If i>N then Need:=False;
  FindBad:=i;
End;

Function Isn (v,k : Integer) : boolean;
Var Ans : boolean;
      i : integer;
Begin
  Ans:=False;
  For i:=1 to k do
    Ans:=(Ans) Or (P[i]=v);
  Isn:=Ans
End;

Procedure MakeGood(v,k : integer);
Var i : integer;
Begin
  If (Timer-Saved)/18.2>19 then Print;
  P[k]:=v;
  I:=1;
  While ((Rd[v,i].w=P[k]) or (Isn(Rd[v,i].w,k))) and (i<=3)
     do inc(i);
  If i<4 then MakeGood(Rd[v,i].w,k+1);

End;

Function FindNum(i,k : integer) : integer;
Var j : integer;
Begin
  j:=1;
  While Rd[i,j].w<>k do Inc(j);
  FindNum:=j;
End;

Procedure Change;
Var i,j : integer;
Begin
  i:=1;
  While P[i+1]<>0 do
    Begin
      Rd[P[i],FindNum(P[i],P[i+1])].c:= not (Rd[P[i],FindNum(P[i],P[i+1])].c);
      Rd[P[i+1],FindNum(P[i+1],P[i])].c:=not Rd[P[i+1],FindNum(P[i+1],P[i])].c;

      Inc(i);
    End;
End;

Procedure Solve;
Var b : integer;
Begin
  Need:=true;
  b:=FindBad;
  While Need do
    Begin
      FillChar(P,SizeOf(P),0);
      b:=FindBad;
      If Need then
        Begin
          MakeGood(b,1);
          Change;
        End;
    End;
End;

Begin
  Saved:=Timer;
  Init;
  Solve;
  Print;
End.