{$A-,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
const
  Max = 1000;
var
  PoleX,PoleY:Word;
  NumZ:Word;
  OutFile:Text;
  Zaseki:array[1..Max] of record
    Hor:Boolean;
    A,B:Word;
    L:Word;
  end;
  ResNum,NumRects:Word;
  Res,Rects:array[1..100] of record
    X,Y,X1,Y1:Word;
  end;
  RUsed:array[1..100] of Boolean;

procedure Input;
var
  F:Text;
  I:Integer;
  X,Y,X1,Y1:Word;
begin
  Assign(F,'Divide.IN');
  Reset(F);
  Read(F,PoleX,PoleY);
  Readln(F,NumZ);
  for I:=1 to NumZ do
    begin
      Read(F,X,Y,X1,Y1);
      with Zaseki[I] do
        if Y=Y1 then
          begin
            if X<X1 then
              begin
                A:=X; B:=X1;
              end
            else
              begin
                A:=X1; B:=X;
              end;
            L:=Y;
            Hor:=TRUE;
          end
        else
          begin
            Hor:=FALSE;
            if Y<Y1 then
              begin
                A:=Y; B:=Y1;
              end
            else
              begin
                A:=Y1; B:=Y;
              end;
            L:=X;
          end;
    end;
  Close(F);
  NumRects:=0;
end;

procedure Output;
var
  F:Text;
  I:Integer;
begin
  Assign(F,'Divide.OUT');
  Rewrite(F);
  Writeln(F,ResNum);
  for I:=1 to ResNum do
    with Res[I] do
      Writeln(F,X,' ',Y,' ',X1,' ',Y1);
  Close(F);
end;

procedure OutWrite(A,B,C,D:Word);
begin
  Inc(NumRects);
  Rects[NumRects].X:=A;
  Rects[NumRects].Y:=B;
  Rects[NumRects].X1:=C;
  Rects[NumRects].Y1:=D;
end;

function IsInRect(X,Y:Word):Boolean;
var
  I:Integer;
begin
  for I:=1 to NumRects do
    if Rects[I].X<=X then
      if Rects[I].Y<=Y then
        if Rects[I].X1>=X then
          if Rects[I].Y1>=Y then
            begin
              IsInRect:=TRUE;
              Exit;
            end;
  IsInrect:=FALSE;
end;

function ContVertZas(X,Y,Y1:Word):Boolean;
var
  I:Integer;
begin
  if Y>Y1 then
    begin
      I:=Y;
      Y:=Y1;
      Y1:=I;
    end;
  for I:=1 to NumZ do
    if not Zaseki[I].Hor then
      if Zaseki[I].L=X then
        if ( (Zaseki[I].A<=Y) and (Zaseki[I].B>=Y) ) or
           ( (Zaseki[I].A<=Y1) and (Zaseki[I].B>=Y1) )
        then
            begin
              ContVertZas:=TRUE;
              Exit;
            end;
  ContVertZas:=FALSE;
end;


function ContHorZas(Y,X,X1:Word):Boolean;
var
  I:Integer;
begin
  if X>X1 then
    begin
      I:=X;
      X:=X1;
      X1:=I;
    end;
  for I:=1 to NumZ do
    if Zaseki[I].Hor then
      if Zaseki[I].L=Y then
        if ( (Zaseki[I].A<=X) and (Zaseki[I].B>=X) ) or
           ( (Zaseki[I].A<=X1) and (Zaseki[I].B>=X1) )
        then
            begin
              ContHorZas:=TRUE;
              Exit;
            end;
  ContHorZas:=FALSE;
end;

procedure Run;
var
  CurX,CurY:Word;
  BegX,BegY:Word;
  Brk:Boolean;
  I,J:Word;
begin
  BegX:=0; BegY:=0;
  while TRUE do
    begin
      CurX:=BegX; CurY:=BegY; Brk:=FALSE;
      while not Brk do
        begin
          Inc(CurY);
          for I:=1 to NumZ do
            if Zaseki[I].Hor then
              if Zaseki[I].L<=CurY then
                begin
                  Brk:=TRUE;
                  Break;
                end;
          if CurY>=PoleY then Brk:=TRUE;
        end;

      Brk:=FALSE;
      while not Brk do
        begin
          Inc(CurX);
          for I:=1 to NumZ do
            if Zaseki[I].Hor then
              if (Zaseki[I].A<=CurX) and (Zaseki[I].L<=CurY) then
                begin
                  Brk:=TRUE;
                  Break;
                end
              else
            else
              if Zaseki[I].L<=CurX then
                begin
                  Brk:=TRUE;
                  Break;
                end;
          if CurX>=PoleX then Brk:=TRUE;
        end;
      OutWrite(BegX,BegY,CurX,CurY);

      BegX:=0; BegY:=0; Brk:=TRUE;
      for J:=0 to PoleY do
       if Brk then
        for I:=0 to PoleX do
          if not IsInRect(I,J) then
            begin
              if I>0 then BegX:=I-1 else BegX:=I;
              if J>0 then BegY:=J-1 else BegY:=J;
              Brk:=FALSE;
              Break;
            end;
       if Brk then Break;
    end;

  ResNum:=0;
  for I:=1 to NumRects do
    RUsed[I]:=FALSE;
  Brk:=FALSE;
  while not Brk do
    begin
      Brk:=TRUE;
      for I:=1 to NumRects do
        if not RUsed[I] then
          begin
            Brk:=FALSE;
            Inc(ResNum);
            Res[ResNum]:=Rects[I];
            RUsed[I]:=TRUE;
            Break;
          end;
      if Brk then Break;
      for I:=1 to NumRects do
        if not RUsed[I] then
          if (Res[ResNum].X1=Rects[I].X) and (Res[ResNum].Y=Rects[I].Y)
             and (Res[ResNum].Y1=Rects[I].Y1)
          then
            if not ContVertZas(Rects[I].X,Rects[I].Y,Rects[I].Y1) then
              begin
                RUsed[I]:=TRUE;
                Res[ResNum].X1:=Rects[I].X1;
              end
            else
          else if (Res[ResNum].X=Rects[I].X1) and (Res[ResNum].Y=Rects[I].Y)
             and (Res[ResNum].Y1=Rects[I].Y1)
          then
            if not ContVertZas(Rects[I].X1,Rects[I].Y,Rects[I].Y1) then
              begin
                RUsed[I]:=TRUE;
                Res[ResNum].X:=Rects[I].X;
              end;
    end;

  NumRects:=ResNum;
  Rects:=Res;

  ResNum:=0;
  for I:=1 to NumRects do
    RUsed[I]:=FALSE;
  Brk:=FALSE;
  while not Brk do
    begin
      Brk:=TRUE;
      for I:=1 to NumRects do
        if not RUsed[I] then
          begin
            Brk:=FALSE;
            Inc(ResNum);
            Res[ResNum]:=Rects[I];
            RUsed[I]:=TRUE;
            Break;
          end;
      if Brk then Break;
      for I:=1 to NumRects do
        if not RUsed[I] then
          if (Res[ResNum].Y1=Rects[I].Y) and (Res[ResNum].X=Rects[I].X)
             and (Res[ResNum].X1=Rects[I].X1)
          then
            if not ContHorZas(Rects[I].Y,Rects[I].X,Rects[I].X1) then
              begin
                RUsed[I]:=TRUE;
                Res[ResNum].Y1:=Rects[I].Y1;
              end
            else
          else if (Res[ResNum].Y=Rects[I].Y1) and (Res[ResNum].X=Rects[I].X)
             and (Res[ResNum].X1=Rects[I].X1)
          then
            if not ContHorZas(Rects[I].Y1,Rects[I].X,Rects[I].X1) then
              begin
                RUsed[I]:=TRUE;
                Res[ResNum].Y:=Rects[I].Y;
              end;
    end;
end;

begin
  Input;
  Run;
  Output;
end.