{$A-,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
const
  Max = 5000;
var
  Num:Word;
  Cities:array[1..Max,1..3] of Word;
  OutFile:Text;

function IsWay(I,J:Integer):Boolean;
begin
  IsWay:=(I<=Num) and (J<=Num) and (I>0) and (J>0) and
    ( (Cities[I,1]=J) or (Cities[I,2]=J) or (Cities[I,3]=J) );
end;

procedure Input;
var
  F:Text;
  I:Integer;
begin
  Assign(F,'RAIL.IN');
  Reset(F);
  Readln(F,Num);
  for I:=1 to Num do
    begin
      if SeekEOF(F) then;
      Read(F,Cities[I,1],Cities[I,2],Cities[I,3]);
    end;
  Close(F);

  Assign(OutFile,'Rail.OUT');
  ReWrite(OutFile);
end;

procedure OutWrite(A,B:Integer);
begin
  Writeln(OutFile,A,' ',B);
end;

function CountNoSol:Boolean;
var
  Nums:array[1..Max] of Word;
  I,J:Integer;
begin
  for I:=1 to Num do Nums[I]:=0;
  for I:=1 to Num do
    for J:=I+1 to Num do
      if IsWay(I,J) then
        begin
          Inc(Nums[I]); Inc(Nums[J]);
        end;
  CountNoSol:=TRUE;
  for I:=1 to Num do
    if Nums[I]<>3 then Exit;
  CountNoSol:=FALSE;
end;

procedure Run;
var
  I,J:Integer;
  Was:Boolean;
  Peaks:array[1..Max] of Boolean;
  FrNum,NxNum:Word;
  Fr,Nx:array[1..Max] of Byte;
begin
  for I:=1 to Num do
    Peaks[I]:=FALSE;
  Was:=TRUE;
  FrNum:=2;
  Fr[1]:=1; Peaks[1]:=TRUE;
  Fr[2]:=Cities[1,1]; Peaks[Fr[2]]:=TRUE;
  OutWrite(1,Fr[2]);
  while Was do
    begin
      Was:=FALSE; NxNum:=0;
      for J:=1 to FrNum do
        for I:=1 to Num do
          if not Peaks[I] then
            if IsWay(I,Fr[J]) then
              begin
                Peaks[I]:=TRUE;
                OutWrite(I,Fr[J]);
                Inc(NxNum);
                Nx[NxNum]:=I; Was:=TRUE;
                Break;
              end;
      Fr:=Nx; FrNum:=NxNum;
    end;
end;

begin
  Input;
  if not CountNoSol then Run else Writeln(OutFile,'NO SOLUTION');
  Close(OutFile);
end.