{$A-,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
const
  Max = 2000;
  Step = 10.0;
  EPS  = 1E-4;
var
  N,N1,L:Word;
  Lens,Speeds,Times:array[1..Max] of LongInt;
  Time:Real;

procedure Input;
var
  F:Text;
  I:Integer;
begin
  Assign(F,'Train.IN');
  Reset(F);
  Readln(F,L); Readln(F,N);
  for I:=1 to N do
    begin
      Readln(F,Times[I],Speeds[I]);
      Lens[I]:=Speeds[I]*Times[I];
    end;
  Close(F);

  Time:=0;
end;

procedure Output;
var
  F:Text;
begin
  Assign(F,'Train.OUT');
  Rewrite(F);
  Writeln(F,Time:1:3);
  Close(F);
end;

function Len(var I:Integer; var UsedTime:Real; Time:Real):Real;
var
  L:Real;
begin
  L:=0;
  if Times[I]-UsedTime>=Time then
    begin
      Len:=L+Speeds[I]*Time;
      UsedTime:=Times[I]-Time;
      Exit;
    end
  else
    begin
      Time:=Time-Times[I]+UsedTime;
      L:=L+Speeds[I]*(Times[I]-UsedTime);
    end;
  Inc(I);
  while TRUE do
    begin
      if Time<Times[I] then
        begin
          Len:=L + Speeds[I]*Time;
          UsedTime:=Time;
          Exit;
        end;
      Time:=Time-Times[I];
      L:=L+Lens[I];
      Inc(I);
      if I>N then
        begin
          Len:=L;
          Exit;
        end;
    end;
end;

procedure OutNot;
var
  F:Text;
begin
  Assign(F,'Train.OUT');
  Rewrite(F);
  Writeln(F,'NOT');
  Close(F);
end;

function Min(A,B:Real):Real;
begin
  if A<B then Min:=A
  else Min:=B;
end;

{function CheckTime:Boolean;
var
  T1,T2:Real;
begin
  for I:=1 to N do
    begin

    end;
end;}

function CheckTime:Boolean;
var
  T1,TU:Real;
  L1,L2:Real;
  I,J:Integer;
  Tms:array[1..Max] of Real;
begin
  I:=1; J:=1;
  I:=1; T1:=0; L1:=0;
  while T1<Time do
    begin
      T1:=T1+Times[I];
      L1:=L1+Lens[I];
      Inc(I);
      if I>N then
        begin
          CheckTime:=TRUE;
          Exit;
        end;
    end;

  TU:=0; J:=1; L2:=Len(J,TU,T1-Time);
  while I<=N do
    begin
      L1:=L1+Lens[I];
      L2:=L2+Len(J,TU,Times[I]);
      if L1-L2<L then
        begin
          CheckTime:=FALSE;
          Exit;
        end;
      Inc(I);
    end;
  CheckTime:=TRUE;
end;

procedure Run(Step:Real);
var
  Tim:Real;
begin
  if Step<EPS then Exit;
  repeat
    Time:=Time+Step;
  until CheckTime;
  Tim:=Time-Step;
  repeat
    Time:=(Tim+Time)/2;
    if Time-Tim<EPS then Exit;
  until not CheckTime;
  Run(Time-Tim);
end;

begin
  Input;
  Run(Step);
  Output;
end.