{$A+,B-,D-,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,0}
Type
  TCity=Record
    Way:Array[1..3] Of Integer;
    Who:Array[0..3] Of Byte;
  End;
Var
  City:Array[1..5000] Of TCity;
  n:Integer;

Procedure WriteResult(Can:Boolean);
Var
  i,j:Integer;
Begin
  Assign(Output,'rail.out');
  Rewrite(Output);
  If Not Can Then Write('NO SOLUTION') Else
    For i:=1 To n Do
      For j:=1 To 3 Do
        If (City[i].Who[j]<2) And (City[i].Way[j]>i) Then WriteLn(i,' ',City[i].Way[j]);
  Close(Output);
  Halt;
End;

Procedure ReadData;
Var
  i:Integer;
Begin
  Assign(Input,'rail.in');
  Reset(Input);
  ReadLn(n);
  For i:=1 To n Do
    With City[i] Do
      ReadLn(Way[1],Way[2],Way[3]);
  Close(Input);
  If Odd(n) Or (n<4) Then WriteResult(False);
End;

Function Fill(n:Integer; Var Owner:Byte):Boolean;
Label
  Restart;
Var
  i:Byte;

  Procedure FindWith(w:Byte);
  Var
    i:Byte;
  Begin
    With City[City[n].Way[w]] Do
      If (Way[1]=n) Then Who[1]:=Owner Else
      If (Way[2]=n) Then Who[2]:=Owner Else
      If (Way[3]=n) Then Who[3]:=Owner;
  End;

Begin
Restart:
  With City[n] Do
  Begin
    If (Who[1]>0) And (Who[1]=Who[2]) Then
    Begin
      If Who[2]=Who[3] Then WriteResult(False);
      Owner:=3-Who[1];
      If Who[3]=Owner Then Exit Else Who[3]:=Owner;
      FindWith(3);
      n:=Way[3]; GoTo Restart;
    End Else
    If (Who[2]>0) And (Who[2]=Who[3]) Then
    Begin
      Owner:=3-Who[2];
      If Who[1]=Owner Then Exit Else Who[1]:=Owner;
      FindWith(1);
      n:=Way[1]; GoTo Restart;
    End Else
    If (Who[3]>0) And (Who[3]=Who[1]) Then
    Begin
      Owner:=3-Who[3];
      If Who[2]=Owner Then Exit Else Who[2]:=Owner;
      FindWith(2);
      n:=Way[2]; GoTo Restart;
    End Else
    Begin
      Who[0]:=Owner;
      For i:=1 To 3 Do
        If Who[i]=0 Then
        Begin
          Owner:=3-Who[i-1];
          Who[i]:=Owner;
          FindWith(i);
          GoTo Restart;
        End;
    End;
  End;
End;

Procedure Solve;
Var
  i:Integer;
  Owner:Byte;
Begin
  Owner:=1;
  For i:=1 To n Do
  Begin
    Fill(i,Owner);
    Owner:=3-Owner;
  End;
End;

Begin
  ReadData;
  Solve;
  WriteResult(True);
End.
