{$N+,G+,R-,I-,S-}
{$M 16384,0,655360}
program FTA;

type Rect = record
              xl, xr, yl: integer;
            end;
     zas = record
             x1, y1, x2, y2: integer;
           end;
var n, m, k, i, j: integer;
    xm, ym: integer;
    cr: integer;
    r: array [1..2000] of rect;
    tmpzas: zas;
    outc: integer;
    out: array [1..1010] of zas;
    z: array [1..1010] of Zas;

procedure OutLn (a, b, c, d: integer);
begin
  inc (outc);
  with out[outc] do
  begin
    x1 := a;
    y1 := b;
    x2 := c;
    y2 := d;
  end;
end;

procedure ReadAll;
var i, j: integer;
begin
  assign (input, 'divide.in');
  reset (input);
   readln(xm, ym);
   readln(n);
   for i := 1 to n do
   with z[i] do
     readln(x1, y1, x2, y2);
  close (input);
end;

procedure Sort(l, r: Integer);
var
  i, j, x: integer;
begin
  i := l; j := r; x := z[(l+r) DIV 2].y1;
  repeat
    while z[i].y1 < x do i := i + 1;
    while x < z[j].y1 do j := j - 1;
    if i <= j then
    begin
      tmpzas := z[i]; z[i] := z[j]; z[j] := tmpzas;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure SortI (var a, b: integer);
var c: integer;
begin
  if a > b then begin c := a; a := b; b := c; end;
end;

procedure SortZaseks;
var i, j: integer;
begin
  for i := 1 to n do
  with z[i] do
  begin
    SortI (x1, x2);
    SortI (y1, y2);
  end;
  Sort (1,n);
end;

procedure ProcessZaseka (var z: Zas);
var i, j, l, rr: integer;
begin
  with z do
  begin
    if (x1 = 0) and (x2 = 0) then exit;
    if (x1 = xm) and (x2 = xm) then exit;
    if (y1 = 0) and (y2 = 0) then exit;
    if (y1 = ym) and (y2 = ym) then exit;
  end;
  with z do
  if x1 = x2 then
  begin { Vertical }
    for i := 1 to cr do
      if (r[i].xl < x1) and (r[i].xr > x1) then
        begin
          for j := cr downto i do
            r[j+1] := r[j];
          r[i]. xr := x1;
          r[i+1]. xl := x1;
          inc (cr);
          exit;
        end;
  end else
  begin { Horizontal }
    for i := 1 to cr do
      if (r[i].xr > x1) then begin l := i; break;end;
    for j := cr downto 1 do
      if (r[j].xl < x2) then begin rr := j; break;end;
    for i := l to rr do
    with r[i] do
      outln(xl,yl,xr,y1);
    r[l].yl := y1;
    r[l].xr := r[rr].xr;
    if rr<>l then
      begin
        for i := rr+1 to cr do
          r[i-rr+l] := r[i];
        cr := cr - rr + l;
      end;
  end;

end;

procedure JustDoItNow;
var i, j, cz: integer;
begin
  for cz := 1 to n do
  ProcessZaseka (z[cz]);
 for i := 1 to cr do
 with r[i] do
  OutLn(xl,yl,xr,ym);
end;

procedure Solve;
var i, j: integer;
begin
  SortZaseks;
  cr := 1;
  with r[1] do
  begin
    xl := 0;
    xr := xm;
    yl := 0;
  end;
  outc := 0;
  JustDoItNow;
end;

procedure PrintRes;
var i: integer;
begin
  assign (output, 'divide.out');
  rewrite (output);
  writeln (OutC);
  for i := 1 to OutC do
  with out[i] do
    writeln(x1,' ',y1,' ',x2,' ',y2);
  close (output);
end;

begin
  ReadAll;
  Solve;
  PrintRes;
end.