{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
Program Task3;

Const MaxC=5000;

Type TCity = Record
               R:Array[1..3] Of Integer;
             End;
Type TGive = Record
               From,_To:Integer;
             End;

Var C:Array[1..MaxC] Of TCity;
    ToGive:Array[1..MaxC] Of TGive;
    MaxGive,N:Integer;

Function Matr(From,_To:Integer):Byte;
Var Exist:Boolean;
    I:Integer;
    R:Byte;
Begin
  With C[From] Do
    If (R[1]=_To) Or (R[2]=_To) Or (R[3]=_To) Then
      Exist:=True Else Exist:=False;
  If Exist Then Begin
    R:=1;
    If MaxGive>0 Then
      For I:=1 To MaxGive Do
        If ((ToGive[I].From=From) And (ToGive[I]._To=_To)) Or
           ((ToGive[I].From=_To) And (ToGive[I]._To=From)) Then
             Begin
               R:=2;Break;
             End;
  End Else R:=0;
  Matr:=R;
End;

Procedure Inp;
Var FN:String;
    F:Text;
    I:Integer;
Begin
  Write('Input  file (Press <ENTER> for RAIL.IN):  ');ReadLn(FN);
  If FN='' Then FN:='RAIL.IN';

  Assign(F,FN);
  Reset(F);

  ReadLn(F,N);
  For I:=1 To N Do With C[I] Do ReadLn(F,R[1],R[2],R[3]);

  Close(F);
End;

Function GivenLinks(X:Integer):Byte;
Var L:Byte;
Begin
  L:=0;
  If Matr(X,C[X].R[1])=2 Then Inc(L);
  If Matr(X,C[X].R[2])=2 Then Inc(L);
  If Matr(X,C[X].R[3])=2 Then Inc(L);
  GivenLinks:=L;
End;

Function Solved:Boolean;
Var I:Integer;
    Z:Byte;
    Slv:Boolean;
Begin
  Slv:=True;
  For I:=1 To N Do Begin
    Z:=GivenLinks(I);
    If (Z=3) Or (Z=0) Then Begin
      Slv:=False;
      Break;
    End;
  End;
  Solved:=Slv;
End;

Procedure Solve;
Var I:Integer;
    Z1,Z2:Byte;
Begin
  I:=1;
  MaxGive:=0;
  Repeat
    If (GivenLinks(I)=0) Then Begin
      Inc(MaxGive);
      With ToGive[MaxGive] Do Begin
        From:=I;
        If (GivenLinks(C[I].R[1])<2) Then _To:=C[I].R[1] Else
        If (GivenLinks(C[I].R[2])<2) Then _To:=C[I].R[2] Else
        If (GivenLinks(C[I].R[3])<2) Then _To:=C[I].R[3];
      End;
    End Else Inc(I);
  Until (Solved) Or (I>N);
End;

Procedure Outp;
Var F:Text;
    FN:String;
    I:Integer;
Begin
  Write('Output file (Press <ENTER> for RAIL.OUT:) ');ReadLn(FN);
  If FN='' Then FN:='RAIL.OUT';

  Assign(F,FN);
  Rewrite(F);

  If Not Solved Then WriteLn(F,'NO SOLUTION') Else
    For I:=1 To MaxGive Do WriteLn(F,ToGive[I].From,' ',ToGive[I]._To);

  Close(F);
End;

Begin
  Inp;
  Solve;
  Outp;
End.