{ $DEFINE DEBUG}
Program Task4;
{$IFDEF DEBUG}
Uses Crt;
{$ENDIF}

Const InputFile='FILYA.IN';
      OutFile  ='FILYA.OUT';

Type TField = Array[1..45,1..41] Of Byte;

Var S,NF:TField;
    Try:Array[1..6] Of TField;
    Turn:Byte;
    HowMany:Integer;
    Finish:Boolean;

Procedure Inp;
Var F:Text;
    St:String;
    I,J:Integer;
Begin
  Assign(F,InputFile);
  Reset(F);
  For I:=1 To 41 Do Begin
    ReadLn(F,St);
    For J:=1 To 45 Do Begin
      S[J,I]:=Ord(St[J])-48;
    End;
  End;
  Close(F);
End;

{$IFDEF DEBUG}
Procedure View(M:TField);
Var I,J:Integer;
Begin
  TextAttr:=$07;
  ClrScr;
  GotoXY(1,1);
  For I:=1 To 41 Do Begin
    For J:=1 To 45 Do Begin
      If M[J,I]=9 Then TextAttr:=$7F Else TextAttr:=M[J,I]*16+0;
      Write(Chr(M[J,I]+48));
    End;
    WriteLn;
  End;
  TextAttr:=$07;
End;
{$ENDIF}

Procedure Mark(Var M:TField;X,Y:Integer;N:Byte);
Begin
  If (X>0) And (X<46) And (Y>0) And (Y<42) Then
    If ((M[X,Y]=S[1,1]) And (N=8)) Or (M[X,Y]=N) Then Begin
      M[X,Y]:=9;
      Inc(HowMany);
      Finish:=False;
    End;
End;

Procedure TryFill(Var M:TField;N:Byte);
Var I,J:Integer;
Begin
  HowMany:=1;
  M[1,1]:=9;
  Repeat
    Finish:=True;
    For I:=1 To 41 Do For J:=1 To 45 Do
      If M[J,I]=9 Then Begin
        Mark(M,J,I-1,N);
        Mark(M,J,I+1,N);
        Mark(M,J+1,I,N);
        Mark(M,J-1,I,N);
  {      Mark(M,J-1,I-1,N);
        Mark(M,J+1,I-1,N);
        Mark(M,J-1,I+1,N);
        Mark(M,J+1,I+1,N);}
      End;
  Until Finish;

  {$IFDEF DEBUG}
  View(M);
  WriteLn('Fill by ',N,', filled=',HowMany);
  ReadKey;
  {$ENDIF}
End;

Procedure Solve;
Var I,Score,BestScore:Integer;
    Best:Byte;
Begin
  NF:=S;
  TryFill(NF,8);
  Best:=0;
  BestScore:=0;
  For I:=1 To 6 Do If (S[1,1]<>I) And (S[45,41]<>I) Then Begin
    Try[I]:=NF;
    TryFill(Try[I],I);
    If HowMany>BestScore Then Begin
      BestScore:=HowMany;
      Best:=I;
    End;
  End;
  If Best=0 Then Begin
    Repeat
      Turn:=Random(6)+1;
    Until (S[1,1]<>Turn) And (S[45,41]<>Turn);
  End Else Turn:=Best;
End;

Procedure Outp;
Var F:Text;
Begin
  Assign(F,OutFile);
  Rewrite(F);
  WriteLn(F,Turn);
  Close(F);
End;

Begin
  Randomize;
  Inp;
  {$IFDEF DEBUG}
  TextMode(CO80+Font8X8);
  View(S);
  ReadKey;
  {$ENDIF}
  Solve;
  Outp;
End.