{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
Program Task5;
{Uses Graph,Crt;}

Const InputFile='TRAIN.IN';
      OutFile  ='TRAIN.OUT';

      Dt=0.0005;

Var L,N:LongInt;
    T,V:Array[0..1000] Of Real;
    MinTime,MaxTime,DelayTime,MaxWay:Real;

Procedure Inp;
Var F:Text;
    I:Integer;
Begin
  Assign(F,InputFile);
  Reset(F);
  ReadLn(F,L);
  ReadLn(F,N);
  For I:=1 To N Do ReadLn(F,T[I],V[I]);
  Close(F);
End;

Function Try:Boolean;
Var Time:Real;
    T1,X1,T2,X2:Real;
    N1,N2:Integer;

Begin
{  ClearDevice;}
  T1:=0;T2:=0;
  X1:=0;X2:=0;
  N1:=1;N2:=0;

  Time:=0;

  T[0]:=DelayTime;
  V[0]:=0;

  Repeat
    X1:=X1+Dt*V[N1];
    If (Time-T1)>=T[N1] Then Begin
      T1:=Time;
      Inc(N1);
    End;
    X2:=X2+Dt*V[N2];
    If (Time-T2)>=T[N2] Then Begin
      T2:=Time;
      Inc(N2);
    End;
{    PutPixel(Round(Time*10),Round(X1/10),15);
    PutPixel(Round(Time*10),Round(X2/10),13);}
    Time:=Time+Dt;
  Until ((X1-X2<L) And (Time>=DelayTime)) Or (X1>=MaxWay);
  If (X1-X2<L) Then Try:=False Else Try:=True;
End;

Procedure Solve;
Var I:Integer;
    Gd,Gm:Integer;
    Found:Boolean;
Begin
{  Gd:=Detect;
  InitGraph(Gd,Gm,'G:\BP\BGI');}
  MaxWay:=0;
  MaxTime:=0;
  For I:=1 To N Do Begin
    MaxWay:=MaxWay+T[I]*V[I];
    MaxTime:=MaxTime+T[I];
  End;

  MinTime:=0;

  Found:=False;
  Repeat
    DelayTime:=(MinTime+MaxTime)/2;
    Found:=Try;
    If Found Then MaxTime:=DelayTime Else MinTime:=DelayTime;
  Until MaxTime-MinTime<Dt;

  DelayTime:=(MinTime+MaxTime)/2;
  DelayTime:=Round(DelayTime*1000)/1000;
End;

Procedure Outp;
Var F:Text;
Begin
  Assign(F,OutFile);
  Rewrite(F);
  WriteLn(F,DelayTime:8:3);
  Close(F);
End;

Begin
  Inp;
  Solve;
  Outp;
End.