

#include <stdio.h>
#include <alloc.h>

FILE *in, *out;
int towns;
struct edge
{      int to;
       unsigned char col;
} cc[5001][3];
int *fre;

void swap(int& x, int& y)
{    int t=x;
     x=y;
     y=t;
}
void io()
{
        fscanf(in,"%d",&towns);
        if(towns%2)
        {       fprintf(out," NO SOLUTION \n");
                return;
        }
        int i;
        int m,n,k;
        int l;
        int c;
        for(i=1;i<=towns;i++)
        {
                cc[i][0].to=cc[i][1].to=cc[i][2].to=0;
                fre[i]=0;
        }
        for(i=1;i<=towns;i++)
        {      fscanf(in,"%d%d%d",&m,&n,&k);
               if(m>n)swap(m,n);
               if(m>k)swap(m,k);
               if(n>k)swap(n,k);
                // m<n<k
               if(fre[i]>2)continue;
               if(k<i)continue;

               if(n<i)         // one (k) left
               {if(cc[i][0].col==cc[i][1].col)
                {               cc[i][fre[i]].col=1-cc[i][0].col;
                                cc[i][fre[i]++].to=k;
                                cc[k][fre[k]].to=i;
                                cc[k][fre[k]++].col=1-cc[i][0].col;
                }
                else
                {
                                cc[i][fre[i]].col=1-cc[k][0].col;
                                cc[i][fre[i]++].to=k;
                                cc[k][fre[k]].to=i;
                                cc[k][fre[k]++].col=1-cc[k][0].col;
                }
               }
               else if(m<i)
               {c=1-cc[k][0].col;


                                cc[i][fre[i]].col=c;
                                cc[i][fre[i]++].to=k;
                                cc[k][fre[k]].to=i;
                                cc[k][fre[k]++].col=c;

                                cc[i][fre[i]].col=1-c;
                                cc[i][fre[i]++].to=n;
                                cc[n][fre[n]].to=i;
                                cc[n][fre[n]++].col=1-c;

               }
               else
               {c=1-cc[k][0].col;
                                cc[i][fre[i]].col=1-c;
                                cc[i][fre[i]++].to=m;
                                cc[m][fre[m]].to=i;
                                cc[m][fre[m]++].col=1-c;

                                cc[i][fre[i]].col=c;
                                cc[i][fre[i]++].to=k;
                                cc[k][fre[k]].to=i;
                                cc[k][fre[k]++].col=c;

                                cc[i][fre[i]].col=1-c;
                                cc[i][fre[i]++].to=n;
                                cc[n][fre[n]].to=i;
                                cc[n][fre[n]++].col=1-c;

               }

        }
        for(i=1;i<=towns;i++)
        {      for(int j=0;j<=2;j++)
               if(cc[i][j].col)
               {              fprintf(out," %d %d \n",i,cc[i][j].to);
                              int dest=cc[i][j].to;
                              for(l=0;l<=2;l++)
                              {
                                if(cc[dest][l].to==i)
                                {       cc[dest][l].col=0;
                                        break;
                                }
                              }
               }
        }
}

int main(void)
{

   if ((in = fopen("rail.in", "rt"))
       == NULL)
   {
      fprintf(stderr, "Cannot open input file.\n");
      return 1;
   }

   if ((out = fopen("rail.out", "wt"))
       == NULL)
   {
      fprintf(stderr, "Cannot open output file.\n");
      return 1;
   }
   if ((fre = (int *) malloc(11000)) == NULL)
{
   printf("Not enough memory to allocate buffer\n");
   return(1);  /* terminate program if out of memory */
}


   io();
   free(fre);
   fclose(in);
   fclose(out);
   return 0;
}
