{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
Program P0705_5;
Uses Crt;

Var fin,fout:text;
    i,j,k:longint;
    L,N:integer;
    T,V:Array[1..1000] of Integer;
    Tp,Sp:Array[0..1000] of Longint;

procedure Normalize;
begin
  Tp[0]:=0;
  Sp[0]:=0;
  for i:=1 to N do begin
    Tp[i]:=Tp[i-1]+T[i];
    Sp[i]:=Sp[i-1]+longint(T[i])*V[i];
  end;
end;

procedure ReadFile;
begin
  Assign(fin,'train.in');
  Reset(fin);
  Read(fin,L,N);
  for i:=1 to N do
  Read(fin,T[i],V[i]);
  Close(fin);
end;

function Pos(Tn:Real):Real;
var i,wp:integer;
begin
  wp:=(N div 2)-1;
  if Tn<Tp[wp] then wp:=wp-1-(N div 4) else wp:=wp+(N div 4);
  if Tn<Tp[wp] then wp:=wp-1-(N div 8) else wp:=wp+(N div 8);
  if Tn<Tp[wp] then wp:=wp-1-(N div 16) else wp:=wp+(N div 16);

  if wp<0 then wp:=0;
  for i:=wp to N-1 do if (Tp[i]<=Tn) and (Tp[i+1]>=Tn) then begin
    Pos:=Sp[i]+V[i+1]*(Tn-Tp[i]);
  end;
  if Tn>Tp[N] then Pos:=Sp[N]+L+L+L;
  if Tn<0 then Pos:=-L-L-L;
end;

function MinRast(Td:Real):Real;
var min,mm:real;
    i:integer;
begin
  min:=1000000;
  for i:=0 to N-1 do begin
    mm:=Pos(Tp[i]+Td)-Sp[i];
    {WriteLn(mm);}
    if mm<min then min:=mm;
  end;

  for i:=1 to N do begin
    mm:=Sp[i]-Pos(Tp[i]-Td);
    {WriteLn(mm);}
    if mm<min then min:=mm;
  end;

  MinRast:=min;
end;

procedure PrintData;
begin
  ClrScr;
  WriteLn('L=',L);
  WriteLn('N=',N);
  for i:=1 to N do
  WriteLn(T[i],',',V[i],' - ',Tp[i],',',Sp[i]);
  WriteLn;
end;

procedure WriteFile;
begin
  Assign(fout,'train.out');
  ReWrite(fout);
  WriteLn(fout,j div 1000,'.',j mod 1000);
  Close(fout);
end;

var Int,St:Real;
label q;
begin
  ReadFile;
  Normalize;
  {PrintData;}
  Int:=Tp[N];
  St:=Int;

q:St:=St/2;
  If St>0.0002 then begin
    if MinRast(Int)>L then Int:=Int-St else Int:=Int+St;
    goto q;
  end;

  j:=trunc(1000*Int);
  if MinRast(j/1000)<L then j:=j+1;
  {WriteLn('MR=',MinRast(j/1000));}
  {WriteLn('Dt=',j div 1000,'.',j mod 1000);
  WriteLn;}
  WriteFile;
  {WriteLn(MinRast(10));}
end.