program s0707_4;

type cell = 1..6;
var fld: array [1..41, 1..45] of cell;
type iarr = array [0..65520 div 2] of integer;
     piarr = ^iarr;
     TScore = array [cell] of integer;

procedure ReadField;
var i, j: integer;
    s: string;
begin
  for i := 1 to 41 do begin
    Readln(s);
    for j := 1 to 45 do begin
      fld[i, j] := ord(s[j])-ord('0');
    end;
  end;
end;

procedure Sol(sx, sy: integer; var count: TScore);
var fld2: array [1..41, 1..45] of boolean;
    pnum1, pnum2: integer;
    ptr1, ptr2: piarr;

type pInteger = ^integer;

  procedure p1Get(n: integer; var x, y: integer; var c: cell);
  begin
    x := ptr1^[(n-1)*2];
    y := ptr1^[(n-1)*2+1];
    c := fld[x, y];
  end;

  procedure p2Get(n: integer; var x, y: integer; var c: cell);
  begin
    x := ptr2^[(n-1)*2];
    y := ptr2^[(n-1)*2+1];
    c := fld[x, y];
  end;

  procedure p1Add(x, y: integer);
  begin
    inc(pnum1);
    ptr1^[(pnum1-1)*2] := x;
    ptr1^[(pnum1-1)*2+1] := y;
  end;

  procedure p2Add(x, y: integer);
  begin
    inc(pnum2);
    ptr2^[(pnum2-1)*2] := x;
    ptr2^[(pnum2-1)*2+1] := y;
  end;

  procedure pSwap;
  var pt: pointer;
      t: integer;
  begin
    pt := ptr1; ptr1 := ptr2; ptr2 := pt;
    t := pnum1; pnum1 := pnum2; pnum2 := t;
  end;

var i, x, y, j: integer;
    c: cell;
    ch: boolean;

  procedure _add(x, y: integer);
  begin
    if fld[x, y] = c then begin
      p2Add(x, y);
      fld2[x, y] := True;
      ch := True;
    end
    else begin
      inc(count[fld[x,y]]);
      fld2[x, y] := True;
    end;
  end;

var maxc: cell;
    max: integer;

begin
  for x := 1 to 41 do for y := 1 to 45 do fld2[x, y] := False;
  for i := 1 to 6 do count[i] := 0;
  fld2[sx, sy] := True;
  GetMem(ptr1, 65520);
  GetMem(ptr2, 65520);
  pnum1 := 0;
  pnum2 := 0;
  p1Add(sx, sy);

  repeat
    ch := False;
    pnum2 := 0;
    for i := 1 to pnum1 do begin
      p1Get(i, x, y, c);
      if (x>1) and (not fld2[x-1, y]) then _add(x-1, y);
      if (x<41) and (not fld2[x+1, y]) then _add(x+1, y);
      if (y>1) and (not fld2[x, y-1]) then _add(x, y-1);
      if (y<45) and (not fld2[x, y+1]) then _add(x, y+1);
    end;
    pSwap;
  until not ch;
end;

var my, en, sum: TScore;
    max, i: integer;
    maxc: cell;

begin
  Assign(Input, 'filya.in'); Reset(Input);
  Assign(Output, 'filya.out'); Rewrite(Output);
  ReadField;
  Sol(1, 1, my);
  Sol(41, 45, en);
  for i := 1 to 6 do sum[i] := my[i]+en[i];
  maxc := 1; max := -1;
  for i := 1 to 6 do begin
    if (sum[i] > max) and (i <> fld[1, 1]) and (i <> fld[41, 45]) then begin
      max := sum[i]; maxc := i;
    end;
  end;
  Writeln(maxc);
end.