Program Task2;
(****************************************************************************)
Type
    TCoord=0..10000;
    TLab=record
        P,B,E:TCoord;
    end;
    TRect=record
        X,Y,X1,Y1:integer;
    end;
Var
   Labs: array [1..1000] of TLab;
   Rects: array [1..1000] of TRect;
   FL,FW: TCoord;
   LabH,LabV:0..1000;
   rf:integer;
(****************************************************************************)
Procedure AssignRect(Var R:Trect;pX,pY,pX1,pY1:TCoord);
          Begin
               R.X:=pX;
               R.Y:=py;
               r.x1:=px1;
               r.y1:=py1
          End;
(****************************************************************************)
Function GetMax(A,B:TCoord):TCoord;
         Begin
              if A>B then GetMax:=A else GetMax:=B;
         End;
(****************************************************************************)
Procedure Sort(Bg,En:integer);
Var
   F: boolean;
   i: integer;
   c: TLab;
          Begin
               Repeat
                     F:=True;
                     For i:=Bg to En-1 do
                         if Labs[i].P>Labs[i+1].P then
                            Begin
                                 F:=false;
                                 c:=Labs[i];
                                 Labs[i]:=Labs[i+1];
                                 Labs[i+1]:=c;
                            End;
               Until F;
          End;
(****************************************************************************)
Procedure Init;
Var
   F: text;
   i,j: integer;
   X,Y,X1,Y1:TCoord;
          Begin
               Assign(F,'divide.in');
               Reset(F);
               ReadLn(F,FL,FW);
               ReadLn(F,j);
               LabH:=0;
               LabV:=0;
               For i:=1 to j do
                   Begin
                    ReadLn(F,X,Y,X1,Y1);
                    if X=X1 then
                       Begin
                            Inc(LabV);
                            With Labs[1000-LabV+1] do
                                 Begin
                                      E:=GetMax(Y,Y1);
                                      B:=Y+Y1-E;
                                      P:=X;
                                 End;
                       End else
                       Begin
                            Inc(LabH);
                            With Labs[LabH] do
                                 Begin
                                      E:=GetMax(X,X1);
                                      B:=X+X1-E;
                                      P:=Y;
                                 End;
                       End;
                   End;
               Close(F);
               Sort(1,LabH);
               Sort(1000-LabV+1,1000);
          End;
(****************************************************************************)
Function isHLab(Bg,En,Ps:TCoord):boolean;
Var
   j:integer;
   f:boolean;
         Begin
              f:=false;
              isHLab:=False;
              For j:=1 to LabH do
                  if Labs[j].P=Ps then
                     Begin
                          f:=true;
                          if (Labs[j].B>Bg) and (Labs[j].B<En) then
                             Begin
                                  isHLab:=True;
                                  Exit;
                             End;
                     End else if F then Break;
         End;
(****************************************************************************)
Function isVLab(Bg,En,Ps:TCoord):boolean;
Var
   j:integer;
   f:boolean;
         Begin
              f:=false;
              isVLab:=False;
              For j:=LabV downto 1 do
                  if Labs[1000-j+1].P=Ps then
                     Begin
                          f:=true;
                          if (Labs[1000-j+1].B>Bg) and (Labs[1000-j+1].B<En) then
                             Begin
                                  isVLab:=True;
                                  Exit;
                             End;
                     End else if F then Break;
         End;
(****************************************************************************)
Procedure RectAdjust;
Var
   i:integer;
          Begin
               For i:=1 to rf-1 do
                   if (Rects[i].X=Rects[rf].X) and (Rects[i].X1=Rects[rf].X1)
                   and ((((Rects[i].Y=Rects[rf].Y1) or (Rects[i].Y=Rects[rf].Y))
                   and isHLab(Rects[i].X,Rects[i].X1,Rects[i].Y))
                   or (((Rects[i].y1=Rects[rf].Y) or (Rects[i].y1=Rects[rf].y1))
                   and isHLab(Rects[i].X,Rects[i].X1,Rects[i].Y1))) then
                      Begin
                           Dec(rf);
                           With Rects[i] do
                                Begin
                                     Y1:=GetMax(Y1,Rects[rf].Y1);
                                     if Y>Rects[rf].Y then Y:=Rects[rf].Y;
                                End;
                           Break;
                      End else
                   if (Rects[i].Y=Rects[rf].Y) and (Rects[i].Y1=Rects[rf].Y1)
                   and ((((Rects[i].X=Rects[rf].X1) or (Rects[i].X=Rects[rf].X))
                   and isVLab(Rects[i].y,Rects[i].y1,Rects[i].x))
                   or (((Rects[i].x1=Rects[rf].x) or (Rects[rf].x1=rects[i].x1))
                   and isVLab(Rects[i].y,Rects[i].y1,Rects[i].x1))) then
                      Begin
                           Dec(rf);
                           With Rects[i] do
                                Begin
                                     X1:=GetMax(X1,Rects[rf].X1);
                                     if X>Rects[rf].X then X:=Rects[rf].X;
                                End;
                           Break;
                      End;

          End;
(****************************************************************************)
Procedure Run;
Var
   pred,predi,j,i: integer;
   F: text;
          Begin
               rf:=0;
               predi:=0;
               For j:=1 to LabH do
                   Begin
                        pred:=0;
                        For i:=LabV downto 1  do
                            if (pred>=Labs[j].E) then Break else
                            if (Labs[1000-i+1].B<Labs[j].P) then
                               Begin
                               if (Labs[1000-i+1].P>Labs[j].B) then
                               Begin
                                    inc(rf);
                                    AssignRect(Rects[rf],pred,predi,Labs[1000-i+1].P,Labs[j].P);
                                    if pred<Labs[j].B then Labs[j].B:=pred;
                                    if Labs[1000-i+1].P>Labs[j].E then Labs[j].E:=Labs[1000-i+1].P;
                                    RectAdjust;
                               End;
                               pred:=Labs[1000-i+1].P;
                               End;
                        if pred<=Labs[j].E then
                           begin
                                if pred<Labs[j].B then Labs[j].B:=pred;
                                Labs[j].E:=fl;
                                Inc(rf);
                                AssignRect(Rects[rf],pred,predi,fl,Labs[j].P);
                                RectAdjust;
                           end;
                        predi:=Labs[j].P;
                   End;
               predi:=0;
               For j:=LabV downto 1 do
                   Begin
                        pred:=0;
                        For i:=1 to LabH  do
                            if (pred>=Labs[1000-j+1].E) then Break else
                            if (Labs[i].B<Labs[1000-j+1].P) then
                               Begin
                               if (Labs[i].P>Labs[1000-j+1].B) then
                               Begin
                                    inc(rf);
                                    AssignRect(Rects[rf],predi,pred,Labs[1000-j+1].P,Labs[i].P);
                                    if pred<Labs[1000-j+1].B then Labs[1000-j+1].B:=pred;
                                    if Labs[i].P>Labs[1000-j+1].E then Labs[1000-j+1].E:=Labs[i].P;
                                    RectAdjust;
                               End;
                                    pred:=Labs[i].P;
                               End;
                        if pred<=Labs[1000-j+1].E then
                           begin
                                Inc(rf);
                                AssignRect(rects[rf],predi,pred,Labs[1000-j+1].P,fw);
                                if pred<Labs[1000-j+1].B then Labs[1000-j+1].B:=pred;
                                Labs[1000-j+1].E:=fw;
                                RectAdjust;
                           end;
                        predi:=Labs[1000-j+1].P;
                   End;
               Assign(F,'divide.out');
               ReWrite(F);
               WriteLn(F,rf);
               For j:=1 to rf do with Rects[j] do
                   WriteLn(F,X,' ',Y,' ',X1,' ',Y1);
               Close(F);
          End;
(****************************************************************************)
Begin
     Init;
     Run;
End.