{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+}
{$M 16384,0,655360}
uses dos;
type
    zaseka=record
             x,y,len:integer;
             dir:byte; { 0, 1  (!) }
           end;           {0 - up, 1 - right }
var
    hor,vert:array [1..1000] of zaseka;
    nh,nv,
    Sx,Sy,N,i,
    NRect:integer;
    hh,mm,ss,s100:Word;
    hh1,mm1,ss1,s1001:word;
    Timer:LongInt;
    x1,y1,x2,y2:integer;
    Rect:array [1..1500] of
          record
           x1,y1,x2,y2:integer;
          end;

procedure sort;
 var i,j:integer;
     tmp:zaseka;
  begin
    for i:=1 to nv-1 do
     for j:=i+1 to nv do
       if Vert[i].x > Vert[j].x then
         begin
          tmp:= Vert[j];
          Vert[j]:=Vert[i];
          Vert[i]:=tmp
         end;
    for i:=1 to nh-1 do
     for j:=i+1 to nh do
       if Hor[i].y > Hor[j].y then
         begin
          tmp := Hor[j];
          Hor[j]:=Hor[i];
          Hor[i]:=tmp
         end;
  end; {Sort}

Function Max(a,b:integer):integer;
  Begin
   if a>b then Max:=a
          else Max:=b;
  end;

Function Min(a,b:integer):integer;
  Begin
   if a<b then Min:=a
          else Min:=b;
  end;

Function Cross(x1, y1, x2, y2:integer):boolean;
var b:boolean;
    i:integer;
  Begin {Rectangle with any Line}
   b:=False;
{   for sx:=1 to 8000 do
    begin for sy:=1 to 20000 do end;}
    for i:=1 to nv do
       if (x1<Vert[i].x) and (Vert[i].x<x2) and
          (Max(Vert[i].y,y1)<Min(Vert[i].y+Vert[i].len, y2))
             then begin b:=True; Break; end;
   if not b then
    for i:=1 to nh do
       if (y1<Hor[i].y) and (Hor[i].y<y2) and
          (Max(Hor[i].x,x1)<Min(Hor[i].x+Hor[i].len, x2))
             then begin b:=True; Break; end;
   Cross:=b;
  End; {Cross}

Function VCross(x1, y1, x2, y2:integer):boolean;
var b:boolean;
    i:integer;
  Begin {Rectangle with any Line}
   b:=False;
    for i:=1 to nv do
       if (x1<Vert[i].x) and (Vert[i].x<x2) and
          (Max(Vert[i].y,y1)<Min(Vert[i].y+Vert[i].len, y2))
             then begin b:=True; Break; end;
   VCross:=b;
  End; {Cross}

Function HCross(x1, y1, x2, y2:integer):boolean;
var b:boolean;
    i:integer;
  Begin {Rectangle with any Line}
   b:=False;
    for i:=1 to nh do
       if (y1<Hor[i].y) and (Hor[i].y<y2) and
          (Max(Hor[i].x,x1)<Min(Hor[i].x+Hor[i].len, x2))
             then begin b:=True; Break; end;
   HCross:=b;
  End; {HCross}

Procedure Cuts(bx1, by1, bx2, by2:integer);
var x1,y1,x2,y2,
     l,r,u,d,cntr:integer;
     Time:longint;
    b,t:boolean;
  begin
  {Cut
    and then if exist Hor(Vert) Line which doesn't cross with
       any line of other type => Try Cuts(Rectangle1)+Cuts(Rectangle2)}
    x1:=bx1; y1:=by1;
    x2:=bx2; y2:=by2;
    b:=True;
    t:=False;cntr:=1;
    l:=1; d:=1; u:=nh; r:=nv;
    while True do
     Begin
      b:=False;
      inc(cntr);
      if (cntr mod 3)=0 then
           begin
            GetTime(hh1,mm1,ss1,s1001);
            Time:= (hh1-hh)*100*60*24+
             (mm1-mm)*100*60+(ss1-ss)*100+(s1001-s100);
            if Time>0+0+20*100 then
                     break;
            Cntr:=0;
           end;
       while (Vert[l].x < x1) and (l <= nv) do inc(l);
{       if l>nv then           } {***********************}
       while (Hor[d].y < y1) and (d <= nh) do inc(d);
{       if d>nh then           } {***********************}
       while (Vert[l].x > x2) and (r >= 1) do dec(r);
{       if r<1 then           } {***********************}
       while (Hor[u].y > y2) and (u >= 1) do dec(u);
{       if u<1 then           } {***********************}
  if ((l>nv)and(d>nh)) or ((r<1)and(u<1))or
   (Not Cross(x1,y1,x2,y2)) then
       begin
        inc(NRect);
        Rect[NRect].x1:=x1;
        Rect[NRect].y1:=y1;
        Rect[NRect].x2:=x2;
        Rect[NRect].y2:=y2;
        break;
       end;

 if (l<=Nv) and (r>=1) and (l<=r) then
    begin
     if not HCross(x1,y1,Vert[l].y,y2) then
       begin
        inc(NRect);
        Rect[NRect].x1:=x1;
        Rect[NRect].y1:=y1;
        Rect[NRect].x2:=Vert[l].x;
        Rect[NRect].y2:=y2;
        x1:=Vert[l].y;
        inc(l);
        b:=True;
       end  else
     if not HCross(Vert[r].x,y1,x2,y2) then
       begin
        inc(NRect);
        Rect[NRect].x1:=Vert[r].x;
        Rect[NRect].y1:=y1;
        Rect[NRect].x2:=x2;
        Rect[NRect].y2:=y2;
        x2:=Vert[r].x;
        Dec(r);
        b:=True;
       end
    end;

 if not b then
  if (d<=Nh) and (u>=1)and (d<=u) then
    begin
     if not VCross(x1,y1,Hor[d].x,y2) then
       begin
        inc(NRect);
        Rect[NRect].x1:=x1;
        Rect[NRect].y1:=y1;
        Rect[NRect].x2:=x2;
        Rect[NRect].y2:=Hor[d].y;
        y1:=Hor[d].y;
        Inc(d);
        b:=True;
       end  else
     if not HCross(x1,Hor[u].y,x2,y2) then
       begin
        inc(NRect);
        Rect[NRect].x1:=x1;
        Rect[NRect].y1:=Hor[u].y;
        Rect[NRect].x2:=x2;
        Rect[NRect].y2:=y2;
        Dec(u);
        y2:=Hor[u].y;
        b:=True;
       end;
    end;
      if t and (not b) then Break;
      if not b then t:=True;
     End; {while}
  end; {Cuts}

Begin
 GetTime(hh,mm,ss,s100);
 assign(input,'divide.in');reset(input);
 assign(output,'divide.out');rewrite(output);
   ReadLn(Sx,Sy);
   ReadLn(N);
   for i:=1 to N do
     Begin
       ReadLn(x1, y1, x2, y2);
       if x1=x2 then
         begin {Vert}
           inc(nv);
           Vert[nv].x:=x1;
           Vert[nv].y:=(y1+y2-abs(y1-y2)) div 2;
           Vert[nv].len:=abs(y1-y2);
           Vert[nv].dir:=0;
         end
                else
          begin  {Hor}
            inc(nh);
            Hor[nh].y:=y1;
            Hor[nh].x:=(x1+x2-abs(x1-x2)) div 2;
            Hor[nh].len:=abs(x1-x2);
            Hor[nh].dir:=1;
          end;
     End;
  Sort;

  cuts(0, 0, Sx, Sy);

  WriteLn(NRect);
  For i:=1 to NRect do
     WriteLn(Rect[i].x1,' ',Rect[i].y1,' ',
                Rect[i].x2,' ',Rect[i].y2);


 Close(input);
 Close(OutPut);
End.

     { Sweet Child in Time,
       You see the line,
       Line is strong between
                good and bad.
       You see the flying man
       Shooting at the world...
       Leds flying...               (?)
          ...taking fall...         (?)
       If you beetle bad
       You'd better close your eyes
                ...
                         Deep Purple 1988(?)}

