{$A+,B+,D+,E-,F-,G+,I+,L+,N+,O-,P+,Q+,R+,S+,T+,V+,X+}
{$M 65520,0,655360}

type whos=(fc,sc);
     links=record
             city1,city2,city3 : integer;
           end;
     priv=record
            city1,city2 : integer;
          end;
     privlinks = array [1..15000] of priv;
     ptrlink = ^privlinks;
     abc1 = array [1..5000] of integer;
     ptrcount = ^abc1;
var finput,foutput : text;
    cities         : array [1..5000] of links;
    prlink         : ptrlink;
    numcities      : integer;
    whoslink       : array [1..15000] of whos;
    citieshaslinks : array [1..5000] of integer;
    fclinks        : ptrcount;
    sclinks        : ptrcount;

{----------------------------------------------------------------------------}

function val1(line:string) : integer;
  var value,code : integer;
  begin
    val(line,value,code);
    val1:=value
  end;

{----------------------------------------------------------------------------}
procedure cleararrays;
  var i : integer;
  begin
    for i:=1 to 5000 do
      begin
        cities[i].city1:=0;
        cities[i].city2:=0;
        cities[i].city3:=0;
        prlink^[(i-1)*3+1].city1:=0;
        prlink^[(i-1)*3+1].city2:=0;
        prlink^[(i-1)*3+2].city1:=0;
        prlink^[(i-1)*3+2].city2:=0;
        prlink^[(i-1)*3+3].city1:=0;
        prlink^[(i-1)*3+3].city2:=0;
        citieshaslinks[i]:=0;
        whoslink[(i-1)*3+1]:=fc;
        whoslink[(i-1)*3+2]:=fc;
        whoslink[(i-1)*3+3]:=fc;
        fclinks^[i]:=0;
        sclinks^[i]:=0
      end;
  end;

{----------------------------------------------------------------------------}

procedure filldata;
  var line,subline1,subline2,subline3 : string;
      i                               : integer;

{----------------------------------------------------------------------------}

  procedure divide3(line : string ; var subline1,subline2,subline3 : string);
    var i : integer;
    begin
      subline1:='';
      subline2:='';
      subline3:='';
      i:=1;
      while not (line[i]=' ') do
        begin
          subline1:=subline1+line[i];
          inc(i)
        end;
      inc(i);
      while not (line[i]=' ') do
        begin
          subline2:=subline2+line[i];
          inc(i)
        end;
      subline3:=copy(line,i+1,length(line)-i)
    end;


{----------------------------------------------------------------------------}

  begin
    readln(finput,line);
    numcities:=val1(line);
    for i:=1 to numcities do
      begin
        readln(finput,line);
        divide3(line,subline1,subline2,subline3);
        cities[i].city1:=val1(subline1);
        cities[i].city2:=val1(subline2);
        cities[i].city3:=val1(subline3)
      end;
  end;

{----------------------------------------------------------------------------}

procedure filllinks;
  var i : integer;
  begin
    for i:=1 to numcities do
      begin
        prlink^[(i-1)*3+1].city1:=i;
        prlink^[(i-1)*3+1].city2:=cities[i].city1;
        prlink^[(i-1)*3+2].city1:=i;
        prlink^[(i-1)*3+2].city2:=cities[i].city2;
        prlink^[(i-1)*3+3].city1:=i;
        prlink^[(i-1)*3+3].city2:=cities[i].city3
      end;
  end;

{----------------------------------------------------------------------------}

procedure countlinks;
  var i : integer;
  begin
    for i:=1 to numcities*3 do
      begin
        inc(citieshaslinks[prlink^[i].city1]);
        inc(citieshaslinks[prlink^[i].city2])
      end;
  end;

{----------------------------------------------------------------------------}

procedure maincount;
  var i:integer;

{----------------------------------------------------------------------------}

function cityhassclinks(i:integer) : integer;
  var fccount,j : integer;
  begin
    fccount:=0;
    for j:=1 to numcities*3 do
      if (prlink^[j].city1=i) or (prlink^[j].city2=i) then if whoslink[j]=sc
        then inc(fccount);
    cityhassclinks:=fccount;
  end;

{----------------------------------------------------------------------------}

procedure privatelink(i:integer);
  var j,k: integer;
  begin
    for j:=1 to numcities*3 do
      begin
        if (prlink^[j].city1=i) and (whoslink[j]=fc) then whoslink[j]:=sc;
      end;
  end;

{----------------------------------------------------------------------------}

  begin
    for i:=1 to numcities do
      begin
        if cityhassclinks(i)<2 then privatelink(i);
      end;
  end;

{----------------------------------------------------------------------------}

function checklinksok : boolean;
  var i:integer;
  begin
    for i:=1 to numcities*3 do
      begin
        if whoslink[i]=fc
          then
            begin
              inc(fclinks^[prlink^[i].city1]);
              inc(fclinks^[prlink^[i].city2])
            end
          else
            begin
              inc(sclinks^[prlink^[i].city1]);
              inc(sclinks^[prlink^[i].city2])
            end;
      end;
    for i:=1 to numcities do if (fclinks^[i]=0) or (sclinks^[i]=0) then
      begin
        checklinksok:=false;
        exit
      end;
    checklinksok:=true;
  end;

{----------------------------------------------------------------------------}

procedure writealllinks;
  var i:integer;
  begin
    for i:=1 to numcities*3 do
      if whoslink[i]=sc then writeln(foutput,prlink^[i].city1,' ',prlink^[i].city2)
  end;

{----------------------------------------------------------------------------}
begin
  assign(finput,'rail.in');
  assign(foutput,'rail.out');
  reset(finput);
  rewrite(foutput);
  prlink:=new(ptrlink);
  fclinks:=new(ptrcount);
  sclinks:=new(ptrcount);
  cleararrays;
  filldata;
  filllinks;
  countlinks;
  maincount;
  if checklinksok
    then writealllinks
    else writeln(foutput,'NO SOLUTION');
  close(finput);
  close(foutput)
end.