type
 Tp=(Hor,Ver);
 FLine=record
  X1,Y1,X2,Y2:Integer;
  LTp:Tp;
 end;
 Point=record
  X,Y:Integer;
 end;
 LPoint=record
  X,Y,NH,NV:Integer;
 end;

var
 LC,NP,NS:Word;
 SX,SY:Integer;
 LArr:Array[1..1000] of FLine;
 SqArr:Array[1..1000] of FLine;
 PArr:Array[1..4000] of LPoint;

{ LTp(L:Fline):Tp;
begin
 If L.X1=L.X2 then Ltp:=Ver else Ltp:=Hor;
end;}

procedure Extend(LN:Word);
var
 CurTp:Tp;
 Cur,Chk:FLine;
 MinExL,MinExR:Integer;
 MinExU:Integer absolute MinExL;
 MinExD:Integer absolute MinExR;
 I:Integer;
begin
 Cur:=LArr[LN];
 MinExL:=0;
 If Cur.LTp=Hor then begin
  MinExR:=SX;
  For I:=1 to LC do begin
   Chk:=LArr[I];
   If (I<>LN)and(Chk.Ltp=Ver) then
    If ((Chk.Y1<Cur.Y1)and(Chk.Y2>Cur.Y2)) then
     If ((Chk.X1<=Cur.X1)and(Chk.X1>MinExL)) then
      MinExL:=Chk.X1 else
     If ((Chk.X1>=Cur.X2)and(Chk.X1<MinExR)) then
      MinExR:=Chk.X1;
  end;
  Cur.X1:=MinExL;
  Cur.X2:=MinExR;
 end
  else
 begin
  MinExU:=SY;
  MinExD:=0;
  For I:=1 to LC do begin
   Chk:=LArr[I];
   If (I<>LN)and(Chk.Ltp=Hor) then
    If ((Chk.X1<Cur.X1)and(Chk.X2>Cur.X2)) then
     If ((Chk.Y1<=Cur.Y1)and(Chk.Y1>MinExD)) then
      MinExD:=Chk.Y1 else
     If ((Chk.Y1>=Cur.Y2)and(Chk.Y1<MinExU)) then
      MinExU:=Chk.Y1;
  end;
  Cur.Y1:=MinExD;
  Cur.Y2:=MinExU;
 end;
 LArr[LN]:=Cur;
end;

procedure AddPoint(X,Y,NL:Integer);
var
 I:Integer;
begin
 If NP>0 then
  for I:=1 to NP do
   If (PArr[I].X=X)and(PArr[I].Y=Y) then Exit;
 Inc(NP);
 PArr[NP].X:=X;
 PArr[NP].Y:=Y;
 If LArr[NL].Ltp=Hor then begin
  PArr[NP].NH:=NL;
  For I:=1 to LC do
   If (LArr[I].LTp=Ver)and(LArr[I].X1=X)and(LArr[I].Y1<=Y)and(LArr[I].Y2>=Y) then begin
    PArr[NP].NV:=I;
    Break;
   end;
 end
  else
 begin
  PArr[NP].NV:=NL;
  For I:=1 to LC do
   If (LArr[I].LTp=Hor)and(LArr[I].Y1=Y)and(LArr[I].X1<=X)and(LArr[I].X2>=X) then begin
    PArr[NP].NH:=I;
    Break;
   end;
 end;
end;

procedure WriteSqrs;
var
 OutF:Text;
 I,I2:Integer;
 MX,MY:Integer;
 XF,YF:Boolean;
 Cur:Point;
begin
 NS:=0;
 for I:=1 to NP do begin
  MX:=10001; MY:=10001;
  XF:=False; YF:=False;
  Cur.X:=PArr[I].X;
  Cur.Y:=PArr[I].Y;
  for I2:=1 to NP do
   if I<>I2 then
    if ((PArr[I2].Y=Cur.Y)and(PArr[I2].X>Cur.X)and(MX>PArr[I2].X)and
        (LArr[PArr[I2].NV].Y1<=Cur.Y)and(LArr[PArr[I2].NV].Y2>Cur.Y)) then begin
     XF:=True;
     MX:=PArr[I2].X;
    end
     else
    if ((PArr[I2].X=Cur.X)and(PArr[I2].Y>Cur.Y)and(MY>PArr[I2].Y)and
        (LArr[PArr[I2].NH].X1<=Cur.X)and(LArr[PArr[I2].NH].X2>Cur.X)) then begin
     YF:=True;
     MY:=PArr[I2].Y;
    end;
  If (XF)and(YF) then begin
   Inc(NS);
   SqArr[NS].X1:=Cur.X;
   SqArr[NS].Y1:=Cur.Y;
   SqArr[NS].X2:=MX;
   SqArr[NS].Y2:=MY;
  end;
 end;
 Assign(OutF,'divide.out');
 Rewrite(OutF);
 Writeln(OutF,NS);
 For I:=1 to NS do
  Writeln(OutF,SqArr[I].X1,' ',SqArr[I].Y1,' ',SqArr[I].X2,' ',SqArr[I].Y2);
 Close(OutF);
end;

var
 InF:Text;
 S,I:Integer;

begin
 NP:=0;
 Assign(InF,'divide.in');
 Reset(InF);
 Readln(InF,SX,SY);
 Readln(InF,LC);
 Inc(LC,4);
 LArr[1].X1:=0; LArr[1].Y1:=0; LArr[1].X2:=0; LArr[1].Y2:=SY;
 LArr[2].X1:=0; LArr[2].Y1:=SY; LArr[2].X2:=SX; LArr[2].Y2:=SY;
 LArr[3].X1:=SX; LArr[3].Y1:=0; LArr[3].X2:=SX; LArr[3].Y2:=SY;
 LArr[4].X1:=0; LArr[4].Y1:=0; LArr[4].X2:=SX; LArr[4].Y2:=0;
 LArr[1].Ltp:=Ver;
 LArr[2].Ltp:=Hor;
 LArr[3].Ltp:=Ver;
 LArr[4].Ltp:=Hor;

 For I:=1 to (LC-4) do begin
  Readln(InF,LArr[I+4].X1,LArr[I+4].Y1,LArr[I+4].X2,LArr[I+4].Y2);
  If LArr[I+4].X1=LArr[I+4].X2 then LArr[I+4].Ltp:=Ver else
      LArr[I+4].Ltp:=Hor;
  If LArr[I+4].X2<LArr[I+4].X1 then begin
   S:=LArr[I+4].X1;
   LArr[I+4].X1:=LArr[I+4].X2;
   LArr[I+4].X2:=S;
  end;
  If LArr[I+4].Y2<LArr[I+4].Y1 then begin
   S:=LArr[I+4].Y1;
   LArr[I+4].Y1:=LArr[I+4].Y2;
   LArr[I+4].Y2:=S;
  end;
 end;
 Close(InF);

 For I:=5 to LC do
  Extend(I);

 For I:=1 to LC do begin
  AddPoint(LArr[I].X1,LArr[I].Y1,I);
  AddPoint(LArr[I].X2,LArr[I].Y2,I);
 end;

 WriteSqrs;
end.