{$M 32000,0,0}
var
 Field:Array[1..41,1..45] of Byte;
 NumC:Array[0..7] of Word;
 MyC,HisC:Byte;

procedure Patch(X,Y:Integer);
begin
 If Field[Y,X]<>MyC then Exit;
 Field[Y,X]:=7;
 If X>1 then Patch(X-1,Y);
 If Y>1 then Patch(X,Y-1);
 If X<45 then Patch(X+1,Y);
 If Y<41 then Patch(X,Y+1);
end;

function NumClrs(X,Y:Integer;N,C:Byte):Word;
var
 R:Word;
begin
 NumClrs:=0;
 If (C=8)or(C=7)or(C<>N) then Exit;
 If C<>Field[Y,X] then Exit;
 Field[Y,X]:=8;
 R:=1;
 If X>1 then R:=R+NumClrs(X-1,Y,N,Field[Y,X-1]);
 If Y>1 then R:=R+NumClrs(X,Y-1,N,Field[Y-1,X]);
 If X<45 then R:=R+NumClrs(X+1,Y,N,Field[Y,X+1]);
 If Y<41 then R:=R+NumClrs(X,Y+1,N,Field[Y+1,X]);
 NumClrs:=R;
end;

procedure ScanLines;
var
 X,Y:Integer;
 C,ToI:Byte;
begin
 For Y:=1 to 41 do
  For X:=1 to 45 do begin
   C:=Field[Y,X];
   If (C=7)and(X>1) then begin
    ToI:=Field[Y,X-1];
    Inc(NumC[ToI],NumClrs(X-1,Y,Field[Y,X-1],Field[Y,X-1]));
   end;
   If (C=7)and(Y>1) then begin
    ToI:=Field[Y-1,X];
    Inc(NumC[ToI],NumClrs(X,Y-1,Field[Y-1,X],Field[Y-1,X]));
   end;
   If (C=7)and(X<45) then begin
    ToI:=Field[Y,X+1];
    Inc(NumC[ToI],NumClrs(X+1,Y,Field[Y,X+1],Field[Y,X+1]));
   end;
   If (C=7)and(Y<41) then begin
    ToI:=Field[Y+1,X];
    Inc(NumC[ToI],NumClrs(X,Y+1,Field[Y+1,X],Field[Y+1,X]));
   end;
   If C=7 then Field[Y,X]:=0;
  end;
end;

function GetMaxC:Byte;
var
 I:Integer;
 M:Word;
 MB:Byte;
begin
 M:=0;
 MB:=0;
 For I:=1 to 6 do
  If (I<>MyC)and(I<>HisC)and(M<NumC[I]) then begin
   MB:=I;
   M:=NumC[I];
  end;
 If MB=0 then
  for MB:=1 to 6 do
   If (MB<>MyC)and(MB<>HisC) then Break;
 GetMaxC:=MB;
end;

var
 InF, OutF:Text;
 X,Y,Cod:Integer;
 S:String;

begin
 Assign(InF,'filya.in');
 Reset(InF);
 For Y:=1 to 41 do begin
  Readln(InF,S);
  For X:=1 to 45 do
   Val(S[X],Field[Y,X],Cod);
 end;
 Close(InF);
 MyC:=Field[1,1];
 HisC:=Field[41,45];
 FillChar(NumC,SizeOf(NumC),0);
 Patch(1,1);
 ScanLines;
 Assign(OutF,'filya.out');
 Rewrite(OutF);
 Writeln(OutF,GetMaxC);
 Close(OutF);

{ Assign(OutF,'filya.tst');
 Rewrite(OutF);
 For Y:=1 to 41 do begin
  For X:=1 to 45 do
   Write(OutF,Field[Y,X]);
  Writeln(OutF);
 end;
 Close(OutF);}
end.