{$A+,B-,D+,E-,F+,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65384,0,655360}
{ fool solve }
Program Train;
Const MaxN=1000;
      Eps=0.00001;
 Var Res, ResD: Real;
     T, V: Array[0..MaxN] Of LongInt;
     L: LongInt;
     N: Integer;

 Procedure Init;
  Var i: Integer;
   Begin
    Assign(Input, 'train.in');
     Reset(Input);
      Read(L, N);
     ResD:=0;
      For i:=1 To N Do Begin
       Read(T[i], V[i]);
       ResD:=ResD+T[i];
      End;
     Close(Input);
   End;

  Function Eq(Const A, B: Real): Boolean;
   Begin
    Eq:=Abs(A-B) < Eps;
   End;

  Function Good(Const i: Real): Boolean;
   Begin
   End;

  Function Max(Const A, B: Real): Real;
   Begin
    If B-A>Eps Then Max:=B Else Max:=A;
   End;

  Function GetT(k: Integer;Const st: Integer): Real;
   Var Os: LongInt;
       Tm: Real;
    Begin
     GetT:=-MaxLongInt; Tm:=0;
     Os:=L;
     While Os<>0 Do Begin
      If (k<1) Or (k>N) Then Begin GetT:=Tm; Exit;End;
      If Os>V[k]*T[k] Then Begin
        Os:=Os-V[k]*T[k];
         Tm:=Tm+T[k];
        Inc(k, st);
       End
      Else Begin
        Tm:=Tm+(Os/V[k]);
        Os:=0;
       End;
     End;
     GetT:=Tm;
    End;

  Function MaxR(Const i: Integer): Real;
   Var R1: Real;
       R2: Real;
    Begin
      R1:=GetT(i-1, -1);
      R2:=GetT(i, 1);
     MaxR:=Max(R1, R2);
    End;

  Procedure Solve;
   Var i: Integer;
    Begin
     Res:=-MaxLongInt;
     For i:=1 To N+1 Do
      Res:=Max(Res, MaxR(i));
     If Res=-MaxLongInt Then Res:=ResD;
    End;

  Procedure Done;
   Begin
    Assign(Output, 'train.out');
     Rewrite(Output);
      WriteLn(Res:0:3);
     Close(Output);
   End;

BEGIN
 Init;
  Solve;
 Done;
END.