{$UNDEF DEBUG}
{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 65520,0,0}
{$IFDEF DEBUG}
{$S+,R+,I+,Y+,D+,L+,O+}
{$ENDIF}
Const
  MaxN=1000;
  MaxM=7000;
Var
  Obl:Array[1..MaxM]Of Record X1,Y1,X2,Y2:Word; End;
  Zas:Array[1..MaxN]Of Record X1,Y1,X2,Y2:Word; End;
  X1,Y1,X2,Y2:Word;
  N,M:Word;
  XM,YM:Word;
  Timer:LongInt Absolute $0040:$006C;
  StartTime:LongInt;
Function ByOne(A,B:Integer):boolean;
begin
  ByOne:=(A=0) Or (B=0) Or (A*B>=0);
end;
Procedure Work;
Var
  T,OM,I,CN:Word;
  A,B,C:Boolean;
  I1,I2:Integer;
Begin
  CN:=0;
  M:=1;
  Assign(Input,'DIVIDE.IN');
  ReSet(Input);
  ReadLn(XM,YM);
  ReadLn(N);
  Obl[1].X1:=0;
  Obl[1].Y1:=0;
  Obl[1].X2:=XM;
  Obl[1].Y2:=YM;
  For CN:=1 To N Do Begin
    ReadLn(X1,Y1,X2,Y2);
    If X1>X2 Then Begin
      T:=X1;
      X1:=X2;
      X2:=T;
    End;
    If Y1>Y2 Then Begin
      T:=Y1;
      Y1:=Y2;
      Y2:=T;
    End;
    Zas[CN].X1:=X1;
    Zas[CN].Y1:=Y1;
    Zas[CN].X2:=X2;
    Zas[CN].Y2:=Y2;
    OM:=M;
    If X1=X2 Then Begin
      For I:=1 To OM Do
        If (X1>Obl[I].X1) And (X1<Obl[I].X2) And Not (
          ByOne((Integer(Y1)-Obl[I].Y1),(Integer(Y1)-Obl[I].Y2))
          And ByOne((Integer(Y1)-Obl[I].Y1),(Integer(Y2)-Obl[I].Y1))
          And ByOne((Integer(Y2)-Obl[I].Y1),(Integer(Y2)-Obl[I].Y2))
          And ByOne((Integer(Y1)-Obl[I].Y2),(Integer(Y2)-Obl[I].Y2))
          And ((Y1<>Obl[I].Y1) Or (Y2<>Obl[I].Y2))
          ) Then Begin
          Inc(M);
          Obl[M]:=Obl[I];
          Obl[I].X2:=X1;
          Obl[M].X1:=X1;
        End;
    End Else Begin
      For I:=1 To OM Do
        If (Y1>Obl[I].Y1) And (Y1<Obl[I].Y2) And Not (
          ByOne((Integer(X1)-Obl[I].X1),(Integer(X1)-Obl[I].X2))
          And ByOne((Integer(X1)-Obl[I].X1),(Integer(X2)-Obl[I].X1))
          And ByOne((Integer(X2)-Obl[I].X1),(Integer(X2)-Obl[I].X2))
          And ByOne((Integer(X1)-Obl[I].X2),(Integer(X2)-Obl[I].X2))
          And ((X1<>Obl[I].X1) Or (X2<>Obl[I].X2))
          ) Then Begin
          Inc(M);
          Obl[M]:=Obl[I];
          Obl[I].Y2:=Y1;
          Obl[M].Y1:=Y1;
        End;
    End;
  End;
  Close(Input);
End;
Procedure Optimize;
Var
  NumOb:Array[1..MaxM]Of Word;
  I,J:Word;
  Max,Mx,MN,MxN:Word;
Function AZOVL(X1,Y1,Y2:Word):Boolean;
Var
  I:Word;
Begin
  For I:=1 To M Do
    If Zas[I].X1=Zas[I].X2 Then
      If (Zas[I].X1=X1) And ((Not ByOne((Integer(Zas[I].Y1)-Y1),(Integer(Zas[I].Y2)-Y1))
      Or Not ByOne((Integer(Zas[I].Y1)-Y1),(Integer(Zas[I].Y1)-Y2))
      Or Not ByOne((Integer(Zas[I].Y1)-Y2),(Integer(Zas[I].Y2)-Y2))
      Or Not ByOne((Integer(Zas[I].Y2)-Y1),(Integer(Zas[I].Y2)-Y2)))
      Or (Zas[I].Y1=Y1) And (Zas[I].Y2=Y2)) Then Begin
        AZOVL:=False;
        Exit;
      End;
  AZOVL:=True;
End;
Function AZOHL(Y1,X1,X2:Word):Boolean;
Var
  I:Word;
Begin
  For I:=1 To M Do
    If Zas[I].Y1=Zas[I].Y2 Then
      If (Zas[I].Y1=Y1) And ((Not ByOne((Integer(Zas[I].X1)-X1),(Integer(Zas[I].X2)-X1))
      Or Not ByOne((Integer(Zas[I].X1)-X1),(Integer(Zas[I].X1)-X2))
      Or Not ByOne((Integer(Zas[I].X1)-X2),(Integer(Zas[I].X2)-X2))
      Or Not ByOne((Integer(Zas[I].X2)-X1),(Integer(Zas[I].X2)-X2)))
      Or (Zas[I].X1=X1) And (Zas[I].X2=X2)) Then Begin
        AZOHL:=False;
        Exit;
      End;
  AZOHL:=True;
End;
Function CanOb(A,B:Word):Boolean;
Begin
  CanOb:=((Obl[A].X2=Obl[B].X1) And (Obl[A].Y1=Obl[B].Y1) And (Obl[A].Y2=Obl[B].Y2) And AZOVL(Obl[A].X2,Obl[A].Y1,Obl[A].Y2))
   Or ((Obl[B].X2=Obl[A].X1) And (Obl[B].Y1=Obl[A].Y1) And (Obl[B].Y2=Obl[A].Y2) And AZOVL(Obl[B].X2,Obl[B].Y1,Obl[B].Y2))
   Or ((Obl[A].Y2=Obl[B].Y1) And (Obl[A].X1=Obl[B].X1) And (Obl[A].X2=Obl[B].X2) And AZOHL(Obl[A].Y2,Obl[A].X1,Obl[A].X2))
   Or ((Obl[B].Y2=Obl[A].Y1) And (Obl[B].X1=Obl[A].X1) And (Obl[B].X2=Obl[A].X2) And AZOHL(Obl[B].Y2,Obl[B].X1,Obl[B].X2));
End;
Function WMin(A,B:Word):Word;
Begin
  If A<B Then WMin:=A Else WMin:=B;
End;
Function WMax(A,B:Word):Word;
Begin
  If A>B Then WMax:=A Else WMax:=B;
End;
Procedure DoOb(A,B:Word);
Var
  T:Word;
Begin
  If A>B Then Begin
    T:=A;
    A:=B;
    B:=T;
  End;
  Inc(M);
  Obl[M].X1:=WMin(Obl[A].X1,Obl[B].X1);
  Obl[M].Y1:=WMin(Obl[A].Y1,Obl[B].Y1);
  Obl[M].X2:=WMax(Obl[A].X2,Obl[B].X2);
  Obl[M].Y2:=WMax(Obl[A].Y2,Obl[B].Y2);
  Move(Obl[A+1],Obl[A],(B-A-1)*SizeOf(Obl[A]));
  Move(Obl[B+1],Obl[B-1],(M-B)*SizeOf(Obl[B]));
  Dec(M,2);
End;
Begin
  FillChar(NumOb,SizeOf(NumOb),0);
  Repeat
    If Timer>=StartTime Then Break;
    For I:=1 To M Do
      For J:=1 To I-1 Do
        If CanOb(I,J) Then Begin
          Inc(NumOb[I]);
          Inc(NumOb[J]);
        End;
    Max:=0;
    MN:=0;
    For I:=1 To M Do If NumOb[I]>Max Then Begin Max:=NumOb[I]; MN:=I; End;
    If MN=0 Then Break;
    Mx:=0;
    MxN:=0;
    For J:=1 To M Do If (MN<>J) And CanOb(MN,J) And (NumOb[J]>Mx) Then Begin Mx:=NumOb[J]; MxN:=J; End;
    If MxN=0 Then Break;
    DoOb(MN,MxN);
  Until False;
End;
Procedure Done;
Var
  I:Word;
Begin
  Assign(Output,'DIVIDE.OUT');
  ReWrite(Output);
  WriteLn(M);
  For I:=1 To M Do WriteLn(Obl[I].X1,' ',Obl[I].Y1,' ',Obl[I].X2,' ',Obl[I].Y2);
  Close(Output);
End;
Begin
  StartTime:=Timer+360;
  Work;
  Optimize;
  Done;
End.