type TField = array [0..40,0..44] of byte;
     TColor = record
                Color, Value: byte;
              end;
var Field: TField;
    Colors: array [1..6] of TColor;
procedure ReadData;
var Input: file of byte;
    i, j: integer;
    b: byte;
begin
  Assign ( Input, 'filya.in');
  Reset ( Input);
  i:=0; j:=0;
  while not EOF ( Input) do
    begin
      Read ( Input, b);
      if b=13 then
        begin
          Read ( Input, b);
          Inc ( j); i:=0;
        end
               else
        begin
          Field[j,i]:=b-48;
          Inc ( i);
        end;
    end;
  Close ( Input);
  for i:=1 to 6 do
    with Colors[i] do
      begin
        Color:=i; Value:=0;
      end;
end;
procedure Counting;
var X, Y: byte;
    Found1, Found2, Found3, Found4, Found5, Found6, Found7: byte;
begin
  X:=0; Found1:=0; Found2:=0; Found3:=0; Found4:=0; Found5:=0; Found6:=0; Found7:=0;
  while Found1+Found2+Found3+Found4+Found5+Found6+Found7<7 do
    begin
      Inc ( X);
      if X>40 then
        begin
          Found1:=1; Found2:=1; Found4:=1; Found7:=1;
        end;
      if X>44 then
        begin
          Found3:=1; Found5:=1; Found6:=1;
        end;
{$R-}
      if (Field[X,X]<>Field[0,0]) and (Found1<1) then
        begin
          Inc ( Colors[Field[X,X]].Value);
          Found1:=1;
        end;
      if (Field[X,0]<>Field[0,0]) and (Found2<1) then
        begin
          Inc ( Colors[Field[X,0]].Value);
          Found2:=1;
        end;
      if (Field[0,X]<>Field[0,0]) and (Found3<1) then
        begin
          Inc ( Colors[Field[0,X]].Value);
          Found3:=1;
        end;
      if (Field[X,X div 2]<>Field[0,0]) and (Found4<1) then
        begin
          Inc ( Colors[Field[X,X div 2]].Value);
          Found4:=1;
        end;
      if (Field[X div 2,X]<>Field[0,0]) and (Found5<1) then
        begin
          Inc ( Colors[Field[X div 2,X]].Value);
          Found5:=1;
        end;
      if (Field[X div 4,X]<>Field[0,0]) and (Found6<1) then
        begin
          Inc ( Colors[Field[X div 4,X]].Value);
          Found6:=1;
        end;
      if (Field[X,X div 4]<>Field[0,0]) and (Found7<1) then
        begin
          Inc ( Colors[Field[X,X div 4]].Value);
          Found7:=1;
        end;
{$R+}
    end;
end;
procedure SortColors;
var Swaped: Boolean;
    Temp: TColor;
    i: integer;
begin
  Swaped:=True;
  while Swaped do
    begin
      Swaped:=False;
      for i:=1 to 5 do
        if Colors[i].Value<Colors[i+1].Value then
          begin
            Swaped:=True;
            Temp:=Colors[i]; Colors[i]:=Colors[i+1]; Colors[i+1]:=Temp;
          end;
    end;
end;
procedure WriteResult;
var Output: Text;
    Clr: byte;
begin
  Randomize;
  Assign ( Output, 'filya.out');
  Rewrite ( Output);
  if Colors[1].Value=0 then
    begin
      Clr:=(Random ( 256) mod 6) + 1;
      while Clr in [Field[0,0],Field[40,44]] do Clr:=((Clr+1) mod 6)+1;
      WriteLn ( Output, Clr);
    end
                       else
    begin
      Clr:=1;
      while Colors[Clr].Color in [Field[0,0],Field[40,44]] do Inc ( Clr);
      WriteLn ( Output, Colors[Clr].Color);
    end;
  Close ( Output);
end;
begin
  ReadData;
  Counting;
  SortColors;
  WriteResult;
end.