type TPart = record
               T, V: word;
             end;
var L, N: word;
    Parts: array [1..1000] of TPart;
    Time: real;
    FullTime: word;
procedure ReadData;
var Input: Text;
    i: integer;
begin
  FullTime:=0;
  Assign ( Input, 'train.in');
  Reset ( Input);
  Read ( Input, L, N);
  for i:=1 to N do
    with Parts[i] do
      begin
        Read ( Input, T, V);
        FullTime:=FullTime+T;
      end;
  Close ( Input);
end;
function XfromT ( aT: real): real;
var Result: real;
    i: integer;
    T: real;
begin
  T:=aT; Result:=0; i:=0;
  while T>0 do
    begin
      Inc ( i);
      if Parts[i].T<T then Result:=Result+Parts[i].T*Parts[i].V
                      else Result:=Result+T*Parts[i].V;
      T:=T-Parts[i].T;
    end;
  XfromT:=Result;
end;
function TfromX ( aX: real): real;
var Result: real;
    i: integer;
    X: real;
begin
  X:=aX; Result:=0; i:=0;
  while X>0 do
    begin
      Inc ( i);
      if Parts[i].T*Parts[i].V<=X then Result:=Result+Parts[i].T
                                  else Result:=Result+X/Parts[i].V;
      X:=X-Parts[i].T*Parts[i].V;
    end;
  TfromX:=Result;
end;
procedure Counting;
type TPoint = record
                X, T: real;
              end;
var i, j: integer;
    Pt, Pt1, Pt2: TPoint;
    TX1, TX2: real;
begin
  Time:=TFromX ( L); Pt.X:=0; Pt.T:=Time;
  for i:=1 to N-1 do
    begin
      Pt.X:=Pt.X+Parts[i].V*Parts[i].T;
      Pt.T:=Pt.T+Parts[i].T;
      if Pt.T<=FullTime then
        if XfromT ( Pt.T)-L<Pt.X then
          begin
            TX2:=TfromX ( Pt.X+L);
            Time:=Time+(TfromX ( Pt.X+L)-Pt.T);
          end;
    end;
end;
procedure WriteResult;
var Output: Text;
begin
  Assign ( Output, 'train.out');
  Rewrite ( Output);
  WriteLn ( Output, Time:10:3);
  Close ( Output);
end;
begin
  ReadData;
  Counting;
  WriteResult;
end.