Var XM,YM : LongInt;
N : LongInt;
Xb,Yb,Xe,Ye : Array[1..1100] of Integer;
A,B,C,D,E : Longint;
NR,NR1 : LongInt;
X1,Y1,X2,Y2 : Array[1..5500] of Integer;
bol : Boolean;

Procedure ReadFile;
Begin
  Assign(Input,'divide.in');
  ReSet(Input);
  ReadLn(XM,YM);
  ReadLn(N);
  For A:=1 to N do
  Begin
    ReadLn(Xb[A],Yb[A],Xe[A],Ye[A]);
    If Xb[A]>Xe[A] then
    Begin
      B:=Xb[A];Xb[A]:=Xe[A];Xe[A]:=B;
    End;
    If Yb[A]>Ye[A] then
    Begin
      B:=Yb[A];Yb[A]:=Ye[A];Ye[A]:=B;
    End;
  End;
  Close(Input);
End;

Function Cross(Y1,Y2,Y3,Y4 : LongInt) : Boolean;
Begin
  If (Abs(Y4-Y1)+Abs(Y1-Y3)=Y4-Y3) or (Abs(Y4-Y2)+Abs(Y2-Y3)=Y4-Y3) or
     (Abs(Y1-Y3)+Abs(Y3-Y2)=Y2-Y1) or (Abs(Y1-Y4)+Abs(Y4-Y2)=Y2-Y1) then
     If not((Y1=Y4) or (Y2=Y3)) then
       Cross:=True else Cross:=False;
End;

Function CrossE(Y1,Y2,Y3,Y4 : LongInt) : Boolean;
Begin
  If (Abs(Y4-Y1)+Abs(Y1-Y3)=Y4-Y3) or (Abs(Y4-Y2)+Abs(Y2-Y3)=Y4-Y3) or
     (Abs(Y1-Y3)+Abs(Y3-Y2)=Y2-Y1) or (Abs(Y1-Y4)+Abs(Y4-Y2)=Y2-Y1) then
       CrossE:=True else CrossE:=False;
End;

Function InSide(X1,X2,X3,X4 : LongInt) : Boolean;
Begin
  If (X3>=X1) and (X4<=X2) then InSide:=True;
End;

Procedure LeftRight;
Begin
  For A:=1 to N do
    If Xb[A]=Xe[A] then
    Begin
      {Left area}
      B:=0;
      For C:=1 to N do
        If (Xe[C]>B) and (Xe[C]<Xb[A]) and Cross(Yb[C],Ye[C],Yb[A],Ye[A]) then B:=Xe[C];
      If B=Xb[A] then B:=0;
      If B<>Xb[A] then
      Begin
        C:=YM;
        D:=0;
        For E:=1 to N do
          If Cross(B,Xb[A],Xb[E],Xe[E]) then
          Begin
            If (Yb[E]<C) and (Yb[E]>=Ye[A]) then C:=Yb[E];
            If (Ye[E]>D) and (Ye[E]<=Yb[A]) then D:=Ye[E];
          End;
        If (B<>Xb[A]) and (D<>C) then
        Begin
          Inc(NR);
          X1[NR]:=B;
          X2[NR]:=Xb[A];
          Y1[NR]:=D;
          Y2[NR]:=C;
        End;
      End;
    End;
  B:=-1;
  For A:=1 to N do
    If (Xb[A]=Xe[A]) and (Xe[A]>B) and (Xe[A]<XM) then Begin C:=A;B:=Xe[A];End;

  If B=-1 then Exit;
  A:=C;
    If Xb[A]=Xe[A] then
    Begin
      {Right area}
      B:=XM;
      For C:=1 to N do
        If (Xe[C]<B) and (Xe[C]>Xb[A]) and Cross(Yb[C],Ye[C],Yb[A],Ye[A]) then B:=Xe[C];
      If B=Xb[A] then B:=XM;
      If B<>Xb[A] then
      Begin
        C:=YM;
        D:=0;
        For E:=1 to N do
          If Cross(Xb[A],B,Xb[E],Xe[E]) then
          Begin
            If (Yb[E]<C) and (Yb[E]>=Ye[A]) then C:=Yb[E];
            If (Ye[E]>D) and (Ye[E]<=Yb[A]) then D:=Ye[E];
          End;
        If (B<>Xb[A]) and (D<>C) then
        Begin
          Inc(NR);
          X1[NR]:=Xb[A];
          X2[NR]:=B;
          Y1[NR]:=D;
          Y2[NR]:=C;
        End;
      End;
    End;
End;

Procedure DownUp;
Begin
  For A:=1 to N do
    If Yb[A]=Ye[A] then
    Begin
      {Left area}
      B:=0;
      For C:=1 to N do
        If (Ye[C]>B) and (Ye[C]<Yb[A]) and Cross(Xb[C],Xe[C],Xb[A],Xe[A]) then B:=Ye[C];
      If B=Yb[A] then B:=0;
      If B<>Yb[A] then
      Begin
        C:=XM;
        D:=0;
        For E:=1 to N do
          If Cross(B,Yb[A],Yb[E],Ye[E]) then
          Begin
            If (Xb[E]<C) and (Xb[E]>=Xe[A]) then C:=Xb[E];
            If (Xe[E]>D) and (Xe[E]<=Xb[A]) then D:=Xe[E];
          End;
        If (B<>Yb[A]) and (D<>C) then
        Begin
          Inc(NR);
          Y1[NR]:=B;
          Y2[NR]:=Yb[A];
          X1[NR]:=D;
          X2[NR]:=C;
        End;
      End;
    End;

  B:=-1;
  For A:=1 to N do
    If (Yb[A]=Ye[A]) and (Ye[A]>B) and (Ye[A]<YM) then Begin C:=A;B:=Ye[A];End;

  If B=-1 then Exit;
  A:=C;
    If Yb[A]=Ye[A] then
    Begin
      {Right area}
      B:=YM;
      For C:=1 to N do
        If (Ye[C]<B) and (Ye[C]>Yb[A]) and Cross(xb[C],Xe[C],Xb[A],Xe[A]) then B:=Ye[C];
      If B=Yb[A] then B:=YM;
      If B<>Yb[A] then
      Begin
        C:=XM;
        D:=0;
        For E:=1 to N do
          If Cross(Yb[A],B,Yb[E],Ye[E]) then
          Begin
            If (Xb[E]<C) and (Xb[E]>=Xe[A]) then C:=Xb[E];
            If (Xe[E]>D) and (Xe[E]<=Xb[A]) then D:=Xe[E];
          End;
        If (B<>Yb[A]) and (D<>C) then
        Begin
          Inc(NR);
          Y1[NR]:=yb[A];
          Y2[NR]:=B;
          X1[NR]:=D;
          X2[NR]:=C;
        End;
      End;
    End;
End;

Procedure Work;
Begin
  NR:=0;
  LeftRight;
  DownUp;
  NR1:=NR;
  NR:=0;
  DownUp;
  LeftRight;
  Assign(Output,'divide.out');
  ReWrite(Output);
  If NR<=NR1 then
  Begin
    WriteLn(NR);
    For A:=1 to NR do
    Begin
      WriteLn(X1[A],' ',Y1[A],' ',X2[A],' ',Y2[A]);
    End;
  End else
  Begin
    LeftRight;
    WriteLn(NR1);
    For A:=1 to NR do
    Begin
      WriteLn(X1[A],' ',Y1[A],' ',X2[A],' ',Y2[A]);
    End;
  End;
  Close(Output);
End;

Begin
  ReadFile;
  Work;
End.