{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 36384,0,655360}
PROGRAM Task2;
  Const
    inp = 'filya.in';
    out = 'filya.out';
    col = 6;
    pr  : Array [1..4,1..2] of shortint =
    (
     (1,0), (0,1), (-1,0), (0,-1)
    );
  Type
    dosk = Array [-1..45, -1..48] Of byte;
    gr   = Array [0..45] Of byte;
  Var
    inf, ouf   : Text;
    Time       : Longint;
    Timer      : Longint Absolute $0000:$046C;
    d          : Dosk;
    best       : Byte;
    Last       : Byte;
    q, w       : Gr;
    MinQ, MinW : Word;

  Procedure Init;
    Var i,j : Word;
        ch  : Char;
        err : Integer;
  Begin
    Assign(inf, inp); Assign(ouf, out);
    Reset(inf); ReWrite(ouf);
     FillChar(d,SizeOf(d),0);
     FillChar(q, SizeOf(q),0);
     FillChar(w, SizeOf(w),0);
     w[1] := 1; q[1] := 1;
     For i := 1 To 41 Do
     Begin
       For j := 1 To 45 Do
       Begin
         Read(inf, ch);
         Val(ch, d[i,j], err);
         If (i <> 1) And (j <> 1) Then
           If d[i,j] = d[1,1] Then
           Begin inc(q[i]); inc(w[j]) End;
       End;
       ReadLn(inf);
     End;
    Close(inf);
    Last := d[1,1]; q[0] := 41; w[0] := 45;
  End;

  Procedure Ser(k: Byte; Var co : Word; d : dosk);
    Var i,j : Word;

    Procedure Search1(x,y: Word);
      Var i : Word;
    Begin
      If d[x,y] = k Then
      Begin
        inc(d[x,y],6);
        inc(co);
      End;
      For i := 1 To 4 Do
       If d[x+pr[i,1], y+pr[i,2]] = k Then
        Search1(x+pr[i,1], y+pr[i,2]);
    End;

    Procedure Search2(x,y: Word);
      Var i : Word;
    Begin
      If ((Timer-Time) / 18.2 > 4.6) Then Exit;
      inc(d[x,y],6); Search1(x,y);
      For i := 1 To 4 Do
       If d[x+pr[i,1], y+pr[i,2]] = last Then
        Search2(x+pr[i,1], y+pr[i,2]);
    End;

  Begin
    For i := 1 To MinQ Do
     For j := 1 To MinW Do
      If (i <> 1) And (j <> 1) Then inc(d[i,j],6);
    co := 0;
    For i := 1 To MinQ Do Search2(i,MinW+1);
    For i := 1 To MinW Do Search2(MinQ+1,i);
  End;

  Function Min(w: Gr): Word;
    Var i : Word;
        m : Word;
  Begin
    i := 0; m := 20;
    Repeat
      inc(i);
      If m > w[i] Then m := w[i];
    Until (i = w[0]);
    Min := m;
  End;

  Procedure Solve;
    Var i : Word;
        bb,co: Word;
  Begin
    Time := Timer; bb := 0; i := 0;
    MinQ := Min(q); MinW := Min(w);
    Repeat
      inc(i);
      If (i <> d[41,45]) And (i <> Last) Then
      Begin
        Ser(i,co, d);
        If co > bb Then
        Begin Best := i; bb := co End;
      End;
    Until (i >= col) Or ((Timer-Time) / 18.2 > 4.6);
    Randomize;
    If best = 0 Then 
     Repeat
       best := Random(6)+1;
     Until (best <> last) And (best <> d[41,45]);
  End;

  Procedure Done;
  Begin
    Write(ouf, best);
    Close(ouf);
  End;

BEGIN
  Init; Solve; Done;
END.