program p1908_5;

 const inf=1e100;
       eps=1e-10;

 var l,n:integer;
     t,v:array[1..1000] of double;
     st,sx:array[0..1000] of double;

 var dt,tt:double;

 function intersects:boolean; { (t,x-l) and (t+tt,x) }
  var i,j:longint;
      t,x:double;
      k,b,z:double;
      cdt,dtopt:double;
  begin
   dtopt:=0;
   cdt:=0;

   { check right }
   for i:=0 to n do begin
    t:=st[i]+tt;
    x:=sx[i];
    for j:=1 to n do if (st[j]>t) and (st[j-1]<=t) then break; { [j-1] - [j] }
    if not((st[j]>t) and (st[j-1]<=t)) then continue;
    k:=v[j];
    b:=sx[j]-l-k*st[j];
    z:=x-(k*t+b);
    if z>0 then begin
     if k>eps then cdt:=z/k else cdt:=inf;
     if st[j]-t<cdt then cdt:=st[j]-t;
    end;
    if dtopt<cdt then dtopt:=cdt;
   end;

   { check down }
   for i:=0 to n do begin
    t:=st[i];
    x:=sx[i]-l;
    for j:=1 to n do if (st[j]+tt>=t) and (st[j-1]+tt<t) then break; { [j-1] - [j] }
    if not((st[j]+tt>=t) and (st[j-1]+tt<t)) then continue;
    k:=v[j];
    b:=sx[j]-k*(st[j]+tt);
    z:=(k*t+b)-x;
    if z>0 then begin
     if k>eps then cdt:=z/k else cdt:=inf;
     if t-(st[j-1]+tt)<cdt then cdt:=t-(st[j-1]+tt);
    end;
    if dtopt<cdt then dtopt:=cdt;
   end;

   if dtopt>eps
    then begin intersects:=true; dt:=dtopt end
    else intersects:=false;
  end;

 procedure moveright;
  begin
   tt:=tt+dt;
  end;

 var i,j:integer;
 begin
  assign(input,'train.in');
  reset(input);
  readln(l);
  readln(n);
  for i:=1 to n do readln(t[i],v[i]);
  close(input);
  st[0]:=0; for i:=1 to n do st[i]:=st[i-1]+t[i];
  sx[0]:=0; for i:=1 to n do sx[i]:=sx[i-1]+v[i]*t[i];

  while intersects do
   moveright;

  assign(output,'train.out');
  rewrite(output);
  writeln(tt:1:10);
  close(output);

 end.
