program Hash4;

const
  LDat:array [1..15] of Integer =
    (19,56,207,604,1181,1501,1649,1542,1190,846,566,327,181,87,44);

function TwoIn(X:Integer):LongInt;
var
  R:LongInt;
  I:Integer;
begin
  R:=1;
  for I:=1 to X do
    R:=R*2;
  TwoIn:=R;
end;

function Hash(S:string):Byte;
var
  R:LongInt;
  I:Integer;
begin
  R:=0;
  for I:=1 to Length(S)-1 do
    R:=R+LDat[I];

  for I:=1 to Length(S) do
    R:=R+Ord(S[I])*(TwoIn(I+Round(Sqrt(Length(S)))));

  R:=(R mod 255)+1;

  Hash:=R;
end;

procedure Run;
var
  S:string;
begin
  AsSign(Input,'HASH.IN');
  ReSet(Input);
  AsSign(Output,'HASH.OUT');
  ReWrite(Output);

  while not SeekEoF(Input) do
    begin
      ReadLn(S);
      WriteLn(Hash(S));
    end;

  Close(Input);
  Close(Output);
end;

begin
  Run;
end.