{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
program Rail1;

var
  D:array [1..5000,1..3] of Integer;
  Was:array [1..5000] of Byte;
  N:Integer;
  Cr:Integer;

procedure LoadData;
var
  I,J:Integer;
begin
  AsSign(Input,'RAIL.IN');
  ReSet(Input);
  ReadLn(N);
  for I:=1 to N do
    for J:=1 to 3 do
      Read(D[I,J]);
  Close(Input);
  AsSign(Output,'RAIL.OUT');
  ReWrite(Output);
end;

procedure MakeRail(From:Integer);
var
  I,J:Integer;
begin
  Was[From]:=Cr+1;
  for I:=1 to 3 do
    if (Was[From]<2) and (Was[D[From,I]]=0) then
      begin
        WriteLn(From,' ',D[From,I]);
        MakeRail(D[From,I]);
        Inc(Was[From]);
      end;
end;

function FNV:Integer;
var
  I:Integer;
begin
  for I:=N downto 1 do
    if (Was[I]=0) then
      begin
        FNV:=I;
        Exit
      end;
  FNV:=0;
end;

function FV1:Integer;
var
  I:Integer;
begin
  for I:=N downto 1 do
    if (Was[I]=1) then
      begin
        FV1:=I;
        Exit
      end;
  FV1:=0;
end;

procedure WriteBad;
begin
  ReWrite(Output);
  Write('NO SOLUTION');
end;

procedure Run;
var
  OldR,R:Integer;
begin
  OldR:=0;
  R:=FNV;
  while (R<>OldR) and (R<>0) do
    begin
      MakeRail(R);
      OldR:=R;
      R:=FNV;
    end;

  if FNV<>0 then
    begin
      Cr:=1;
      OldR:=0;
      R:=FV1;
      while (R<>OldR) and (R<>0) do
        begin
          MakeRail(R);
          OldR:=R;
          R:=FV1;
        end;

      if FNV<>0 then WriteBad;
    end;

  Close(Output);
end;

begin
  LoadData;
  Run;
end.