program Bal1;

var
  M:LongInt;
  N:LongInt;

  Ang:array [1..1000] of LongInt;
  Sde:array [1..1000] of LongInt;

procedure LoadData;
begin
  AsSign(Input,'BAL.IN');
  ReSet(Input);
  Read(M,N);
  Close(Input);
end;

function SolveIt:Boolean;
var
  K:LongInt;
  L:LongInt;
  I:Integer;
begin
  K:=(N div M)+1;
  L:=N mod M;

  if (L=0) then
    begin
      for I:=1 to M do
        Sde[I]:=K-1;

      SolveIt:=True;
      Exit;
    end;

  for I:=1 to M do
    if I<=L then Sde[I]:=K
            else Sde[I]:=K-1;

  if (L>(M div 2)) or (K>1) then
    begin

      for I:=M downto L+2 do
        begin
          Sde[I]:=Sde[I]-1;
          Ang[I]:=1;
        end;

      Sde[1]:=Sde[1]-1;
      Ang[1]:=1;

      SolveIt:=True;
    end
  else
    if L=(M div 2) then
      begin
        for I:=1 to M do
          begin
            Sde[I]:=0;
            if (I mod 2)=0 then Ang[I]:=1;
            SolveIt:=True;
          end
      end
    else
      SolveIt:=False;

end;

procedure WriteAnswer;
var
  I:Integer;
begin
  AsSign(Output,'BAL.OUT');
  ReWrite(Output);

  Write(Sde[M],' ');
  for I:=1 to M-1 do
    begin
      WriteLn(Ang[I]);
      Write(Sde[I],' ');
    end;

  WriteLn(Ang[M]);

  Close(Output);
end;

procedure WriteNo;
begin
  AsSign(Output,'BAL.OUT');
  ReWrite(Output);
  WriteLn('NO');
  Close(Output);
end;

begin
  LoadData;
  if SolveIt then WriteAnswer
             else WriteNo;
end.