uses crt;

type
  thv=(vert,horiz);
  trec=record
    hv: thv;
    x1,y1,x2,y2: word;
  end;
var
  zarr: array[1..1000] of trec;
  zan: word;
  zall: array[1..1000] of trec;
  znum,maxx,maxy: word;

function inpx1(x1,y1,x2,y2:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to znum do
    if (((zarr[i].y1<=y2)and(zarr[i].y2>=y1)) and (x1=zarr[i].x1)) and (zarr[i].hv=vert) then j:=true;
{    if (((x>=zarr[i].x1) and (x<=zarr[i].x2)) and ((y>=zarr[i].y1) and (y<=zarr[i].y2))) and (zarr[i].hv=vert) then j:=true;}
  inpx1:=j;
end;

function inpx2(x1,y1,x2,y2:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to znum do
    if (((zarr[i].y1<=y2)and(zarr[i].y2>=y1)) and (x2=zarr[i].x1)) and (zarr[i].hv=vert) then j:=true;
{    if (((x>=zarr[i].x1) and (x<=zarr[i].x2)) and ((y>=zarr[i].y1) and (y<=zarr[i].y2))) and (zarr[i].hv=vert) then j:=true;}
  inpx2:=j;
end;

function inpy1(x1,y1,x2,y2:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to znum do
    if (((zarr[i].x1<=x2)and(zarr[i].x2>=x1)) and (y1=zarr[i].y1)) and (zarr[i].hv=horiz) then j:=true;
{    if ((((zarr[i].x1>=x1) and (zarr[i].x2<=x2)) or ((x1>=zarr[i].x1) and (x2<=zarr[i].x2))) and (y2+1=zarr[i].y2))
      and (zarr[i].hv=horiz) then j:=true;
{    if (((x>=zarr[i].x1) and (x<=zarr[i].x2)) and ((y>=zarr[i].y1) and (y<=zarr[i].y2))) and (zarr[i].hv=horiz) then j:=true;}
  inpy1:=j;
end;

function inpy2(x1,y1,x2,y2:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to znum do
    if (((zarr[i].x1<=x2)and(zarr[i].x2>=x1)) and (y2=zarr[i].y1)) and (zarr[i].hv=horiz) then j:=true;
{    if ((((zarr[i].x1>=x1) and (zarr[i].x2<=x2)) or ((x1>=zarr[i].x1) and (x2<=zarr[i].x2))) and (y1-1=zarr[i].y1))
      and (zarr[i].hv=horiz) then j:=true;
{    if (((x>=zarr[i].x1) and (x<=zarr[i].x2)) and ((y>=zarr[i].y1) and (y<=zarr[i].y2))) and (zarr[i].hv=horiz) then j:=true;}
  inpy2:=j;
end;

function inp(x,y:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to znum do
    if ((x>=zarr[i].x1) and (x<=zarr[i].x2)) and ((y>=zarr[i].y1) and (y<=zarr[i].y2)) then j:=true;
  inp:=j;
end;

function inall(x,y:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to zan do
    if ((x>zall[i].x1) and (x<zall[i].x2)) and ((y>zall[i].y1) and (y<zall[i].y2)) then j:=true;
  inall:=j;
end;

function iii(x1,y1,x2,y2:word): boolean;
var i: word; j: boolean;
begin
  j:=false;
  for i:=1 to zan do
    if ((zall[i].x1=x1) and (zall[i].y1=y1)) and ((zall[i].x1=x1) and (zall[i].y1=y1)) then j:=true;
  iii:=j;
end;

procedure draw;
var i,j: integer;
begin
  for i:=1 to maxx do begin gotoxy(i*2,1); write('##'); end;
  for i:=1 to maxx do begin gotoxy(i*2,maxy); write('##'); end;
  for i:=1 to maxy do begin gotoxy(1,i); write('#'); end;
  for i:=1 to maxy do begin gotoxy(maxx*2+1,i); write('#'); end;
  for i:=1 to znum do begin
    if zarr[i].x1=zarr[i].x2 then
      for j:=1 to zarr[i].y2-zarr[i].y1+1 do begin
        gotoxy(zarr[i].x1*2,j+zarr[i].y1); write('|');
      end;
    if zarr[i].y1=zarr[i].y2 then
      for j:=1 to zarr[i].x2-zarr[i].x1+1 do begin
        gotoxy((j+zarr[i].x1)*2,zarr[i].y1); write('--');
      end;
  end;
end;

var
  xc1,yc1,xc2,yc2: word;
  xx1,yy1,xx2,yy2: boolean;
procedure solve;
var
  i,j,a,b,c,m: integer;
begin
  xx1:=false; yy1:=false;
  xx2:=false; yy2:=false;
  repeat
    if (not inpx1(xc1,yc1,xc2,yc2)) and (xc1>0) then dec(xc1) else xx1:=true;
    if (not inpx2(xc1,yc1,xc2,yc2)) and (xc2<maxx) then inc(xc2) else xx2:=true;
    if (not inpy1(xc1,yc1,xc2,yc2)) and (yc1>0) then dec(yc1) else yy1:=true;
    if (not inpy2(xc1,yc1,xc2,yc2)) and (yc2<maxy) then inc(yc2) else yy2:=true;
  until ((xx1=true) and (xx2=true)) and ((xx1=true) and (xx2=true));
  if (zan<>0) then begin
    if (xc1<>xc2) and (yc1<>yc2) then
    if (((not inall(xc1,yc1)) and (not inall(xc2,yc2)))) and (not iii(xc1,yc1,xc2,yc2)) then begin
      inc(zan);
      zall[zan].x1:=xc1;
      zall[zan].y1:=yc1;
      zall[zan].x2:=xc2;
      zall[zan].y2:=yc2;
    end;
  end else begin
    inc(zan);
    zall[zan].x1:=xc1;
    zall[zan].y1:=yc1;
    zall[zan].x2:=xc2;
    zall[zan].y2:=yc2;
  end;
  if (zan>=znum*2) then m:=znum*3;
end;
var
  f: text;
  x,y,i,j,a,b,c,m: integer;
  stx,sty: word;
begin
  randomize;
  zan:=0;
  assign(f,'divide.in');
  reset(f);
  readln(f,maxx,maxy);
  readln(f,znum);
  stx:=maxx div 100;
  sty:=maxy div 100;
  for i:=1 to znum do readln(f,zarr[i].x1,zarr[i].y1,zarr[i].x2,zarr[i].y2);
  close(f);
  for i:=1 to znum do begin
    if (zarr[i].x1>zarr[i].x2) or (zarr[i].y1>zarr[i].y2) then begin
      a:=zarr[i].x2;
      zarr[i].x2:=zarr[i].x1;
      zarr[i].x1:=a;
      a:=zarr[i].y2;
      zarr[i].y2:=zarr[i].y1;
      zarr[i].y1:=a;
    end;
    if zarr[i].x1=zarr[i].x2 then zarr[i].hv:=vert else zarr[i].hv:=horiz;
  end;
  for x:=0 to maxx do begin
    for y:=0 to maxy do begin
      xc1:=x; xc2:=xc1;
      yc1:=y; yc2:=yc1;
      if (not inall(x,y)) then solve;
      y:=y+sty;
    end;
    x:=x+stx;
  end;
  assign(f,'divide.out');
  rewrite(f);
  writeln(f,zan);
  for i:=1 to zan do writeln(f,zall[i].x1,' ',zall[i].y1,' ',zall[i].x2,' ',zall[i].y2);
  close(f);
end.