{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 65520,0,655360}

Program Quick;

Const WorkTime=350;
      MaxN=5001;

Var A:array [1..MaxN,1..3] of Byte;
    Ne:array [1..MaxN] of Boolean;
    O,F:array [0..MaxN] of Integer;
    C:array [1..MaxN] of Integer;
    N,Yk,T,Tt:Integer;
    ItIs:Boolean;
    Time:LongInt Absolute $40:$6C;
    BegTime:LongInt;

Procedure Init;
Var I:Integer;
Begin
  BegTime:=Time;
  Assign(InPut,'Rail.In');
  ReSet(InPut);
  ReadLn(N);
  For I:=1 to N do
      Read(A[I,1],A[I,2],A[I,3]);
  Close(InPut);
End;

Procedure TimeOut;
Begin
  IF Time<BegTime+WorkTime Then Exit;
  Assign(OutPut,'Rail.Out');
  ReWrite(OutPut);
  WriteLn('NO SOLUTION');
  Close(OutPut);
  Halt;
End;

Procedure Print;
Var I:Integer;
Begin
  For I:=1 to Yk-1 do
     WriteLn(O[I],' ',O[I+1]);
  ItIs:=True;
End;

Procedure Rec(V:Integer);
Var I:Integer;
Begin
  TimeOut;
  Ne[V]:=False;
  IF Yk=F[Tt+1]-F[Tt] Then Print;
  IF ItIs Then Exit;
  For I:=1 to 3 do
    IF Ne[A[V,I]] Then
    Begin
      Inc(Yk);
      O[Yk]:=A[V,I];
      Rec(A[V,I]);
      IF ItIs Then Exit;
      Dec(Yk)
    End;
  Ne[V]:=True;
End;

Procedure Glu(V:Integer);
Var I:Integer;
Begin
  IF C[V]<>0 Then Exit;
  C[V]:=T;
  For I:=1 to 3 do Glu(A[V,I]);
End;

Procedure Solve;
Var I:Integer;
Begin
  FillChar(F,SizeOf(F),0);
  FillChar(C,SizeOF(C),0);
  T:=0;
  For I:=1 to N do
    IF C[I]=0 Then
      Begin
        Inc(T);
        F[T]:=I;
        Glu(I);
      End;
  F[T+1]:=N+1;
  FillChar(Ne,SizeOf(Ne),1);
  Assign(OutPut,'Rail.Out');
  Rewrite(OutPut);
  For I:=1 to T do
    Begin
      ItIs:=False;
      Tt:=I;
      Yk:=1;
      O[Yk]:=F[I];
      Rec(F[I]);
    End;
  Close(OutPut);
End;

Begin
  Init;
  Solve;
End.