{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}

Program S2107_5;
Const MaxN=1000;
      Eps=0.0000001;

Type Tos=record
           T,L:Real;
         End;
     Line=Record
            A,B,C:Real;
          End;

Var A,B:array [1..MaxN] of Tos;
    Dx:array [1..MaxN*2] of Real;
    N,Tm:Integer;
    L:Real;

Procedure Init;
Var I:integer;
Begin
  Assign(InPut,'Train.In');
  ReSet(InPut);
  ReadLn(L);
  ReadLn(N);
  For I:=1 to N do
     Read(A[I].T,A[I].L);
  Close(InPut);
End;

Procedure MakeWay;
Var I:Integer;
Begin
  B[1].T:=0;
  B[1].L:=0;
  For I:=1 to N do
     Begin
       B[I+1].T:=B[I].T+A[I].T;
       B[I+1].L:=B[I].L+A[I].T*A[I].L;
     End;
  Inc(N);
End;

Procedure TLine(Const T1,T2:Tos;Var R:Line);
Begin
  With R do
    Begin
      A:=T1.L-T2.L;
      B:=T2.T-T1.T;
      C:=T1.T*T2.L-T1.L*T2.T;
    End;
End;

Procedure PTos(Const L1,L2:Line;Var Is:Boolean;Var P:Tos);
Var R:Real;
Begin
  R:=L1.B*L2.A-L1.A*L2.B;
  IF Abs(R)>Eps Then
     With P do
       Begin
         T:=(L1.C*L2.B-L1.B*L2.C)/R;
         L:=(L1.A*L2.C-L1.C*L2.A)/R;
         Is:=True;
       End
       Else Is:=False;
End;

Function Long(Const F,S:Tos):Real;
Var C1,C2:Real;
Begin
  C1:=Sqr(F.T-S.T);
  C2:=Sqr(F.L-S.L);
  Long:=Sqrt(C1+C2);
End;

Function FindDx(T:Tos):Real;
Var L1,L2:Line;
    H:Tos;
    Is:Boolean;
Begin
    While (B[Tm+1].L<T.L) And (Tm<N) do Inc(Tm);
    H.T:=T.T+1;
    H.L:=T.L;
    TLine(T,H,L1);
    TLine(B[Tm],B[Tm+1],L2);
    PTos(L1,L2,Is,H);
    IF Not Is Then Inc(Tm);
  FindDx:=Long(T,H);
End;

Procedure Print(Mx:Real);
Begin
  Assign(OutPut,'Train.Out');
  ReWrite(OutPut);
  WriteLn(Mx:0:8);
  Close(OutPut);
End;

Procedure Solve;
Var I:Integer;
    Mx:Real;
    H:Tos;
Begin
  MakeWay;
  Tm:=1;
  For I:=2 to N do
    Begin
      H.T:=B[I].T;
      H.L:=B[I].L-L;
      IF H.L>=0 Then Dx[I]:=FindDx(H)
                Else Dx[I]:=0;
    End;
  For I:=1 to N do B[I].L:=B[I].L-L;
  Tm:=1;
  H.T:=0;
  H.L:=0;
  Dx[1]:=FindDx(H);
  For I:=1 to N do
    Begin
      H.T:=B[I].T;
      H.L:=B[I].L+L;
      IF H.L<=B[N].L Then Dx[N+I]:=FindDx(H)
                     Else Dx[N+I]:=0;
    End;
  H.T:=B[N].T;
  Mx:=Dx[1];
  For I:=2 to N*2 do
     IF Dx[I]>Mx Then Mx:=Dx[I];
  IF B[N].L>0 Then Print(Mx)
              Else Print(B[N].T);
End;

Begin
  Init;
  Solve;
End.