#include <stdio.h>

#define INPUT "hash.in"
//#define INPUT "words.txt"
//#define INPUT "con"
#define OUTPUT "hash.out"

#define MAX 80
//#define TEST

FILE *in, *out;

static int already[256];

/*
char abc2idx[] = ""
                 "";
*/

char abc2idx[] = "㧫"
                 "";

int words = 0;

int code (char c)
{
        int i;

        for (i = 0; i < 32 * 2; i ++)
                if (abc2idx[i] == c)
                   return i;

        return 0;
}

int hash (char *str)
{
        char *p;

        int
           d,
           res = 0;

        for (p = str; *p; p ++)
        {
             res = (res & 15) | ((res & 0xF0) << 1);
             d = code (*p) % 32;
             if (d < 16)
                res += d;
             else
                 res += ((d % 16) + 1) << 4;

             res &= 255;
             if (!res)
                res = 0x10;
        }

        already[res]++;
        return res;
}

int main (void)
{
        int n;

        char
            str[MAX + 1];

        // 뢠 䠩.
        if ((in = fopen (INPUT, "rt")) == NULL)
        {
                printf ("Can't open "INPUT"\n");
                return 1;
        }

        if ((out = fopen (OUTPUT, "wt")) == NULL)
        {
                fclose (in);
                printf ("Can't create "OUTPUT"\n");
                return 2;
        }

        while (fscanf (in, "%s", str) > 0)
        {
              fprintf (out, "%d\n", hash (str));
              words ++;
        }

        fclose (in);
        fclose (out);

#if defined (TEST)
        int sum = 0;
        for (n = 0; n < 256; n ++)
            if (already[n] > 1)
               sum += already[n] - 1;

        printf (" - %d ( %d ᫮)\n", sum, words);
#endif

      return 0;
}
