{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
program P2110_3;
uses crt;
var
  tcount:integer;
  rcount:integer;
  rails:array[1..7000] of record
          fr_:integer;
          to_:integer;
          co_:byte;
        end;
  tco1,tco2:array[1..5000] of integer;
  tco1count, tco2count:integer;
function newrail(from, to_:integer):boolean;
var
  i:integer;
  ok:Boolean;
begin
  ok:=true;
  for i:=1 to rcount do
    begin
      if rails[i].to_ = from then
        if rails[i].fr_ = to_ then
          begin
            ok:=false;
            break;
          end;
    end;
  newrail:=ok;
end;
function newtco1(town:integer):boolean;
var
  i:integer;
  ok:Boolean;
begin
  ok:=true;
  for i:=1 to tco1count do
    begin
      if tco1[i] = town then
        begin
          ok:=false;
          break;
        end;
    end;
  newtco1:=ok;
end;
function newtco2(town:integer):boolean;
var
  i:integer;
  ok:Boolean;
begin
  ok:=true;
  for i:=1 to tco2count do
    begin
      if tco2[i] = town then
        begin
          ok:=false;
          break;
        end;
    end;
  newtco2:=ok;
end;
procedure readrail;
var
  f:text;
  i,j:integer;
  t:array[1..3] of integer;
begin
  assign(f,'rail.in');
  reset(f);
  read(f,tcount);
  for i:=1 to tcount do
    begin
      read(f,t[1],t[2],t[3]);
      for j:=1 to 3 do
        if newrail(i,t[j]) then
          begin
            inc(rcount);
            rails[rcount].fr_:=i;
            rails[rcount].to_:=t[j];
          end;
    end;
  close(f);
end;
procedure trace;
var
  i:integer;
begin
  for i:=1 to rcount do
    begin
      if newtco1(rails[i].to_) and newtco1(rails[i].fr_) then
        begin
          inc(tco1count);
          tco1[tco1count]:=rails[i].to_;
          rails[i].co_:=1;
          inc(tco1count);
          tco1[tco1count]:=rails[i].fr_;
          rails[i].co_:=1;
        end;
    end;
  if tco1count<tcount then
  for i:=1 to rcount do
    if newtco1(rails[i].fr_) then
      BEGIN
          inc(tco1count);
          tco1[tco1count]:=rails[i].to_;
          rails[i].co_:=1;
      end;
  for i:=1 to rcount do
    if rails[i].co_=0 then
      begin
        if newtco2(rails[i].fr_) then
          BEGIN
              inc(tco2count);
              tco2[tco2count]:=rails[i].fr_;
          end;
        if newtco2(rails[i].to_) then
          BEGIN
              inc(tco2count);
              tco2[tco2count]:=rails[i].to_;
          end;

      end;
end;
procedure writeout;
var
  f:text;
  i:integer;
begin
  assign(f,'rail.out');
  rewrite(f);
  if (tco1count<>tcount) or (tco2count<>tcount) then
    begin
      writeln(f,'NO SOLUTION');
    end
  else
    begin
      for i:=1 to rcount do
        if rails[i].co_=1 then
          writeln(f,rails[i].fr_,' ',rails[i].to_);
    end;
  close(f);
end;
var
  i:integer;
begin
  rcount:=0;
  tco1count:=0;
  tco2count:=0;
  for i:=1 to 5000 do
    rails[i].co_:=0;
  readrail;
  trace;
  writeout;
end.