program HashFunction; {Russia Olymp'98 - Nikokoshev Ilia}{1}
{ $define DEBUG}
{ $define TEST}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
{$ifdef DEBUG} {$R+,Q+} {$endif}

const
  InFile='hash.in';
  OutFile='hash.out';

function HashFunc(const st:string):byte;
  var {i:byte;}
      i,res:longint;
      st2:char;
  const h:set of byte=[43,128,143,243];
  begin
  res:=65536;
  if length(st)=1 then st2:=' ' else st2:=st[2];
{
  for i:=1 to length(st) do
    inc(res,ord(st[i]));
{}
  for i:=1 to length(st) do
     if i mod 2=0 then inc(res,i*ord(st[i])) else dec(res,i*ord(st[i]));
{}

  res:=res mod 256;
  if res in h then
    if ord(st[length(st)])mod 4=0 then res:=ord(st[1]);
  if (res=56)and (ord(st[length(st)]) mod 8=0) then res:=ord(st[length(st)]) div 3;
  if res=0 then res:=(ord(st[1]) and 63)+(ord(st2) and 3)*64;
  HashFunc:=res;
  end;

{$ifdef TEST}
procedure Run;
  var st:string;
      data:array[0..255] of word;
      i,a:byte;
      max:word;
  begin
  fillchar(data,sizeof(data),0);
  repeat
    readln(st);
    inc(data[HashFunc(st)]);
  until seekeof(input);
  max:=0;
  for i:=0 to 255 do
    if data[i]>max then max:=data[i];
  Writeln('MAX= ',max);
  for i:=1 to 255 do
    begin
    write(i:3,' ',data[i]);
    if data[i]>=max then write('! ') else write('  ');
    end;
  write('   !! ',max);
  end;
{$else}
procedure Run;
  var st:string;
  begin
  repeat
    readln(st);
    writeln(HashFunc(st));
  until seekeof(input);
  end;
{$endif}

begin
  Assign(input,InFile);
  Reset(input);
{$ifndef TEST}
  Assign(output,OutFile);
  Rewrite(output);
{$endif}
  Run;
  Close(input);
  Close(output);
end.
