program Divide; {Russia Olymp'98 - Nikokoshev Ilia}{N2}
{ $define DEBUG}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
{$ifdef DEBUG} {$R+,Q+} {$endif}

const
  InFile='divide.in';
  OutFile='divide.out';

type tProecRec=record wh:integer; ln:integer end;
     tProect{ion}=array[0..999] of tProecRec;
     tDataRec=record x1,y1,x2,y2:integer; end;
     tRectRec=tDataRec;
var
  SZx,SZy:word;
  N:word;
  data:array[1..1000] of tDataRec;
  px,py:tProect;
  npx,npy:integer;
  res:array[1..5000] of tRectRec;
  nres:word;

procedure ReadData;
  var i:word;
      procedure Swap(var x,y:integer);
        var t:word;
        begin
        t:=x;
        x:=y;
        y:=t;
        end;
  begin
  Assign(input,InFile);
  Reset(input);
  Read(SZx,SZy);
  Read(N);
  for i:=1 to N do
    with data[i] do
      begin
      read(x1,y1,x2,y2);
      if x1>x2 then swap(x1,x2);
      if y1>y2 then swap(y1,y2);
      end;
  Close(input);
  with data[N+1]do begin x1:=-1;   x2:=SZx+1; y1:=0;    y2:=0     end;
  with data[N+2]do begin x1:=-1;   x2:=SZx+1; y1:=SZy;  y2:=SZy   end;
  with data[N+3]do begin x1:=0;    x2:=0;     y1:=-1;   y2:=SZy+1 end;
  with data[N+4]do begin x1:=SZx;  x2:=SZx;   y1:=-1;   y2:=SZy+1 end;
  end;

procedure WriteSol;
  var i:word;
  begin
  Assign(output,OutFile);
  Rewrite(output);
  writeln(nres);
  for i:=1 to nres do
    with res[i] do writeln(x1,' ',y1,' ',x2,' ',y2);

  Close(output);
  end;

procedure SortP(var p:TProect; n:word);
  var done:boolean;
      t:tProecRec;
      i:word;
  begin
  done:=false;
  repeat
    done:=true;
    for i:=0 to n-1 do
      if p[i].wh>p[i+1].wh then
        begin
        t:=p[i];
        p[i]:=p[i+1];
        p[i+1]:=t;
        done:=false;
        end;
  until done;
  end;

function Find1(const p:tProect; what:word):word;
  var i:word;
  begin
  for i:=1 to 10000 do
    if p[i].wh>=what then
      begin
      Find1:=i-1;
      exit;
      end;
  halt(10);
  end;
function Find2(const p:tProect; what:word):word;
  var i:word;
  begin
  for i:=0 to 10000 do
    if p[i].wh>what then
      begin
      Find2:=i;
      exit;
      end;
  halt(10);
  end;
function Find1_(const p:tProect; what:word):word;
  var i:word;
  begin
  for i:=1 to 10000 do
    if p[i].wh>what then
      begin
      Find1_:=i-1;
      exit;
      end;
  halt(10);
  end;
function Find2_(const p:tProect; what:word):word;
  var i:word;
  begin
  for i:=0 to 10000 do
    if p[i].wh>=what then
      begin
      Find2_:=i;
      exit;
      end;
  halt(10);
  end;

procedure Expand(i:word);
  var h,l:word;
  begin
  with data[i] do
    if y1=y2 then
      begin
      h:=Find1(px,x1);
      repeat
        l:=px[h].ln;
        if (data[l].y1<y1) and (data[l].y2>y1) then
          break;
        dec(h);
      until false;
      x1:=data[l].x1;
      h:=Find2(px,x2);
      repeat
        l:=px[h].ln;
        if (data[l].y1<y1) and (data[l].y2>y1) then
          break;
        inc(h);
      until false;
      x2:=data[l].x1;
      end
    else
      begin
      h:=Find1_(py,y1);
      repeat
        l:=py[h].ln;
        if (data[l].x1<=x1) and (data[l].x2>=x1) then
          break;
        dec(h);
      until false;
      y1:=data[l].y1;
      h:=Find2_(py,y2);
      repeat
        l:=py[h].ln;
        if (data[l].x1<=x1) and (data[l].x2>=x1) then
          break;
        inc(h);
      until false;
      y2:=data[l].y1;
      end;
  end;

procedure AddRect(xi,yi:word);
  var i,l:word;
  begin
  inc(nres);
  with res[nres] do
    begin
    x1:=data[px[xi].ln].x1;
    y1:=data[py[yi].ln].y1;
    for i:=xi+1 to 1000 do
      begin
      l:=px[i].ln;
      if (data[l].y1<=y1) and (data[l].y2>y1) then
        break;
      end;
    x2:=data[l].x1;
    for i:=yi+1 to 1000 do
      begin
      l:=py[i].ln;
      if (data[l].x1<=x1) and (data[l].x2>x1) then
        break;
      end;
    y2:=data[l].y1;
    end;
  end;

procedure Run;
  var i,j:word;
  begin
  nres:=0;
  npx:=-1; npy:=-1;
  for i:=1 to N+4 do
    with data[i] do
      if x1=x2 then
        begin
        inc(npx);
        px[npx].wh:=x1;
        px[npx].ln:=i;
        end
      else
        begin
        inc(npy);
        py[npy].wh:=y1;
        py[npy].ln:=i;
        end;
  SortP(px,npx);
  SortP(py,npy);
  for i:=1 to N do
    Expand(i);
  with data[N+3]do begin x1:=0;    x2:=0;     y1:=0;   y2:=SZy end;
  with data[N+4]do begin x1:=SZx;  x2:=SZx;   y1:=0;   y2:=SZy end;
  px[npx+1].wh:=10000;
  py[npy+1].wh:=10000;
  for i:=0 to npx-1 do
    with data[px[i].ln] do
      for j:=Find2_(py,y1) to Find1(py,y2) do
        if (data[py[j].ln].x1<=x1) and (data[py[j].ln].x2>x1) then
          AddRect(i,j);
  end;


begin
ReadData;
Run;
WriteSol;
end.
