program Filya; {Russia Olimp'98 -II day} {4}
{ $define DEBUG}

{$M 40000,0,65536}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
{$ifdef DEBUG} {$R+,Q+} {$endif}

const
  InFile='filya.in';
  OutFile='filya.out';
var
  tbl:array[0..46,0..42] of shortint;
  answer:byte;

procedure ReadData;
  var x,y:byte;
      ch:char;
  begin
  Assign(input,InFile);
  Reset(input);
  fillchar(tbl,sizeof(tbl),10);
  for y:=1 to 41 do
    begin
    for x:=1 to 45 do
      begin
      read(ch);
      tbl[x,y]:=ord(ch)-ord('0');
      end;
    readln;
    end;
  Close(input);
  end;

procedure WriteSol;
  begin
  Assign(output,OutFile);
  Rewrite(output);
  writeln(answer);
  Close(output);
  end;

var HowMark:shortint;

procedure Mark(x,y:byte);
  var a:byte;
  begin
  a:=tbl[x,y];
  tbl[x,y]:=HowMark;
  if tbl[x+1,y]=a then Mark(x+1,y);
  if tbl[x,y+1]=a then Mark(x,y+1);
  if tbl[x-1,y]=a then Mark(x-1,y);
  if tbl[x,y-1]=a then Mark(x,y-1);
  end;

procedure Run;
  var res:array[1..6] of word;
      max:integer;
      c11:byte;
      i:byte;
        procedure Calculate(tx,ty:byte; _howmark:shortint);
          var x,y:byte;
          begin
          HowMark:=_howmark;
          Mark(tx,ty);
          fillchar(res,sizeof(res),0);
          for x:=1 to 45 do
            for y:=1 to 41 do
              if tbl[x,y]>0 then
                if (tbl[x,y+1]=_howmark) or (tbl[x,y-1]=_howmark) or (tbl[x+1,y]=_howmark) or (tbl[x-1,y]=_howmark) then
                  inc(res[tbl[x,y]]);
          end;
  begin
  c11:=tbl[1,1];
  Calculate(1,1,-1);
  max:=-1;
  for i:=1 to 6 do
    if (i<>c11) and (i<>tbl[45,41]) and (res[i]>max) then
      begin
      answer:=i;
      max:=res[i];
      end;
  end;

begin
ReadData;
Run;
WriteSol;
end.