{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
program _3_;
const Limit = 355;
      nsol = 'NO SOLUTION';
var l: array [1..5000, 0..2] of Word;
    c: array [1..5000, 0..2] of Byte;
    n: Word;
    Timer: LongInt absolute $40:$6C;
    Save: LongInt;

procedure CT;
begin
 if Timer - Save >= Limit then begin
  Write (nsol);
  Close (OutPut);
  Halt;
 end;
end;

procedure Init;
var i, j: Word;
begin
 Assign (Input, 'RAIL.IN'); Reset (Input);
 Assign (Output, 'RAIL.OUT'); Rewrite (Output);
 Read (n);
 for i := 1 to n do
  for j := 0 to 2 do Read (l[i,j]);
end;

function fi (i, j: Word): Byte;
var k,q: Word;
begin
 k := l[i,j];
 for q := 0 to 2 do if l[k,q] = i then Break;
 fi := q;
end;

procedure Put (i: Word; j: Byte);
var k: Word;
begin
 c[i,j] := 1;
 if j <> 0 then begin c[i, 0] := 0; c[l[i,0], fi (i,0)] := 0; end;
 if j <> 1 then begin c[i, 1] := 0; c[l[i,1], fi (i,1)] := 0; end;
 if j <> 2 then begin c[i, 2] := 0; c[l[i,2], fi (i,2)] := 0; end;

 k := l[i, j];

 j := fi (i, j);
 c[k,j] := 1;
 if j <> 0 then begin c[k, 0] := 0; c[l[k,0], fi(k,0)] := 0; end;
 if j <> 1 then begin c[k, 1] := 0; c[l[k,1], fi(k,1)] := 0; end;
 if j <> 2 then begin c[k, 2] := 0; c[l[k,2], fi(k,2)] := 0; end;
end;

function Solve (i0, j0: Word): Word;
var i, j, k, q: Word;
    fnd: Boolean;
label 1;
begin
 FillChar (c, SizeOf (c), 2);
 Put (i0, j0);

 repeat
  CT;
  fnd := False;
  for i := 1 to n do begin
   if (c[i, 0] = 0) and (c[i, 1] = 0) and (c[i, 2] = 2) then
    begin Put (i, 2); fnd := true; Break; end else
   if (c[i, 0] = 0) and (c[i, 1] = 2) and (c[i, 2] = 0) then
    begin Put (i, 1); fnd := true; Break; end else
   if (c[i, 0] = 2) and (c[i, 1] = 0) and (c[i, 2] = 0) then
    begin Put (i, 0); fnd := true; Break; end;
  end;
  if not fnd then begin
   for i := 1 to n do
    for j := 0 to 2 do
     if c[i, j] = 2 then begin
      Put (i, j);
      fnd := True;
      Goto 1;
     end;
  end;
1:
 until not Fnd;
 for i := 1 to n do begin
  if (c[i, 0] = c[i, 1]) and
     (c[i, 1] = c[i, 2]) then Exit;
 end;
 for i := 1 to n do
  for j := 0 to 2 do
   if c[i, j] = 1 then begin
    k := l[i, j];
    WriteLn (i, ' ', k);
    if l[k, 0] = i then q := 0 else
     if l[k, 1] = i then q := 1 else
      if l[k, 2] = i then q := 2;
    c[k, q] := 2;
   end;
 Close (OutPut);
 Halt;
end;

var i0, j0: Word;
begin
 Init;
 Save := Timer;
 repeat
  i0 := Random (n) + 1;
  j0 := Random (3);
  Solve (i0, j0);
  CT;
 until False;
end.