#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int sizex,sizey;
int numLines;
int upper[10000];
int xs[1000];
int xi[1000];

struct Line
{
	int x1,y1,x2,y2;
	char present;
};

Line lines[1000];

int sort_function(const void *ap,const void *bp)
{
	Line *a=(Line*)ap,*b=(Line*)bp;
	if(a->x1!=a->x2)
	{
		if(b->x1==b->x2)
			return 1;
		else
		{
			if(b->y1<a->y1)
				return -1;
			else
				return 1;
		}
	}
	else
	{
		if(b->x1!=b->x2)
		{
			if(a->x1==a->x2)
				return -1;
			else
			{
				if(a->y1<b->y1)
					return 1;
				else
					return -1;
			}
		}
		else
		{
			if(a->x1<b->x1)
				return -1;
			else
				return 1;
		}
	}
}

int upptr,zzz;

int findup(Line *ptr)
{
	if(upptr==numLines)
		return 0;
	ptr->x1=lines[upptr].x1;
	ptr->x2=lines[upptr].x2;
	ptr->y1=lines[upptr].y1;
	ptr->y2=lines[upptr++].y2;
	return 1;
}

char buf[256],*token;

long numRegs=0;

void addregion(FILE *fp,int left,int right,int y)
{
	int prev=upper[left],start=left;
	for(int i=left+1;i<right;i++)
	{
		if(upper[i]!=prev)
		{
//			fprintf(fp,"%d %d %d %d\n",start,prev,i,y);
			if((start!=i)&&(y!=prev))
			{
				numRegs++;
				fprintf(fp,"%d %d %d %d\n",start,y,i,prev);
			}
			for(int j=start;j<i;j++)
				upper[j]=y;
			prev=upper[i];
			start=i;
		}
	}
//	fprintf(fp,"%d %d %d %d\n",start,prev,right,y);
	if((start!=right)&&(y!=prev))
	{
		numRegs++;
		fprintf(fp,"%d %d %d %d\n",start,y,right,prev);
	}
	for(int j=start;j<right;j++)
		upper[j]=y;
}

void main(void)
{
	FILE *fp,*fo;
	fp=fopen("divide.in","rt");
	fo=fopen("divide.out","wt");

	fprintf(fo,"           \n");

	fgets(buf,256,fp);
	sscanf(buf,"%d %d",&sizex,&sizey);
	fgets(buf,256,fp);
	sscanf(buf,"%d",&numLines);

	for(int i=0;i<sizex;i++)
		upper[i]=sizey;
	for(i=0;i<numLines;i++)
	{
		fgets(buf,256,fp);
		sscanf(buf,"%d %d %d %d",&lines[i].x1,&lines[i].y1,&lines[i].x2,&lines[i].y2);
		lines[i].present=1;
	}

	qsort((void*)lines,numLines,sizeof(lines[0]),sort_function);

	for(i=0;i<numLines;i++)
	{
		if(lines[i].y1==lines[i].y2)
		{
			upptr=zzz=i;
			break;
		}
	}

	Line up;
	int left,right;
	while(findup(&up))
	{
		int t=0,ptr=0;
		if(up.y1==sizey)
			continue;
		if(up.x1>up.x2)
			up.x1^=up.x2^=up.x1^=up.x2;
		for(int i=0;i<zzz;i++)
		{
			if(lines[i].present&&((lines[i].y1>up.y1)||(lines[i].y2>up.y2)))
			{
//				if((lines[i].y1>=up.y1)&&(lines[i].y2>=up.y1))
//					lines[i].present=0;
				xi[t]=i;
				xs[t++]=lines[i].x1;
			}
		}
		if(t)
		{
			if(!xs[0])
				ptr=1;
			for(i=ptr;i<t+1;i++)
			{
				if(!i)
					left=0;
				else
					left=xs[i-1];
				if(i==t)
					right=sizex;
				else
					right=xs[i];
				if(right<=up.x1)
					continue;
/*				if(!left)
				{
					if(((right>up.x1)&&(right<=up.x2))||(right==sizex))
						goto a;
				}*/
				if(left>=up.x2)
					break;
//				if(left<up.x1)
//					left=up.x1;
//				if(right>up.x2)
//				{
//					if(right!=sizex)
//						right=up.x2;
//				}
a:				for(int z=0;z<t;z++)
				{
					if((lines[xi[z]].y1>=up.y1)&&(lines[xi[z]].y2>=up.y1))
						if((lines[xi[z]].x1>=left)&&(lines[xi[z]].x2<=right))
							lines[xi[z]].present=0;
				}
				addregion(fo,left,right,up.y1);
			}
			for(i=up.x1;i<up.x2;i++)
				upper[i]=up.y1;
		}
		else
		{
			addregion(fo,0,sizex,up.y1);
			for(i=0;i<sizex;i++)
				upper[i]=up.y1;
		}
	}

	int t=0;
	for(i=0;i<zzz;i++)
		if(lines[i].present)
			xs[t++]=lines[i].x1;

	int ptr=0;
	if(!xs[0])
		ptr=1;
	for(i=ptr;i<t+1;i++)
	{
		if(!i)
			left=0;
		else
			left=xs[i-1];
		if(i==t)
			right=sizex;
		else
			right=xs[i];
		addregion(fo,left,right,0);
	}

	fclose(fo);
	fo=fopen("divide.out","r+");
	fprintf(fo,"%ld",numRegs);
	fclose(fo);
	fclose(fp);
}
