program DivideEtImpera;
{ LMD !!!! Full MustDie !}
const
   InFile = 'divide.in';
   OutFile = 'divide.out';
   Max = 1000;
   MaxRect = 4000;
type
   _2pt = record
     x1,y1,x2,y2:integer;
   end;
var
   inf,outf:text;
   minx,miny,maxx,maxy:integer;
   horlins:array [1..1000] of _2pt;
   verlins:array [1..1000] of _2pt;
   rects:array [1..MaxRect] of _2pt;
   i,n,lin_cnt:integer;
   rec_cnt:integer;
   hors,vers:integer;
   tmp:integer;
   rtmp:_2pt;
   top,bottom,left,right:_2pt;
   ind:integer;

procedure AddRect(r:_2pt);
begin
   inc(rec_cnt);
   rects[rec_cnt]:=r;
end;

function CheckTop:Boolean;
var
   ok:boolean;
begin
   { Check for top hor line }
   CheckTop:=false;
   if hors=0 then exit;
   top:=horlins[1];
   ind:=i;
   for i:=2 to hors do
      if horlins[i].y1>top.y1 then begin top:=horlins[i]; ind:=i; end;
   ok:=true;
   for i:=1 to vers do
      if verlins[i].y2>top.y1 then begin ok:=false; break; end;
   if ok then begin
      rtmp.x1:=minx;
      rtmp.x2:=maxx;
      rtmp.y1:=top.y1;
      rtmp.y2:=maxy;
      AddRect(rtmp);
      maxy:=top.y1;
      for i:=ind+1 to hors do
         horlins[i-1]:=horlins[i];
      dec(hors);
      CheckTop:=true;
      exit;
   end;
end;

function CheckBottom:Boolean;
var
   ok:boolean;
begin
   { Check for bottom hor line }
   CheckBottom:=False;
   if hors=0 then Exit;
   bottom:=horlins[1];
   ind:=i;
   for i:=2 to hors do
      if horlins[i].y1<bottom.y1 then begin bottom:=horlins[i]; ind:=i; end;
   ok:=true;
   for i:=1 to vers do
      if verlins[i].y1<bottom.y1 then begin ok:=false; break; end;
   if ok then begin
      rtmp.x1:=minx;
      rtmp.x2:=maxx;
      rtmp.y1:=miny;
      rtmp.y2:=bottom.y1;
      AddRect(rtmp);
      miny:=bottom.y1;
      for i:=ind+1 to hors do
         horlins[i-1]:=horlins[i];
      dec(hors);
      CheckBottom:=true;
      exit;
   end;
end;

function CheckLeft:Boolean;
var
   ok:boolean;
begin
   { Check for left ver line }
   CheckLeft:=false;
   if vers=0 then exit;
   Left:=verlins[1];
   ind:=i;
   for i:=2 to vers do
      if verlins[i].x1<Left.x1 then begin Left:=verlins[i]; ind:=i; end;
   ok:=true;
   for i:=1 to vers do
      if horlins[i].x1<Left.x1 then begin ok:=false; break; end;
   if ok then begin
      rtmp.y1:=miny;
      rtmp.y2:=maxy;
      rtmp.x1:=minx;
      rtmp.x2:=Left.x1;
      AddRect(rtmp);
      minx:=Left.x1;
      for i:=ind+1 to vers do
         verlins[i-1]:=verlins[i];
      dec(vers);
      CheckLeft:=true;
      exit;
   end;
end;

function CheckRight:Boolean;
var
   ok:boolean;
begin
   { Check for right ver line }
   CheckRight:=false;
   if vers=0 then exit;
   Left:=verlins[1];
   ind:=i;
   for i:=2 to vers do
      if verlins[i].x1>Right.x1 then begin Right:=verlins[i]; ind:=i; end;
   ok:=true;
   for i:=1 to vers do
      if horlins[i].x2>Right.x1 then begin ok:=false; break; end;
   if ok then begin
      rtmp.y1:=miny;
      rtmp.y2:=maxy;
      rtmp.x1:=Right.x1;
      rtmp.x2:=maxx;
      AddRect(rtmp);
      maxx:=Right.x1;
      for i:=ind+1 to vers do
         verlins[i-1]:=verlins[i];
      dec(vers);
      CheckRight:=true;
      exit;
   end;
end;


begin
   assign(inf,InFile);
   reset(inf);
   assign(outf,OutFile);
   rewrite(outf);
   minx:=0; miny:=0;
   readln(inf,maxx,maxy);
   readln(inf,lin_cnt);
   hors:=0; vers:=0;
   for i:=1 to lin_cnt do
     with rects[1] do begin
       readln(inf,x1,y1,x2,y2);
       { // sort by x,y-coordinates }
       if x1=x2 then begin
         inc(vers);
         if y2<y1 then begin
           tmp:=y1;
           y1:=y2;
           y2:=tmp;
         end;
         verlins[vers]:=rects[1];
       end;
       if y1=y2 then begin
         inc(hors);
         if x2<x1 then begin
            tmp:=x1;
            x1:=x2;
            x2:=tmp;
         end;
         horlins[hors]:=rects[1];
       end;
     end;

   while (hors>0) or (vers>0) do begin
      if CheckTop or CheckBottom then Continue;
      if CheckLeft or CheckRight then Continue;
      writeln('Deadlock...');
      break;
   end;
   { // Add one lefted rect }
   rtmp.x1:=minx;
   rtmp.y1:=miny;
   rtmp.x2:=maxx;
   rtmp.y2:=maxy;
   AddRect(rtmp);
   writeln(outf,rec_cnt);
   for i:=1 to rec_cnt do
      with rects[i] do writeln(outf,x1,' ',y1,' ',x2,' ',y2);
   close(inf);
   close(outf);
end.