{$A+}{$F+}{$G+}{$I+}{$N-}{$P+}{$Q+}{$R+}{$S+}{$T+}{$V+}{$X+}{$Y-}
program Task2;
type tZas=array[1..4] of integer;
var f1,f2:text;
    SizeX:integer;
    SizeY:integer;
    i,j:integer;
    Zas:array[1..1000] of tZas;
    cZas:integer;
    Recs:array[1..5000] of tZas;
    cRecs:integer;
procedure Swap(var x,y:integer);
var t:integer;
begin
   t:=x;
   x:=y;
   y:=t;
end;
function ZasType(i:integer):integer;
begin
   if Zas[i,1]=Zas[i,3] then ZasType:=1 else begin
      if Zas[i,2]=Zas[i,4] then ZasType:=2 else begin
         halt(0);
      end;
   end;
end;
procedure SplitRec(iZas:integer;iRec:integer);
begin
   inc(cRecs);
   Recs[cRecs,1]:=Recs[iRec,1];
   Recs[cRecs,2]:=Recs[iRec,2];
   if ZasType(i)=1 then begin
      Recs[cRecs,3]:=Zas[i,1];
      Recs[cRecs,4]:=Recs[iRec,4];
      Recs[iRec,1]:=Zas[i,1];
   end else begin
      Recs[cRecs,3]:=Recs[iRec,3];
      Recs[cRecs,4]:=Zas[i,2];
      Recs[iRec,2]:=Zas[i,2];
   end;
end;
procedure DelRec(iRec:integer);
var i:integer;
begin
   dec(cRecs);
   for i:=iRec to cRecs do Recs[i]:=Recs[i+1];
end;
function InBounds(x,b1,b2:integer):boolean;
begin
  InBounds:=(x>b1)and(x<b2)
end;
function OnBound(x,b1,b2:integer):boolean;
begin
  OnBound:=(x=b1)or(x=b2)
end;
function InRect(iZas:integer;iRec:integer):boolean;
begin
   InRect:=false;
   if ZasType(iZas)=1 then begin
      if InBounds(Zas[iZas,1],Recs[iRec,1],Recs[iRec,3]) then begin
         if InBounds(Zas[iZas,2],Recs[iRec,2],Recs[iRec,4]) then InRect:=true;
         if InBounds(Zas[iZas,4],Recs[iRec,2],Recs[iRec,4]) then InRect:=true;
         if OnBound(Zas[iZas,2],Recs[iRec,2],Recs[iRec,4]) then begin
            if OnBound(Zas[iZas,2],Recs[iRec,2],Recs[iRec,4])or
               InBounds(Recs[iRec,2],Zas[iZas,2],Zas[iZas,4])or
               InBounds(Recs[iRec,4],Zas[iZas,2],Zas[iZas,4])then InRect:=true;
         end;
         if OnBound(Zas[iZas,4],Recs[iRec,2],Recs[iRec,4]) then begin
            if OnBound(Zas[iZas,2],Recs[iRec,2],Recs[iRec,4])or
               InBounds(Recs[iRec,2],Zas[iZas,2],Zas[iZas,4])or
               InBounds(Recs[iRec,4],Zas[iZas,2],Zas[iZas,4])then InRect:=true;
         end;
      end;
   end else begin
      if InBounds(Zas[iZas,2],Recs[iRec,2],Recs[iRec,4]) then begin
         if InBounds(Zas[iZas,1],Recs[iRec,1],Recs[iRec,3]) then InRect:=true;
         if InBounds(Zas[iZas,3],Recs[iRec,1],Recs[iRec,3]) then InRect:=true;
         if OnBound(Zas[iZas,1],Recs[iRec,1],Recs[iRec,3]) then begin
            if OnBound(Zas[iZas,3],Recs[iRec,1],Recs[iRec,3])or
               InBounds(Recs[iRec,1],Zas[iZas,1],Zas[iZas,3])or
               InBounds(Recs[iRec,3],Zas[iZas,1],Zas[iZas,3])then InRect:=true;
         end;
         if OnBound(Zas[iZas,3],Recs[iRec,1],Recs[iRec,3]) then begin
            if OnBound(Zas[iZas,1],Recs[iRec,1],Recs[iRec,3])or
               InBounds(Recs[iRec,1],Zas[iZas,1],Zas[iZas,3])or
               InBounds(Recs[iRec,3],Zas[iZas,1],Zas[iZas,3])then InRect:=true;
         end;
      end;
   end;
end;
function MergeRecs(iRec1,iRec2:integer):boolean;
var i:integer;
begin
   MergeRecs:=false;
   if (Recs[iRec1,1]=Recs[iRec2,1])and(Recs[iRec1,3]=Recs[iRec2,3])then begin
      if (Recs[iRec1,2]=Recs[iRec2,4])then begin
         Recs[cRecs+1,1]:=Recs[iRec1,1];
         Recs[cRecs+1,2]:=Recs[iRec2,2];
         Recs[cRecs+1,3]:=Recs[iRec1,3];
         Recs[cRecs+1,4]:=Recs[iRec1,4];
         for i:=1 to cZas do if InRect(i,cRecs+1) then exit;
         Recs[iRec1]:=Recs[cRecs+1];
         DelRec(iRec2);
         MergeRecs:=true;
      end;
      if (Recs[iRec1,4]=Recs[iRec2,2]) then begin
         Recs[cRecs+1,1]:=Recs[iRec1,1];
         Recs[cRecs+1,2]:=Recs[iRec1,2];
         Recs[cRecs+1,3]:=Recs[iRec1,3];
         Recs[cRecs+1,4]:=Recs[iRec2,4];
         for i:=1 to cZas do if InRect(i,cRecs+1) then exit;
         Recs[iRec1]:=Recs[cRecs+1];
         DelRec(iRec2);
         MergeRecs:=true;
      end;
   end;
   if (Recs[iRec1,2]=Recs[iRec2,2])and(Recs[iRec1,4]=Recs[iRec2,4])then begin
      if (Recs[iRec1,1]=Recs[iRec2,3])then begin
         Recs[cRecs+1,1]:=Recs[iRec2,1];
         Recs[cRecs+1,2]:=Recs[iRec1,2];
         Recs[cRecs+1,3]:=Recs[iRec1,3];
         Recs[cRecs+1,4]:=Recs[iRec1,4];
         for i:=1 to cZas do if InRect(i,cRecs+1) then exit;
         Recs[iRec1]:=Recs[cRecs+1];
         DelRec(iRec2);
         MergeRecs:=true;
      end;
      if (Recs[iRec1,3]=Recs[iRec2,1]) then begin
         Recs[cRecs+1,1]:=Recs[iRec1,1];
         Recs[cRecs+1,2]:=Recs[iRec1,2];
         Recs[cRecs+1,3]:=Recs[iRec2,3];
         Recs[cRecs+1,4]:=Recs[iRec1,4];
         for i:=1 to cZas do if InRect(i,cRecs+1) then exit;
         Recs[iRec1]:=Recs[cRecs+1];
         DelRec(iRec2);
         MergeRecs:=true;
      end;
   end;
end;
begin
   assign(f1,'divide.in');
   assign(f2,'divide.out');
   reset(f1);
   rewrite(f2);
   read(f1,SizeX,SizeY);
   cRecs:=1;
   Recs[1,1]:=0;
   Recs[1,2]:=0;
   Recs[1,3]:=SizeX;
   Recs[1,4]:=SizeY;
   read(f1,cZas);

   for i:=1 to cZas do begin
       read(f1,Zas[i,1],Zas[i,2],Zas[i,3],Zas[i,4]);
       if Zas[i,2]>Zas[i,4] then Swap(Zas[i,2],Zas[i,4]);
       if Zas[i,1]>Zas[i,3] then Swap(Zas[i,1],Zas[i,3]);
       for j:=1 to cRecs do if InRect(i,j) then SplitRec(i,j);
   end;
   for i:=cRecs downto 2 do begin
       for j:=i-1 downto 1 do begin
          if MergeRecs(j,i) then break;
       end;
   end;
   writeln(f2,cRecs);
   for i:=1 to cRecs do begin
       writeln(f2,Recs[i,1]:4,Recs[i,2]:4,Recs[i,3]:4,Recs[i,4]:4)
   end;
   close(f1);
   close(f2);
end.