var fi,fo:text;
    s:string;
const cl:Array [1..15] of integer=(1,2,5,15,30,38,42,39,30,22,14,9,5,2,1);
      cb:Array [''..''] of integer=(57,427,784,313,477,33,123,455,222,0,571,197,376,630,636,1926,389,1087,316,
                                      301,152,152,42,197,93,77,0,0,0,41,8,41);
      csl:Array [0..7] of integer=(349,1899,3382,2829,1147,340,47,7);

type sl=set of ''..'';
     wt=string[15];

function toup(x:char):char;
begin
  if (ord(x)>159) and (ord(x)<176) then toup:=chr(ord(x)-160+128)
  else if (ord(x)>223) then toup:=chr(ord(x)-224+128)
  else toup:=x;
end;

function countg(w:wt):integer;
var i,t:integer;
begin
  t:=0;
  for i:=1 to length(w) do
    if pos(w[i],'㨥')<>0 then
      inc(t);
  countg:=t;
end;

function inlex(w:wt):longint;
var i:integer;
    s:longint;
    f:longint;
begin
  f:=0;
  s:=1024*1024*1024 div 16;
  for i:=1 to 6 do begin
    if i<=length(w) then
      f:=f+(ord(toup(w[i]))-128)*s;
    s:=s div 32;
  end;
  inlex:=f;
end;

function hash(w:wt):Integer;
var i,cmin,cmax:integer;
    cbs:Array [''..''] of integer;
    cbsl:Array [''..''] of char;
    tc,k,j:char;
    t:Integer;
    dmi,dma:real;
    ng:integer;
    il:longint;
begin
  cmin:=1;
  for i:=2 to length(w) do
    cmin:=cmin+cl[i-1];

  cmax:=cmin-1+cl[length(w)];
  if cmin=cmax then begin
    if cmin>255 then cmin:=255;
    hash:=cmin;
    exit;
  end;
  for k:='' to '' do begin
    cbs[k]:=cb[k];
    cbsl[k]:=k;
  end;
  for k:='' to '' do
    for j:=chr(ord(k)+1) to '' do
      if cbs[j]<cbs[k] then begin
        t:=cbs[k];cbs[k]:=cbs[j];cbs[j]:=t;
        tc:=cbsl[k];
        cbsl[k]:=cbsl[j];cbsl[j]:=tc;
      end;
  dma:=cmin;
  for k:='' to '' do begin
    dmi:=dma;
    dma:=dmi+cbs[chr(ord(k))]/10000*(cmax-cmin+1);
    if cbsl[k]=toup(w[1]) then break;
  end;
  cmin:=trunc(dmi);cmax:=trunc(dma);
  if cmin=cmax then begin
    if cmin>255 then cmin:=255;
    hash:=cmin;
    exit;
  end;
  ng:=countg(w);
  dma:=cmin;
  for i:=0 to 7 do begin
    dmi:=dma;
    dma:=dmi+csl[i]/10000*(cmax-cmin+1);
    if ng=i then break;
  end;
  cmin:=trunc(dmi);cmax:=trunc(dma);
  if cmin=cmax then begin
    if cmin>255 then cmin:=255;
    hash:=cmin;
    exit;
  end;
  il:=inlex(w);
  cmin:=cmin+trunc((il/(1024.0*1024.0*1024.0))*(cmax-cmin+1));
  if cmin>255 then cmin:=255;
  hash:=cmin;
end;

begin
  assign(fi,'hash.in');
  assign(fo,'hash.out');
  reset(fi);
  rewrite(fo);
  while not eof(fi) do begin
    readln(fi,s);
    writeln(fo,hash(s));
  end;
  close(fi);
  close(fo);
End.