Program RailRoads;
Uses Crt;
Const
  MaxN = 5000;
  MaxM = 15000;
  Cmp                   : Array[1..6,1..3] of Byte =
                              ((0,0,1),(0,1,0),(0,1,1),
                               (1,0,0),(1,0,1),(1,1,0));
Type
  MyPtrType             = ^tMyPtrType;
  tMyPtrType            = Array[1..MaxM,1..2] of Integer;
Var
  FNI, FNO              : Text;
  A                     : Array[1..MaxN,1..3] of Integer;
  W                     : Array[1..MaxN] of 0..1;
  N, i, Q, M            : Integer;
  Nd                    : MyPtrType;
  Usd                   : Array[1..MaxM] of Boolean;

{}
Procedure DefineNode(Town  : Integer);
  Var
    T, S,S1,S2,S3, Ti           : Integer;
    Flag                        : Boolean;
    TW                          : Array[1..6] of Integer;
    TUsd                        : Array[1..6] of Boolean;

{}
  Procedure StoreVars;
    Var
      Ti        : Integer;
    Begin
      TW[1]:=W[S];
      TW[2]:=W[S+1];
      TW[3]:=W[S+2];
      For Ti:=1 to 3 do
        Begin
          If Nd^[(A[Town,1]-1)*3+Ti,2] = Town Then
            Begin
              S1:=(A[Town,1]-1)*3+Ti;
              TW[4]:=W[(A[Town,1]-1)*3+Ti];
            End;
        End;
      For Ti:=1 to 3 do
        Begin
          If Nd^[(A[Town,2]-1)*3+Ti,2] = Town Then
            Begin
              S2:=(A[Town,2]-1)*3+Ti;
              TW[5]:=W[(A[Town,2]-1)*3+Ti];
            End;
        End;
      For Ti:=1 to 3 do
        Begin
          If Nd^[(A[Town,3]-1)*3+Ti,2] = Town Then
            Begin
              S3:=(A[Town,3]-1)*3+Ti;
              TW[6]:=W[(A[Town,3]-1)*3+Ti];
            End;
        End;
      TUsd[1]:=Usd[S];
      TUsd[2]:=Usd[S+1];
      TUsd[3]:=Usd[S+2];
      TUsd[4]:=Usd[S1];
      TUsd[5]:=Usd[S2];
      TUsd[6]:=Usd[S3];
    End;

{}
  Procedure ReStoreVars;
    Begin
      W[S]:=TW[1];
      W[S+1]:=TW[2];
      W[S+2]:=TW[3];
      W[S1]:=TW[4];
      W[S2]:=TW[5];
      W[S3]:=TW[6];
      Usd[S]:=TUsd[1];
      Usd[S+1]:=TUsd[2];
      Usd[S+2]:=TUsd[3];
      Usd[S1]:=TUsd[4];
      Usd[S2]:=TUsd[5];
      Usd[S3]:=TUsd[6];
    End;

{}
  Begin
    Flag:=True;
    For T:=1 to N do
      If Not(W[(T-1)*3+1]+W[(T-1)*3+2]+W[(T-1)*3+3] in [1..2]) Then Flag:=False;

    If Flag Then
      Begin
        FillChar(Usd,SizeOf(Usd),False);
        For T:=1 to M do
          If W[T] = 1 Then
            Begin
              If Not Usd[T] Then
                Begin
                  Usd[T]:=True;
                  For Ti:=1 to 3 do
                    Begin
                      If Nd^[(Nd^[T,2]-1)*3+Ti,2] = ((T-1) div 3)+1 Then
                        Begin
                          Usd[(Nd^[T,2]-1)*3+Ti]:=True;
                        End;
                    End;
                  WriteLn(FNO,Nd^[T,1],' ',Nd^[T,2]);
                End;
            End;
        Close(FNO);
        Halt(1);
      End;

    S:=(Town-1)*3+1;

    If (Not Flag)and(Town <= N) Then
      Begin
        For T:=1 to 6 do
          Begin
            StoreVars;
            If Not Usd[S] Then
              Begin W[S]:=Cmp[T,1]; Usd[S]:=True; End;
            If Not Usd[S+1] Then
              Begin W[S+1]:=Cmp[T,2]; Usd[S+1]:=True; End;
            If Not Usd[S+2] Then
              Begin W[S+2]:=Cmp[T,3]; Usd[S+2]:=True; End;
            If Not Usd[S1] Then
              Begin W[S1]:=Cmp[T,1]; Usd[S1]:=True; End;
            If Not Usd[S2] Then
              Begin W[S2]:=Cmp[T,2]; Usd[S2]:=True; End;
            If Not Usd[S3] Then
              Begin W[S3]:=Cmp[T,3]; Usd[S3]:=True; End;
            DefineNode(Town+1);
            RestoreVars;
          End;
      End;

  End;

{}
Begin
  New(Nd);

  FillChar(W,SizeOf(W),0);
  FillChar(A,SizeOf(A),0);
  FillChar(Usd,SizeOf(Usd),False);
  For i:=1 to MaxM do
    Begin
      Nd^[i,1]:=0;
      Nd^[i,2]:=0;
    End;

  Assign(FNI,'rail.in');
  Reset(FNI);
  Assign(FNO,'rail.out');
  Rewrite(FNO);

  ReadLn(FNI,N);
  M:=N*3;
  Q:=0;
  For i:=1 to N do
    Begin
      If Not EOF(FNI) Then
        Begin
          ReadLn(FNI,A[i,1],A[i,2],A[i,3]);
          Inc(Q);  Nd^[Q,1]:=i;  Nd^[Q,2]:=A[i,1];
          Inc(Q);  Nd^[Q,1]:=i;  Nd^[Q,2]:=A[i,2];
          Inc(Q);  Nd^[Q,1]:=i;  Nd^[Q,2]:=A[i,3];
        End;
    End;
{}

  DefineNode(1);

{}

  Close(FNI);
  Close(FNO);
  Dispose(Nd);
End.