 const
  NMax = 1000;
 type
  T2n = array [1..2] of Integer;
 var
  Path: array [1..NMax] of T2n;
  N, L: Integer;
  r: Real;

 procedure ReadAll;
  var
   i: Integer;
  begin
   Assign(Input, 'train.in');
   Reset(Input);

   ReadLn(L);
   ReadLn(N);
   for i := 1 to N do
    Read(Path[i, 1], Path[i, 2]);

   Close(Input);
  end;

  function GetTime(St, Len: Integer): real;
   var
    i: Integer;
    t: Real;
    CurL, ld: Integer;
   begin
    CurL := 0;
    ld := 0;
    t := 0;
    repeat
     CurL := CurL + ld;
     ld := Path[st+1, 1]*Path[st+1, 2];
     if CurL+ld < Len then t := t + Path[st+1, 1];
     inc(st);
    until (CurL+ld >= Len) or (st > n);
    if st > n then GetTime := t else
     begin
      dec(st);
      GetTime := t + (Len-CurL)/Path[st+1, 2];
     end;
   end;

  procedure Solve;
   var
    i: Integer;
    x: T2n;
    a: Real;
   begin
    r := 0;
    for i := 0 to N-1 do
     begin
      a := GetTime(i, L);
      if r < a then r := a;
     end;

    for i := 1 to N div 2 do
     begin
      x := Path[i];
      Path[i] := Path[n-i+1];
      Path[n-i+1] := x;
     end;

    for i := 0 to N-1 do
     begin
      a := GetTime(i, L);
      if r < a then r := a;
     end;
   end;

  procedure Out;
   begin
    Assign(Output, 'train.out');
    ReWrite(Output);

    WriteLn(r:20:5);

    Close(Output);
   end;

 begin
  ReadAll;
  Solve;
  Out;
 end.