{$A-,B-,D-,E-,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}

program Problem_5;
 const maxN=1200;
       eps=0.0001;
 type real=extended;
      cross=record
             t,v:integer;
            end;
 var road:array[1..maxN] of cross;
     bt:  array[1..maxN+1] of longint;
     rast:array[1..maxN+1] of longint;
     l,n:integer;
     timer:longint absolute $40:$6C;
     saved:longint;

 function Eq(x,y:real):boolean;
  begin
  Eq:=abs(x-y)<eps;
  end;

 function Lng(time:real):real;
  var i:integer;
  begin
  i:=1; while (bt[i]<time) or Eq(bt[i],time) do inc(i);
  Lng:=rast[i-1]+(time-bt[i-1])*(rast[i]-rast[i-1])/(bt[i]-bt[i-1]);
  end;

 function Min(x,y:real):real;
  begin
  if x<y then Min:=x else Min:=y;
  end;

 function Max(x,y:real):real;
  begin
  if x>y then Max:=x else Max:=y;
  end;

 procedure Init;
  var i:integer;
  begin
  bt[1]:=0; rast[1]:=0;
  assign(input,'train.in'); reset(input);
  read(l,n);
  for i:=1 to n do begin
    read(road[i].t,road[i].v);
    bt[i+1]:=bt[i]+road[i].t;
    rast[i+1]:=rast[i]+road[i].t*longint(road[i].v);
   end;
  bt[n+2]:=bt[n+1]+1; rast[n+2]:=rast[n+1];
  close(input);
  end;

 function Is(num1,num2:integer; time:real):boolean;
  var mx,mn:real;
      lb1,le1,lb2,le2:real;
  begin
  Is:=false;
  if Eq(bt[num1+1]-bt[num1],0) or Eq(bt[num2+1]-bt[num2],0) then exit;
  mx:=Max(bt[num1],bt[num2]+time);
  mn:=Min(bt[num1]+road[num1].t,bt[num2]+time+road[num2].t);
  if mx>mn then exit;
  lb1:=Lng(mx)-l; lb2:=Lng(mx-time);
  le1:=Lng(mn)-l; le2:=Lng(mn-time);
  Is:=true;
  if (lb2>lb1) or (le2>le1) then exit;
  Is:=false;
  end;

 function checkRoad(time:real):boolean;
  var i,j:integer;
  begin
  checkRoad:=false;
  for j:=1 to N do begin
    if bt[j]+time>bt[n+1] then begin checkRoad:=true; exit; end;
    for i:=1 to N do
     if (bt[i]+road[i].t>bt[j]+time) or (Eq(bt[i]+road[i].t,bt[j]+time)) then begin
       if Is(i,j,time) then exit;
       if bt[i]>bt[j]+road[j].t+time then break;
      end;
   end;
  checkRoad:=true;
  end;

 procedure Solve;
  var l,r,time:real;
  begin
  l:=0; r:=bt[n+1];
  while not Eq(l,r) do begin
    time:=(l+r)/2;
    if checkRoad(time) then r:=time
     else l:=time;
   end;
  assign(output,'train.out'); rewrite(output);
  writeln(r:0:3);
{  writeln((timer-saved)/18.2);}
  close(output);
  end;

 BEGIN
 saved:=timer;
 Init;
 Solve;
 END.