{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
type rect=record
     x1,y1,x2,y2:integer;
     end;
var  n,cnt:integer;
     zas:array[1..1000]of rect;
     obl:array[1..1000]of rect;
     tmax:rect;maxarea:integer; fl:boolean;
     xmax,ymax:integer;

procedure ReadData;
var i:integer;k:integer;
begin
     read(xmax,ymax);
     read(n);
     for i:=1 to n do
     begin
      read(zas[i].x1,zas[i].y1,zas[i].x2,zas[i].y2);
      with zas[i] do
      begin
           if x1>x2 then begin k:=x1;x1:=x2;x2:=k;end;
           if y1>y2 then begin k:=y1;y1:=y2;y2:=k;end;
      end;
     end;
end;

procedure rectcopy(var d:rect;t:rect);
begin
     d.x1:=t.x1;
     d.x2:=t.x2;
     d.y1:=t.y1;
     d.y2:=t.y2;
end;

function per(a,b:rect):boolean;
var p:boolean;
begin

     per:=((a.x1<b.x2)and(a.x2>b.x1))
       and((a.y1<b.y2)and(a.y2>b.y1));
end;

function legal(t:rect):boolean;
var
i:integer;
begin
     legal:=true;
     for i:=1 to cnt do if per(t,obl[i]) then begin legal:=false;exit;end;
     for i:=1 to n do if per(t,zas[i]) then begin legal:=false;exit;end;
end;

function tryout(t:rect):boolean;
var tmp:rect;a:integer;x,y:integer;
begin
     maxarea:=0;
     for x:=t.x1+1 to xmax do
         for y:=t.y1+1 to ymax do
         begin
              tmp.x1:=t.x1;
              tmp.x2:=x;
              tmp.y1:=t.y1;
              tmp.y2:=y;
              if legal(tmp) then
              begin
                   a:=(tmp.x2-tmp.x1)*(tmp.y2-tmp.y1);
                   if a>maxarea then
                   begin
                        maxarea:=a;
                        rectcopy(tmax,tmp);
                   end;
              end else break;
         end;
end;


procedure Solve;
var x,y:integer;t:rect;
begin
     cnt:=0;
     for y:=0 to ymax-1 do
         for x:=0 to xmax-1 do
         begin
              t.x1:=x;t.x2:=x+1;
              t.y1:=y;t.y2:=y+1;
              if legal(t) then
              begin
                 maxarea:=0;
                 tryout(t);
                 inc(cnt);
                 rectcopy(obl[cnt],tmax);
              end;
         end;
end;

procedure Print;
var i:integer;
begin
     writeln(cnt);
     for i:=1 to cnt do
         with obl[i] do
              writeln(x1,' ',y1,' ',x2,' ',y2);
end;

BEGIN
        Assign(input,'divide.in');
        Assign(output,'divide.out');
        reset(input);
        rewrite(output);
	ReadData;
	Solve;
	Print;
        close(input);close(output);
END.
