{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,0}
{$DEFINE ALFA}

type      TF = Array [1..41, 1..45] of Byte;
var       F: TF;
          Ans: Integer;
          Start: Integer;
          OTime: LongInt;
          Time: LongInt absolute 0:$46C;
const     Rec = 6;


procedure ReadAll;
var       I, J: Integer;
          Inp: Text;
          C: Char;
begin
 Assign (Inp, 'FILYA.IN'); Reset (Inp);
 for I := 1 to 41 do
 begin
  for J := 1 to 45 do
  begin
   Read (Inp, C);
   F [I, J] := Ord (C) - 48;
  end;
  ReadLn (Inp);
 end;
 Close (Inp);
end;

procedure SOLVE;

function OC2 : Integer;
var      O: array [1..1845, 1..2] of byte;
         FN, ON: Integer;
         G: Boolean;
         Q, X, Y: integer;
begin
 Q := F [1,1];
 ON := 1; FN := 1;
 O [1,1]:= 1; O[1,2]:=1; Q := F [1,1]; F [1,1] := F [1,1] or 128;
 while FN <= ON do
 begin
  X := O [FN, 1]; Y := O [FN, 2]; Inc (FN);
  if X > 1 then if F [Y, X-1] = Q then
  begin
   Inc (ON);
   O [ON,1] := X-1;
   O [ON,2] := Y;
   F [Y, X-1] := F [Y, X-1] or 128;
  end;
  if X < 45 then if F [Y, X+1] = Q then
  begin
   Inc (ON);
   O [ON,1] := X+1;
   O [ON,2] := Y;
   F [Y, X+1] := F [Y, X+1] or 128;
  end;
  if Y < 41 then if F [Y+1, X] = Q then
  begin
   Inc (ON);
   O [ON,1] := X;
   O [ON,2] := Y+1;
   F [Y+1, X] := F [Y+1, X] or 128;
  end;
  if Y > 1 then if F [Y-1, X] = Q then
  begin
   Inc (ON);
   O [ON,1] := X;
   O [ON,2] := Y-1;
   F [Y-1, X] := F [Y-1, X] or 128;
  end;
 end;
 OC2 := ON;
end;

procedure MarkFrom (X, Y, T: integer);
var       O: array [1..1845, 1..2] of byte;
          ON: Integer;
          G: Boolean;
          I, Q: integer;
begin
 Q := F [Y,X];
 ON := 1;
 O [1,1]:= X; O[1,2]:=Y; T := T or 128; F[Y, X] := T;
 repeat
  G := True;
  for I := 1 to ON do if F [O [I, 2], O [I, 1]] > 128 then
  begin
   X := O [I, 1]; Y := O [I, 2];
   if X > 1 then if F [Y, X-1] = Q then
   begin
    Inc (ON);
    O [ON,1] := X-1;
    O [ON,2] := Y;
    F [Y, X-1] := T;
    G := False;
   end;
   if Y > 1 then if F [Y-1, X] = Q then
   begin
    Inc (ON);
    O [ON,1] := X;
    O [ON,2] := Y-1;
    F [Y-1, X] := T;
    G := False;
   end;
   if X < 45 then if F [Y, X+1] = Q then
   begin
    Inc (ON);
    O [ON,1] := X+1;
    O [ON,2] := Y;
    F [Y, X+1] := T;
    G := False;
   end;
   if Y < 41 then if F [Y+1, X] = Q then
   begin
    Inc (ON);
    O [ON,1] := X;
    O [ON,2] := Y+1;
    F [Y+1, X] := T;
    G := False;
   end;
   F [Y,X] := F[Y,X] and 127;
  end;
 until G;
end;

function ItThink (De: Integer; FC, FO: Integer; var BI: Integer;Need: Integer): Integer; forward;

function IThink (De: Integer; FC, FO: Integer; var BI: Integer;Need: Integer): Integer;
var      I, Val, Best: Integer;
         O, Trash: Integer;
         T: TF;
begin
 if (Time-OTime>77) then Exit;
 if (De = 0) then
 begin
  T := F;
  IThink := OC2;
  F := T;
  Exit;
 end;

 Best := 0; BI := 0;
 for I := 1 to 6 do if (I <> F [1,1]) and (I <> F [41, 45]) then
 begin
  {DoIt}
  T := F;
  MarkFrom (1, 1, I);
  {----}
  Val := ItThink(De-1, FO, FC, Trash, Best);
  if (Time-OTime>77) then Exit;
  {RestoreIt}
  F := T;
  {---------}
  if Val > Best then
  begin
   Best := Val; {$IFDEF ALFA}
   If Best >= Need Then
   begin
    IThink := Best;
    Exit;
   end; {$ENDIF}
   BI := I;
  end;
 end;
 IThink := Best;
end;

function ItThink (De: Integer; FC, FO: Integer; var BI: Integer;Need: Integer): Integer;
var      I, Val, Best: Integer;
         O, Trash: Integer;
         T: TF;
begin
 if (Time-OTime>77) then Exit;
 if De = 0 then
 begin
  T := F;
  ItThink := OC2;
  F := T;
  Exit;
 end;
 Best := 32767; BI := 0;
 for I := 1 to 6 do if (I <> F [1,1]) and (I <> F [41, 45]) then
 begin
  {DoIt}
  T :=F;
  MarkFrom (45, 41, I);
  {----}
  Val := IThink (De-1, FO, FC, Trash, Best);
  if (Time-OTime>77) then Exit;
  {RestoreIt}
  F := T;
  {---------}
  if Val < Best then
  begin
   Best := Val; {$IFDEF ALFA}
   If Best <= Need Then
   Begin
    ItThink := Best;
    Exit;
   End; {$ENDIF}
   BI := I;
  end;
 end;
 ItThink := Best;
end;

var     T: TF;

begin
 T := F;
 Start := OC2;
 F := T;
 IThink (Rec, 0, 0, Ans, 32767);
end;

procedure WriteOut;
var       Out: Text;
begin
 Assign (Out, 'FILYA.OUT'); ReWrite (Out);
 WriteLn (Out, Ans);
 Close (Out);
end;

begin
 OTime := Time;
 ReadAll;
 SOLVE;
 WriteOut;
end.