{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}

const max_n = 5000;
type  tCity = array[1..max_n,1..2] of integer;
      tData = array[1..3] of integer;
var   city : tCity;
      n    : integer;
      f    : text;

procedure init_data;
var i,j : integer;
begin
     for i := 1 to max_n do for j := 1 to 2 do city[i,j] := 0;
     assign(f,'rail.out'); rewrite(f);
end;

procedure write_no_solution;
begin
     rewrite(f);
     writeln(f,'NO SOLUTION');
     close(f);
     halt(0);
end;

procedure process_data(data : tData; k : integer);
var i,j,l : integer;
begin
     l := 0;
     for i := 1 to 3 do begin
         for j := 1 to 2 do
             if city[data[i],j] = 0 then begin l := j; break end;
         if l <> 0 then break;
     end;

     if l = 0 then write_no_solution;

     for j := 1 to l-1 do
         if city[data[i],j] = k then exit;

     city[data[i],l] := k;
     for j := 1 to 2 do
         if city[k,j] = 0 then break;
     city[k,j] := data[i];
     writeln(f,k,' ',data[i]);
end;

procedure read_data(s : string);
var f : text; i : integer; data : tData;
begin
     assign(f,s); reset(f);
     read(f,n);
     for i := 1 to n do begin
         read(f,data[1],data[2],data[3]);
         process_data(data,i);
     end;
     close(f);
end;

begin
     init_data;
     read_data('rail.in');
     close(f);
end.
