#include <stdio.h>
#include <math.h>
#define filein "clepsidre.in"
#define fileout "clepsidre.out"
#define eps 1e-6

long int N, K;
int nM, M[100], where[100];
long int d[30];

void get(long int x, int k)
{
if (k == 1)
  {
    M[nM] = 1;
    where[nM] = 0;
    nM++;
    return;
  }

if (!(x%2))
  {
    get(x/2, k-1);
    return;
  }

if (x < d[k-1])
  {
    get(x, k-1);

    M[nM] = where[nM-1];
    where[nM] = 1-where[nM-1];
    nM++;
    return;
  }

get(d[k]-x, k);
where[nM-1] = 1-where[nM-1];

return;
}

int main()
{
double doi;
long int i, x;

freopen(filein, "r", stdin);
scanf("%ld %ld", &N, &K);

for (d[0] = i = 1; d[i-1] < N; i++)
  d[i] = d[i-1]*2;

for (doi = 2, i = 1; 1; doi *= 2, i++)
  {
    x = (doi*K)/N;

    if (fabs(K-(x/doi)*N) < eps)
      break;
  }

nM = 0;
get(x, i);

freopen(fileout, "w", stdout);
printf("%d\n", nM);
for (i = 0; i < nM; i++)
  printf("%d\n", M[i]);

return 0;
}