/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N) */

#include <stdio.h>
#include <string.h>
#define filein "prefix.in"
#define fileout "prefix.out"
#define maxn 1000001

char x[maxn];
int prefix[maxn];

int main()
{
int t, i, k, l, n, max;

freopen(filein, "r", stdin);
freopen(fileout, "w", stdout);

for (scanf("%d ", &t); t; t--)
  {
  gets(x);
  n = strlen(x);
  
  prefix[0] = k = -1;
  for (i = 1; i < n; i++)
    {
      while (k > -1 && x[k+1] != x[i])
        k = prefix[k];
  
      if (x[k+1] == x[i])
        k++;
  
      prefix[i] = k;
    }
  
  for (max = 0, i = n-1; i; i--)
    if ((!((i+1) % (i-prefix[i]))) && (i-prefix[i] <= (i+1)>>1))
      {
        max = i+1;
        break;
      }
      
  printf("%d\n", max);
  }

return 0;
}