#include <cstdio>
#include <vector>

using namespace std;

#define maxN 100000
#define maxM 300000
#define INFI 0x3f3f3f3f

#define BG begin()
#define ED end()
#define IT iterator

typedef vector<int> vint;
typedef vector<bool> vbol;

int N, M, C;
vint vec[maxN];
vint sol;
vbol usd;
bool drw;

void do_df(int node)
{
    if(usd[node])
        return;
    usd[node] = true;
    
    if(drw)
        sol[node] = C++;
    
    for(vint::IT i = vec[node].BG; i != vec[node].ED; ++ i)
        do_df(*i);
}

int main(void)
{ 
    freopen("zapada.in", "r", stdin);

    scanf("%d %d", &N, &M);

    for(int i = 0; i < M; ++ i) {
        int x, y;

        scanf("%d %d", &x, &y);
        vec[y-1].push_back(x-1);        
    }

    fclose(stdin);

    usd.clear();
    usd.resize(N, false);
    
    int last = -1;
    drw  = false;
    
    for(int i = 0; i < N; ++ i) if(!usd[i]) {
        last = i;
        do_df(i);
    }

    usd.clear(); usd.resize(N, false);
    sol.clear(); sol.resize(N, INFI);

    drw = true; C = 1;
    do_df(last);

    freopen("zapada.out", "w", stdout);

    for(vint::IT i = sol.BG; i != sol.ED; ++ i) {
        printf("%d\n", *i);
        if(*i == INFI)
            fprintf(stderr, "Wrong\n");
    }

    fclose(stdout);

    return 0;     
}

